/*
 *  Controllers.h
 *  toycars
 *
 *  Created by Ruben Henner Zilibowitz on 28/06/08.
 *  Copyright 2008 Ruben Henner Zilibowitz. All rights reserved.
 *
 */

#ifndef CONTROLLERS_H
#define CONTROLLERS_H

enum ControllerType {
   kKeyboardController,
   kXBox360Controller,
   kPlaystation3Controller,
   kNoController
};

enum JoystickButton {
   kStartButton,
   kBackButton,
   kLeftButton,
   kRightButton,
   kDownButton,
   kUpButton,
   kAButton,
   kBButton,
   kXButton,
   kYButton,
   kLeftShoulderButton,
   kRightShoulderButton
};

enum JoystickAxis {
   kLeftTrigger,
   kRightTrigger,
   kLeftHorizontalAxis,
   kLeftVerticalAxis,
   kRightHorizontalAxis,
   kRightVerticalAxis
};

int mapJoystickDeviceToPlayer(int which);
JoystickButton mapJoyButtonInput(int btn, ControllerType type);
JoystickAxis mapJoyAxisInput(int axis, ControllerType type, short inAxisValue, short *outAxisValue);

#endif // CONTROLLERS_H
