/*
 *  Menu.h
 *  ToyCars
 *
 *  Created by Ruben Henner Zilibowitz on 24/11/05.
 *  Copyright 2005 Ruben Henner Zilibowitz. All rights reserved.
 *
 */

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include "SDL.h"
#include "SDL_image.h"

class Menu
{
public:
   Menu(char **inItems, int inNumItems, const char * inTitle = 0, const char * inBackgroundImage = 0);
   ~Menu();
   
   int doMenu();
   
protected:
   char **items;
   const int numItems;
   const char * title;
   const char * backgroundImage;
   int abs(int x);
   SDL_Surface* img;
   int curItem;
   
   void drawBackground();
   void drawMenu();
   void nextItem();
   void prevItem();
};
