/*
	Copyright (C) 2005 by Ruben Henner Zilibowitz <rzilibowitz@users.sourceforge.net>
	Part of the Toy Cars Project http://toycars.sourceforge.net

	This program is free software; you can redistribute it and/or modify
	it under the terms of the license.
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY.

	See the COPYING file for more details.
*/

/*
 *  Created by Ruben Henner Zilibowitz on 31/10/07.
 */

#ifndef ROBOTHOTPOTATOPLAYER_H
#define ROBOTHOTPOTATOPLAYER_H

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include "RobotPlayer.h"

enum FastestRoute
{
	kForwardsTrack,
	kBackwardsTrack,
	kDirectLine
};

const long kRobotHotPotatoPlayerType = 'RHPP';

class RobotHotPotatoPlayer : public RobotPlayer
{
public:
			RobotHotPotatoPlayer(ToyCar& inCar, list<Tuple> *path, int inPlayerNumber, FMOD::System* inFMOD_System);
	virtual ~RobotHotPotatoPlayer() {}
	
	virtual void	integrateKeys(double dt);
	
	virtual void	printDebugInfo() const;
   
protected:
	void	avoidPlayer(const Player *player, double dt);
	void	catchPlayer(const Player *player, double dt, FastestRoute route);
	FastestRoute	playerDistance(const Player *player, double *dist);
	
	double backupDist;
	
	// debugging data
	FastestRoute debugRoute;
	bool avoiding;
	bool catching;
	const Player* targetPlayer;
};

#endif // ROBOTHOTPOTATOPLAYER_H
