/*
	Copyright (C) 2005 by Ruben Henner Zilibowitz <rzilibowitz@users.sourceforge.net>
	Part of the Toy Cars Project http://toycars.sourceforge.net

	This program is free software; you can redistribute it and/or modify
	it under the terms of the license.
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY.

	See the COPYING file for more details.
*/

/*
 *  Created by Ruben Henner Zilibowitz on 5/08/05.
 */

#ifndef ROBOTPLAYER_H
#define ROBOTPLAYER_H

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include "Player.h"

const long kRobotPlayerType = 'RBPL';

class RobotPlayer : public Player
{
public:
			RobotPlayer(ToyCar& inCar, list<Tuple> *path, int inPlayerNumber, FMOD::System* inFMOD_System);
	virtual ~RobotPlayer() {}
	
	virtual void	doEvent(PlayerEvent* event)	{}
	virtual void	integrateKeys(double dt);
	
	virtual void	printDebugInfo() const;
   
   virtual bool isAI() const { return true; }
	
protected:
	void	driveTowards(Tuple aim, double throttle);
	void	followPath(bool forwards, double dt);
	void	backup(bool forwards, double dt);
	
	double	backupDist;
	
	// debug data
	bool unsticking;
};

#endif // ROBOTPLAYER_H
