/*
 *  TcPreferences.h
 *  ToyCars
 *
 *  Created by Ruben Henner Zilibowitz on 16/12/05.
 *  Copyright 2005 Ruben Henner Zilibowitz. All rights reserved.
 *
 */

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include "Controllers.h"

const int kNumPlayerControllerOptions = 4;

struct PreferencesData {
   int screenwidth, screenheight;
   bool fullscreen;
	int maxParticles;
	double fuseLength;
	bool music;
	bool sounds;
   ControllerType playerControllers[kNumPlayerControllerOptions];
};

class TcPreferences
{
public:
   TcPreferences(const char *inFilename);
   ~TcPreferences();
    
   int getScreenWidth() { return data.screenwidth; }
   int getScreenHeight() { return data.screenheight; }
   bool getFullscreen() { return data.fullscreen; }
   int getMaxParticles() { return data.maxParticles; }
   double getFuseLength() { return data.fuseLength; }
	bool getModifiedScreenPrefs() { return modifiedScreenPrefs; }
	bool getMusic() { return data.music; }
	bool getSounds() { return data.sounds; }
	ControllerType getControllerType(int playerNum) { return (1 <= playerNum && playerNum <= kNumPlayerControllerOptions) ? data.playerControllers[playerNum-1] : kNoController; }
   
   void savePreferences(const char *filename);
	
	void drawPrefs();
	
protected:
	char *filename;
	bool modifiedScreenPrefs;
   void defaultPrefs();
	const char *controllerName(ControllerType n);
	void drawControllersPrefs();
   void copyPrefsData(PreferencesData *src, PreferencesData *dst);
   
   PreferencesData data;
   PreferencesData tempData;
};
