/*
 *  Tileset.cpp
 *  toycars
 *
 *  Created by Ruben Henner Zilibowitz on 17/02/09.
 *  Copyright 2009 Ruben Henner Zilibowitz. All rights reserved.
 *
 */

#include "Tileset.h"

Tileset::Tileset(const ScPixelData& pixelData, int inTileWidth, int inTileHeight, short border, short inSeperation, bool inBlend,
                  TileGroup &inRoad,
                  TileGroup &inOffroad,
                  TileGroup &inWall)
	:	ScTilemap(pixelData, inTileWidth, inTileHeight, border, inSeperation, inBlend),
      road(inRoad), offroad(inOffroad), wall(inWall)
{
}

Tileset::~Tileset()
{
}

const TileGroup* Tileset::tileGroup(int t)
{
   const int x = t % paletteWidth;
   const int y = t / paletteWidth;
   if (road.minx <= x && x <= road.maxx && road.miny <= y && y <= road.maxy)
      return &road;
   if (offroad.minx <= x && x <= offroad.maxx && offroad.miny <= y && y <= offroad.maxy)
      return &offroad;
   if (wall.minx <= x && x <= wall.maxx && wall.miny <= y && y <= wall.maxy)
      return &wall;
   return NULL;
}
