/*
 *  Tileset.h
 *  toycars
 *
 *  Created by Ruben Henner Zilibowitz on 17/02/09.
 *  Copyright 2009 Ruben Henner Zilibowitz. All rights reserved.
 *
 */

#ifndef TILESET_H
#define TILESET_H

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include "ScTilemap.h"

enum TileType
{
   kRoad, kOffroad, kWall, kNoTile
};

struct TileGroup {
   int minx, maxx, miny, maxy;   // the block on the tiles image this group corresponds to
   double grip;   // surface grip (1 means normal grip; 0 means no grip)
   GLubyte r, g, b;  // dust colour
};

class Tileset : public ScTilemap
{
public:
               Tileset( const ScPixelData& pixelData,
                        int inTileWidth,
                        int inTileHeight,
                        short border,
                        short inSeperation,
                        bool inBlend,
                        TileGroup &inRoad,
                        TileGroup &inOffroad,
                        TileGroup &inWall);
      virtual  ~Tileset();
   
   /*void  setRoadTiles(int minx, int maxx, int miny, int maxy);
   void  setOffroadTiles(int minx, int maxx, int miny, int maxy);
   void  setWallTiles(int minx, int maxx, int miny, int maxy);*/
   
   const TileGroup* tileGroup(int t);
   
protected:
   TileGroup road, offroad, wall;
};

#endif
