/*
 *  ImportImageBox.cpp
 *  toycars_track_editor
 *
 *  Created by Ruben Henner Zilibowitz on 18/02/09.
 *  Copyright 2009 Ruben Henner Zilibowitz. All rights reserved.
 *
 */

#include "ImportImageBox.h"
#include "FL/Fl_Image.H"
#include <cstdio>

ImportImageBox::ImportImageBox(int x, int y, int w, int h, const char *c) : Fl_Box(x,y,w,h,c), filename(NULL)
{
}

ImportImageBox::ImportImageBox(Fl_Boxtype b, int x, int y, int w, int h, const char *c) : Fl_Box(b,x,y,w,h,c), filename(NULL)
{
}

ImportImageBox::~ImportImageBox()
{
}

int ImportImageBox::handle(int event)
{
   unsigned char *colour;
   if (event == FL_PUSH) {
      Fl_Light_Button *btn;
      if (roadBtn->value() == 1) {
         btn = roadBtn;
         colour = roadColour;
      }
      else if (offroadBtn->value() == 1) {
         btn = offroadBtn;
         colour = offroadColour;
      }
      else if (wallBtn->value() == 1) {
         btn = wallBtn;
         colour = wallColour;
      }
      else
         return 1;
      
      Fl_Image *img = image();
      int xpos = Fl::event_x() - (w() - img->w())*0.5 + x();
      int ypos = Fl::event_y() - (h() - img->h())*0.5 + y();
      int c;
      if (0 <= xpos && xpos < img->w() && 0 <= ypos && ypos < img->h()) {
         const char * imgdat = *img->data();
         const char * pixel = imgdat + (img->w()*ypos + xpos)*img->d();
         c = fl_rgb_color(pixel[0], pixel[1], pixel[2]);
         colour[0] = pixel[0];
         colour[1] = pixel[1];
         colour[2] = pixel[2];
      }
      else {
         c = FL_BACKGROUND_COLOR;
         colour[0] = -1;
         colour[1] = -1;
         colour[2] = -1;
      }
      btn->color(c);
      btn->clear();
      btn->set();
      return 1;
   }
   return 0;
}
