/*
 *  ImportImageBox.h
 *  toycars_track_editor
 *
 *  Created by Ruben Henner Zilibowitz on 18/02/09.
 *  Copyright 2009 Ruben Henner Zilibowitz. All rights reserved.
 *
 */

#ifndef IMPORTIMAGEBOX_H
#define IMPORTIMAGEBOX_H 1
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif
#include <FL/Fl.H>
#include <FL/Fl_Box.H>
#include <FL/Fl_Light_Button.H>

// forwards declaration
class TrackEditorUI;

class ImportImageBox : public Fl_Box {
public:
      ImportImageBox(int x, int y, int w, int h, const char *c = 0);
      ImportImageBox(Fl_Boxtype b, int x, int y, int w, int h, const char *c);
      ~ImportImageBox();
   
   virtual int handle(int event);
   
   void setBtns(Fl_Light_Button *r, Fl_Light_Button *o, Fl_Light_Button *w) { roadBtn = r; offroadBtn = o; wallBtn = w; }
   void setFilename(const char *f) { filename = f; }
   const char *getFilename() { return filename; }
   
   const unsigned char *getRoadColour() { return roadColour; }
   const unsigned char *getOffroadColour() { return offroadColour; }
   const unsigned char *getWallColour() { return wallColour; }
   
protected:
   Fl_Light_Button *roadBtn;
   unsigned char roadColour[3];
   Fl_Light_Button *offroadBtn;
   unsigned char offroadColour[3];
   Fl_Light_Button *wallBtn;
   unsigned char wallColour[3];
   const char *filename;
};

#endif
