/*
 *  CurveView.h
 *  toycars_vehicle_editor
 *
 *  Created by Ruben Henner Zilibowitz on 23/02/09.
 *  Copyright 2009 Ruben Henner Zilibowitz. All rights reserved.
 *
 */

#ifndef CURVEVIEW_H
#define CURVEVIEW_H 1
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif
#include <FL/Fl.H>
#include <FL/Fl_Box.H>

class CurveView : public Fl_Box {
public:
      CurveView(int x, int y, int w, int h, const char *c = 0);
      CurveView(Fl_Boxtype b, int x, int y, int w, int h, const char *c);
      ~CurveView();
   
   int handle(int event);
   void draw();
   
   void setConsts(double *ys) { xs = ys; }
   
   void reset();
   
protected:
   double pacejkaFn(double value);
   
   double *xs;
   double x1,x2,y1,y2;  // bounds
   int gradations;
   double oldX, oldY;
};

#endif
