/*
	Copyright (C) 2005 by Ruben Henner Zilibowitz <rzilibowitz@users.sourceforge.net>
	Part of the Toy Cars Project http://toycars.sourceforge.net

	This program is free software; you can redistribute it and/or modify
	it under the terms of the license.
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY.

	See the COPYING file for more details.
*/

/*
 *  ScAnimation.h
 *  ToyCars
 *
 *  Created by Ruben Henner Zilibowitz on 6/12/05.
 *
 */

#ifndef SCANIMATION_H
#define SCANIMATION_H

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include "ScComponent.h"
#include <list>

using namespace std;

class ScAnimation : public list<ScComponent*>
{
public:
    ScAnimation();
    ~ScAnimation();
    
    void draw();
    void process(double dt);
    void scheduleRemove(ScComponent* component);
    
protected:
    list<ScComponent*> removals;
};

#endif
