/*
 *  SpriteView.h
 *  toycars_vehicle_editor
 *
 *  Created by Ruben Henner Zilibowitz on 23/02/09.
 *  Copyright 2009 Ruben Henner Zilibowitz. All rights reserved.
 *
 */

#ifndef SPRITEVIEW_H
#define SPRITEVIEW_H 1
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif
#include <FL/Fl.H>
#include <FL/Fl_Gl_Window.H>
#include <FL/gl.h>
#include <FL/Fl_Value_Input.H>
#include "ScSprite.h"
#include "VehicleObject.h"

enum VehicleEditSetting {
   kGeometry,
   kAxelWidth,
   kFrontAxel,
   kRearAxel,
   kFrontWheelInset,
   kFrontWheelRadius,
   kRearWheelRadius,
   kNoSetting
};

class SpriteView : public Fl_Gl_Window {
public:
      SpriteView(int x,int y,int w,int h,const char *l=0);
      ~SpriteView();
   
   int handle(int event);
   void draw();
   
   void setRotation(double x) { rotation = x; }
   void setSteerAngle(double x) { steerAngle = x; }
   void setScale(double x) { scale = x; }
   void setVehicleObject(VehicleObject *x) { o = x; }
   void setSetting(VehicleEditSetting x) { setting = x; }
   void setSettingInput(Fl_Value_Input *x) { settingInput = x; }
   void setConvexChoice(int x) { convexChoice = x; }
   
   void reset();
   
   void resetVehicleSprite();
   void resetWheelSprite();
   
   double getRotation() { return rotation; }
   double getSteerAngle() { return steerAngle; }
   double getScale() { return scale; }
   
protected:
   void drawVehicleSprite();
   void drawWheelsSprites();
   
   VehicleEditSetting setting;
   Fl_Value_Input *settingInput;
   VehicleObject *o;
   ScSprite *vehicleSprite;
   ScSprite *wheelSprite;
   double rotation;
   double steerAngle;
   double scale;
   bool mouseIsDown;
   bool mouseIsInside;
   double mousex, mousey;
   int convexChoice;
   bool mouseConvexity;
};

#endif
