// generated by Fast Light User Interface Designer (fluid) version 1.0109

#include "VehicleEditorUI.h"
#include <FL/Fl_File_Chooser.H>
#include "ScException.h"
#include "TextConstants.h"
#include "ScSprite.h"
#include "SearchDirectories.h"

void VehicleEditorUI::cb_newVehicle_i(Fl_Menu_*, void*) {
  if (!check_save()) return;
spriteView->reset();
vehicleObj.reset();
updateVehicleEditorUI();
}
void VehicleEditorUI::cb_newVehicle(Fl_Menu_* o, void* v) {
  ((VehicleEditorUI*)(o->parent()->user_data()))->cb_newVehicle_i(o,v);
}

void VehicleEditorUI::cb_open_i(Fl_Menu_*, void*) {
  if (!check_save()) return;

  char *newfile = fl_file_chooser("Open File?", "*.xml", NULL);
  if (newfile != NULL) {
     spriteView->reset();
     try { vehicleObj.loadVehicle(newfile); }
     catch (ScException e) {
     	e.printMsg();
        fl_alert("Failed to open file %s\n", newfile);
        return;
     }
     strncpy(filename, newfile, 255);
     mainWindow->label(vehicleObj.getTitle());
     updateVehicleEditorUI();
     updateTireCurvesUI();
  };
}
void VehicleEditorUI::cb_open(Fl_Menu_* o, void* v) {
  ((VehicleEditorUI*)(o->parent()->user_data()))->cb_open_i(o,v);
}

void VehicleEditorUI::cb_save_i(Fl_Menu_*, void*) {
  if (filename[0] == '\0') {
  // No filename - get one!
  cb_saveAs_i(0,0);
  return;
 }
 else {
  try { vehicleObj.saveVehicle(filename); }
  catch (ScException e) {
   e.printMsg();
   fl_alert("Failed to save file %s", filename);
  }
 };
}
void VehicleEditorUI::cb_save(Fl_Menu_* o, void* v) {
  ((VehicleEditorUI*)(o->parent()->user_data()))->cb_save_i(o,v);
}

void VehicleEditorUI::cb_saveAs_i(Fl_Menu_*, void*) {
  char *newfile;

 newfile = fl_file_chooser("Save File As?", "*.xml", filename);
 if (newfile != NULL) {
  try { vehicleObj.saveVehicle(newfile); }
  catch (ScException e) {
   e.printMsg();
   fl_alert("Failed to save file %s", newfile);
   return;
  }
  strncpy(filename, newfile, 255);
 };
}
void VehicleEditorUI::cb_saveAs(Fl_Menu_* o, void* v) {
  ((VehicleEditorUI*)(o->parent()->user_data()))->cb_saveAs_i(o,v);
}

void VehicleEditorUI::cb_install_i(Fl_Menu_*, void*) {
  if (filename[0] != '\0') {
   try { vehicleObj.installVehicle(filename); }
   catch (ScException e) {
      e.printMsg();
      fl_alert("Failed to install file %s\n", filename);
      return;
   }
   fl_alert("Install done.");
}
else
   fl_alert("Save map first.");
}
void VehicleEditorUI::cb_install(Fl_Menu_* o, void* v) {
  ((VehicleEditorUI*)(o->parent()->user_data()))->cb_install_i(o,v);
}

void VehicleEditorUI::cb_uninstall_i(Fl_Menu_*, void*) {
  if (filename[0] != '\0') {
   try { vehicleObj.uninstallVehicle(filename); }
   catch (ScException e) {
      e.printMsg();
      fl_alert("Failed to uninstall file %s\n", filename);
      return;
   }
   fl_alert("Uninstall done.");
}
else
   fl_alert("Open map first.");
}
void VehicleEditorUI::cb_uninstall(Fl_Menu_* o, void* v) {
  ((VehicleEditorUI*)(o->parent()->user_data()))->cb_uninstall_i(o,v);
}

void VehicleEditorUI::cb_quit_i(Fl_Menu_*, void*) {
  if (changed && !check_save())
 return;

 exit(0);
}
void VehicleEditorUI::cb_quit(Fl_Menu_* o, void* v) {
  ((VehicleEditorUI*)(o->parent()->user_data()))->cb_quit_i(o,v);
}

void VehicleEditorUI::cb_loadSprite_i(Fl_Menu_*, void*) {
  char *newfile = fl_file_chooser("Open Vehicle Sprite Image File?", "*.{jpg,png,bmp,pnm,pbm,pgm,ppm}", NULL);
  if (newfile != NULL) {
      int w, h;
      if (doLoadSpriteDialog(&w, &h)) {
         strncpy(vehicleObj.getVehicleSpriteFilename(), newfile, 255);
         vehicleObj.setVehicleFrameWidth(w);
         vehicleObj.setVehicleFrameHeight(h);
         spriteView->resetVehicleSprite();
      }
   };
}
void VehicleEditorUI::cb_loadSprite(Fl_Menu_* o, void* v) {
  ((VehicleEditorUI*)(o->parent()->user_data()))->cb_loadSprite_i(o,v);
}

void VehicleEditorUI::cb_loadSpriteFromDataDir_i(Fl_Menu_*, void*) {
  const char *name = fl_input("Enter name:");
if (name != NULL) {
   try { vehicleObj.loadSpriteFromDataDir(name); }
   catch (ScException e) {
      e.printMsg();
      fl_alert("Failed to open file %s\n", name);
      return;
   }
   updateVehicleEditorUI();
   spriteView->resetVehicleSprite();
};
}
void VehicleEditorUI::cb_loadSpriteFromDataDir(Fl_Menu_* o, void* v) {
  ((VehicleEditorUI*)(o->parent()->user_data()))->cb_loadSpriteFromDataDir_i(o,v);
}

void VehicleEditorUI::cb_loadWheelSprite_i(Fl_Menu_*, void*) {
  char *newfile = fl_file_chooser("Open Wheel Sprite Image File?", "*.{jpg,png,bmp,pnm,pbm,pgm,ppm}", NULL);
  if (newfile != NULL) {
      int w, h;
      if (doLoadSpriteDialog(&w, &h)) {
         strncpy(vehicleObj.getWheelSpriteFilename(), newfile, 255);
         vehicleObj.setWheelFrameWidth(w);
         vehicleObj.setWheelFrameHeight(h);
         spriteView->resetWheelSprite();
      }
   };
}
void VehicleEditorUI::cb_loadWheelSprite(Fl_Menu_* o, void* v) {
  ((VehicleEditorUI*)(o->parent()->user_data()))->cb_loadWheelSprite_i(o,v);
}

void VehicleEditorUI::cb_loadWheelSpriteFromDataDir_i(Fl_Menu_*, void*) {
  const char *name = fl_input("Enter name:");
if (name != NULL) {
   try { vehicleObj.loadWheelSpriteFromDataDir(name); }
   catch (ScException e) {
      e.printMsg();
      fl_alert("Failed to open file %s\n", name);
      return;
   }
   updateVehicleEditorUI();
   spriteView->resetWheelSprite();
};
}
void VehicleEditorUI::cb_loadWheelSpriteFromDataDir(Fl_Menu_* o, void* v) {
  ((VehicleEditorUI*)(o->parent()->user_data()))->cb_loadWheelSpriteFromDataDir_i(o,v);
}

void VehicleEditorUI::cb_properties_i(Fl_Menu_*, void*) {
  propertiesWindow->show();
}
void VehicleEditorUI::cb_properties(Fl_Menu_* o, void* v) {
  ((VehicleEditorUI*)(o->parent()->user_data()))->cb_properties_i(o,v);
}

void VehicleEditorUI::cb_tireFrictionCurves_i(Fl_Menu_*, void*) {
  tireCurvesWindow->show();
}
void VehicleEditorUI::cb_tireFrictionCurves(Fl_Menu_* o, void* v) {
  ((VehicleEditorUI*)(o->parent()->user_data()))->cb_tireFrictionCurves_i(o,v);
}

void VehicleEditorUI::cb_setTitle_i(Fl_Menu_*, void*) {
  const char *str = fl_input("Enter title:");
if (str) {
   vehicleObj.setTitle(str);
   mainWindow->label(str);
};
}
void VehicleEditorUI::cb_setTitle(Fl_Menu_* o, void* v) {
  ((VehicleEditorUI*)(o->parent()->user_data()))->cb_setTitle_i(o,v);
}

void VehicleEditorUI::cb_setAuthor_i(Fl_Menu_*, void*) {
  const char *str = fl_input("Enter author name:");
if (str) {
   vehicleObj.setAuthor(str);
};
}
void VehicleEditorUI::cb_setAuthor(Fl_Menu_* o, void* v) {
  ((VehicleEditorUI*)(o->parent()->user_data()))->cb_setAuthor_i(o,v);
}

void VehicleEditorUI::cb_newConvex_i(Fl_Menu_*, void*) {
  int n = convexChoice->size();
if (n > 0)
   n--;
char str[64];
sprintf(str, "%d", n);
convexChoice->add(str);
convexChoice->value(n);
vehicleObj.getGeometry()->push_back(std::list<Vec2D>::list());
spriteView->setConvexChoice(n);
spriteView->redraw();
}
void VehicleEditorUI::cb_newConvex(Fl_Menu_* o, void* v) {
  ((VehicleEditorUI*)(o->parent()->user_data()))->cb_newConvex_i(o,v);
}

void VehicleEditorUI::cb_removexConvex_i(Fl_Menu_*, void*) {
  if (convexChoice->size() > 1) {
   Geometry::iterator it = vehicleObj.getGeometry()->begin();
   it += convexChoice->value();
   convexChoice->remove(convexChoice->size()-2);
   if (convexChoice->size() > 1) {
      convexChoice->value(0);
   }
   else {
      convexChoice->value((const Fl_Menu*)NULL);
   }
   vehicleObj.getGeometry()->erase(it);
   spriteView->setConvexChoice(0);
   spriteView->redraw();
};
}
void VehicleEditorUI::cb_removexConvex(Fl_Menu_* o, void* v) {
  ((VehicleEditorUI*)(o->parent()->user_data()))->cb_removexConvex_i(o,v);
}

void VehicleEditorUI::cb_about_i(Fl_Menu_*, void*) {
  aboutBox->show();
}
void VehicleEditorUI::cb_about(Fl_Menu_* o, void* v) {
  ((VehicleEditorUI*)(o->parent()->user_data()))->cb_about_i(o,v);
}

void VehicleEditorUI::cb_help_i(Fl_Menu_*, void*) {
  helpWindow->show();
}
void VehicleEditorUI::cb_help(Fl_Menu_* o, void* v) {
  ((VehicleEditorUI*)(o->parent()->user_data()))->cb_help_i(o,v);
}

Fl_Menu_Item VehicleEditorUI::menu_mainMenuBar[] = {
 {"File", 0,  0, 0, 64, FL_NORMAL_LABEL, 0, 14, 0},
 {"New...", 0x4006e,  (Fl_Callback*)VehicleEditorUI::cb_newVehicle, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {"Open...", 0x4006f,  (Fl_Callback*)VehicleEditorUI::cb_open, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {"Save", 0x40073,  (Fl_Callback*)VehicleEditorUI::cb_save, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {"Save As...", 0x50073,  (Fl_Callback*)VehicleEditorUI::cb_saveAs, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {"Install", 0x40069,  (Fl_Callback*)VehicleEditorUI::cb_install, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {"Uninstall", 0x40075,  (Fl_Callback*)VehicleEditorUI::cb_uninstall, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {"Quit", 0x40071,  (Fl_Callback*)VehicleEditorUI::cb_quit, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {0,0,0,0,0,0,0,0,0},
 {"Vehicle", 0,  0, 0, 64, FL_NORMAL_LABEL, 0, 14, 0},
 {"Load Sprite...", 0,  (Fl_Callback*)VehicleEditorUI::cb_loadSprite, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {"Load Sprite From Data Dir...", 0,  (Fl_Callback*)VehicleEditorUI::cb_loadSpriteFromDataDir, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {"Load Wheel Sprite...", 0,  (Fl_Callback*)VehicleEditorUI::cb_loadWheelSprite, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {"Load Wheel Sprite From Data Dir...", 0,  (Fl_Callback*)VehicleEditorUI::cb_loadWheelSpriteFromDataDir, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {"Properties...", 0,  (Fl_Callback*)VehicleEditorUI::cb_properties, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {"Tire Friction Curves...", 0,  (Fl_Callback*)VehicleEditorUI::cb_tireFrictionCurves, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {"Title...", 0,  (Fl_Callback*)VehicleEditorUI::cb_setTitle, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {"Author...", 0,  (Fl_Callback*)VehicleEditorUI::cb_setAuthor, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {"New Convex", 0x4002e,  (Fl_Callback*)VehicleEditorUI::cb_newConvex, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {"Remove Convex", 0x4002c,  (Fl_Callback*)VehicleEditorUI::cb_removexConvex, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {0,0,0,0,0,0,0,0,0},
 {"Help", 0,  0, 0, 64, FL_NORMAL_LABEL, 0, 14, 0},
 {"About toycars_vehicle_editor...", 0,  (Fl_Callback*)VehicleEditorUI::cb_about, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {"Help...", 0,  (Fl_Callback*)VehicleEditorUI::cb_help, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {0,0,0,0,0,0,0,0,0},
 {0,0,0,0,0,0,0,0,0}
};
Fl_Menu_Item* VehicleEditorUI::fileMenu = VehicleEditorUI::menu_mainMenuBar + 0;
Fl_Menu_Item* VehicleEditorUI::newVehicle = VehicleEditorUI::menu_mainMenuBar + 1;
Fl_Menu_Item* VehicleEditorUI::open = VehicleEditorUI::menu_mainMenuBar + 2;
Fl_Menu_Item* VehicleEditorUI::save = VehicleEditorUI::menu_mainMenuBar + 3;
Fl_Menu_Item* VehicleEditorUI::saveAs = VehicleEditorUI::menu_mainMenuBar + 4;
Fl_Menu_Item* VehicleEditorUI::install = VehicleEditorUI::menu_mainMenuBar + 5;
Fl_Menu_Item* VehicleEditorUI::uninstall = VehicleEditorUI::menu_mainMenuBar + 6;
Fl_Menu_Item* VehicleEditorUI::quit = VehicleEditorUI::menu_mainMenuBar + 7;
Fl_Menu_Item* VehicleEditorUI::vehicleMenu = VehicleEditorUI::menu_mainMenuBar + 9;
Fl_Menu_Item* VehicleEditorUI::loadSprite = VehicleEditorUI::menu_mainMenuBar + 10;
Fl_Menu_Item* VehicleEditorUI::loadSpriteFromDataDir = VehicleEditorUI::menu_mainMenuBar + 11;
Fl_Menu_Item* VehicleEditorUI::loadWheelSprite = VehicleEditorUI::menu_mainMenuBar + 12;
Fl_Menu_Item* VehicleEditorUI::loadWheelSpriteFromDataDir = VehicleEditorUI::menu_mainMenuBar + 13;
Fl_Menu_Item* VehicleEditorUI::properties = VehicleEditorUI::menu_mainMenuBar + 14;
Fl_Menu_Item* VehicleEditorUI::tireFrictionCurves = VehicleEditorUI::menu_mainMenuBar + 15;
Fl_Menu_Item* VehicleEditorUI::setTitle = VehicleEditorUI::menu_mainMenuBar + 16;
Fl_Menu_Item* VehicleEditorUI::setAuthor = VehicleEditorUI::menu_mainMenuBar + 17;
Fl_Menu_Item* VehicleEditorUI::newConvex = VehicleEditorUI::menu_mainMenuBar + 18;
Fl_Menu_Item* VehicleEditorUI::removexConvex = VehicleEditorUI::menu_mainMenuBar + 19;
Fl_Menu_Item* VehicleEditorUI::helpMenu = VehicleEditorUI::menu_mainMenuBar + 21;
Fl_Menu_Item* VehicleEditorUI::about = VehicleEditorUI::menu_mainMenuBar + 22;
Fl_Menu_Item* VehicleEditorUI::help = VehicleEditorUI::menu_mainMenuBar + 23;

void VehicleEditorUI::cb_rotationRoller_i(Fl_Roller* o, void*) {
  spriteView->setRotation(o->value());
spriteView->redraw();
}
void VehicleEditorUI::cb_rotationRoller(Fl_Roller* o, void* v) {
  ((VehicleEditorUI*)(o->parent()->user_data()))->cb_rotationRoller_i(o,v);
}

void VehicleEditorUI::cb_steerAngleRoller_i(Fl_Roller* o, void*) {
  spriteView->setSteerAngle(o->value());
spriteView->redraw();
}
void VehicleEditorUI::cb_steerAngleRoller(Fl_Roller* o, void* v) {
  ((VehicleEditorUI*)(o->parent()->user_data()))->cb_steerAngleRoller_i(o,v);
}

void VehicleEditorUI::cb_geometryBtn_i(Fl_Button*, void*) {
  spriteView->setSetting(kGeometry);
spriteView->redraw();
}
void VehicleEditorUI::cb_geometryBtn(Fl_Button* o, void* v) {
  ((VehicleEditorUI*)(o->parent()->user_data()))->cb_geometryBtn_i(o,v);
}

void VehicleEditorUI::cb_setAxelWidth_i(Fl_Button*, void*) {
  spriteView->setSetting(kAxelWidth);
spriteView->setSettingInput(axelWidthInput);
spriteView->redraw();
}
void VehicleEditorUI::cb_setAxelWidth(Fl_Button* o, void* v) {
  ((VehicleEditorUI*)(o->parent()->user_data()))->cb_setAxelWidth_i(o,v);
}

void VehicleEditorUI::cb_setFrontAxel_i(Fl_Button*, void*) {
  spriteView->setSetting(kFrontAxel);
spriteView->setSettingInput(frontAxelInput);
spriteView->redraw();
}
void VehicleEditorUI::cb_setFrontAxel(Fl_Button* o, void* v) {
  ((VehicleEditorUI*)(o->parent()->user_data()))->cb_setFrontAxel_i(o,v);
}

void VehicleEditorUI::cb_setRearAxel_i(Fl_Button*, void*) {
  spriteView->setSetting(kRearAxel);
spriteView->setSettingInput(rearAxelInput);
spriteView->redraw();
}
void VehicleEditorUI::cb_setRearAxel(Fl_Button* o, void* v) {
  ((VehicleEditorUI*)(o->parent()->user_data()))->cb_setRearAxel_i(o,v);
}

void VehicleEditorUI::cb_setWheelInset_i(Fl_Button*, void*) {
  spriteView->setSetting(kFrontWheelInset);
spriteView->setSettingInput(frontWheelInsetInput);
spriteView->redraw();
}
void VehicleEditorUI::cb_setWheelInset(Fl_Button* o, void* v) {
  ((VehicleEditorUI*)(o->parent()->user_data()))->cb_setWheelInset_i(o,v);
}

void VehicleEditorUI::cb_setFrontWheelRadius_i(Fl_Button*, void*) {
  spriteView->setSetting(kFrontWheelRadius);
spriteView->setSettingInput(frontWheelRadiusInput);
spriteView->redraw();
}
void VehicleEditorUI::cb_setFrontWheelRadius(Fl_Button* o, void* v) {
  ((VehicleEditorUI*)(o->parent()->user_data()))->cb_setFrontWheelRadius_i(o,v);
}

void VehicleEditorUI::cb_setRearWheelRadius_i(Fl_Button*, void*) {
  spriteView->setSetting(kRearWheelRadius);
spriteView->setSettingInput(rearWheelRadiusInput);
spriteView->redraw();
}
void VehicleEditorUI::cb_setRearWheelRadius(Fl_Button* o, void* v) {
  ((VehicleEditorUI*)(o->parent()->user_data()))->cb_setRearWheelRadius_i(o,v);
}

void VehicleEditorUI::cb_wheelLayer_i(Fl_Check_Button* o, void*) {
  vehicleObj.setWheelAboveSprite(o->value());
spriteView->redraw();
}
void VehicleEditorUI::cb_wheelLayer(Fl_Check_Button* o, void* v) {
  ((VehicleEditorUI*)(o->parent()->user_data()))->cb_wheelLayer_i(o,v);
}

void VehicleEditorUI::cb_convexChoice_i(Fl_Choice* o, void*) {
  spriteView->setConvexChoice(o->value());
}
void VehicleEditorUI::cb_convexChoice(Fl_Choice* o, void* v) {
  ((VehicleEditorUI*)(o->parent()->user_data()))->cb_convexChoice_i(o,v);
}

void VehicleEditorUI::cb_scaleRoller_i(Fl_Roller* o, void*) {
  spriteView->setScale(o->value());
spriteView->redraw();
}
void VehicleEditorUI::cb_scaleRoller(Fl_Roller* o, void* v) {
  ((VehicleEditorUI*)(o->parent()->user_data()))->cb_scaleRoller_i(o,v);
}

void VehicleEditorUI::cb_axelWidthInput_i(Fl_Value_Input* o, void*) {
  vehicleObj.setAxelWidth(o->value());
spriteView->redraw();
}
void VehicleEditorUI::cb_axelWidthInput(Fl_Value_Input* o, void* v) {
  ((VehicleEditorUI*)(o->parent()->user_data()))->cb_axelWidthInput_i(o,v);
}

void VehicleEditorUI::cb_frontAxelInput_i(Fl_Value_Input* o, void*) {
  vehicleObj.setFrontAxel(o->value());
spriteView->redraw();
}
void VehicleEditorUI::cb_frontAxelInput(Fl_Value_Input* o, void* v) {
  ((VehicleEditorUI*)(o->parent()->user_data()))->cb_frontAxelInput_i(o,v);
}

void VehicleEditorUI::cb_rearAxelInput_i(Fl_Value_Input* o, void*) {
  vehicleObj.setRearAxel(o->value());
spriteView->redraw();
}
void VehicleEditorUI::cb_rearAxelInput(Fl_Value_Input* o, void* v) {
  ((VehicleEditorUI*)(o->parent()->user_data()))->cb_rearAxelInput_i(o,v);
}

void VehicleEditorUI::cb_frontWheelInsetInput_i(Fl_Value_Input* o, void*) {
  vehicleObj.setFrontWheelInset(o->value());
spriteView->redraw();
}
void VehicleEditorUI::cb_frontWheelInsetInput(Fl_Value_Input* o, void* v) {
  ((VehicleEditorUI*)(o->parent()->user_data()))->cb_frontWheelInsetInput_i(o,v);
}

void VehicleEditorUI::cb_frontWheelRadiusInput_i(Fl_Value_Input* o, void*) {
  vehicleObj.setFrontWheelRadius(o->value());
spriteView->redraw();
}
void VehicleEditorUI::cb_frontWheelRadiusInput(Fl_Value_Input* o, void* v) {
  ((VehicleEditorUI*)(o->parent()->user_data()))->cb_frontWheelRadiusInput_i(o,v);
}

void VehicleEditorUI::cb_rearWheelRadiusInput_i(Fl_Value_Input* o, void*) {
  vehicleObj.setRearWheelRadius(o->value());
spriteView->redraw();
}
void VehicleEditorUI::cb_rearWheelRadiusInput(Fl_Value_Input* o, void* v) {
  ((VehicleEditorUI*)(o->parent()->user_data()))->cb_rearWheelRadiusInput_i(o,v);
}

void VehicleEditorUI::cb_ok_i(Fl_Return_Button*, void*) {
  vehicleObj.setMass(mass->value());
vehicleObj.setInertia(inertia->value());
vehicleObj.setDrag(drag->value());
vehicleObj.setRollingResistance(rollingResistance->value());
vehicleObj.setFrontWheelInertia(frontWheelInertia->value());
vehicleObj.setRearWheelInertia(rearWheelInertia->value());
propertiesWindow->hide();
}
void VehicleEditorUI::cb_ok(Fl_Return_Button* o, void* v) {
  ((VehicleEditorUI*)(o->parent()->user_data()))->cb_ok_i(o,v);
}

void VehicleEditorUI::cb_cancel_i(Fl_Button*, void*) {
  propertiesWindow->hide();
}
void VehicleEditorUI::cb_cancel(Fl_Button* o, void* v) {
  ((VehicleEditorUI*)(o->parent()->user_data()))->cb_cancel_i(o,v);
}

void VehicleEditorUI::cb_frontSlipRatio_i(Fl_Menu_*, void*) {
  curveView->setConsts(vehicleObj.getFrontSlipRatioPacejka());
updateTireCurvesUI();
curveView->redraw();
}
void VehicleEditorUI::cb_frontSlipRatio(Fl_Menu_* o, void* v) {
  ((VehicleEditorUI*)(o->parent()->user_data()))->cb_frontSlipRatio_i(o,v);
}

void VehicleEditorUI::cb_frontSlipAngle_i(Fl_Menu_*, void*) {
  curveView->setConsts(vehicleObj.getFrontSlipAnglePacejka());
updateTireCurvesUI();
curveView->redraw();
}
void VehicleEditorUI::cb_frontSlipAngle(Fl_Menu_* o, void* v) {
  ((VehicleEditorUI*)(o->parent()->user_data()))->cb_frontSlipAngle_i(o,v);
}

void VehicleEditorUI::cb_rearSlipRatio_i(Fl_Menu_*, void*) {
  curveView->setConsts(vehicleObj.getRearSlipRatioPacejka());
updateTireCurvesUI();
curveView->redraw();
}
void VehicleEditorUI::cb_rearSlipRatio(Fl_Menu_* o, void* v) {
  ((VehicleEditorUI*)(o->parent()->user_data()))->cb_rearSlipRatio_i(o,v);
}

void VehicleEditorUI::cb_rearSlipAngle_i(Fl_Menu_*, void*) {
  curveView->setConsts(vehicleObj.getRearSlipAnglePacejka());
updateTireCurvesUI();
curveView->redraw();
}
void VehicleEditorUI::cb_rearSlipAngle(Fl_Menu_* o, void* v) {
  ((VehicleEditorUI*)(o->parent()->user_data()))->cb_rearSlipAngle_i(o,v);
}

Fl_Menu_Item VehicleEditorUI::menu_curveSelect[] = {
 {"Front Slip Ratio", 0,  (Fl_Callback*)VehicleEditorUI::cb_frontSlipRatio, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {"Front Slip Angle", 0,  (Fl_Callback*)VehicleEditorUI::cb_frontSlipAngle, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {"Rear Slip Ratio", 0,  (Fl_Callback*)VehicleEditorUI::cb_rearSlipRatio, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {"Rear Slip Angle", 0,  (Fl_Callback*)VehicleEditorUI::cb_rearSlipAngle, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {0,0,0,0,0,0,0,0,0}
};
Fl_Menu_Item* VehicleEditorUI::frontSlipRatio = VehicleEditorUI::menu_curveSelect + 0;
Fl_Menu_Item* VehicleEditorUI::frontSlipAngle = VehicleEditorUI::menu_curveSelect + 1;
Fl_Menu_Item* VehicleEditorUI::rearSlipRatio = VehicleEditorUI::menu_curveSelect + 2;
Fl_Menu_Item* VehicleEditorUI::rearSlipAngle = VehicleEditorUI::menu_curveSelect + 3;

void VehicleEditorUI::cb_aValue_i(Fl_Counter* o, void*) {
  getPacejkaConsts(curveSelect->value())[0] = o->value();
curveView->redraw();
}
void VehicleEditorUI::cb_aValue(Fl_Counter* o, void* v) {
  ((VehicleEditorUI*)(o->parent()->user_data()))->cb_aValue_i(o,v);
}

void VehicleEditorUI::cb_bValue_i(Fl_Counter* o, void*) {
  getPacejkaConsts(curveSelect->value())[1] = o->value();
curveView->redraw();
}
void VehicleEditorUI::cb_bValue(Fl_Counter* o, void* v) {
  ((VehicleEditorUI*)(o->parent()->user_data()))->cb_bValue_i(o,v);
}

void VehicleEditorUI::cb_cValue_i(Fl_Counter* o, void*) {
  getPacejkaConsts(curveSelect->value())[2] = o->value();
curveView->redraw();
}
void VehicleEditorUI::cb_cValue(Fl_Counter* o, void* v) {
  ((VehicleEditorUI*)(o->parent()->user_data()))->cb_cValue_i(o,v);
}

void VehicleEditorUI::cb_dValue_i(Fl_Counter* o, void*) {
  getPacejkaConsts(curveSelect->value())[3] = o->value();
curveView->redraw();
}
void VehicleEditorUI::cb_dValue(Fl_Counter* o, void* v) {
  ((VehicleEditorUI*)(o->parent()->user_data()))->cb_dValue_i(o,v);
}

void VehicleEditorUI::cb_resetCurveView_i(Fl_Button*, void*) {
  curveView->reset();
curveView->redraw();
}
void VehicleEditorUI::cb_resetCurveView(Fl_Button* o, void* v) {
  ((VehicleEditorUI*)(o->parent()->user_data()))->cb_resetCurveView_i(o,v);
}

VehicleEditorUI::VehicleEditorUI() {
  { mainWindow = new Fl_Double_Window(642, 420);
    mainWindow->user_data((void*)(this));
    { mainMenuBar = new Fl_Menu_Bar(0, 0, 645, 20);
      mainMenuBar->menu(menu_mainMenuBar);
    } // Fl_Menu_Bar* mainMenuBar
    { rotationRoller = new Fl_Roller(425, 295, 25, 95, "Rotation");
      rotationRoller->callback((Fl_Callback*)cb_rotationRoller);
    } // Fl_Roller* rotationRoller
    { steerAngleRoller = new Fl_Roller(500, 295, 25, 95, "Steer Angle");
      steerAngleRoller->minimum(-0.5);
      steerAngleRoller->maximum(0.5);
      steerAngleRoller->callback((Fl_Callback*)cb_steerAngleRoller);
    } // Fl_Roller* steerAngleRoller
    { geometryBtn = new Fl_Button(415, 25, 90, 25, "Geometry");
      geometryBtn->type(102);
      geometryBtn->callback((Fl_Callback*)cb_geometryBtn);
    } // Fl_Button* geometryBtn
    { setAxelWidth = new Fl_Button(415, 55, 100, 25, "Axel Width");
      setAxelWidth->type(102);
      setAxelWidth->callback((Fl_Callback*)cb_setAxelWidth);
    } // Fl_Button* setAxelWidth
    { setFrontAxel = new Fl_Button(415, 85, 100, 25, "Front Axel");
      setFrontAxel->type(102);
      setFrontAxel->callback((Fl_Callback*)cb_setFrontAxel);
    } // Fl_Button* setFrontAxel
    { setRearAxel = new Fl_Button(415, 115, 100, 25, "Rear Axel");
      setRearAxel->type(102);
      setRearAxel->callback((Fl_Callback*)cb_setRearAxel);
    } // Fl_Button* setRearAxel
    { setWheelInset = new Fl_Button(415, 145, 120, 25, "Front Wheel Inset");
      setWheelInset->type(102);
      setWheelInset->callback((Fl_Callback*)cb_setWheelInset);
    } // Fl_Button* setWheelInset
    { setFrontWheelRadius = new Fl_Button(415, 175, 135, 25, "Front Wheel Radius");
      setFrontWheelRadius->type(102);
      setFrontWheelRadius->callback((Fl_Callback*)cb_setFrontWheelRadius);
    } // Fl_Button* setFrontWheelRadius
    { setRearWheelRadius = new Fl_Button(415, 205, 135, 25, "Rear Wheel Radius");
      setRearWheelRadius->type(102);
      setRearWheelRadius->callback((Fl_Callback*)cb_setRearWheelRadius);
    } // Fl_Button* setRearWheelRadius
    { wheelLayer = new Fl_Check_Button(415, 235, 145, 25, "Wheel Layer Above");
      wheelLayer->down_box(FL_DOWN_BOX);
      wheelLayer->callback((Fl_Callback*)cb_wheelLayer);
    } // Fl_Check_Button* wheelLayer
    { convexChoice = new Fl_Choice(520, 25, 80, 25);
      convexChoice->down_box(FL_BORDER_BOX);
      convexChoice->callback((Fl_Callback*)cb_convexChoice);
    } // Fl_Choice* convexChoice
    { spriteView = new SpriteView(5, 25, 395, 390, "This is the sprite_view");
      spriteView->box(FL_UP_BOX);
      spriteView->color(FL_BACKGROUND_COLOR);
      spriteView->selection_color(FL_BACKGROUND_COLOR);
      spriteView->labeltype(FL_NORMAL_LABEL);
      spriteView->labelfont(0);
      spriteView->labelsize(14);
      spriteView->labelcolor(FL_FOREGROUND_COLOR);
      spriteView->align(FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
      spriteView->when(FL_WHEN_RELEASE);
      Fl_Group::current()->resizable(spriteView);
    } // SpriteView* spriteView
    { scaleRoller = new Fl_Roller(575, 295, 25, 95, "Scale");
      scaleRoller->minimum(1);
      scaleRoller->maximum(8);
      scaleRoller->step(0.005);
      scaleRoller->value(2);
      scaleRoller->callback((Fl_Callback*)cb_scaleRoller);
    } // Fl_Roller* scaleRoller
    { axelWidthInput = new Fl_Value_Input(520, 55, 110, 25);
      axelWidthInput->maximum(200);
      axelWidthInput->step(0.01);
      axelWidthInput->callback((Fl_Callback*)cb_axelWidthInput);
    } // Fl_Value_Input* axelWidthInput
    { frontAxelInput = new Fl_Value_Input(520, 85, 110, 25);
      frontAxelInput->maximum(200);
      frontAxelInput->step(0.01);
      frontAxelInput->callback((Fl_Callback*)cb_frontAxelInput);
    } // Fl_Value_Input* frontAxelInput
    { rearAxelInput = new Fl_Value_Input(520, 115, 110, 25);
      rearAxelInput->maximum(200);
      rearAxelInput->step(0.01);
      rearAxelInput->callback((Fl_Callback*)cb_rearAxelInput);
    } // Fl_Value_Input* rearAxelInput
    { frontWheelInsetInput = new Fl_Value_Input(540, 145, 90, 25);
      frontWheelInsetInput->maximum(200);
      frontWheelInsetInput->step(0.01);
      frontWheelInsetInput->callback((Fl_Callback*)cb_frontWheelInsetInput);
    } // Fl_Value_Input* frontWheelInsetInput
    { frontWheelRadiusInput = new Fl_Value_Input(555, 175, 75, 25);
      frontWheelRadiusInput->maximum(200);
      frontWheelRadiusInput->step(0.01);
      frontWheelRadiusInput->callback((Fl_Callback*)cb_frontWheelRadiusInput);
    } // Fl_Value_Input* frontWheelRadiusInput
    { rearWheelRadiusInput = new Fl_Value_Input(555, 205, 75, 25);
      rearWheelRadiusInput->maximum(200);
      rearWheelRadiusInput->step(0.01);
      rearWheelRadiusInput->callback((Fl_Callback*)cb_rearWheelRadiusInput);
    } // Fl_Value_Input* rearWheelRadiusInput
    mainWindow->end();
  } // Fl_Double_Window* mainWindow
  { loadSpriteDialog = new Fl_Double_Window(250, 100, "Enter Frame Dimensions");
    loadSpriteDialog->user_data((void*)(this));
    { widthInput = new Fl_Value_Input(55, 15, 65, 25, "Width");
      widthInput->minimum(20);
      widthInput->maximum(400);
      widthInput->step(1);
      widthInput->value(80);
    } // Fl_Value_Input* widthInput
    { heightInput = new Fl_Value_Input(55, 55, 65, 25, "Height");
      heightInput->minimum(20);
      heightInput->maximum(400);
      heightInput->step(1);
      heightInput->value(80);
    } // Fl_Value_Input* heightInput
    { okButton = new Fl_Return_Button(150, 55, 80, 25, "OK");
    } // Fl_Return_Button* okButton
    { cancelButton = new Fl_Button(150, 15, 80, 25, "Cancel");
    } // Fl_Button* cancelButton
    loadSpriteDialog->set_modal();
    loadSpriteDialog->end();
  } // Fl_Double_Window* loadSpriteDialog
  { aboutBox = new Fl_Double_Window(250, 205, "About");
    aboutBox->user_data((void*)(this));
    { Fl_Text_Display* o = aboutDisplay = new Fl_Text_Display(25, 20, 200, 160);
      Fl_Text_Buffer *buf = new Fl_Text_Buffer(0);
      buf->append(kAboutBoxText);
      o->buffer(buf);
    } // Fl_Text_Display* aboutDisplay
    aboutBox->set_modal();
    aboutBox->end();
  } // Fl_Double_Window* aboutBox
  { helpWindow = new Fl_Double_Window(512, 384, "Help");
    helpWindow->user_data((void*)(this));
    { Fl_Text_Display* o = helpDisplay = new Fl_Text_Display(20, 20, 472, 344);
      helpDisplay->align(FL_ALIGN_WRAP|FL_ALIGN_INSIDE);
      Fl_Text_Buffer *buf = new Fl_Text_Buffer(0);
      buf->append(kHelpText);
      o->buffer(buf);
      o->wrap_mode(1,70);
    } // Fl_Text_Display* helpDisplay
    helpWindow->set_modal();
    helpWindow->end();
    helpWindow->resizable(helpWindow);
  } // Fl_Double_Window* helpWindow
  { propertiesWindow = new Fl_Double_Window(259, 270, "Properties");
    propertiesWindow->user_data((void*)(this));
    { mass = new Fl_Value_Input(140, 20, 45, 25, "Mass");
      mass->maximum(10000);
    } // Fl_Value_Input* mass
    { inertia = new Fl_Value_Input(140, 50, 45, 25, "Inertia");
      inertia->maximum(10000);
    } // Fl_Value_Input* inertia
    { drag = new Fl_Value_Input(140, 80, 45, 25, "Drag");
      drag->maximum(100);
    } // Fl_Value_Input* drag
    { rollingResistance = new Fl_Value_Input(140, 110, 45, 25, "Rolling Resistance");
      rollingResistance->maximum(100);
    } // Fl_Value_Input* rollingResistance
    { frontWheelInertia = new Fl_Value_Input(140, 140, 45, 25, "Front Wheel Inertia");
      frontWheelInertia->maximum(100);
    } // Fl_Value_Input* frontWheelInertia
    { rearWheelInertia = new Fl_Value_Input(140, 170, 45, 25, "Rear Wheel Inertia");
    } // Fl_Value_Input* rearWheelInertia
    { ok = new Fl_Return_Button(155, 225, 70, 25, "Ok");
      ok->callback((Fl_Callback*)cb_ok);
    } // Fl_Return_Button* ok
    { cancel = new Fl_Button(75, 225, 70, 25, "Cancel");
      cancel->callback((Fl_Callback*)cb_cancel);
    } // Fl_Button* cancel
    propertiesWindow->set_modal();
    propertiesWindow->end();
  } // Fl_Double_Window* propertiesWindow
  { tireCurvesWindow = new Fl_Double_Window(625, 400, "Tire Curves");
    tireCurvesWindow->user_data((void*)(this));
    { curveView = new CurveView(5, 5, 390, 390, "This is the curve_view");
      curveView->box(FL_NO_BOX);
      curveView->color(FL_BACKGROUND_COLOR);
      curveView->selection_color(FL_BACKGROUND_COLOR);
      curveView->labeltype(FL_NORMAL_LABEL);
      curveView->labelfont(0);
      curveView->labelsize(14);
      curveView->labelcolor(FL_FOREGROUND_COLOR);
      curveView->align(FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
      curveView->when(FL_WHEN_RELEASE);
      Fl_Group::current()->resizable(curveView);
    } // CurveView* curveView
    { curveSelect = new Fl_Choice(495, 25, 120, 25, "Curve Select");
      curveSelect->down_box(FL_BORDER_BOX);
      curveSelect->menu(menu_curveSelect);
    } // Fl_Choice* curveSelect
    { aValue = new Fl_Counter(475, 125, 105, 25, "A");
      aValue->minimum(-100);
      aValue->maximum(100);
      aValue->step(0.01);
      aValue->callback((Fl_Callback*)cb_aValue);
    } // Fl_Counter* aValue
    { bValue = new Fl_Counter(475, 170, 105, 25, "B");
      bValue->minimum(-100);
      bValue->maximum(100);
      bValue->step(0.01);
      bValue->callback((Fl_Callback*)cb_bValue);
    } // Fl_Counter* bValue
    { cValue = new Fl_Counter(475, 215, 105, 25, "C");
      cValue->minimum(-100);
      cValue->maximum(100);
      cValue->step(0.01);
      cValue->callback((Fl_Callback*)cb_cValue);
    } // Fl_Counter* cValue
    { dValue = new Fl_Counter(475, 260, 105, 25, "D");
      dValue->minimum(-100);
      dValue->maximum(100);
      dValue->step(0.01);
      dValue->callback((Fl_Callback*)cb_dValue);
    } // Fl_Counter* dValue
    { resetCurveView = new Fl_Button(485, 320, 85, 25, "Reset View");
      resetCurveView->callback((Fl_Callback*)cb_resetCurveView);
    } // Fl_Button* resetCurveView
    tireCurvesWindow->end();
  } // Fl_Double_Window* tireCurvesWindow
  changed = false;
  filename[0] = '\0';
  spriteView->setVehicleObject(&vehicleObj);
  curveView->setConsts(vehicleObj.getFrontSlipRatioPacejka());
  mainWindow->label("");
  updateVehicleEditorUI();
  setGlobalSearchDirs();
}

VehicleEditorUI::~VehicleEditorUI() {
  freeGlobalSearchDirs();
}

void VehicleEditorUI::show(int argc, char **argv) {
  mainWindow->show(argc, argv);
tireCurvesWindow->show();
mainWindow->show();
}

void VehicleEditorUI::setChanged(bool val) {
  changed = val;
}

int VehicleEditorUI::check_save() {
  if (!changed) return 1;

  int r = fl_choice("The current file has not been saved.\n"
                    "Would you like to save it now?",
                    "Cancel", "Save", "Discard");

  if (r == 1) {
    cb_save_i(0,0); // Save the file...
    return !changed;
  }

  return (r == 2) ? 1 : 0;
}

void VehicleEditorUI::updateVehicleEditorUI() {
  char str[256];

axelWidthInput->value(vehicleObj.getAxelWidth());
frontAxelInput->value(vehicleObj.getFrontAxel());
rearAxelInput->value(vehicleObj.getRearAxel());
frontWheelInsetInput->value(vehicleObj.getFrontWheelInset());
frontWheelRadiusInput->value(vehicleObj.getFrontWheelRadius());
rearWheelRadiusInput->value(vehicleObj.getRearWheelRadius());

wheelLayer->value(vehicleObj.getWheelsAboveSprite());
rotationRoller->value(spriteView->getRotation());
steerAngleRoller->value(spriteView->getSteerAngle());

mass->value(vehicleObj.getMass());
inertia->value(vehicleObj.getInertia());
drag->value(vehicleObj.getDrag());
rollingResistance->value(vehicleObj.getRollingResistance());
frontWheelInertia->value(vehicleObj.getFrontWheelInertia());
rearWheelInertia->value(vehicleObj.getRearWheelInertia());

int geomSize = vehicleObj.getGeometry()->size();
convexChoice->clear();
for (int i = 0; i < geomSize; i++) {
   sprintf(str, "%d", i);
   convexChoice->add(str);
}
if (geomSize > 0) {
   convexChoice->value(0);
}
else {
   convexChoice->value((Fl_Menu*)NULL);
   convexChoice->redraw();
}
}

void VehicleEditorUI::updateTireCurvesUI() {
  double *arr = getPacejkaConsts(curveSelect->value());
aValue->value(arr[0]);
bValue->value(arr[1]);
cValue->value(arr[2]);
dValue->value(arr[3]);
curveView->redraw();
}

double * VehicleEditorUI::getPacejkaConsts(int k) {
  switch (curveSelect->value()) {
   case 0:
      return vehicleObj.getFrontSlipRatioPacejka();
   case 1:
      return vehicleObj.getFrontSlipAnglePacejka();
   case 2:
      return vehicleObj.getRearSlipRatioPacejka();
   case 3:
      return vehicleObj.getRearSlipAnglePacejka();
}
return NULL;
}

bool VehicleEditorUI::doLoadSpriteDialog(int *w, int *h) {
  bool val;
   loadSpriteDialog->show();
   // deactivate Fl::grab(), because it is incompatible with Fl::readqueue()
   Fl_Window* g = Fl::grab();
   if (g) // do an alternative grab to avoid floating menus, if possible
      Fl::grab(loadSpriteDialog);
   for (;;) {
      Fl_Widget *o = Fl::readqueue();
      if (!o) Fl::wait();
      else if (o == cancelButton) {val = false; break;}
      else if (o == okButton) {val = true; break;}
      else if (o == loadSpriteDialog) {val = false; break;}
   }
   if (g) // regrab the previous popup menu, if there was one
      Fl::grab(g);
   //*w = atoi(widthInput->value());
   //*h = atoi(heightInput->value());
   *w = widthInput->value();
   *h = heightInput->value();
   loadSpriteDialog->hide();
   return val;
}
