// generated by Fast Light User Interface Designer (fluid) version 1.0109

#include "TrackEditorUI.h"
#include <FL/Fl_File_Chooser.H>
#include "ScException.h"
#include "TextConstants.h"

void TrackEditorUI::cb_newMap_i(Fl_Menu_*, void*) {
  if (!check_save()) return;
newTrackDialog->show();
}
void TrackEditorUI::cb_newMap(Fl_Menu_* o, void* v) {
  ((TrackEditorUI*)(o->parent()->user_data()))->cb_newMap_i(o,v);
}

void TrackEditorUI::cb_open_i(Fl_Menu_*, void*) {
  if (!check_save()) return;

  char *newfile = fl_file_chooser("Open File?", "*.xml", NULL);
  //printf("file: %s\n", newfile);
  if (newfile != NULL) {
     try { trackView->loadMap(newfile); }
     catch (ScException e) {
     	e.printMsg();
        fl_alert("Failed to open file %s\n", newfile);
        return;
     }
     strncpy(filename, newfile, 255);
     mainWindow->label(filename);
  };
}
void TrackEditorUI::cb_open(Fl_Menu_* o, void* v) {
  ((TrackEditorUI*)(o->parent()->user_data()))->cb_open_i(o,v);
}

void TrackEditorUI::cb_import_i(Fl_Menu_*, void*) {
  if (!check_save()) return;

  const char *newfile = fl_file_chooser("Import Image File?", "*.{jpg,png,bmp,pnm,pbm,pgm,ppm}", NULL);
  if (newfile != NULL) {
     trackView->resetImportImageDialog(newfile);
     importImageDialog->show();
   };
}
void TrackEditorUI::cb_import(Fl_Menu_* o, void* v) {
  ((TrackEditorUI*)(o->parent()->user_data()))->cb_import_i(o,v);
}

void TrackEditorUI::cb_save_i(Fl_Menu_*, void*) {
  if (filename[0] == '\0') {
  // No filename - get one!
  cb_saveAs_i(0,0);
  return;
 }
 else {
  try { trackView->saveMap(filename); }
  catch (ScException e) {
   e.printMsg();
   fl_alert("Failed to save file %s", filename);
  }
 };
}
void TrackEditorUI::cb_save(Fl_Menu_* o, void* v) {
  ((TrackEditorUI*)(o->parent()->user_data()))->cb_save_i(o,v);
}

void TrackEditorUI::cb_saveAs_i(Fl_Menu_*, void*) {
  char *newfile;

 newfile = fl_file_chooser("Save File As?", "*.xml", filename);
 if (newfile != NULL) {
  try { trackView->saveMap(newfile); }
  catch (ScException e) {
   e.printMsg();
   fl_alert("Failed to save file %s", newfile);
   return;
  }
  strncpy(filename, newfile, 255);
  mainWindow->label(filename);
 };
}
void TrackEditorUI::cb_saveAs(Fl_Menu_* o, void* v) {
  ((TrackEditorUI*)(o->parent()->user_data()))->cb_saveAs_i(o,v);
}

void TrackEditorUI::cb_install_i(Fl_Menu_*, void*) {
  if (filename[0] != '\0')
   trackView->installMap(filename);
else
   fl_alert("Save map first.");
}
void TrackEditorUI::cb_install(Fl_Menu_* o, void* v) {
  ((TrackEditorUI*)(o->parent()->user_data()))->cb_install_i(o,v);
}

void TrackEditorUI::cb_uninstall_i(Fl_Menu_*, void*) {
  if (filename[0] != '\0')
   trackView->uninstallMap(filename);
else
   fl_alert("Open map first.");
}
void TrackEditorUI::cb_uninstall(Fl_Menu_* o, void* v) {
  ((TrackEditorUI*)(o->parent()->user_data()))->cb_uninstall_i(o,v);
}

void TrackEditorUI::cb_quit_i(Fl_Menu_*, void*) {
  if (changed && !check_save())
 return;

 exit(0);
}
void TrackEditorUI::cb_quit(Fl_Menu_* o, void* v) {
  ((TrackEditorUI*)(o->parent()->user_data()))->cb_quit_i(o,v);
}

void TrackEditorUI::cb_draw_i(Fl_Menu_*, void*) {
  trackView->setTool(kDrawTool);
}
void TrackEditorUI::cb_draw(Fl_Menu_* o, void* v) {
  ((TrackEditorUI*)(o->parent()->user_data()))->cb_draw_i(o,v);
}

void TrackEditorUI::cb_path_i(Fl_Menu_*, void*) {
  trackView->setTool(kPathTool);
}
void TrackEditorUI::cb_path(Fl_Menu_* o, void* v) {
  ((TrackEditorUI*)(o->parent()->user_data()))->cb_path_i(o,v);
}

void TrackEditorUI::cb_startline_i(Fl_Menu_*, void*) {
  trackView->setTool(kStartlineTool);
}
void TrackEditorUI::cb_startline(Fl_Menu_* o, void* v) {
  ((TrackEditorUI*)(o->parent()->user_data()))->cb_startline_i(o,v);
}

void TrackEditorUI::cb_scroll_i(Fl_Menu_*, void*) {
  trackView->setTool(kScrollTool);
}
void TrackEditorUI::cb_scroll(Fl_Menu_* o, void* v) {
  ((TrackEditorUI*)(o->parent()->user_data()))->cb_scroll_i(o,v);
}

void TrackEditorUI::cb_roadSign_i(Fl_Menu_*, void*) {
  trackView->setTool(kRoadSignTool);
}
void TrackEditorUI::cb_roadSign(Fl_Menu_* o, void* v) {
  ((TrackEditorUI*)(o->parent()->user_data()))->cb_roadSign_i(o,v);
}

void TrackEditorUI::cb_easyLeft_i(Fl_Menu_*, void*) {
  trackView->setSign(kEasyLeft);
}
void TrackEditorUI::cb_easyLeft(Fl_Menu_* o, void* v) {
  ((TrackEditorUI*)(o->parent()->user_data()))->cb_easyLeft_i(o,v);
}

#include <FL/Fl_Image.H>
static unsigned char idata_EasyLeft[] =
{255,255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,0,0,0,1,0,0,0,2,0,
0,0,4,0,0,0,5,0,0,0,7,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,
0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,
8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,
0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,
0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,
0,0,0,7,0,0,0,5,0,0,0,4,0,0,0,2,0,0,0,1,255,255,255,0,255,255,255,0,255,255,
255,0,255,255,255,0,255,255,255,0,255,255,255,0,0,0,0,1,0,0,0,3,0,0,0,6,0,0,0,
10,0,0,0,14,0,0,0,18,0,0,0,21,0,0,0,23,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,
0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,
0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,
24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,
0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,
0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,23,0,0,0,21,0,0,0,18,0,0,0,
14,0,0,0,10,0,0,0,6,0,0,0,3,0,0,0,1,255,255,255,0,255,255,255,0,255,255,255,0,
0,0,0,1,0,0,0,3,0,0,0,8,230,230,230,100,247,247,247,201,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,241,241,241,206,194,194,194,118,0,0,0,39,0,0,0,33,0,
0,0,24,0,0,0,15,0,0,0,8,0,0,0,3,0,0,0,1,255,255,255,0,255,255,255,0,0,0,0,3,0,
0,0,8,225,225,225,102,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,171,171,171,134,0,0,0,
58,0,0,0,45,0,0,0,31,0,0,0,18,0,0,0,8,0,0,0,3,255,255,255,0,0,0,0,1,0,0,0,6,0,
0,0,15,246,246,246,202,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,229,229,229,217,0,0,
0,84,0,0,0,69,0,0,0,50,0,0,0,31,0,0,0,15,0,0,0,6,0,0,0,1,0,0,0,2,0,0,0,10,0,0,
0,24,255,255,255,255,255,255,255,255,255,255,255,255,79,44,44,255,105,88,46,
255,114,93,49,255,101,85,50,255,97,83,51,255,97,84,52,255,97,85,52,255,97,85,52,
255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,
255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,
255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,
255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,
255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,
255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,97,84,51,255,95,80,48,
255,96,80,43,255,109,87,34,255,95,75,22,255,44,44,9,255,255,255,255,255,255,255,
255,255,255,255,255,255,0,0,0,105,0,0,0,90,0,0,0,69,0,0,0,45,0,0,0,24,0,0,0,10,
0,0,0,2,0,0,0,4,0,0,0,14,0,0,0,33,255,255,255,255,255,255,255,255,255,255,255,
255,103,85,39,255,73,63,42,255,83,71,45,255,116,98,47,255,128,106,49,255,128,
106,50,255,128,107,50,255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,
51,255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,51,
255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,51,255,
129,108,51,255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,51,255,129,
108,51,255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,
51,255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,51,
255,129,108,51,255,129,108,51,255,129,108,51,255,129,107,50,255,128,106,49,255,
126,105,47,255,122,100,42,255,100,82,34,255,58,46,22,255,47,31,9,255,105,70,0,
255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,118,0,0,0,105,0,0,0,
84,0,0,0,58,0,0,0,33,0,0,0,14,0,0,0,4,0,0,0,5,0,0,0,18,0,0,0,39,255,255,255,
255,255,255,255,255,255,255,255,255,109,89,35,255,77,64,37,255,188,150,40,255,
254,209,43,255,255,217,45,255,255,214,46,255,255,216,46,255,255,216,46,255,255,
216,46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,216,
46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,216,46,
255,255,216,46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,216,46,255,
255,216,46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,
216,46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,216,
46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,216,46,
255,255,216,46,255,255,215,43,255,255,215,40,255,255,213,32,255,249,195,22,255,
152,117,8,255,35,22,0,255,113,83,0,255,255,255,255,255,255,255,255,255,255,255,
255,255,0,0,0,124,0,0,0,113,0,0,0,94,0,0,0,68,0,0,0,39,0,0,0,18,0,0,0,5,0,0,0,7,
0,0,0,21,0,0,0,44,255,255,255,255,255,255,255,255,255,255,255,255,88,71,31,
255,107,88,34,255,253,201,36,255,255,220,37,255,255,214,38,255,255,212,38,255,
255,214,38,255,255,213,37,255,255,213,37,255,255,213,37,255,255,213,37,255,255,
213,37,255,255,213,37,255,255,213,37,255,255,213,37,255,255,213,37,255,255,213,
37,255,255,213,37,255,255,213,37,255,255,213,37,255,255,213,37,255,255,213,37,
255,255,213,37,255,255,213,37,255,255,213,37,255,255,213,37,255,255,213,37,255,
255,213,37,255,255,213,37,255,255,213,37,255,255,213,37,255,255,213,37,255,255,
213,37,255,255,213,37,255,255,213,37,255,255,213,37,255,255,213,37,255,255,213,
37,255,255,213,37,255,255,213,37,255,255,213,37,255,255,213,34,255,255,212,29,
255,255,213,20,255,255,215,7,255,231,175,0,255,55,39,0,255,70,51,0,255,255,255,
255,255,255,255,255,255,255,255,255,255,0,0,0,126,0,0,0,117,0,0,0,100,0,0,0,75,
0,0,0,44,0,0,0,21,0,0,0,7,0,0,0,8,0,0,0,23,0,0,0,46,255,255,255,255,255,255,
255,255,255,255,255,255,81,66,30,255,117,95,31,255,255,212,31,255,255,213,31,
255,254,207,31,255,254,206,29,255,255,208,28,255,255,208,27,255,255,207,26,255,
255,207,26,255,255,207,26,255,255,207,26,255,255,207,26,255,255,207,26,255,255,
207,26,255,255,207,26,255,255,207,26,255,255,207,26,255,255,207,26,255,255,207,
26,255,255,207,26,255,255,207,26,255,255,207,26,255,255,207,26,255,255,207,26,
255,255,207,26,255,255,207,26,255,255,207,26,255,255,207,26,255,255,207,26,255,
255,207,26,255,255,207,26,255,255,207,26,255,255,207,26,255,255,207,26,255,255,
207,26,255,255,207,26,255,255,207,26,255,255,207,26,255,255,207,26,255,255,207,
25,255,255,207,22,255,255,205,16,255,255,201,6,255,251,205,0,255,232,177,0,255,
60,44,0,255,57,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,
127,0,0,0,119,0,0,0,102,0,0,0,78,0,0,0,46,0,0,0,23,0,0,0,8,0,0,0,8,0,0,0,24,0,0,
0,47,255,255,255,255,255,255,255,255,255,255,255,255,79,65,28,255,115,95,29,
255,255,211,28,255,255,212,26,255,254,205,23,255,255,206,19,255,255,206,17,255,
255,205,15,255,255,205,15,255,255,205,15,255,255,205,15,255,255,205,15,255,255,
205,15,255,255,205,15,255,255,205,15,255,255,205,15,255,255,205,15,255,255,205,
15,255,255,205,15,255,255,205,15,255,255,205,15,255,255,205,15,255,255,205,15,
255,255,205,15,255,255,205,15,255,255,205,15,255,255,205,15,255,255,205,15,255,
255,205,15,255,255,205,15,255,255,205,15,255,255,205,15,255,255,205,15,255,255,
205,15,255,255,205,15,255,255,205,15,255,255,205,15,255,255,205,15,255,255,205,
15,255,255,205,15,255,255,205,13,255,255,204,10,255,255,203,4,255,251,199,0,
255,240,197,0,255,221,175,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,
255,255,255,255,255,255,0,0,0,127,0,0,0,119,0,0,0,103,0,0,0,79,0,0,0,47,0,0,0,
24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,
255,255,79,65,28,255,116,94,28,255,255,213,26,255,255,210,23,255,255,206,18,255,
255,205,13,255,255,204,10,255,255,203,7,255,255,203,6,255,255,203,6,255,255,203,
6,255,255,202,6,255,255,202,6,255,255,202,6,255,255,202,6,255,255,202,6,255,
255,202,6,255,255,202,6,255,255,202,6,255,255,202,6,255,255,202,6,255,255,202,6,
255,255,202,6,255,255,202,6,255,255,202,6,255,255,202,6,255,255,202,6,255,255,
203,6,255,255,203,6,255,255,203,6,255,255,203,6,255,255,203,6,255,255,203,6,255,
255,203,6,255,255,203,6,255,255,203,6,255,255,203,6,255,255,203,6,255,255,203,6,
255,255,203,6,255,255,203,5,255,255,202,1,255,251,199,0,255,243,192,0,255,233,
189,0,255,217,171,0,255,57,44,0,255,59,41,0,255,255,255,255,255,255,255,255,255,
255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,
8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,
80,65,28,255,115,94,28,255,255,213,25,255,255,210,21,255,255,205,15,255,255,
204,9,255,255,203,5,255,255,202,2,255,255,202,1,255,255,202,1,255,255,204,1,255,
255,206,1,255,255,209,1,255,255,209,1,255,255,209,1,255,255,209,1,255,255,209,1,
255,255,210,1,255,255,210,1,255,255,210,1,255,255,210,1,255,255,210,1,255,255,
210,1,255,255,210,1,255,255,210,1,255,255,208,1,255,255,206,1,255,255,204,1,255,
255,202,1,255,255,202,1,255,255,202,1,255,255,202,1,255,255,202,1,255,255,202,1,
255,255,202,1,255,255,202,1,255,255,202,1,255,255,202,1,255,255,202,1,255,255,
202,1,255,255,202,0,255,253,200,0,255,247,196,0,255,239,189,0,255,230,189,0,255,
214,169,0,255,57,43,0,255,59,41,0,255,255,255,255,255,255,255,255,255,255,255,
255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,
8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,80,65,28,
255,115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,255,
255,203,3,255,255,202,1,255,255,202,0,255,255,204,0,255,255,210,0,255,253,201,0,
255,255,203,0,255,255,209,0,255,255,207,0,255,255,207,0,255,255,208,0,255,255,
207,0,255,255,207,0,255,255,207,0,255,255,207,0,255,255,207,0,255,255,207,0,255,
255,207,0,255,255,206,0,255,255,202,0,255,255,208,0,255,255,208,0,255,255,201,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
254,201,0,255,251,199,0,255,245,194,0,255,238,189,0,255,230,189,0,255,217,165,0,
255,57,43,0,255,59,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,
0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,
0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,80,65,28,255,115,94,
28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,
255,255,202,1,255,255,202,0,255,255,206,0,255,247,197,0,255,90,86,0,255,22,31,0,
255,30,36,0,255,32,36,0,255,26,34,0,255,30,35,0,255,21,25,0,255,19,27,0,255,23,
33,0,255,19,24,0,255,20,24,0,255,19,24,0,255,23,32,0,255,22,33,0,255,33,38,0,
255,134,117,0,255,255,206,0,255,255,204,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,
255,238,189,0,255,230,189,0,255,216,165,0,255,57,43,0,255,58,41,0,255,255,255,
255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,
0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,
255,255,255,255,255,255,80,65,28,255,115,94,28,255,255,213,25,255,255,210,20,
255,255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,
206,0,255,255,198,0,255,109,78,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,
0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,
0,0,0,255,0,0,0,255,60,43,0,255,247,195,0,255,255,205,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,254,201,0,255,251,199,0,
255,245,194,0,255,238,189,0,255,230,189,0,255,217,165,0,255,57,43,0,255,58,41,0,
255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,
104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,
255,255,255,255,255,255,255,255,255,80,65,28,255,115,94,28,255,255,213,25,255,
255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,255,202,
0,255,255,204,0,255,255,216,0,255,239,186,0,255,17,8,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,15,9,0,255,168,122,0,255,255,208,0,255,255,204,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,254,
201,0,255,251,199,0,255,245,194,0,255,238,189,0,255,230,189,0,255,214,169,0,255,
57,43,0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,
128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,
0,48,255,255,255,255,255,255,255,255,255,255,255,255,80,65,28,255,115,94,28,
255,255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,255,
255,202,1,255,255,202,0,255,255,201,0,255,255,206,0,255,255,208,0,255,113,84,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,32,20,0,255,191,143,0,255,255,209,0,255,255,
209,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,189,0,255,230,
189,0,255,217,165,0,255,57,43,0,255,58,41,0,255,255,255,255,255,255,255,255,255,
255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,
8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,
80,65,28,255,115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,
204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,202,0,255,255,203,0,255,
255,218,0,255,242,190,0,255,19,16,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,
0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,5,3,0,255,119,85,0,255,255,
207,0,255,255,226,0,255,255,207,0,255,255,201,0,255,255,201,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,254,201,0,255,251,199,0,255,245,
194,0,255,238,189,0,255,230,189,0,255,215,165,0,255,57,43,0,255,58,41,0,255,255,
255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,
80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,
255,255,255,255,255,255,80,65,28,255,115,94,28,255,255,213,25,255,255,210,20,
255,255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,
202,0,255,255,201,0,255,255,206,0,255,255,207,0,255,114,84,0,255,0,0,0,255,0,0,
0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,
0,0,255,6,5,0,255,103,94,0,255,241,194,0,255,255,214,0,255,255,212,0,255,255,
202,0,255,255,201,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,254,201,0,
255,251,199,0,255,245,194,0,255,238,189,0,255,230,189,0,255,218,165,0,255,57,43,
0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,
0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,
48,255,255,255,255,255,255,255,255,255,255,255,255,80,65,28,255,115,94,28,255,
255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,255,255,
202,1,255,255,202,0,255,255,202,0,255,255,202,0,255,255,203,0,255,255,218,0,255,
241,188,0,255,20,16,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,
0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,41,39,0,255,163,141,0,
255,250,199,0,255,255,218,0,255,255,206,0,255,255,203,0,255,255,201,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,189,0,255,230,189,0,
255,215,165,0,255,57,43,0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,
255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,
0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,80,65,
28,255,115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,
255,255,203,3,255,255,202,1,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
201,0,255,255,206,0,255,255,208,0,255,122,89,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,2,0,255,82,71,0,255,235,187,0,255,255,215,0,255,255,210,0,255,
255,202,0,255,255,201,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,
189,0,255,230,189,0,255,214,169,0,255,57,43,0,255,58,41,0,255,255,255,255,255,
255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,
0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,
255,255,255,255,80,65,28,255,115,94,28,255,255,213,25,255,255,210,20,255,255,
205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,203,0,255,255,216,0,255,244,191,0,255,24,14,
0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,
0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,27,20,0,255,159,135,
0,255,255,207,0,255,255,211,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,254,201,0,255,251,199,0,
255,245,194,0,255,238,189,0,255,230,189,0,255,217,165,0,255,57,43,0,255,58,41,0,
255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,
104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,
255,255,255,255,255,255,255,255,255,80,65,28,255,115,94,28,255,255,213,25,255,
255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,255,202,
0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,201,0,255,255,206,0,255,
255,207,0,255,117,85,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,
0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,
0,0,0,255,10,10,0,255,141,121,0,255,255,207,0,255,255,210,0,255,255,200,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,254,201,0,
255,251,199,0,255,245,194,0,255,238,189,0,255,230,189,0,255,214,169,0,255,57,43,
0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,
0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,
48,255,255,255,255,255,255,255,255,255,255,255,255,80,65,28,255,115,94,28,255,
255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,255,255,
202,1,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,203,0,255,255,218,0,255,241,190,0,255,13,7,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,31,21,0,255,41,29,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,
0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,9,12,0,255,159,135,0,255,255,215,0,255,
255,206,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,254,201,0,255,251,199,0,255,245,194,0,255,238,188,0,255,230,187,0,255,214,
169,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,
255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,
0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,80,65,28,255,
115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,
203,3,255,255,202,1,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,201,0,255,255,208,0,255,255,204,0,255,92,64,0,255,0,0,0,255,0,
0,0,255,0,0,0,255,178,132,0,255,254,198,0,255,162,118,0,255,32,20,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,22,18,
0,255,232,183,0,255,255,217,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,188,0,
255,230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,
255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,
24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,
255,255,80,65,28,255,115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,
255,204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,201,0,255,255,203,0,255,255,217,0,255,239,
186,0,255,9,10,0,255,0,0,0,255,0,0,0,255,252,200,0,255,255,228,0,255,255,212,0,
255,237,186,0,255,96,67,0,255,3,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,
0,0,0,255,0,0,0,255,0,0,0,255,69,64,0,255,250,200,0,255,255,210,0,255,255,200,
0,255,255,202,0,255,255,202,0,255,255,202,0,255,254,201,0,255,251,199,0,255,
245,194,0,255,238,188,0,255,230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,255,
255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,
0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,
255,255,255,255,255,255,255,255,80,65,28,255,115,94,28,255,255,213,25,255,255,
210,20,255,255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
201,0,255,255,208,0,255,255,206,0,255,99,74,0,255,0,0,0,255,61,40,0,255,255,201,
0,255,255,209,0,255,255,207,0,255,255,219,0,255,251,195,0,255,156,115,0,255,
32,23,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,1,0,
255,179,154,0,255,255,215,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,188,0,255,230,189,0,255,
214,170,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,
255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,
8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,80,65,28,
255,115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,255,
255,203,3,255,255,202,1,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,201,0,255,255,203,0,255,255,214,0,255,248,
195,0,255,188,141,0,255,243,191,0,255,255,215,0,255,255,202,0,255,255,203,0,255,
255,204,0,255,255,210,0,255,255,213,0,255,234,184,0,255,38,25,0,255,0,0,0,255,0,
0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,62,50,0,255,255,205,0,255,255,
208,0,255,255,201,0,255,255,202,0,255,255,202,0,255,254,201,0,255,251,199,0,255,
245,194,0,255,238,188,0,255,230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,255,
255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,
0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,
255,255,255,255,255,255,255,255,80,65,28,255,115,94,28,255,255,213,25,255,255,
210,20,255,255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,201,0,255,255,203,0,255,255,208,0,255,254,199,0,255,255,210,0,255,
255,205,0,255,254,200,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,208,0,
255,255,215,0,255,176,128,0,255,7,3,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,6,4,0,255,247,193,0,255,255,216,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,188,0,255,230,189,0,
255,214,170,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,
255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,
0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,80,65,
28,255,115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,
255,255,203,3,255,255,202,1,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
254,201,0,255,255,201,0,255,254,201,0,255,254,200,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,201,0,255,255,203,0,255,255,212,0,255,255,198,0,255,103,
76,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,152,116,0,
255,255,207,0,255,255,204,0,255,255,202,0,255,255,202,0,255,254,201,0,255,251,
199,0,255,245,194,0,255,238,188,0,255,230,189,0,255,214,170,0,255,57,42,0,255,
58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,
120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,
255,255,255,255,255,255,255,255,255,255,255,80,65,28,255,115,94,28,255,255,213,
25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,201,0,255,255,202,0,255,255,218,0,255,243,192,0,255,14,10,0,255,0,0,0,255,0,
0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,68,61,0,255,255,206,0,255,255,206,0,255,
255,201,0,255,255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,188,0,
255,230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,
255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,
24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,
255,255,80,65,28,255,115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,
255,204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,201,0,255,255,210,0,
255,255,210,0,255,57,44,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,
20,15,0,255,255,206,0,255,255,208,0,255,255,201,0,255,255,202,0,255,254,201,0,
255,251,199,0,255,245,194,0,255,238,188,0,255,230,189,0,255,214,170,0,255,57,42,
0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,
0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,
48,255,255,255,255,255,255,255,255,255,255,255,255,80,65,28,255,115,94,28,255,
255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,255,255,
202,1,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,201,0,255,255,207,0,255,255,210,0,255,115,84,0,255,
0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,4,1,0,255,255,206,0,255,255,
210,0,255,255,201,0,255,255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,
238,188,0,255,230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,255,255,255,255,
255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,
0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,
255,255,255,255,255,80,65,28,255,115,94,28,255,255,213,25,255,255,210,20,255,
255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,202,
0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
201,0,255,255,206,0,255,255,212,0,255,147,110,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,2,1,0,255,255,208,0,255,255,210,0,255,255,201,0,255,255,
202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,188,0,255,230,189,0,255,
214,170,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,
255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,
8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,80,65,28,
255,115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,255,
255,203,3,255,255,202,1,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,206,0,255,255,209,0,
255,147,110,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,1,0,0,255,
255,208,0,255,255,210,0,255,255,201,0,255,255,202,0,255,254,201,0,255,251,199,0,
255,245,194,0,255,238,188,0,255,230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,
255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,
104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,
255,255,255,255,255,255,255,255,255,80,65,28,255,115,94,28,255,255,213,25,255,
255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,255,202,
0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,205,0,255,255,210,0,255,149,112,0,255,0,0,0,255,0,0,
0,255,0,0,0,255,0,0,0,255,0,0,0,255,2,1,0,255,255,208,0,255,255,210,0,255,255,
201,0,255,255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,188,0,255,
230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,255,
255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,
0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,
255,80,65,28,255,115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,
204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,205,0,255,
255,212,0,255,148,129,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,4,
1,0,255,255,208,0,255,255,210,0,255,255,201,0,255,255,202,0,255,254,201,0,255,
251,199,0,255,245,194,0,255,238,188,0,255,230,189,0,255,214,170,0,255,57,42,0,
255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,
120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,
255,255,255,255,255,255,255,255,255,255,255,80,65,28,255,115,94,28,255,255,213,
25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,205,0,255,255,212,0,255,149,129,0,255,0,0,0,255,
0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,255,207,0,255,255,210,0,255,
255,201,0,255,255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,188,0,
255,230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,
255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,
24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,
255,255,80,65,28,255,115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,
255,204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,205,0,
255,255,209,0,255,149,115,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,255,207,0,255,255,210,0,255,255,201,0,255,255,202,0,255,254,201,0,
255,251,199,0,255,245,194,0,255,238,188,0,255,230,189,0,255,214,170,0,255,57,42,
0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,
0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,
48,255,255,255,255,255,255,255,255,255,255,255,255,80,65,28,255,115,94,28,255,
255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,255,255,
202,1,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,206,0,255,255,210,0,255,149,113,0,255,
0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,255,207,0,255,255,
210,0,255,255,201,0,255,255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,
238,188,0,255,230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,255,255,255,255,
255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,
0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,
255,255,255,255,255,80,65,28,255,115,94,28,255,255,213,25,255,255,210,20,255,
255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,202,
0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,206,0,255,255,209,0,255,145,109,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,255,205,0,255,255,210,0,255,255,201,0,255,255,
202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,188,0,255,230,189,0,255,
214,170,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,
255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,
8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,80,65,28,
255,115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,255,
255,203,3,255,255,202,1,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,204,0,255,255,203,0,
255,148,112,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,6,5,0,255,
249,197,0,255,255,208,0,255,255,201,0,255,255,202,0,255,254,201,0,255,251,199,0,
255,245,194,0,255,238,188,0,255,230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,
255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,
104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,
255,255,255,255,255,255,255,255,255,80,65,28,255,115,94,28,255,255,213,25,255,
255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,255,202,
0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,203,0,255,255,210,0,255,250,195,0,255,163,120,0,255,
162,118,0,255,167,120,0,255,174,127,0,255,172,125,0,255,178,129,0,255,255,209,0,
255,255,204,0,255,255,201,0,255,255,202,0,255,254,201,0,255,251,199,0,255,245,
194,0,255,238,188,0,255,230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,255,255,
255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,
80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,
255,255,255,255,255,255,80,65,28,255,115,94,28,255,255,213,25,255,255,210,20,
255,255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,203,0,255,255,209,0,255,255,202,0,255,255,207,0,255,
255,209,0,255,255,210,0,255,255,209,0,255,255,202,0,255,255,208,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,
188,0,255,230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,255,255,255,255,255,
255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,
0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,
255,255,255,255,80,65,28,255,115,93,27,255,255,213,25,255,255,210,19,255,255,
205,13,255,255,203,6,255,255,202,1,255,254,201,0,255,254,201,0,255,254,201,0,
255,254,201,0,255,254,201,0,255,254,201,0,255,254,201,0,255,254,201,0,255,254,
201,0,255,254,201,0,255,254,201,0,255,254,201,0,255,254,201,0,255,254,201,0,255,
254,201,0,255,254,201,0,255,254,201,0,255,254,201,0,255,254,201,0,255,254,201,0,
255,254,201,0,255,254,201,0,255,254,200,0,255,254,201,0,255,254,203,0,255,254,
203,0,255,254,203,0,255,254,203,0,255,254,201,0,255,253,200,0,255,253,199,0,255,
254,201,0,255,254,201,0,255,253,200,0,255,249,197,0,255,244,193,0,255,237,187,0,
255,229,188,0,255,214,170,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,
255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,
24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,
255,255,80,65,28,255,114,92,26,255,255,212,22,255,255,209,16,255,255,204,9,255,
255,202,1,255,252,200,0,255,249,197,0,255,248,196,0,255,248,196,0,255,248,196,0,
255,248,196,0,255,248,196,0,255,248,196,0,255,248,196,0,255,248,196,0,255,248,
196,0,255,248,196,0,255,248,196,0,255,248,196,0,255,248,196,0,255,248,196,0,255,
248,196,0,255,248,196,0,255,248,196,0,255,248,196,0,255,248,196,0,255,248,196,0,
255,248,196,0,255,248,196,0,255,248,196,0,255,248,196,0,255,248,196,0,255,248,
196,0,255,248,196,0,255,248,196,0,255,248,196,0,255,248,196,0,255,248,196,0,255,
248,196,0,255,247,196,0,255,245,194,0,255,240,190,0,255,233,184,0,255,227,186,0,
255,213,169,0,255,57,42,0,255,58,40,0,255,255,255,255,255,255,255,255,255,255,
255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,
0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,79,65,
27,255,113,91,24,255,255,211,18,255,255,208,10,255,255,202,1,255,248,196,0,255,
243,192,0,255,240,190,0,255,239,189,0,255,239,189,0,255,239,189,0,255,239,189,0,
255,239,189,0,255,239,189,0,255,239,189,0,255,239,189,0,255,239,189,0,255,239,
189,0,255,239,189,0,255,239,189,0,255,239,189,0,255,239,189,0,255,239,189,0,255,
239,189,0,255,239,189,0,255,239,189,0,255,239,189,0,255,239,189,0,255,239,189,0,
255,239,189,0,255,239,189,0,255,239,189,0,255,239,189,0,255,239,189,0,255,239,
189,0,255,239,189,0,255,239,189,0,255,239,189,0,255,239,189,0,255,239,189,0,255,
238,189,0,255,236,187,0,255,233,185,0,255,228,180,0,255,224,184,0,255,211,167,0,
255,58,42,0,255,58,40,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,
0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,
0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,77,61,24,255,111,87,
19,255,255,210,10,255,255,208,0,255,244,192,0,255,236,186,0,255,230,181,0,255,
227,179,0,255,226,178,0,255,226,178,0,255,226,178,0,255,226,178,0,255,226,178,0,
255,226,178,0,255,226,178,0,255,226,178,0,255,226,178,0,255,226,178,0,255,226,
178,0,255,226,178,0,255,226,178,0,255,226,178,0,255,226,178,0,255,226,178,0,255,
226,178,0,255,226,178,0,255,226,178,0,255,226,178,0,255,226,178,0,255,226,178,0,
255,226,178,0,255,226,178,0,255,226,178,0,255,226,178,0,255,226,178,0,255,226,
178,0,255,226,178,0,255,226,178,0,255,226,178,0,255,226,178,0,255,225,177,0,255,
224,177,0,255,222,175,0,255,221,174,0,255,218,179,0,255,209,166,0,255,57,43,0,
255,57,40,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,
120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,
255,255,255,255,255,255,255,255,255,255,255,77,61,19,255,93,72,10,255,254,201,0,
255,242,202,0,255,230,188,0,255,221,179,0,255,216,175,0,255,213,173,0,255,212,
172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,
212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,
255,212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,212,
172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,
212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,
255,212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,212,
172,0,255,212,172,0,255,212,180,0,255,199,151,0,255,53,36,0,255,66,48,0,255,255,
255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,
80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,
255,255,255,255,255,255,86,65,10,255,45,29,0,255,171,128,0,255,227,175,0,255,
217,179,0,255,209,170,0,255,206,168,0,255,203,166,0,255,203,166,0,255,203,166,0,
255,203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,203,
166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,
203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,
255,203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,203,
166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,
203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,204,168,0,
255,206,162,0,255,131,100,0,255,32,20,0,255,98,70,0,255,255,255,255,255,255,255,
255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,
24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,
255,255,64,47,0,255,25,14,0,255,48,32,0,255,89,62,0,255,105,79,0,255,105,80,0,
255,105,80,0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,
255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,
255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,
255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,
255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,
255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,
255,105,79,0,255,103,78,0,255,79,58,0,255,37,26,0,255,32,19,0,255,83,60,0,255,
255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,
0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,
255,255,255,255,255,255,255,255,39,0,0,255,54,38,0,255,61,43,0,255,47,32,0,255,
41,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,
0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,
40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,
0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,
40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,
0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,
40,27,0,255,47,33,0,255,62,45,0,255,61,43,0,255,29,29,0,255,255,255,255,255,
255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,
0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,47,232,232,232,214,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,221,221,221,225,0,0,0,127,0,0,0,119,0,0,0,103,0,0,0,79,0,0,0,47,
0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,23,0,0,0,46,164,164,164,140,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,133,133,133,173,0,0,0,127,0,0,0,119,0,0,0,102,0,0,0,78,0,0,0,46,
0,0,0,23,0,0,0,8,0,0,0,7,0,0,0,21,0,0,0,44,0,0,0,75,148,148,148,155,223,223,
223,223,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,221,221,221,225,133,133,
133,173,0,0,0,127,0,0,0,126,0,0,0,117,0,0,0,100,0,0,0,75,0,0,0,44,0,0,0,21,0,0,
0,7,0,0,0,5,0,0,0,18,0,0,0,39,0,0,0,68,0,0,0,94,0,0,0,113,0,0,0,124,0,0,0,127,
0,0,0,127,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
127,0,0,0,127,0,0,0,124,0,0,0,113,0,0,0,94,0,0,0,68,0,0,0,39,0,0,0,18,0,0,0,5,0,
0,0,4,0,0,0,14,0,0,0,33,0,0,0,58,0,0,0,84,0,0,0,105,0,0,0,118,0,0,0,124,0,0,0,
126,0,0,0,127,0,0,0,127,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,127,0,0,0,127,0,0,0,126,0,0,0,
124,0,0,0,118,0,0,0,105,0,0,0,84,0,0,0,58,0,0,0,33,0,0,0,14,0,0,0,4,0,0,0,2,0,0,
0,10,0,0,0,24,0,0,0,45,0,0,0,69,0,0,0,90,0,0,0,105,0,0,0,113,0,0,0,117,0,0,0,
119,0,0,0,119,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,
120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,
120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,
120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,
120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,
120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,119,0,0,0,119,0,0,0,117,0,0,0,113,0,0,0,
105,0,0,0,90,0,0,0,69,0,0,0,45,0,0,0,24,0,0,0,10,0,0,0,2,0,0,0,1,0,0,0,6,0,0,0,
15,0,0,0,31,0,0,0,50,0,0,0,69,0,0,0,84,0,0,0,94,0,0,0,100,0,0,0,102,0,0,0,103,
0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,
104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,
104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,
104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,
104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,
104,0,0,0,104,0,0,0,104,0,0,0,103,0,0,0,102,0,0,0,100,0,0,0,94,0,0,0,84,0,0,0,
69,0,0,0,50,0,0,0,31,0,0,0,15,0,0,0,6,0,0,0,1,255,255,255,0,0,0,0,3,0,0,0,8,0,
0,0,18,0,0,0,31,0,0,0,45,0,0,0,58,0,0,0,68,0,0,0,75,0,0,0,78,0,0,0,79,0,0,0,
80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,
0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,
0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,
80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,
0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,79,0,0,0,78,
0,0,0,75,0,0,0,68,0,0,0,58,0,0,0,45,0,0,0,31,0,0,0,18,0,0,0,8,0,0,0,3,255,255,
255,0,255,255,255,0,0,0,0,1,0,0,0,3,0,0,0,8,0,0,0,15,0,0,0,24,0,0,0,33,0,0,0,39,
0,0,0,44,0,0,0,46,0,0,0,47,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,
48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,
0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,
0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,
48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,
0,48,0,0,0,48,0,0,0,47,0,0,0,46,0,0,0,44,0,0,0,39,0,0,0,33,0,0,0,24,0,0,0,15,
0,0,0,8,0,0,0,3,0,0,0,1,255,255,255,0,255,255,255,0,255,255,255,0,0,0,0,1,0,0,
0,3,0,0,0,6,0,0,0,10,0,0,0,14,0,0,0,18,0,0,0,21,0,0,0,23,0,0,0,24,0,0,0,24,0,
0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,
24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,
0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,
0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,
24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,23,0,0,
0,21,0,0,0,18,0,0,0,14,0,0,0,10,0,0,0,6,0,0,0,3,0,0,0,1,255,255,255,0,255,255,
255,0,255,255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,0,0,0,1,0,0,0,2,0,
0,0,4,0,0,0,5,0,0,0,7,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,
0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,
8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,
0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,
0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,
0,0,0,7,0,0,0,5,0,0,0,4,0,0,0,2,0,0,0,1,255,255,255,0,255,255,255,0,255,255,
255,0,255,255,255,0};
static Fl_RGB_Image image_EasyLeft(idata_EasyLeft, 64, 64, 4, 0);

void TrackEditorUI::cb_easyRight_i(Fl_Menu_*, void*) {
  trackView->setSign(kEasyRight);
}
void TrackEditorUI::cb_easyRight(Fl_Menu_* o, void* v) {
  ((TrackEditorUI*)(o->parent()->user_data()))->cb_easyRight_i(o,v);
}

static unsigned char idata_EasyRight[] =
{255,255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,0,0,0,1,0,0,0,2,0,
0,0,4,0,0,0,5,0,0,0,7,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,
0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,
8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,
0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,
0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,
0,0,0,7,0,0,0,5,0,0,0,4,0,0,0,2,0,0,0,1,255,255,255,0,255,255,255,0,255,255,
255,0,255,255,255,0,255,255,255,0,255,255,255,0,0,0,0,1,0,0,0,3,0,0,0,6,0,0,0,
10,0,0,0,14,0,0,0,18,0,0,0,21,0,0,0,23,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,
0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,
0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,
24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,
0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,
0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,23,0,0,0,21,0,0,0,18,0,0,0,
14,0,0,0,10,0,0,0,6,0,0,0,3,0,0,0,1,255,255,255,0,255,255,255,0,255,255,255,0,
0,0,0,1,0,0,0,3,0,0,0,8,230,230,230,100,247,247,247,201,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,241,241,241,206,194,194,194,118,0,0,0,39,0,0,0,33,0,
0,0,24,0,0,0,15,0,0,0,8,0,0,0,3,0,0,0,1,255,255,255,0,255,255,255,0,0,0,0,3,0,
0,0,8,225,225,225,102,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,171,171,171,134,0,0,0,
58,0,0,0,45,0,0,0,31,0,0,0,18,0,0,0,8,0,0,0,3,255,255,255,0,0,0,0,1,0,0,0,6,0,
0,0,15,246,246,246,202,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,229,229,229,217,0,0,
0,84,0,0,0,69,0,0,0,50,0,0,0,31,0,0,0,15,0,0,0,6,0,0,0,1,0,0,0,2,0,0,0,10,0,0,
0,24,255,255,255,255,255,255,255,255,255,255,255,255,74,74,44,255,105,88,46,
255,114,93,49,255,101,85,50,255,97,83,51,255,97,84,52,255,97,85,52,255,97,85,52,
255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,
255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,
255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,
255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,
255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,
255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,97,84,51,255,95,80,48,
255,96,80,43,255,109,87,34,255,95,75,22,255,44,44,9,255,255,255,255,255,255,255,
255,255,255,255,255,255,0,0,0,105,0,0,0,90,0,0,0,69,0,0,0,45,0,0,0,24,0,0,0,10,
0,0,0,2,0,0,0,4,0,0,0,14,0,0,0,33,255,255,255,255,255,255,255,255,255,255,255,
255,117,87,39,255,72,59,42,255,83,71,45,255,116,98,47,255,128,106,49,255,128,
106,50,255,128,107,50,255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,
51,255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,51,
255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,51,255,
129,108,51,255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,51,255,129,
108,51,255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,
51,255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,51,
255,129,108,51,255,129,108,51,255,129,108,51,255,129,107,50,255,128,106,49,255,
126,105,47,255,122,100,42,255,100,82,34,255,58,46,22,255,47,31,9,255,105,70,0,
255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,118,0,0,0,105,0,0,0,
84,0,0,0,58,0,0,0,33,0,0,0,14,0,0,0,4,0,0,0,5,0,0,0,18,0,0,0,39,255,255,255,
255,255,255,255,255,255,255,255,255,119,98,35,255,78,64,37,255,188,150,40,255,
254,209,43,255,255,217,45,255,255,214,46,255,255,216,46,255,255,216,46,255,255,
216,46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,216,
46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,216,46,
255,255,216,46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,216,46,255,
255,216,46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,
216,46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,216,
46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,216,46,
255,255,216,46,255,255,215,43,255,255,215,40,255,255,213,32,255,249,195,22,255,
152,117,8,255,35,22,0,255,113,83,0,255,255,255,255,255,255,255,255,255,255,255,
255,255,0,0,0,124,0,0,0,113,0,0,0,94,0,0,0,68,0,0,0,39,0,0,0,18,0,0,0,5,0,0,0,7,
0,0,0,21,0,0,0,44,255,255,255,255,255,255,255,255,255,255,255,255,77,62,31,
255,106,88,34,255,253,201,36,255,255,220,37,255,255,214,38,255,255,212,38,255,
255,214,38,255,255,213,37,255,255,213,37,255,255,213,37,255,255,213,37,255,255,
213,37,255,255,213,37,255,255,213,37,255,255,213,37,255,255,213,37,255,255,213,
37,255,255,213,37,255,255,213,37,255,255,213,37,255,255,213,37,255,255,213,37,
255,255,213,37,255,255,213,37,255,255,213,37,255,255,213,37,255,255,213,37,255,
255,213,37,255,255,213,37,255,255,213,37,255,255,213,37,255,255,213,37,255,255,
213,37,255,255,213,37,255,255,213,37,255,255,213,37,255,255,213,37,255,255,213,
37,255,255,213,37,255,255,213,37,255,255,213,37,255,255,213,34,255,255,212,29,
255,255,213,20,255,255,215,7,255,231,175,0,255,55,39,0,255,70,51,0,255,255,255,
255,255,255,255,255,255,255,255,255,255,0,0,0,126,0,0,0,117,0,0,0,100,0,0,0,75,
0,0,0,44,0,0,0,21,0,0,0,7,0,0,0,8,0,0,0,23,0,0,0,46,255,255,255,255,255,255,
255,255,255,255,255,255,65,54,30,255,117,96,31,255,255,212,31,255,255,213,31,
255,254,207,31,255,254,206,29,255,255,208,28,255,255,208,27,255,255,207,26,255,
255,207,26,255,255,207,26,255,255,207,26,255,255,207,26,255,255,207,26,255,255,
207,26,255,255,207,26,255,255,207,26,255,255,207,26,255,255,207,26,255,255,207,
26,255,255,207,26,255,255,207,26,255,255,207,26,255,255,207,26,255,255,207,26,
255,255,207,26,255,255,207,26,255,255,207,26,255,255,207,26,255,255,207,26,255,
255,207,26,255,255,207,26,255,255,207,26,255,255,207,26,255,255,207,26,255,255,
207,26,255,255,207,26,255,255,207,26,255,255,207,26,255,255,207,26,255,255,207,
25,255,255,207,22,255,255,205,16,255,255,201,6,255,251,205,0,255,232,177,0,255,
60,44,0,255,57,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,
127,0,0,0,119,0,0,0,102,0,0,0,78,0,0,0,46,0,0,0,23,0,0,0,8,0,0,0,8,0,0,0,24,0,0,
0,47,255,255,255,255,255,255,255,255,255,255,255,255,61,52,28,255,115,95,29,
255,255,211,28,255,255,212,26,255,254,205,23,255,255,206,19,255,255,206,17,255,
255,205,15,255,255,205,15,255,255,205,15,255,255,205,15,255,255,205,15,255,255,
205,15,255,255,205,15,255,255,205,15,255,255,205,15,255,255,205,15,255,255,205,
15,255,255,205,15,255,255,205,15,255,255,205,15,255,255,205,15,255,255,205,15,
255,255,205,15,255,255,205,15,255,255,205,15,255,255,205,15,255,255,205,15,255,
255,205,15,255,255,205,15,255,255,205,15,255,255,205,15,255,255,205,15,255,255,
205,15,255,255,205,15,255,255,205,15,255,255,205,15,255,255,205,15,255,255,205,
15,255,255,205,15,255,255,205,13,255,255,204,10,255,255,203,4,255,251,199,0,
255,240,197,0,255,221,175,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,
255,255,255,255,255,255,0,0,0,127,0,0,0,119,0,0,0,103,0,0,0,79,0,0,0,47,0,0,0,
24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,
255,255,64,52,28,255,117,94,28,255,255,213,26,255,255,210,23,255,255,206,18,255,
255,205,13,255,255,204,10,255,255,203,7,255,255,203,6,255,255,203,6,255,255,203,
6,255,255,203,6,255,255,203,6,255,255,203,6,255,255,203,6,255,255,203,6,255,
255,203,6,255,255,203,6,255,255,203,6,255,255,203,6,255,255,203,6,255,255,203,6,
255,255,203,6,255,255,203,6,255,255,203,6,255,255,203,6,255,255,203,6,255,255,
203,6,255,255,203,6,255,255,203,6,255,255,203,6,255,255,203,6,255,255,203,6,255,
255,203,6,255,255,203,6,255,255,203,6,255,255,203,6,255,255,203,6,255,255,203,6,
255,255,203,6,255,255,203,5,255,255,202,1,255,251,199,0,255,243,192,0,255,233,
189,0,255,217,171,0,255,57,44,0,255,59,41,0,255,255,255,255,255,255,255,255,255,
255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,
8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,
63,52,28,255,115,94,28,255,255,213,25,255,255,210,21,255,255,205,15,255,255,
204,9,255,255,203,5,255,255,202,2,255,255,202,1,255,255,202,1,255,255,202,1,255,
255,202,1,255,255,202,1,255,255,202,1,255,255,202,1,255,255,202,1,255,255,202,1,
255,255,202,1,255,255,202,1,255,255,202,1,255,255,201,1,255,255,201,1,255,255,
201,1,255,255,201,1,255,255,201,1,255,255,201,1,255,255,201,1,255,255,201,1,255,
255,201,1,255,255,201,1,255,255,201,1,255,255,201,1,255,255,201,1,255,255,201,1,
255,255,201,1,255,255,201,1,255,255,201,1,255,255,202,1,255,255,202,1,255,255,
202,1,255,255,202,0,255,253,200,0,255,247,196,0,255,239,189,0,255,230,189,0,255,
214,169,0,255,57,43,0,255,59,41,0,255,255,255,255,255,255,255,255,255,255,255,
255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,
8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,65,52,28,
255,115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,255,
255,203,3,255,255,202,1,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,203,0,255,255,206,0,255,255,210,0,255,255,211,0,255,
255,211,0,255,255,211,0,255,255,211,0,255,255,211,0,255,255,211,0,255,255,211,0,
255,255,211,0,255,255,211,0,255,255,211,0,255,255,211,0,255,255,211,0,255,255,
212,0,255,255,208,0,255,255,205,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
254,201,0,255,251,199,0,255,245,194,0,255,238,189,0,255,230,189,0,255,217,165,0,
255,57,43,0,255,59,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,
0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,
0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,115,94,
28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,
255,255,202,1,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,203,0,255,255,208,0,255,255,207,0,255,255,199,0,255,255,206,0,255,255,208,0,
255,255,208,0,255,255,208,0,255,255,208,0,255,255,208,0,255,255,208,0,255,255,
208,0,255,255,208,0,255,255,208,0,255,255,208,0,255,255,208,0,255,255,202,0,255,
248,194,0,255,255,213,0,255,255,203,0,255,255,202,0,255,255,202,0,255,254,201,0,
255,251,199,0,255,245,194,0,255,238,189,0,255,230,189,0,255,216,165,0,255,57,43,
0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,
0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,
48,255,255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,115,94,28,255,
255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,255,255,
202,1,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,206,0,
255,253,203,0,255,118,107,0,255,0,3,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,39,30,0,255,241,190,0,255,255,205,0,255,255,202,0,255,255,202,0,
255,254,201,0,255,251,199,0,255,245,194,0,255,238,189,0,255,230,189,0,255,217,
165,0,255,57,43,0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,
255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,
0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,
115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,
203,3,255,255,202,1,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,205,0,255,250,197,0,255,101,77,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,
0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,
0,0,255,0,0,0,255,0,0,0,255,116,77,0,255,255,202,0,255,255,205,0,255,255,202,
0,255,255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,189,0,255,
230,189,0,255,214,169,0,255,57,43,0,255,58,41,0,255,255,255,255,255,255,255,255,
255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,
0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,
255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,
204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,204,0,255,255,214,0,255,236,183,0,255,58,38,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,20,12,0,255,243,189,0,255,255,218,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,
238,189,0,255,230,189,0,255,217,165,0,255,57,43,0,255,58,41,0,255,255,255,255,
255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,
0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,
255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,255,
255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,202,
0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,201,0,255,255,204,0,255,255,222,0,
255,249,193,0,255,85,61,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,
0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,122,84,0,255,255,
207,0,255,255,208,0,255,254,200,0,255,255,202,0,255,255,202,0,255,254,201,0,255,
251,199,0,255,245,194,0,255,238,189,0,255,230,189,0,255,215,165,0,255,57,43,0,
255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,
120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,
255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,
25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,201,0,255,255,203,0,255,255,
209,0,255,255,223,0,255,255,215,0,255,139,124,0,255,6,7,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,25,17,
0,255,243,188,0,255,255,217,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,189,0,255,230,189,0,
255,218,165,0,255,57,43,0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,
255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,
0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,64,52,
28,255,115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,
255,255,203,3,255,255,202,1,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,201,0,255,255,201,0,255,
255,205,0,255,255,213,0,255,255,213,0,255,237,188,0,255,89,79,0,255,5,6,0,255,0,
0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,
0,0,0,255,0,0,0,255,132,95,0,255,255,208,0,255,255,208,0,255,254,200,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,
255,238,189,0,255,230,189,0,255,215,165,0,255,57,43,0,255,58,41,0,255,255,255,
255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,
0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,
255,255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,
255,255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,201,0,255,
255,201,0,255,255,207,0,255,255,217,0,255,247,198,0,255,142,127,0,255,27,21,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,19,13,0,255,243,191,0,255,255,217,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,254,201,0,255,
251,199,0,255,245,194,0,255,238,189,0,255,230,189,0,255,214,169,0,255,57,43,0,
255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,
120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,
255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,
25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,201,0,
255,255,203,0,255,255,209,0,255,255,217,0,255,232,185,0,255,72,64,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,122,84,0,255,255,207,0,255,255,208,
0,255,254,200,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
254,201,0,255,251,199,0,255,245,194,0,255,238,189,0,255,230,189,0,255,217,165,0,
255,57,43,0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,
0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,
0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,115,94,
28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,
255,255,202,1,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
201,0,255,255,203,0,255,255,210,0,255,255,211,0,255,176,149,0,255,30,24,0,255,0,
0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,
0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,24,16,0,255,243,190,0,255,
255,217,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,189,0,255,230,
189,0,255,214,169,0,255,57,43,0,255,58,41,0,255,255,255,255,255,255,255,255,255,
255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,
8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,
64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,
204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,201,0,255,255,201,0,255,255,209,0,255,255,212,0,255,157,139,0,255,14,17,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,125,84,0,255,
255,207,0,255,255,208,0,255,254,200,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,
188,0,255,230,187,0,255,214,169,0,255,57,42,0,255,58,41,0,255,255,255,255,255,
255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,
0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,
255,255,255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,255,255,
205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,201,0,255,255,207,0,255,255,215,0,255,176,150,0,255,15,18,
0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,
0,0,255,1,0,0,255,67,37,0,255,77,52,0,255,0,0,0,255,0,0,0,255,0,0,0,255,9,6,0,
255,243,190,0,255,255,218,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,254,201,0,255,251,199,0,255,
245,194,0,255,238,188,0,255,230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,255,
255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,
0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,
255,255,255,255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,
210,20,255,255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,255,202,0,
255,255,202,0,255,255,201,0,255,255,203,0,255,255,216,0,255,239,188,0,255,35,29,
0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,
0,0,255,33,24,0,255,158,113,0,255,255,209,0,255,255,204,0,255,8,6,0,255,0,0,0,
255,0,0,0,255,77,60,0,255,255,204,0,255,255,208,0,255,254,200,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,254,
201,0,255,251,199,0,255,245,194,0,255,238,188,0,255,230,189,0,255,214,170,0,255,
57,42,0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,
128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,
0,48,255,255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,115,94,28,
255,255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,255,
255,202,1,255,255,202,0,255,255,202,0,255,255,201,0,255,255,207,0,255,255,209,0,
255,106,94,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,
0,0,255,2,0,0,255,93,66,0,255,237,186,0,255,255,212,0,255,255,222,0,255,255,
208,0,255,13,10,0,255,0,0,0,255,12,5,0,255,235,185,0,255,255,219,0,255,255,202,
0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,188,0,
255,230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,
255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,
24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,
255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,
255,204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,202,0,255,255,203,0,
255,255,217,0,255,241,190,0,255,15,15,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,20,10,0,255,159,114,0,255,253,196,0,255,255,217,0,255,
255,207,0,255,255,207,0,255,255,204,0,255,106,70,0,255,13,2,0,255,107,70,0,255,
255,204,0,255,255,208,0,255,254,200,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,254,201,0,255,251,
199,0,255,245,194,0,255,238,188,0,255,230,189,0,255,214,170,0,255,57,42,0,255,
58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,
120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,
255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,
25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,
255,202,0,255,255,201,0,255,255,205,0,255,255,208,0,255,110,95,0,255,0,0,0,255,
0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,14,8,0,255,177,128,0,255,
255,205,0,255,255,213,0,255,255,204,0,255,254,200,0,255,255,204,0,255,255,212,0,
255,255,202,0,255,245,195,0,255,255,202,0,255,255,212,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,188,0,
255,230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,
255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,
24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,
255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,
255,204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,201,0,255,255,211,0,
255,255,204,0,255,19,16,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,
0,0,0,255,143,101,0,255,255,203,0,255,255,213,0,255,255,204,0,255,254,200,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,205,0,255,255,207,0,255,255,
205,0,255,255,202,0,255,254,200,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,254,201,0,
255,251,199,0,255,245,194,0,255,238,188,0,255,230,189,0,255,214,170,0,255,57,42,
0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,
0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,
48,255,255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,115,94,28,255,
255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,255,255,
202,1,255,255,202,0,255,255,203,0,255,255,216,0,255,250,196,0,255,0,0,0,255,0,0,
0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,61,43,0,255,248,194,0,255,255,
214,0,255,255,204,0,255,254,200,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,
238,188,0,255,230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,255,255,255,255,
255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,
0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,
255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,255,
255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,255,201,0,255,255,205,
0,255,255,206,0,255,156,120,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,
0,255,0,0,0,255,171,129,0,255,255,212,0,255,255,206,0,255,254,200,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,188,0,255,230,189,0,255,
214,170,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,
255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,
8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,64,52,28,
255,115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,255,
255,203,3,255,255,202,1,255,255,201,0,255,255,207,0,255,255,209,0,255,103,91,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,8,4,0,255,252,200,0,255,
255,215,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,254,201,0,255,251,199,0,
255,245,194,0,255,238,188,0,255,230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,
255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,
104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,
255,255,255,255,255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,25,255,
255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,255,201,
0,255,255,209,0,255,255,209,0,255,70,52,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,
0,0,255,0,0,0,255,41,25,0,255,255,209,0,255,255,210,0,255,254,200,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,188,0,255,
230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,255,
255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,
0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,
255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,
204,8,255,255,203,3,255,255,202,1,255,255,201,0,255,255,209,0,255,255,206,0,255,
49,31,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,64,43,0,255,255,
210,0,255,255,208,0,255,255,201,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,254,201,0,255,
251,199,0,255,245,194,0,255,238,188,0,255,230,189,0,255,214,170,0,255,57,42,0,
255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,
120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,
255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,
25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,
255,201,0,255,255,209,0,255,255,208,0,255,44,27,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,66,47,0,255,255,209,0,255,255,208,0,255,255,201,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,188,0,
255,230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,
255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,
24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,
255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,
255,204,8,255,255,203,3,255,255,202,1,255,255,201,0,255,255,209,0,255,255,209,0,
255,53,39,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,55,38,0,255,
255,208,0,255,255,208,0,255,255,201,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,254,201,0,
255,251,199,0,255,245,194,0,255,238,188,0,255,230,189,0,255,214,170,0,255,57,42,
0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,
0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,
48,255,255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,115,94,28,255,
255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,255,255,
202,1,255,255,201,0,255,255,209,0,255,255,208,0,255,55,37,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,55,38,0,255,255,208,0,255,255,208,0,255,255,
201,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,
238,188,0,255,230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,255,255,255,255,
255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,
0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,
255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,255,
255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,255,201,0,255,255,209,
0,255,255,208,0,255,56,40,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,67,51,0,255,255,209,0,255,255,208,0,255,255,201,0,255,255,202,0,255,255,202,
0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,188,0,255,230,189,0,255,
214,170,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,
255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,
8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,64,52,28,
255,115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,255,
255,203,3,255,255,202,1,255,255,201,0,255,255,209,0,255,255,208,0,255,56,40,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,65,49,0,255,255,207,0,255,
255,208,0,255,255,201,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,254,201,0,255,251,199,0,
255,245,194,0,255,238,188,0,255,230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,
255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,
104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,
255,255,255,255,255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,25,255,
255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,255,201,
0,255,255,209,0,255,255,208,0,255,56,40,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,
0,0,255,0,0,0,255,68,52,0,255,255,210,0,255,255,208,0,255,255,201,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,188,0,255,
230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,255,
255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,
0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,
255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,
204,8,255,255,203,3,255,255,202,1,255,255,201,0,255,255,209,0,255,255,206,0,255,
52,36,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,64,47,0,255,255,
207,0,255,255,208,0,255,255,201,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,254,201,0,255,
251,199,0,255,245,194,0,255,238,188,0,255,230,189,0,255,214,170,0,255,57,42,0,
255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,
120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,
255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,
25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,
255,201,0,255,255,208,0,255,254,202,0,255,55,40,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,65,43,0,255,254,202,0,255,255,206,0,255,255,201,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,188,0,
255,230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,
255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,
24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,
255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,
255,204,8,255,255,203,3,255,255,202,1,255,255,201,0,255,255,205,0,255,255,206,0,
255,167,125,0,255,118,78,0,255,120,78,0,255,122,80,0,255,120,78,0,255,118,75,0,
255,168,127,0,255,255,206,0,255,255,204,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,188,0,255,230,189,0,255,
214,170,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,
255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,
8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,64,52,28,
255,115,93,27,255,255,213,25,255,255,210,19,255,255,205,13,255,255,203,6,255,
255,202,1,255,254,201,0,255,254,201,0,255,254,203,0,255,254,208,0,255,254,203,0,
255,254,202,0,255,254,208,0,255,254,208,0,255,254,208,0,255,254,202,0,255,254,
205,0,255,254,207,0,255,254,201,0,255,254,201,0,255,254,201,0,255,254,201,0,255,
254,201,0,255,254,201,0,255,254,201,0,255,254,201,0,255,254,201,0,255,254,201,0,
255,254,201,0,255,254,201,0,255,254,201,0,255,254,201,0,255,254,201,0,255,254,
201,0,255,254,201,0,255,254,201,0,255,254,201,0,255,254,201,0,255,254,201,0,255,
253,200,0,255,249,197,0,255,244,193,0,255,237,187,0,255,229,188,0,255,214,170,0,
255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,
0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,
0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,114,92,
26,255,255,212,22,255,255,209,16,255,255,204,9,255,255,202,1,255,252,200,0,255,
249,197,0,255,248,196,0,255,248,196,0,255,248,195,0,255,248,197,0,255,248,199,0,
255,248,200,0,255,248,200,0,255,248,200,0,255,248,199,0,255,248,198,0,255,248,
196,0,255,247,195,0,255,248,196,0,255,248,196,0,255,248,196,0,255,248,196,0,255,
248,196,0,255,248,196,0,255,248,196,0,255,248,196,0,255,248,196,0,255,248,196,0,
255,248,196,0,255,248,196,0,255,248,196,0,255,248,196,0,255,248,196,0,255,248,
196,0,255,248,196,0,255,248,196,0,255,248,196,0,255,248,196,0,255,247,196,0,255,
245,194,0,255,240,190,0,255,233,184,0,255,227,186,0,255,213,169,0,255,57,42,0,
255,58,40,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,
120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,
255,255,255,255,255,255,255,255,255,255,255,65,51,27,255,113,91,24,255,255,211,
18,255,255,208,10,255,255,202,1,255,248,196,0,255,243,192,0,255,240,190,0,255,
239,189,0,255,239,189,0,255,239,189,0,255,239,189,0,255,239,189,0,255,239,189,0,
255,239,189,0,255,239,189,0,255,239,189,0,255,239,189,0,255,239,189,0,255,239,
189,0,255,239,189,0,255,239,189,0,255,239,189,0,255,239,189,0,255,239,189,0,255,
239,189,0,255,239,189,0,255,239,189,0,255,239,189,0,255,239,189,0,255,239,189,0,
255,239,189,0,255,239,189,0,255,239,189,0,255,239,189,0,255,239,189,0,255,239,
189,0,255,239,189,0,255,239,189,0,255,239,189,0,255,238,189,0,255,236,187,0,255,
233,185,0,255,228,180,0,255,224,184,0,255,211,167,0,255,58,42,0,255,58,40,0,255,
255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,
0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,
255,255,255,255,255,255,255,255,60,48,24,255,111,88,19,255,255,211,10,255,255,
208,0,255,244,192,0,255,236,186,0,255,230,181,0,255,227,179,0,255,226,178,0,255,
226,178,0,255,226,178,0,255,226,178,0,255,226,178,0,255,226,178,0,255,226,178,0,
255,226,178,0,255,226,178,0,255,226,178,0,255,226,178,0,255,226,178,0,255,226,
178,0,255,226,178,0,255,226,178,0,255,226,178,0,255,226,178,0,255,226,178,0,255,
226,178,0,255,226,178,0,255,226,178,0,255,226,178,0,255,226,178,0,255,226,178,0,
255,226,178,0,255,226,178,0,255,226,178,0,255,226,178,0,255,226,178,0,255,226,
178,0,255,226,178,0,255,226,178,0,255,225,177,0,255,224,177,0,255,222,175,0,255,
221,174,0,255,218,179,0,255,209,166,0,255,57,43,0,255,57,40,0,255,255,255,255,
255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,
0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,
255,255,255,255,255,64,51,19,255,92,71,10,255,254,201,0,255,242,202,0,255,230,
188,0,255,221,179,0,255,216,175,0,255,213,173,0,255,212,172,0,255,212,172,0,255,
212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,
255,212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,212,
172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,
212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,
255,212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,212,
172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,
212,180,0,255,199,151,0,255,53,36,0,255,66,48,0,255,255,255,255,255,255,255,255,
255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,
0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,
255,95,71,10,255,43,29,0,255,171,128,0,255,227,175,0,255,217,179,0,255,209,170,
0,255,206,168,0,255,203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,
203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,
255,203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,203,
166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,
203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,
255,203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,203,
166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,204,168,0,255,206,162,0,255,
131,100,0,255,32,20,0,255,98,70,0,255,255,255,255,255,255,255,255,255,255,255,
255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,
8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,73,50,0,
255,25,14,0,255,48,32,0,255,89,62,0,255,105,79,0,255,105,80,0,255,105,80,0,255,
103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,
103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,
103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,
103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,
103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,
103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,105,79,0,255,
103,78,0,255,79,58,0,255,37,26,0,255,32,19,0,255,83,60,0,255,255,255,255,255,
255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,
0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,
255,255,255,255,34,0,0,255,54,38,0,255,61,43,0,255,47,32,0,255,41,27,0,255,40,
27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,
255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,
27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,
255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,
27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,
255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,47,
33,0,255,62,45,0,255,61,43,0,255,29,29,0,255,255,255,255,255,255,255,255,255,
255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,
8,0,0,0,8,0,0,0,24,0,0,0,47,232,232,232,214,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
221,221,221,225,0,0,0,127,0,0,0,119,0,0,0,103,0,0,0,79,0,0,0,47,0,0,0,24,0,0,0,
8,0,0,0,8,0,0,0,23,0,0,0,46,164,164,164,140,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
133,133,133,173,0,0,0,127,0,0,0,119,0,0,0,102,0,0,0,78,0,0,0,46,0,0,0,23,0,0,0,
8,0,0,0,7,0,0,0,21,0,0,0,44,0,0,0,75,148,148,148,155,223,223,223,223,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,221,221,221,225,133,133,133,173,0,0,0,
127,0,0,0,126,0,0,0,117,0,0,0,100,0,0,0,75,0,0,0,44,0,0,0,21,0,0,0,7,0,0,0,5,0,
0,0,18,0,0,0,39,0,0,0,68,0,0,0,94,0,0,0,113,0,0,0,124,0,0,0,127,0,0,0,127,0,0,
0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,
0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,
0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,127,0,0,0,
127,0,0,0,124,0,0,0,113,0,0,0,94,0,0,0,68,0,0,0,39,0,0,0,18,0,0,0,5,0,0,0,4,0,0,
0,14,0,0,0,33,0,0,0,58,0,0,0,84,0,0,0,105,0,0,0,118,0,0,0,124,0,0,0,126,0,0,0,
127,0,0,0,127,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,127,0,0,0,127,0,0,0,126,0,0,0,124,0,0,0,
118,0,0,0,105,0,0,0,84,0,0,0,58,0,0,0,33,0,0,0,14,0,0,0,4,0,0,0,2,0,0,0,10,0,0,
0,24,0,0,0,45,0,0,0,69,0,0,0,90,0,0,0,105,0,0,0,113,0,0,0,117,0,0,0,119,0,0,0,
119,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,
120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,
120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,
120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,
120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,
120,0,0,0,120,0,0,0,120,0,0,0,119,0,0,0,119,0,0,0,117,0,0,0,113,0,0,0,105,0,0,0,
90,0,0,0,69,0,0,0,45,0,0,0,24,0,0,0,10,0,0,0,2,0,0,0,1,0,0,0,6,0,0,0,15,0,0,0,
31,0,0,0,50,0,0,0,69,0,0,0,84,0,0,0,94,0,0,0,100,0,0,0,102,0,0,0,103,0,0,0,104,
0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,
104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,
104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,
104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,
104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,
104,0,0,0,104,0,0,0,103,0,0,0,102,0,0,0,100,0,0,0,94,0,0,0,84,0,0,0,69,0,0,0,50,
0,0,0,31,0,0,0,15,0,0,0,6,0,0,0,1,255,255,255,0,0,0,0,3,0,0,0,8,0,0,0,18,0,0,
0,31,0,0,0,45,0,0,0,58,0,0,0,68,0,0,0,75,0,0,0,78,0,0,0,79,0,0,0,80,0,0,0,80,
0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,
80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,
0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,
0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,
80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,79,0,0,0,78,0,0,0,75,0,0,
0,68,0,0,0,58,0,0,0,45,0,0,0,31,0,0,0,18,0,0,0,8,0,0,0,3,255,255,255,0,255,
255,255,0,0,0,0,1,0,0,0,3,0,0,0,8,0,0,0,15,0,0,0,24,0,0,0,33,0,0,0,39,0,0,0,44,
0,0,0,46,0,0,0,47,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,
48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,
0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,
0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,
48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,
0,48,0,0,0,47,0,0,0,46,0,0,0,44,0,0,0,39,0,0,0,33,0,0,0,24,0,0,0,15,0,0,0,8,0,
0,0,3,0,0,0,1,255,255,255,0,255,255,255,0,255,255,255,0,0,0,0,1,0,0,0,3,0,0,0,
6,0,0,0,10,0,0,0,14,0,0,0,18,0,0,0,21,0,0,0,23,0,0,0,24,0,0,0,24,0,0,0,24,0,0,
0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,
0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,
24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,
0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,
0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,23,0,0,0,21,0,0,0,
18,0,0,0,14,0,0,0,10,0,0,0,6,0,0,0,3,0,0,0,1,255,255,255,0,255,255,255,0,255,
255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,0,0,0,1,0,0,0,2,0,0,0,4,0,0,
0,5,0,0,0,7,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,
0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,
0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,
8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,
0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,7,0,
0,0,5,0,0,0,4,0,0,0,2,0,0,0,1,255,255,255,0,255,255,255,0,255,255,255,0,255,
255,255,0};
static Fl_RGB_Image image_EasyRight(idata_EasyRight, 64, 64, 4, 0);

void TrackEditorUI::cb_hardLeft_i(Fl_Menu_*, void*) {
  trackView->setSign(kHardLeft);
}
void TrackEditorUI::cb_hardLeft(Fl_Menu_* o, void* v) {
  ((TrackEditorUI*)(o->parent()->user_data()))->cb_hardLeft_i(o,v);
}

static unsigned char idata_HardLeft[] =
{255,255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,0,0,0,1,0,0,0,2,0,
0,0,4,0,0,0,5,0,0,0,7,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,
0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,
8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,
0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,
0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,
0,0,0,7,0,0,0,5,0,0,0,4,0,0,0,2,0,0,0,1,255,255,255,0,255,255,255,0,255,255,
255,0,255,255,255,0,255,255,255,0,255,255,255,0,0,0,0,1,0,0,0,3,0,0,0,6,0,0,0,
10,0,0,0,14,0,0,0,18,0,0,0,21,0,0,0,23,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,
0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,
0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,
24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,
0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,
0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,23,0,0,0,21,0,0,0,18,0,0,0,
14,0,0,0,10,0,0,0,6,0,0,0,3,0,0,0,1,255,255,255,0,255,255,255,0,255,255,255,0,
0,0,0,1,0,0,0,3,0,0,0,8,230,230,230,100,247,247,247,201,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,241,241,241,206,194,194,194,118,0,0,0,39,0,0,0,33,0,
0,0,24,0,0,0,15,0,0,0,8,0,0,0,3,0,0,0,1,255,255,255,0,255,255,255,0,0,0,0,3,0,
0,0,8,225,225,225,102,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,171,171,171,134,0,0,0,
58,0,0,0,45,0,0,0,31,0,0,0,18,0,0,0,8,0,0,0,3,255,255,255,0,0,0,0,1,0,0,0,6,0,
0,0,15,246,246,246,202,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,229,229,229,217,0,0,
0,84,0,0,0,69,0,0,0,50,0,0,0,31,0,0,0,15,0,0,0,6,0,0,0,1,0,0,0,2,0,0,0,10,0,0,
0,24,255,255,255,255,255,255,255,255,255,255,255,255,74,74,44,255,105,88,46,
255,114,93,49,255,101,85,50,255,97,83,51,255,97,84,52,255,97,85,52,255,97,85,52,
255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,
255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,
255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,
255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,
255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,
255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,97,84,51,255,95,80,48,
255,96,80,43,255,109,87,34,255,95,75,22,255,44,44,9,255,255,255,255,255,255,255,
255,255,255,255,255,255,0,0,0,105,0,0,0,90,0,0,0,69,0,0,0,45,0,0,0,24,0,0,0,10,
0,0,0,2,0,0,0,4,0,0,0,14,0,0,0,33,255,255,255,255,255,255,255,255,255,255,255,
255,117,87,39,255,72,59,42,255,83,71,45,255,116,98,47,255,128,106,49,255,128,
106,50,255,128,107,50,255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,
51,255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,51,
255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,51,255,
129,108,51,255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,51,255,129,
108,51,255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,
51,255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,51,
255,129,108,51,255,129,108,51,255,129,108,51,255,129,107,50,255,128,106,49,255,
126,105,47,255,122,100,42,255,100,82,34,255,58,46,22,255,47,31,9,255,105,70,0,
255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,118,0,0,0,105,0,0,0,
84,0,0,0,58,0,0,0,33,0,0,0,14,0,0,0,4,0,0,0,5,0,0,0,18,0,0,0,39,255,255,255,
255,255,255,255,255,255,255,255,255,119,98,35,255,78,64,37,255,188,150,40,255,
254,209,43,255,255,217,45,255,255,214,46,255,255,216,46,255,255,216,46,255,255,
216,46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,216,
46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,216,46,
255,255,216,46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,216,46,255,
255,216,46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,
216,46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,216,
46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,216,46,
255,255,216,46,255,255,215,43,255,255,215,40,255,255,213,32,255,249,195,22,255,
152,117,8,255,35,22,0,255,113,83,0,255,255,255,255,255,255,255,255,255,255,255,
255,255,0,0,0,124,0,0,0,113,0,0,0,94,0,0,0,68,0,0,0,39,0,0,0,18,0,0,0,5,0,0,0,7,
0,0,0,21,0,0,0,44,255,255,255,255,255,255,255,255,255,255,255,255,77,62,31,
255,106,88,34,255,253,201,36,255,255,220,37,255,255,214,38,255,255,212,38,255,
255,214,38,255,255,213,37,255,255,213,37,255,255,213,37,255,255,213,37,255,255,
213,37,255,255,213,37,255,255,213,37,255,255,213,37,255,255,213,37,255,255,213,
37,255,255,213,37,255,255,213,37,255,255,213,37,255,255,213,37,255,255,213,37,
255,255,213,37,255,255,213,37,255,255,213,37,255,255,213,37,255,255,213,37,255,
255,213,37,255,255,213,37,255,255,213,37,255,255,213,37,255,255,213,37,255,255,
213,37,255,255,213,37,255,255,213,37,255,255,213,37,255,255,213,37,255,255,213,
37,255,255,213,37,255,255,213,37,255,255,213,37,255,255,213,34,255,255,212,29,
255,255,213,20,255,255,215,7,255,231,175,0,255,55,39,0,255,70,51,0,255,255,255,
255,255,255,255,255,255,255,255,255,255,0,0,0,126,0,0,0,117,0,0,0,100,0,0,0,75,
0,0,0,44,0,0,0,21,0,0,0,7,0,0,0,8,0,0,0,23,0,0,0,46,255,255,255,255,255,255,
255,255,255,255,255,255,65,54,30,255,117,96,31,255,255,212,31,255,255,213,31,
255,254,207,31,255,254,206,29,255,255,208,28,255,255,208,27,255,255,207,26,255,
255,207,26,255,255,207,26,255,255,207,26,255,255,207,26,255,255,207,26,255,255,
207,26,255,255,207,26,255,255,207,26,255,255,207,26,255,255,207,26,255,255,207,
26,255,255,207,26,255,255,207,26,255,255,207,26,255,255,207,26,255,255,207,26,
255,255,207,26,255,255,207,26,255,255,207,26,255,255,207,26,255,255,207,26,255,
255,207,26,255,255,207,26,255,255,207,26,255,255,207,26,255,255,207,26,255,255,
207,26,255,255,207,26,255,255,207,26,255,255,207,26,255,255,207,26,255,255,207,
25,255,255,207,22,255,255,205,16,255,255,201,6,255,251,205,0,255,232,177,0,255,
60,44,0,255,57,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,
127,0,0,0,119,0,0,0,102,0,0,0,78,0,0,0,46,0,0,0,23,0,0,0,8,0,0,0,8,0,0,0,24,0,0,
0,47,255,255,255,255,255,255,255,255,255,255,255,255,61,52,28,255,115,95,29,
255,255,211,28,255,255,212,26,255,254,205,23,255,255,206,19,255,255,206,17,255,
255,205,15,255,255,205,15,255,255,205,15,255,255,205,15,255,255,205,15,255,255,
205,15,255,255,205,15,255,255,205,15,255,255,205,15,255,255,205,15,255,255,205,
15,255,255,204,15,255,255,204,15,255,255,206,15,255,255,207,15,255,255,207,15,
255,255,205,15,255,255,205,15,255,255,205,15,255,255,205,15,255,255,205,15,255,
255,205,15,255,255,205,15,255,255,205,15,255,255,205,15,255,255,205,15,255,255,
205,15,255,255,205,15,255,255,205,15,255,255,205,15,255,255,205,15,255,255,205,
15,255,255,205,15,255,255,205,13,255,255,204,10,255,255,203,4,255,251,199,0,
255,240,197,0,255,221,175,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,
255,255,255,255,255,255,0,0,0,127,0,0,0,119,0,0,0,103,0,0,0,79,0,0,0,47,0,0,0,
24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,
255,255,64,52,28,255,117,94,28,255,255,213,26,255,255,210,23,255,255,206,18,255,
255,205,13,255,255,204,10,255,255,203,7,255,255,203,6,255,255,203,6,255,255,203,
6,255,255,203,6,255,255,203,6,255,255,203,6,255,255,203,6,255,255,203,6,255,
255,202,6,255,255,202,6,255,255,204,6,255,255,209,6,255,255,215,6,255,253,202,6,
255,254,204,6,255,255,210,6,255,255,201,6,255,255,203,6,255,255,203,6,255,255,
203,6,255,255,203,6,255,255,203,6,255,255,203,6,255,255,203,6,255,255,203,6,255,
255,203,6,255,255,203,6,255,255,203,6,255,255,203,6,255,255,203,6,255,255,203,6,
255,255,203,6,255,255,203,5,255,255,202,1,255,251,199,0,255,243,192,0,255,233,
189,0,255,217,171,0,255,57,44,0,255,59,41,0,255,255,255,255,255,255,255,255,255,
255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,
8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,
63,52,28,255,115,94,28,255,255,213,25,255,255,210,21,255,255,205,15,255,255,
204,9,255,255,203,5,255,255,202,2,255,255,202,1,255,255,202,1,255,255,202,1,255,
255,202,1,255,255,202,1,255,255,202,1,255,255,202,1,255,255,201,1,255,255,201,1,
255,255,207,1,255,255,215,1,255,255,208,1,255,240,194,1,255,136,124,1,255,153,
134,1,255,255,210,1,255,255,204,1,255,255,202,1,255,255,202,1,255,255,202,1,255,
255,202,1,255,255,202,1,255,255,202,1,255,255,202,1,255,255,202,1,255,255,202,1,
255,255,202,1,255,255,202,1,255,255,202,1,255,255,202,1,255,255,202,1,255,255,
202,1,255,255,202,0,255,253,200,0,255,247,196,0,255,239,189,0,255,230,189,0,255,
214,169,0,255,57,43,0,255,59,41,0,255,255,255,255,255,255,255,255,255,255,255,
255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,
8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,65,52,28,
255,115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,255,
255,203,3,255,255,202,1,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,201,0,255,255,201,0,255,255,205,0,255,255,212,0,255,255,
215,0,255,242,190,0,255,110,87,0,255,17,11,0,255,0,0,0,255,13,11,0,255,250,198,
0,255,255,207,0,255,255,201,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,254,
201,0,255,251,199,0,255,245,194,0,255,238,189,0,255,230,189,0,255,217,165,0,255,
57,43,0,255,59,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,
128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,
0,48,255,255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,115,94,28,
255,255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,255,
255,202,1,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,201,0,
255,255,203,0,255,255,208,0,255,255,218,0,255,250,198,0,255,154,135,0,255,33,27,
0,255,0,0,0,255,0,0,0,255,0,0,0,255,20,11,0,255,255,204,0,255,255,208,0,255,
255,201,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,254,201,0,255,251,199,0,255,
245,194,0,255,238,189,0,255,230,189,0,255,216,165,0,255,57,43,0,255,58,41,0,255,
255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,
0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,
255,255,255,255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,
210,20,255,255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,255,202,0,
255,255,202,0,255,255,201,0,255,255,201,0,255,255,205,0,255,255,214,0,255,255,
211,0,255,237,187,0,255,84,72,0,255,0,1,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,
0,255,73,60,0,255,255,212,0,255,255,210,0,255,255,205,0,255,255,205,0,255,255,
205,0,255,255,205,0,255,255,205,0,255,255,205,0,255,255,205,0,255,255,205,0,255,
255,205,0,255,255,205,0,255,255,205,0,255,255,204,0,255,255,203,0,255,255,201,0,
255,255,201,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,189,0,255,230,
189,0,255,217,165,0,255,57,43,0,255,58,41,0,255,255,255,255,255,255,255,255,255,
255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,
8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,
64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,
204,8,255,255,203,3,255,255,202,1,255,255,201,0,255,255,201,0,255,255,203,0,255,
255,211,0,255,255,216,0,255,243,195,0,255,127,113,0,255,20,18,0,255,0,0,0,255,0,
0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,133,107,0,255,255,216,0,255,
255,214,0,255,255,210,0,255,255,210,0,255,255,210,0,255,255,210,0,255,255,207,0,
255,255,211,0,255,255,211,0,255,255,207,0,255,255,207,0,255,255,211,0,255,255,
209,0,255,255,205,0,255,255,210,0,255,255,210,0,255,255,204,0,255,254,202,0,255,
251,198,0,255,245,194,0,255,238,189,0,255,230,189,0,255,214,169,0,255,57,43,0,
255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,
120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,
255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,
25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,255,255,201,1,255,
255,202,0,255,255,208,0,255,255,218,0,255,253,201,0,255,180,155,0,255,48,46,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,90,73,0,255,151,136,0,255,145,134,0,255,145,133,0,255,145,133,0,255,145,133,
0,255,141,130,0,255,134,114,0,255,143,130,0,255,143,131,0,255,128,117,0,255,
128,117,0,255,143,131,0,255,142,132,0,255,149,136,0,255,192,166,0,255,248,198,0,
255,255,207,0,255,254,211,0,255,251,199,0,255,245,194,0,255,238,189,0,255,230,
189,0,255,217,165,0,255,57,43,0,255,58,41,0,255,255,255,255,255,255,255,255,255,
255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,
8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,
64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,
203,8,255,255,202,3,255,255,205,1,255,255,213,0,255,255,213,0,255,236,186,0,255,
86,71,0,255,3,4,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,25,18,0,255,142,106,0,255,251,200,0,255,251,
208,0,255,245,192,0,255,238,189,0,255,230,189,0,255,215,165,0,255,57,43,0,255,
58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,
120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,
255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,
25,255,255,210,20,255,255,205,14,255,255,203,8,255,255,209,3,255,255,218,1,255,
243,193,0,255,140,124,0,255,25,22,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,
0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,1,0,255,131,120,0,255,251,210,0,255,245,198,0,255,238,189,0,255,230,189,0,
255,218,165,0,255,57,43,0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,
255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,
0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,64,52,
28,255,115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,206,8,
255,255,214,3,255,224,176,1,255,52,45,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,19,15,0,255,241,186,0,255,245,206,0,255,238,
189,0,255,230,189,0,255,215,165,0,255,57,43,0,255,58,41,0,255,255,255,255,255,
255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,
0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,
255,255,255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,255,255,
205,14,255,255,206,8,255,238,188,3,255,69,49,1,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,156,117,0,255,
245,198,0,255,238,190,0,255,230,189,0,255,214,169,0,255,57,43,0,255,58,41,0,255,
255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,
0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,
255,255,255,255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,
210,20,255,255,205,14,255,255,206,8,255,255,214,3,255,229,180,1,255,92,62,0,255,
0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,106,86,0,255,245,198,0,255,238,192,0,255,230,189,0,255,217,165,0,255,57,43,
0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,
0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,
48,255,255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,115,94,28,255,
255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,206,3,255,255,
217,1,255,252,197,0,255,162,124,0,255,41,27,0,255,0,0,0,255,0,0,0,255,0,0,0,255,
0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,105,82,0,255,245,201,0,255,238,193,0,255,230,
189,0,255,214,169,0,255,57,43,0,255,58,41,0,255,255,255,255,255,255,255,255,255,
255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,
8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,
64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,
204,8,255,255,202,3,255,255,204,1,255,255,212,0,255,255,212,0,255,241,187,0,255,
112,73,0,255,19,12,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,
0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,
0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,
0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,103,85,
0,255,245,201,0,255,238,192,0,255,230,188,0,255,214,169,0,255,57,42,0,255,58,
41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,
0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,
255,255,255,255,255,255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,25,
255,255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,255,255,201,1,255,255,
202,0,255,255,206,0,255,255,216,0,255,255,205,0,255,235,185,0,255,71,51,0,255,0,
0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,
86,57,0,255,178,122,0,255,197,134,0,255,196,133,0,255,198,135,0,255,199,149,0,
255,199,149,0,255,198,135,0,255,197,132,0,255,187,122,0,255,157,99,0,255,72,46,
0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,
102,90,0,255,245,203,0,255,238,192,0,255,230,189,0,255,214,170,0,255,57,42,0,
255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,
120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,
255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,
25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,
255,202,0,255,255,201,0,255,255,202,0,255,255,208,0,255,255,220,0,255,246,190,0,
255,140,99,0,255,30,18,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,
0,0,0,255,106,84,0,255,255,214,0,255,255,216,0,255,255,208,0,255,255,209,0,
255,255,210,0,255,255,210,0,255,255,209,0,255,255,211,0,255,255,210,0,255,255,
217,0,255,251,197,0,255,17,11,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,
0,255,0,0,0,255,103,85,0,255,245,201,0,255,238,191,0,255,230,189,0,255,214,
170,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,
255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,
0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,
115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,
203,3,255,255,202,1,255,255,202,0,255,255,202,0,255,255,201,0,255,255,201,0,255,
255,204,0,255,255,213,0,255,255,209,0,255,237,186,0,255,92,59,0,255,1,0,0,255,0,
0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,40,31,0,255,255,208,0,255,255,210,0,255,
255,203,0,255,255,204,0,255,255,202,0,255,255,202,0,255,255,204,0,255,255,204,0,
255,255,203,0,255,255,215,0,255,255,212,0,255,15,12,0,255,0,0,0,255,0,0,0,255,0,
0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,103,83,0,255,245,202,0,255,238,192,0,
255,230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,
255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,
24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,
255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,
255,204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,201,0,255,255,202,0,255,255,208,0,255,255,218,0,255,251,
193,0,255,161,112,0,255,40,25,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,255,
203,0,255,255,210,0,255,255,201,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,201,0,255,255,211,0,255,255,207,0,255,20,16,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,88,73,0,255,245,
200,0,255,238,192,0,255,230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,255,255,
255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,
80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,
255,255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,
255,255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,201,0,255,255,201,0,255,
255,204,0,255,255,211,0,255,255,211,0,255,241,188,0,255,113,75,0,255,6,2,0,255,
0,0,0,255,0,0,0,255,252,199,0,255,255,209,0,255,255,201,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,201,0,255,255,211,0,
255,255,208,0,255,20,15,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,
0,0,0,255,88,71,0,255,245,200,0,255,238,193,0,255,230,189,0,255,214,170,0,255,
57,42,0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,
128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,
0,48,255,255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,115,94,28,
255,255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,255,
255,202,1,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,206,0,255,255,
217,0,255,255,201,0,255,188,141,0,255,105,60,0,255,132,91,0,255,255,204,0,255,
255,205,0,255,255,201,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,201,0,255,255,211,0,255,255,208,0,255,22,15,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,89,71,0,255,245,202,0,255,
238,193,0,255,230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,255,255,255,255,
255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,
0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,
255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,255,
255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,202,
0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,201,0,255,255,204,0,255,255,209,0,255,255,210,0,
255,253,197,0,255,254,200,0,255,255,210,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,201,0,255,
255,211,0,255,255,207,0,255,22,11,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,
0,0,0,255,0,0,0,255,89,71,0,255,245,202,0,255,238,193,0,255,230,189,0,255,214,
170,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,
255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,
0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,
115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,
203,3,255,255,202,1,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,200,0,255,255,204,0,255,255,205,0,255,255,205,0,255,255,
202,0,255,254,200,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,201,0,255,255,211,0,255,255,209,0,255,22,15,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,89,71,0,255,245,
202,0,255,238,193,0,255,230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,255,255,
255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,
80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,
255,255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,
255,255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,201,0,255,
255,210,0,255,255,208,0,255,22,15,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,
0,0,0,255,0,0,0,255,89,71,0,255,245,202,0,255,238,193,0,255,230,189,0,255,214,
170,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,
255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,
0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,
115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,
203,3,255,255,202,1,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,201,0,255,255,210,0,255,255,209,0,255,22,16,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,89,71,0,255,245,
202,0,255,238,193,0,255,230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,255,255,
255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,
80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,
255,255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,
255,255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,201,0,255,
255,210,0,255,255,209,0,255,22,16,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,
0,0,0,255,0,0,0,255,89,71,0,255,245,202,0,255,238,193,0,255,230,189,0,255,214,
170,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,
255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,
0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,
115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,
203,3,255,255,202,1,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,201,0,255,255,210,0,255,255,209,0,255,22,16,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,89,71,0,255,245,
202,0,255,238,193,0,255,230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,255,255,
255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,
80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,
255,255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,
255,255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,201,0,255,
255,210,0,255,255,209,0,255,21,16,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,
0,0,0,255,0,0,0,255,89,71,0,255,245,202,0,255,238,193,0,255,230,189,0,255,214,
170,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,
255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,
0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,
115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,
203,3,255,255,202,1,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,201,0,255,255,210,0,255,255,209,0,255,25,16,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,89,71,0,255,245,
202,0,255,238,193,0,255,230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,255,255,
255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,
80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,
255,255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,
255,255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,201,0,255,
255,210,0,255,255,209,0,255,27,16,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,
0,0,0,255,0,0,0,255,89,71,0,255,245,202,0,255,238,193,0,255,230,189,0,255,214,
170,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,
255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,
0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,
115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,
203,3,255,255,202,1,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,201,0,255,255,210,0,255,255,209,0,255,28,18,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,89,71,0,255,245,
202,0,255,238,193,0,255,230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,255,255,
255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,
80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,
255,255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,
255,255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,201,0,255,
255,210,0,255,255,209,0,255,27,16,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,
0,0,0,255,0,0,0,255,89,71,0,255,245,202,0,255,238,193,0,255,230,189,0,255,214,
170,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,
255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,
0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,
115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,
203,3,255,255,202,1,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,201,0,255,255,210,0,255,255,209,0,255,27,17,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,90,71,0,255,245,
202,0,255,238,193,0,255,230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,255,255,
255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,
80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,
255,255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,
255,255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,201,0,255,
255,210,0,255,255,205,0,255,19,11,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,
0,0,0,255,0,0,0,255,82,66,0,255,245,199,0,255,238,192,0,255,230,189,0,255,214,
170,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,
255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,
0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,
115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,
203,3,255,255,202,1,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,201,0,255,255,208,0,255,250,197,0,255,43,26,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,91,75,0,255,242,
191,0,255,238,190,0,255,230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,255,255,
255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,
80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,
255,255,255,255,255,255,64,52,28,255,115,93,27,255,255,213,25,255,255,210,19,
255,255,205,13,255,255,203,6,255,255,202,1,255,254,201,0,255,254,201,0,255,254,
201,0,255,254,201,0,255,254,201,0,255,254,201,0,255,254,201,0,255,254,201,0,255,
254,201,0,255,254,201,0,255,254,201,0,255,254,201,0,255,254,201,0,255,254,201,0,
255,254,201,0,255,254,201,0,255,254,201,0,255,254,201,0,255,254,201,0,255,254,
201,0,255,254,201,0,255,254,201,0,255,254,201,0,255,254,201,0,255,254,200,0,255,
254,203,0,255,254,215,0,255,240,187,0,255,195,137,0,255,195,133,0,255,195,135,0,
255,195,135,0,255,193,132,0,255,192,133,0,255,241,187,0,255,244,205,0,255,237,
188,0,255,229,188,0,255,214,170,0,255,57,42,0,255,58,41,0,255,255,255,255,255,
255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,
0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,
255,255,255,255,64,52,28,255,114,92,26,255,255,212,22,255,255,209,16,255,255,
204,9,255,255,202,1,255,252,200,0,255,249,197,0,255,248,196,0,255,248,196,0,255,
248,196,0,255,248,196,0,255,248,196,0,255,248,196,0,255,248,196,0,255,248,196,0,
255,248,196,0,255,248,196,0,255,248,196,0,255,248,196,0,255,248,196,0,255,248,
196,0,255,248,196,0,255,248,196,0,255,248,196,0,255,248,196,0,255,248,196,0,255,
248,196,0,255,248,196,0,255,248,196,0,255,248,196,0,255,248,196,0,255,248,195,0,
255,248,199,0,255,248,204,0,255,248,198,0,255,248,204,0,255,248,204,0,255,248,
204,0,255,248,204,0,255,247,198,0,255,245,202,0,255,240,192,0,255,232,183,0,255,
227,186,0,255,213,169,0,255,57,42,0,255,58,40,0,255,255,255,255,255,255,255,255,
255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,
0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,
255,65,51,27,255,113,91,24,255,255,211,18,255,255,208,10,255,255,202,1,255,248,
196,0,255,243,192,0,255,240,190,0,255,239,189,0,255,239,189,0,255,239,189,0,255,
239,189,0,255,239,189,0,255,239,189,0,255,239,189,0,255,239,189,0,255,239,189,0,
255,239,189,0,255,239,189,0,255,239,189,0,255,239,189,0,255,239,189,0,255,239,
189,0,255,239,189,0,255,239,189,0,255,239,189,0,255,239,189,0,255,239,189,0,255,
239,189,0,255,239,189,0,255,239,189,0,255,239,189,0,255,239,189,0,255,239,189,0,
255,238,188,0,255,239,189,0,255,239,191,0,255,239,191,0,255,239,191,0,255,239,
191,0,255,238,189,0,255,235,186,0,255,232,183,0,255,228,181,0,255,224,184,0,255,
211,167,0,255,58,42,0,255,58,40,0,255,255,255,255,255,255,255,255,255,255,255,
255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,
8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,60,48,24,
255,111,88,19,255,255,211,10,255,255,208,0,255,244,192,0,255,236,186,0,255,230,
181,0,255,227,179,0,255,226,178,0,255,226,178,0,255,226,178,0,255,226,178,0,255,
226,178,0,255,226,178,0,255,226,178,0,255,226,178,0,255,226,178,0,255,226,178,0,
255,226,178,0,255,226,178,0,255,226,178,0,255,226,178,0,255,226,178,0,255,226,
178,0,255,226,178,0,255,226,178,0,255,226,178,0,255,226,178,0,255,226,178,0,255,
226,178,0,255,226,178,0,255,226,178,0,255,226,178,0,255,226,178,0,255,226,178,0,
255,226,178,0,255,226,178,0,255,226,178,0,255,226,178,0,255,226,178,0,255,225,
177,0,255,224,177,0,255,222,175,0,255,221,176,0,255,218,179,0,255,209,166,0,255,
57,43,0,255,57,40,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,
128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,
0,48,255,255,255,255,255,255,255,255,255,255,255,255,64,51,19,255,92,71,10,
255,254,201,0,255,242,202,0,255,230,188,0,255,221,179,0,255,216,175,0,255,213,
173,0,255,212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,
212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,
255,212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,212,
172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,
212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,
255,212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,212,
172,0,255,212,172,0,255,212,172,0,255,212,180,0,255,199,151,0,255,53,36,0,255,
66,48,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,
120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,
255,255,255,255,255,255,255,255,255,255,255,95,71,10,255,43,29,0,255,171,128,0,
255,227,175,0,255,217,179,0,255,209,170,0,255,206,168,0,255,203,166,0,255,203,
166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,
203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,
255,203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,203,
166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,
203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,
255,203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,203,
166,0,255,204,168,0,255,206,162,0,255,131,100,0,255,32,20,0,255,98,70,0,255,255,
255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,
80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,
255,255,255,255,255,255,73,50,0,255,25,14,0,255,48,32,0,255,89,62,0,255,105,79,
0,255,105,80,0,255,105,80,0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,
0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,
0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,
0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,
0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,
0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,
0,255,103,79,0,255,105,79,0,255,103,78,0,255,79,58,0,255,37,26,0,255,32,19,0,
255,83,60,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,
120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,
255,255,255,255,255,255,255,255,255,255,255,34,0,0,255,54,38,0,255,61,43,0,255,
47,32,0,255,41,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,
0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,
40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,
0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,
40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,
0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,
40,27,0,255,40,27,0,255,47,33,0,255,62,45,0,255,61,43,0,255,29,29,0,255,255,
255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,
80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,47,232,232,232,214,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,221,221,221,225,0,0,0,127,0,0,0,119,0,0,0,103,0,0,0,79,
0,0,0,47,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,23,0,0,0,46,164,164,164,140,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,133,133,133,173,0,0,0,127,0,0,0,119,0,0,0,102,0,0,0,78,
0,0,0,46,0,0,0,23,0,0,0,8,0,0,0,7,0,0,0,21,0,0,0,44,0,0,0,75,148,148,148,155,
223,223,223,223,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,221,221,221,225,
133,133,133,173,0,0,0,127,0,0,0,126,0,0,0,117,0,0,0,100,0,0,0,75,0,0,0,44,0,0,0,
21,0,0,0,7,0,0,0,5,0,0,0,18,0,0,0,39,0,0,0,68,0,0,0,94,0,0,0,113,0,0,0,124,0,0,
0,127,0,0,0,127,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,
0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,
0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,127,0,0,0,127,0,0,0,124,0,0,0,113,0,0,0,94,0,0,0,68,0,0,0,39,0,0,0,18,
0,0,0,5,0,0,0,4,0,0,0,14,0,0,0,33,0,0,0,58,0,0,0,84,0,0,0,105,0,0,0,118,0,0,0,
124,0,0,0,126,0,0,0,127,0,0,0,127,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,127,0,0,0,127,0,0,0,
126,0,0,0,124,0,0,0,118,0,0,0,105,0,0,0,84,0,0,0,58,0,0,0,33,0,0,0,14,0,0,0,4,0,
0,0,2,0,0,0,10,0,0,0,24,0,0,0,45,0,0,0,69,0,0,0,90,0,0,0,105,0,0,0,113,0,0,0,
117,0,0,0,119,0,0,0,119,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,
120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,
120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,
120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,
120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,
120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,119,0,0,0,119,0,0,0,117,0,0,0,
113,0,0,0,105,0,0,0,90,0,0,0,69,0,0,0,45,0,0,0,24,0,0,0,10,0,0,0,2,0,0,0,1,0,0,
0,6,0,0,0,15,0,0,0,31,0,0,0,50,0,0,0,69,0,0,0,84,0,0,0,94,0,0,0,100,0,0,0,102,
0,0,0,103,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,
104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,
104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,
104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,
104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,
104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,103,0,0,0,102,0,0,0,100,0,0,0,94,0,0,0,
84,0,0,0,69,0,0,0,50,0,0,0,31,0,0,0,15,0,0,0,6,0,0,0,1,255,255,255,0,0,0,0,3,0,
0,0,8,0,0,0,18,0,0,0,31,0,0,0,45,0,0,0,58,0,0,0,68,0,0,0,75,0,0,0,78,0,0,0,79,
0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,
80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,
0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,
0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,
80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,79,0,0,
0,78,0,0,0,75,0,0,0,68,0,0,0,58,0,0,0,45,0,0,0,31,0,0,0,18,0,0,0,8,0,0,0,3,
255,255,255,0,255,255,255,0,0,0,0,1,0,0,0,3,0,0,0,8,0,0,0,15,0,0,0,24,0,0,0,33,
0,0,0,39,0,0,0,44,0,0,0,46,0,0,0,47,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,
48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,
0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,
0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,
48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,
0,48,0,0,0,48,0,0,0,48,0,0,0,47,0,0,0,46,0,0,0,44,0,0,0,39,0,0,0,33,0,0,0,24,
0,0,0,15,0,0,0,8,0,0,0,3,0,0,0,1,255,255,255,0,255,255,255,0,255,255,255,0,0,
0,0,1,0,0,0,3,0,0,0,6,0,0,0,10,0,0,0,14,0,0,0,18,0,0,0,21,0,0,0,23,0,0,0,24,0,
0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,
24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,
0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,
0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,
24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,
0,23,0,0,0,21,0,0,0,18,0,0,0,14,0,0,0,10,0,0,0,6,0,0,0,3,0,0,0,1,255,255,255,
0,255,255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,0,0,0,
1,0,0,0,2,0,0,0,4,0,0,0,5,0,0,0,7,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,
0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,
0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,
0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,
8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,
0,8,0,0,0,8,0,0,0,7,0,0,0,5,0,0,0,4,0,0,0,2,0,0,0,1,255,255,255,0,255,255,255,
0,255,255,255,0,255,255,255,0};
static Fl_RGB_Image image_HardLeft(idata_HardLeft, 64, 64, 4, 0);

void TrackEditorUI::cb_hardRight_i(Fl_Menu_*, void*) {
  trackView->setSign(kHardRight);
}
void TrackEditorUI::cb_hardRight(Fl_Menu_* o, void* v) {
  ((TrackEditorUI*)(o->parent()->user_data()))->cb_hardRight_i(o,v);
}

static unsigned char idata_HardRight[] =
{255,255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,0,0,0,1,0,0,0,2,0,
0,0,4,0,0,0,5,0,0,0,7,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,
0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,
8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,
0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,
0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,
0,0,0,7,0,0,0,5,0,0,0,4,0,0,0,2,0,0,0,1,255,255,255,0,255,255,255,0,255,255,
255,0,255,255,255,0,255,255,255,0,255,255,255,0,0,0,0,1,0,0,0,3,0,0,0,6,0,0,0,
10,0,0,0,14,0,0,0,18,0,0,0,21,0,0,0,23,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,
0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,
0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,
24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,
0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,
0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,23,0,0,0,21,0,0,0,18,0,0,0,
14,0,0,0,10,0,0,0,6,0,0,0,3,0,0,0,1,255,255,255,0,255,255,255,0,255,255,255,0,
0,0,0,1,0,0,0,3,0,0,0,8,230,230,230,100,247,247,247,201,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,241,241,241,206,194,194,194,118,0,0,0,39,0,0,0,33,0,
0,0,24,0,0,0,15,0,0,0,8,0,0,0,3,0,0,0,1,255,255,255,0,255,255,255,0,0,0,0,3,0,
0,0,8,225,225,225,102,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,171,171,171,134,0,0,0,
58,0,0,0,45,0,0,0,31,0,0,0,18,0,0,0,8,0,0,0,3,255,255,255,0,0,0,0,1,0,0,0,6,0,
0,0,15,246,246,246,202,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,229,229,229,217,0,0,
0,84,0,0,0,69,0,0,0,50,0,0,0,31,0,0,0,15,0,0,0,6,0,0,0,1,0,0,0,2,0,0,0,10,0,0,
0,24,255,255,255,255,255,255,255,255,255,255,255,255,74,74,44,255,105,88,46,
255,114,93,49,255,101,85,50,255,97,83,51,255,97,84,52,255,97,85,52,255,97,85,52,
255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,
255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,
255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,
255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,
255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,
255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,97,84,51,255,95,80,48,
255,96,80,43,255,109,87,34,255,95,75,22,255,44,44,9,255,255,255,255,255,255,255,
255,255,255,255,255,255,0,0,0,105,0,0,0,90,0,0,0,69,0,0,0,45,0,0,0,24,0,0,0,10,
0,0,0,2,0,0,0,4,0,0,0,14,0,0,0,33,255,255,255,255,255,255,255,255,255,255,255,
255,117,87,39,255,72,59,42,255,83,71,45,255,116,98,47,255,128,106,49,255,128,
106,50,255,128,107,50,255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,
51,255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,51,
255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,51,255,
129,108,51,255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,51,255,129,
108,51,255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,
51,255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,51,
255,129,108,51,255,129,108,51,255,129,108,51,255,129,107,50,255,128,106,49,255,
126,105,47,255,122,100,42,255,100,82,34,255,58,46,22,255,47,31,9,255,105,70,0,
255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,118,0,0,0,105,0,0,0,
84,0,0,0,58,0,0,0,33,0,0,0,14,0,0,0,4,0,0,0,5,0,0,0,18,0,0,0,39,255,255,255,
255,255,255,255,255,255,255,255,255,119,98,35,255,78,64,37,255,188,150,40,255,
254,209,43,255,255,217,45,255,255,214,46,255,255,216,46,255,255,216,46,255,255,
216,46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,216,
46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,216,46,
255,255,216,46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,216,46,255,
255,216,46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,
216,46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,216,
46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,216,46,
255,255,216,46,255,255,215,43,255,255,215,40,255,255,213,32,255,249,195,22,255,
152,117,8,255,35,22,0,255,113,83,0,255,255,255,255,255,255,255,255,255,255,255,
255,255,0,0,0,124,0,0,0,113,0,0,0,94,0,0,0,68,0,0,0,39,0,0,0,18,0,0,0,5,0,0,0,7,
0,0,0,21,0,0,0,44,255,255,255,255,255,255,255,255,255,255,255,255,77,62,31,
255,106,88,34,255,253,201,36,255,255,220,37,255,255,214,38,255,255,212,38,255,
255,214,38,255,255,213,37,255,255,213,37,255,255,213,37,255,255,213,37,255,255,
213,37,255,255,213,37,255,255,213,37,255,255,213,37,255,255,213,37,255,255,213,
37,255,255,213,37,255,255,213,37,255,255,213,37,255,255,213,37,255,255,213,37,
255,255,213,37,255,255,213,37,255,255,213,37,255,255,213,37,255,255,213,37,255,
255,213,37,255,255,213,37,255,255,213,37,255,255,213,37,255,255,213,37,255,255,
213,37,255,255,213,37,255,255,213,37,255,255,213,37,255,255,213,37,255,255,213,
37,255,255,213,37,255,255,213,37,255,255,213,37,255,255,213,34,255,255,212,29,
255,255,213,20,255,255,215,7,255,231,175,0,255,55,39,0,255,70,51,0,255,255,255,
255,255,255,255,255,255,255,255,255,255,0,0,0,126,0,0,0,117,0,0,0,100,0,0,0,75,
0,0,0,44,0,0,0,21,0,0,0,7,0,0,0,8,0,0,0,23,0,0,0,46,255,255,255,255,255,255,
255,255,255,255,255,255,65,54,30,255,117,96,31,255,255,212,31,255,255,213,31,
255,254,207,31,255,254,206,29,255,255,208,28,255,255,208,27,255,255,207,26,255,
255,207,26,255,255,207,26,255,255,207,26,255,255,207,26,255,255,207,26,255,255,
207,26,255,255,207,26,255,255,207,26,255,255,207,26,255,255,207,26,255,255,207,
26,255,255,207,26,255,255,207,26,255,255,207,26,255,255,207,26,255,255,207,26,
255,255,207,26,255,255,207,26,255,255,207,26,255,255,207,26,255,255,207,26,255,
255,207,26,255,255,207,26,255,255,207,26,255,255,207,26,255,255,207,26,255,255,
207,26,255,255,207,26,255,255,207,26,255,255,207,26,255,255,207,26,255,255,207,
25,255,255,207,22,255,255,205,16,255,255,201,6,255,251,205,0,255,232,177,0,255,
60,44,0,255,57,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,
127,0,0,0,119,0,0,0,102,0,0,0,78,0,0,0,46,0,0,0,23,0,0,0,8,0,0,0,8,0,0,0,24,0,0,
0,47,255,255,255,255,255,255,255,255,255,255,255,255,61,52,28,255,115,95,29,
255,255,211,28,255,255,212,26,255,254,205,23,255,255,206,19,255,255,206,17,255,
255,205,15,255,255,205,15,255,255,205,15,255,255,205,15,255,255,205,15,255,255,
205,15,255,255,205,15,255,255,205,15,255,255,205,15,255,255,205,15,255,255,205,
15,255,255,205,15,255,255,205,15,255,255,205,15,255,255,205,15,255,255,205,15,
255,255,205,15,255,255,205,15,255,255,207,15,255,255,209,15,255,255,209,15,255,
255,207,15,255,255,205,15,255,255,205,15,255,255,205,15,255,255,205,15,255,255,
205,15,255,255,205,15,255,255,205,15,255,255,205,15,255,255,205,15,255,255,205,
15,255,255,205,15,255,255,205,13,255,255,204,10,255,255,203,4,255,251,199,0,
255,240,197,0,255,221,175,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,
255,255,255,255,255,255,0,0,0,127,0,0,0,119,0,0,0,103,0,0,0,79,0,0,0,47,0,0,0,
24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,
255,255,64,52,28,255,117,94,28,255,255,213,26,255,255,210,23,255,255,206,18,255,
255,205,13,255,255,204,10,255,255,203,7,255,255,203,6,255,255,203,6,255,255,203,
6,255,255,203,6,255,255,203,6,255,255,203,6,255,255,203,6,255,255,203,6,255,
255,203,6,255,255,203,6,255,255,203,6,255,255,203,6,255,255,203,6,255,255,203,6,
255,255,203,6,255,255,203,6,255,255,207,6,255,255,214,6,255,249,197,6,255,252,
200,6,255,255,213,6,255,255,209,6,255,255,203,6,255,255,202,6,255,255,203,6,255,
255,203,6,255,255,203,6,255,255,203,6,255,255,203,6,255,255,203,6,255,255,203,6,
255,255,203,6,255,255,203,5,255,255,202,1,255,251,199,0,255,243,192,0,255,233,
189,0,255,217,171,0,255,57,44,0,255,59,41,0,255,255,255,255,255,255,255,255,255,
255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,
8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,
63,52,28,255,115,94,28,255,255,213,25,255,255,210,21,255,255,205,15,255,255,
204,9,255,255,203,5,255,255,202,2,255,255,202,1,255,255,202,1,255,255,202,1,255,
255,202,1,255,255,202,1,255,255,202,1,255,255,202,1,255,255,202,1,255,255,202,1,
255,255,202,1,255,255,202,1,255,255,202,1,255,255,202,1,255,255,202,1,255,255,
202,1,255,255,202,1,255,255,210,1,255,239,188,1,255,61,59,1,255,59,60,1,255,181,
160,1,255,255,205,1,255,255,216,1,255,255,206,1,255,255,203,1,255,255,201,1,255,
255,202,1,255,255,202,1,255,255,202,1,255,255,202,1,255,255,202,1,255,255,202,1,
255,255,202,0,255,253,200,0,255,247,196,0,255,239,189,0,255,230,189,0,255,214,
169,0,255,57,43,0,255,59,41,0,255,255,255,255,255,255,255,255,255,255,255,255,
255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,
0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,65,52,28,255,
115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,
203,3,255,255,202,1,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
204,0,255,254,202,0,255,161,122,0,255,0,0,0,255,0,0,0,255,8,9,0,255,97,85,0,255,
238,191,0,255,255,213,0,255,255,212,0,255,255,204,0,255,255,201,0,255,255,201,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,254,201,0,255,251,
199,0,255,245,194,0,255,238,189,0,255,230,189,0,255,217,165,0,255,57,43,0,255,
59,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,
120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,
255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,
25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,
255,202,0,255,255,202,0,255,255,201,0,255,255,201,0,255,255,201,0,255,255,201,0,
255,255,201,0,255,255,201,0,255,255,201,0,255,255,201,0,255,255,201,0,255,255,
201,0,255,255,201,0,255,255,201,0,255,255,201,0,255,255,203,0,255,255,207,0,255,
199,158,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,30,27,0,255,141,124,0,255,
245,196,0,255,255,216,0,255,255,209,0,255,255,202,0,255,255,201,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,
189,0,255,230,189,0,255,216,165,0,255,57,43,0,255,58,41,0,255,255,255,255,255,
255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,
0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,
255,255,255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,255,255,
205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,255,201,0,255,255,202,0,
255,255,203,0,255,255,207,0,255,255,208,0,255,255,209,0,255,255,209,0,255,255,
209,0,255,255,209,0,255,255,209,0,255,255,209,0,255,255,209,0,255,255,209,0,255,
255,209,0,255,255,209,0,255,255,210,0,255,255,220,0,255,255,208,0,255,24,19,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,50,48,0,255,183,158,0,255,
253,202,0,255,255,218,0,255,255,206,0,255,255,203,0,255,255,201,0,255,255,202,0,
255,254,201,0,255,251,199,0,255,245,194,0,255,238,189,0,255,230,189,0,255,217,
165,0,255,57,43,0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,
255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,
0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,
115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,
203,3,255,255,202,1,255,255,206,0,255,255,212,0,255,255,209,0,255,255,207,0,255,
255,204,0,255,255,206,0,255,255,208,0,255,255,209,0,255,255,204,0,255,255,209,0,
255,255,207,0,255,255,207,0,255,255,206,0,255,255,208,0,255,255,206,0,255,255,
206,0,255,255,215,0,255,255,206,0,255,61,45,0,255,0,0,0,255,0,0,0,255,0,0,0,255,
0,0,0,255,0,0,0,255,0,0,0,255,3,6,0,255,84,73,0,255,236,186,0,255,255,213,0,
255,255,212,0,255,255,204,0,255,255,203,0,255,254,200,0,255,251,199,0,255,245,
194,0,255,238,189,0,255,230,189,0,255,214,169,0,255,57,43,0,255,58,41,0,255,255,
255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,
80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,
255,255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,
255,255,205,14,255,255,203,8,255,255,203,3,255,255,207,1,255,255,213,0,255,246,
197,0,255,169,143,0,255,104,96,0,255,74,53,0,255,70,51,0,255,68,65,0,255,66,64,
0,255,56,46,0,255,64,63,0,255,52,55,0,255,53,52,0,255,52,43,0,255,52,51,0,255,
52,43,0,255,52,52,0,255,53,56,0,255,52,45,0,255,4,4,0,255,0,0,0,255,0,0,0,255,
0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,25,25,0,255,138,
125,0,255,246,196,0,255,255,213,0,255,255,210,0,255,254,201,0,255,251,198,0,255,
245,194,0,255,238,189,0,255,230,189,0,255,217,165,0,255,57,43,0,255,58,41,0,255,
255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,
0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,
255,255,255,255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,
210,20,255,255,205,14,255,255,203,8,255,255,209,3,255,255,212,1,255,181,144,0,
255,46,43,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,
0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,
0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,
0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,54,47,0,255,185,147,0,255,
255,204,0,255,254,214,0,255,251,203,0,255,245,195,0,255,238,189,0,255,230,189,0,
255,215,165,0,255,57,43,0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,
255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,
0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,64,52,
28,255,115,94,28,255,255,213,25,255,255,210,20,255,255,204,14,255,255,205,8,
255,255,216,3,255,235,187,1,255,30,27,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,11,11,0,255,109,98,0,255,239,189,0,255,251,207,0,255,245,201,0,
255,238,189,0,255,230,189,0,255,218,165,0,255,57,43,0,255,58,41,0,255,255,255,
255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,
0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,
255,255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,
255,255,204,14,255,255,209,8,255,255,206,3,255,96,74,1,255,0,0,0,255,0,0,0,255,
0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,25,23,0,255,159,
127,0,255,245,195,0,255,238,190,0,255,230,189,0,255,215,165,0,255,57,43,0,255,
58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,
120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,
255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,
25,255,255,210,20,255,255,204,14,255,255,211,8,255,255,205,3,255,18,17,1,255,0,
0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,
0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,8,2,0,255,135,95,0,255,241,189,0,255,238,190,0,255,230,189,0,255,214,169,0,
255,57,43,0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,
0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,
0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,115,94,
28,255,255,213,25,255,255,210,20,255,255,204,14,255,255,212,8,255,255,207,3,
255,1,1,1,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,70,48,0,255,230,181,0,255,251,202,0,255,245,201,0,255,238,189,0,255,230,189,
0,255,217,165,0,255,57,43,0,255,58,41,0,255,255,255,255,255,255,255,255,255,
255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,
8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,
64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,255,255,204,14,255,255,
212,8,255,255,209,3,255,1,1,1,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,24,15,0,255,137,94,0,255,245,189,0,255,254,219,0,255,251,205,0,255,245,194,
0,255,237,187,0,255,230,189,0,255,214,169,0,255,57,43,0,255,58,41,0,255,255,
255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,
80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,
255,255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,
255,255,204,14,255,255,212,8,255,255,208,3,255,1,1,1,255,0,0,0,255,0,0,0,255,0,
0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,
0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,9,5,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,71,48,0,255,232,182,0,255,255,208,0,255,255,215,0,255,
254,203,0,255,250,197,0,255,245,194,0,255,238,189,0,255,230,187,0,255,214,169,0,
255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,
0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,
0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,115,94,
28,255,255,213,25,255,255,210,20,255,255,204,14,255,255,212,8,255,255,208,3,
255,1,1,1,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,11,6,
0,255,159,124,0,255,254,203,0,255,255,208,0,255,255,209,0,255,255,207,0,255,
255,207,0,255,255,207,0,255,255,207,0,255,255,208,0,255,255,214,0,255,255,203,0,
255,50,42,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,
0,255,25,15,0,255,138,95,0,255,245,188,0,255,255,220,0,255,255,208,0,255,255,
202,0,255,253,199,0,255,251,199,0,255,245,194,0,255,238,188,0,255,230,189,0,255,
214,170,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,
255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,
8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,64,52,28,
255,115,94,28,255,255,213,25,255,255,210,20,255,255,204,14,255,255,212,8,255,
255,209,3,255,1,1,1,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,74,55,0,255,255,205,0,255,255,220,0,255,255,209,0,255,255,210,0,255,255,210,
0,255,255,210,0,255,255,210,0,255,255,210,0,255,255,209,0,255,255,220,0,255,
255,215,0,255,29,26,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,
0,255,79,48,0,255,236,184,0,255,255,208,0,255,255,213,0,255,255,204,0,255,254,
200,0,255,255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,188,0,255,
230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,255,
255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,
0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,
255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,255,255,204,14,255,255,
212,8,255,255,209,3,255,1,1,1,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,103,80,0,255,255,212,0,255,255,208,0,255,254,199,0,255,255,201,0,
255,255,201,0,255,255,201,0,255,255,201,0,255,255,201,0,255,255,202,0,255,255,
214,0,255,253,201,0,255,5,2,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,32,19,
0,255,155,109,0,255,248,192,0,255,255,220,0,255,255,208,0,255,255,202,0,255,
254,200,0,255,255,202,0,255,255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,
255,238,188,0,255,230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,255,255,255,
255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,
0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,
255,255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,
255,255,204,14,255,255,212,8,255,255,209,3,255,1,1,1,255,0,0,0,255,0,0,0,255,0,
0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,107,81,0,255,255,209,0,255,255,206,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,203,0,255,255,208,0,255,173,146,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,3,0,0,255,94,65,0,255,238,186,0,255,255,210,0,255,255,212,0,255,255,204,0,
255,254,200,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,254,
201,0,255,251,199,0,255,245,194,0,255,238,188,0,255,230,189,0,255,214,170,0,255,
57,42,0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,
128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,
0,48,255,255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,115,94,28,
255,255,213,25,255,255,210,20,255,255,204,14,255,255,212,8,255,255,209,3,255,1,
1,1,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,106,81,0,
255,255,209,0,255,255,206,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,204,0,255,255,200,0,255,152,119,0,255,
0,0,0,255,0,0,0,255,39,27,0,255,174,125,0,255,253,196,0,255,255,218,0,255,255,
208,0,255,255,202,0,255,254,200,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,188,0,
255,230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,
255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,
24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,
255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,255,255,204,14,255,
255,212,8,255,255,209,3,255,1,1,1,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,
0,0,255,0,0,0,255,107,80,0,255,255,209,0,255,255,206,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,203,0,255,
255,210,0,255,250,196,0,255,159,110,0,255,149,104,0,255,241,188,0,255,255,213,0,
255,255,212,0,255,255,204,0,255,254,200,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,254,201,0,255,
251,199,0,255,245,194,0,255,238,188,0,255,230,189,0,255,214,170,0,255,57,42,0,
255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,
120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,
255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,
25,255,255,210,20,255,255,204,14,255,255,212,8,255,255,209,3,255,1,1,1,255,0,0,
0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,101,71,0,255,255,208,
0,255,255,206,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,203,0,255,255,209,0,255,255,202,0,
255,254,201,0,255,255,213,0,255,255,206,0,255,255,202,0,255,254,200,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,188,0,
255,230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,
255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,
24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,
255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,255,255,204,14,255,
255,212,8,255,255,209,3,255,1,1,1,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,
0,0,255,0,0,0,255,107,80,0,255,255,209,0,255,255,206,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,201,0,255,255,203,0,255,255,202,0,255,255,202,0,255,254,200,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,254,201,0,255,
251,199,0,255,245,194,0,255,238,188,0,255,230,189,0,255,214,170,0,255,57,42,0,
255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,
120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,
255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,
25,255,255,210,20,255,255,204,14,255,255,212,8,255,255,209,3,255,1,1,1,255,0,0,
0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,106,81,0,255,255,209,
0,255,255,206,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,188,0,
255,230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,
255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,
24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,
255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,255,255,204,14,255,
255,212,8,255,255,209,3,255,1,1,1,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,
0,0,255,0,0,0,255,106,81,0,255,255,209,0,255,255,206,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,254,201,0,255,
251,199,0,255,245,194,0,255,238,188,0,255,230,189,0,255,214,170,0,255,57,42,0,
255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,
120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,
255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,
25,255,255,210,20,255,255,204,14,255,255,212,8,255,255,209,3,255,1,1,1,255,0,0,
0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,106,81,0,255,255,209,
0,255,255,206,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,188,0,
255,230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,
255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,
24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,
255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,255,255,204,14,255,
255,212,8,255,255,209,3,255,1,1,1,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,
0,0,255,0,0,0,255,106,81,0,255,255,209,0,255,255,206,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,254,201,0,255,
251,199,0,255,245,194,0,255,238,188,0,255,230,189,0,255,214,170,0,255,57,42,0,
255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,
120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,
255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,
25,255,255,210,20,255,255,204,14,255,255,212,8,255,255,209,3,255,1,1,1,255,0,0,
0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,109,81,0,255,255,207,
0,255,255,206,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,188,0,
255,230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,
255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,
24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,
255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,255,255,204,14,255,
255,212,8,255,255,209,3,255,1,1,1,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,
0,0,255,0,0,0,255,119,85,0,255,255,210,0,255,255,206,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,254,201,0,255,
251,199,0,255,245,194,0,255,238,188,0,255,230,189,0,255,214,170,0,255,57,42,0,
255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,
120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,
255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,
25,255,255,210,20,255,255,204,14,255,255,212,8,255,255,209,3,255,1,1,1,255,0,0,
0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,109,81,0,255,255,207,
0,255,255,206,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,188,0,
255,230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,
255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,
24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,
255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,255,255,204,14,255,
255,212,8,255,255,209,3,255,1,1,1,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,
0,0,255,0,0,0,255,106,81,0,255,255,209,0,255,255,206,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,254,201,0,255,
251,199,0,255,245,194,0,255,238,188,0,255,230,189,0,255,214,170,0,255,57,42,0,
255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,
120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,
255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,
25,255,255,210,20,255,255,204,14,255,255,212,8,255,255,209,3,255,1,1,1,255,0,0,
0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,106,81,0,255,255,209,
0,255,255,206,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,188,0,
255,230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,
255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,
24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,
255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,255,255,204,14,255,
255,212,8,255,255,209,3,255,1,1,1,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,
0,0,255,0,0,0,255,107,81,0,255,255,209,0,255,255,206,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,254,201,0,255,
251,199,0,255,245,194,0,255,238,188,0,255,230,189,0,255,214,170,0,255,57,42,0,
255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,
120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,
255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,
25,255,255,210,20,255,255,204,14,255,255,212,8,255,255,207,3,255,1,1,1,255,0,0,
0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,105,80,0,255,255,208,
0,255,255,206,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,188,0,
255,230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,
255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,
24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,
255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,255,255,204,14,255,
255,211,8,255,255,202,3,255,1,1,1,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,
0,0,255,0,0,0,255,119,89,0,255,255,206,0,255,255,204,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,254,201,0,255,
251,199,0,255,245,194,0,255,238,188,0,255,230,189,0,255,214,170,0,255,57,42,0,
255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,
120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,
255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,115,93,27,255,255,213,
25,255,255,210,19,255,255,204,13,255,255,209,6,255,255,202,1,255,115,69,0,255,
97,63,0,255,118,70,0,255,120,70,0,255,124,82,0,255,120,81,0,255,120,82,0,255,
195,153,0,255,254,206,0,255,254,201,0,255,254,201,0,255,254,201,0,255,254,201,0,
255,254,201,0,255,254,201,0,255,254,201,0,255,254,201,0,255,254,201,0,255,254,
201,0,255,254,201,0,255,254,201,0,255,254,201,0,255,254,201,0,255,254,201,0,255,
254,201,0,255,254,201,0,255,254,201,0,255,254,201,0,255,254,201,0,255,254,201,0,
255,254,201,0,255,254,201,0,255,254,201,0,255,253,200,0,255,249,197,0,255,244,
193,0,255,237,187,0,255,229,188,0,255,214,170,0,255,57,42,0,255,58,41,0,255,255,
255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,
80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,
255,255,255,255,255,255,64,52,28,255,114,92,26,255,255,212,22,255,255,209,16,
255,255,203,9,255,255,204,1,255,252,210,0,255,248,193,0,255,248,201,0,255,248,
204,0,255,248,202,0,255,248,203,0,255,248,201,0,255,248,196,0,255,248,201,0,255,
248,201,0,255,247,195,0,255,248,196,0,255,248,196,0,255,248,196,0,255,248,196,0,
255,248,196,0,255,248,196,0,255,248,196,0,255,248,196,0,255,248,196,0,255,248,
196,0,255,248,196,0,255,248,196,0,255,248,196,0,255,248,196,0,255,248,196,0,255,
248,196,0,255,248,196,0,255,248,196,0,255,248,196,0,255,248,196,0,255,248,196,0,
255,248,196,0,255,248,196,0,255,247,196,0,255,245,194,0,255,240,190,0,255,233,
184,0,255,227,186,0,255,213,169,0,255,57,42,0,255,58,40,0,255,255,255,255,255,
255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,
0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,
255,255,255,255,65,51,27,255,113,91,24,255,255,211,18,255,255,208,10,255,255,
202,1,255,248,196,0,255,243,192,0,255,240,192,0,255,239,193,0,255,239,193,0,255,
239,193,0,255,239,193,0,255,239,193,0,255,239,192,0,255,239,190,0,255,238,188,0,
255,238,187,0,255,239,189,0,255,239,189,0,255,239,189,0,255,239,189,0,255,239,
189,0,255,239,189,0,255,239,189,0,255,239,189,0,255,239,189,0,255,239,189,0,255,
239,189,0,255,239,189,0,255,239,189,0,255,239,189,0,255,239,189,0,255,239,189,0,
255,239,189,0,255,239,189,0,255,239,189,0,255,239,189,0,255,239,189,0,255,239,
189,0,255,239,189,0,255,238,189,0,255,236,187,0,255,233,185,0,255,228,180,0,255,
224,184,0,255,211,167,0,255,58,42,0,255,58,40,0,255,255,255,255,255,255,255,255,
255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,
0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,
255,60,48,24,255,111,88,19,255,255,211,10,255,255,208,0,255,244,192,0,255,236,
186,0,255,230,181,0,255,227,179,0,255,226,178,0,255,226,178,0,255,226,178,0,255,
226,178,0,255,226,178,0,255,226,178,0,255,226,178,0,255,226,178,0,255,226,178,0,
255,226,178,0,255,226,178,0,255,226,178,0,255,226,178,0,255,226,178,0,255,226,
178,0,255,226,178,0,255,226,178,0,255,226,178,0,255,226,178,0,255,226,178,0,255,
226,178,0,255,226,178,0,255,226,178,0,255,226,178,0,255,226,178,0,255,226,178,0,
255,226,178,0,255,226,178,0,255,226,178,0,255,226,178,0,255,226,178,0,255,226,
178,0,255,225,177,0,255,224,177,0,255,222,175,0,255,221,174,0,255,218,179,0,255,
209,166,0,255,57,43,0,255,57,40,0,255,255,255,255,255,255,255,255,255,255,255,
255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,
8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,64,51,19,
255,92,71,10,255,254,201,0,255,242,202,0,255,230,188,0,255,221,179,0,255,216,
175,0,255,213,173,0,255,212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,
212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,
255,212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,212,
172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,
212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,
255,212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,212,
172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,212,180,0,255,199,151,0,255,
53,36,0,255,66,48,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,
128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,
0,48,255,255,255,255,255,255,255,255,255,255,255,255,95,71,10,255,43,29,0,255,
171,128,0,255,227,175,0,255,217,179,0,255,209,170,0,255,206,168,0,255,203,166,0,
255,203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,203,
166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,
203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,
255,203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,203,
166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,
203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,
255,203,166,0,255,204,168,0,255,206,162,0,255,131,100,0,255,32,20,0,255,98,70,0,
255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,
104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,
255,255,255,255,255,255,255,255,255,73,50,0,255,25,14,0,255,48,32,0,255,89,62,0,
255,105,79,0,255,105,80,0,255,105,80,0,255,103,79,0,255,103,79,0,255,103,79,0,
255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,
255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,
255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,
255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,
255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,
255,103,79,0,255,103,79,0,255,105,79,0,255,103,78,0,255,79,58,0,255,37,26,0,255,
32,19,0,255,83,60,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,
128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,
0,48,255,255,255,255,255,255,255,255,255,255,255,255,34,0,0,255,54,38,0,255,
61,43,0,255,47,32,0,255,41,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,
0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,
40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,
0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,
40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,
0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,
40,27,0,255,40,27,0,255,40,27,0,255,47,33,0,255,62,45,0,255,61,43,0,255,29,29,
0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,
0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,47,232,232,
232,214,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,221,221,221,225,0,0,0,127,0,0,0,119,0,0,
0,103,0,0,0,79,0,0,0,47,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,23,0,0,0,46,164,164,
164,140,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,133,133,133,173,0,0,0,127,0,0,0,119,0,0,
0,102,0,0,0,78,0,0,0,46,0,0,0,23,0,0,0,8,0,0,0,7,0,0,0,21,0,0,0,44,0,0,0,75,
148,148,148,155,223,223,223,223,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
221,221,221,225,133,133,133,173,0,0,0,127,0,0,0,126,0,0,0,117,0,0,0,100,0,0,0,
75,0,0,0,44,0,0,0,21,0,0,0,7,0,0,0,5,0,0,0,18,0,0,0,39,0,0,0,68,0,0,0,94,0,0,0,
113,0,0,0,124,0,0,0,127,0,0,0,127,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,127,0,0,0,127,0,0,0,124,0,0,0,113,0,0,0,94,0,0,0,68,0,0,0,
39,0,0,0,18,0,0,0,5,0,0,0,4,0,0,0,14,0,0,0,33,0,0,0,58,0,0,0,84,0,0,0,105,0,0,
0,118,0,0,0,124,0,0,0,126,0,0,0,127,0,0,0,127,0,0,0,128,0,0,0,128,0,0,0,128,0,
0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,
0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
127,0,0,0,127,0,0,0,126,0,0,0,124,0,0,0,118,0,0,0,105,0,0,0,84,0,0,0,58,0,0,0,
33,0,0,0,14,0,0,0,4,0,0,0,2,0,0,0,10,0,0,0,24,0,0,0,45,0,0,0,69,0,0,0,90,0,0,0,
105,0,0,0,113,0,0,0,117,0,0,0,119,0,0,0,119,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,
120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,
120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,
120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,
120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,
120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,119,0,0,0,
119,0,0,0,117,0,0,0,113,0,0,0,105,0,0,0,90,0,0,0,69,0,0,0,45,0,0,0,24,0,0,0,10,
0,0,0,2,0,0,0,1,0,0,0,6,0,0,0,15,0,0,0,31,0,0,0,50,0,0,0,69,0,0,0,84,0,0,0,94,
0,0,0,100,0,0,0,102,0,0,0,103,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,
104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,
104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,
104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,
104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,
104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,103,0,0,0,102,0,0,0,
100,0,0,0,94,0,0,0,84,0,0,0,69,0,0,0,50,0,0,0,31,0,0,0,15,0,0,0,6,0,0,0,1,255,
255,255,0,0,0,0,3,0,0,0,8,0,0,0,18,0,0,0,31,0,0,0,45,0,0,0,58,0,0,0,68,0,0,0,75,
0,0,0,78,0,0,0,79,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,
80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,
0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,
0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,
80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,
0,80,0,0,0,79,0,0,0,78,0,0,0,75,0,0,0,68,0,0,0,58,0,0,0,45,0,0,0,31,0,0,0,18,
0,0,0,8,0,0,0,3,255,255,255,0,255,255,255,0,0,0,0,1,0,0,0,3,0,0,0,8,0,0,0,15,
0,0,0,24,0,0,0,33,0,0,0,39,0,0,0,44,0,0,0,46,0,0,0,47,0,0,0,48,0,0,0,48,0,0,0,
48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,
0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,
0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,
48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,
0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,47,0,0,0,46,0,0,0,44,0,0,0,39,
0,0,0,33,0,0,0,24,0,0,0,15,0,0,0,8,0,0,0,3,0,0,0,1,255,255,255,0,255,255,255,
0,255,255,255,0,0,0,0,1,0,0,0,3,0,0,0,6,0,0,0,10,0,0,0,14,0,0,0,18,0,0,0,21,0,
0,0,23,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,
24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,
0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,
0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,
24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,
0,24,0,0,0,24,0,0,0,23,0,0,0,21,0,0,0,18,0,0,0,14,0,0,0,10,0,0,0,6,0,0,0,3,0,
0,0,1,255,255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,
255,255,255,0,0,0,0,1,0,0,0,2,0,0,0,4,0,0,0,5,0,0,0,7,0,0,0,8,0,0,0,8,0,0,0,8,0,
0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,
0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,
8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,
0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,
0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,7,0,0,0,5,0,0,0,4,0,0,0,2,0,0,0,1,255,255,
255,0,255,255,255,0,255,255,255,0,255,255,255,0};
static Fl_RGB_Image image_HardRight(idata_HardRight, 64, 64, 4, 0);

void TrackEditorUI::cb_easyLeftThenRight_i(Fl_Menu_*, void*) {
  trackView->setSign(kEasyLeftThenRight);
}
void TrackEditorUI::cb_easyLeftThenRight(Fl_Menu_* o, void* v) {
  ((TrackEditorUI*)(o->parent()->user_data()))->cb_easyLeftThenRight_i(o,v);
}

static unsigned char idata_EasyLeftThenRight[] =
{255,255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,0,0,0,1,0,0,0,2,0,
0,0,4,0,0,0,5,0,0,0,7,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,
0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,
8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,
0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,
0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,
0,0,0,7,0,0,0,5,0,0,0,4,0,0,0,2,0,0,0,1,255,255,255,0,255,255,255,0,255,255,
255,0,255,255,255,0,255,255,255,0,255,255,255,0,0,0,0,1,0,0,0,3,0,0,0,6,0,0,0,
10,0,0,0,14,0,0,0,18,0,0,0,21,0,0,0,23,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,
0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,
0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,
24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,
0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,
0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,23,0,0,0,21,0,0,0,18,0,0,0,
14,0,0,0,10,0,0,0,6,0,0,0,3,0,0,0,1,255,255,255,0,255,255,255,0,255,255,255,0,
0,0,0,1,0,0,0,3,0,0,0,8,230,230,230,100,247,247,247,201,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,241,241,241,206,194,194,194,118,0,0,0,39,0,0,0,33,0,
0,0,24,0,0,0,15,0,0,0,8,0,0,0,3,0,0,0,1,255,255,255,0,255,255,255,0,0,0,0,3,0,
0,0,8,225,225,225,102,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,171,171,171,134,0,0,0,
58,0,0,0,45,0,0,0,31,0,0,0,18,0,0,0,8,0,0,0,3,255,255,255,0,0,0,0,1,0,0,0,6,0,
0,0,15,246,246,246,202,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,229,229,229,217,0,0,
0,84,0,0,0,69,0,0,0,50,0,0,0,31,0,0,0,15,0,0,0,6,0,0,0,1,0,0,0,2,0,0,0,10,0,0,
0,24,255,255,255,255,255,255,255,255,255,255,255,255,74,74,44,255,105,88,46,
255,114,93,49,255,101,85,50,255,97,83,51,255,97,84,52,255,97,85,52,255,97,85,52,
255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,
255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,
255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,
255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,
255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,
255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,97,84,51,255,95,80,48,
255,96,80,43,255,112,90,34,255,98,75,22,255,44,44,9,255,255,255,255,255,255,255,
255,255,255,255,255,255,0,0,0,105,0,0,0,90,0,0,0,69,0,0,0,45,0,0,0,24,0,0,0,10,
0,0,0,2,0,0,0,4,0,0,0,14,0,0,0,33,255,255,255,255,255,255,255,255,255,255,255,
255,117,87,39,255,72,59,42,255,83,71,45,255,116,98,47,255,128,106,49,255,128,
106,50,255,128,107,50,255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,
51,255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,51,
255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,51,255,
129,108,51,255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,51,255,129,
108,51,255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,
51,255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,51,
255,129,108,51,255,129,108,51,255,129,108,51,255,129,107,50,255,128,106,49,255,
126,105,47,255,122,100,42,255,98,80,34,255,56,44,22,255,42,26,9,255,147,128,62,
255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,118,0,0,0,105,0,0,0,
84,0,0,0,58,0,0,0,33,0,0,0,14,0,0,0,4,0,0,0,5,0,0,0,18,0,0,0,39,255,255,255,
255,255,255,255,255,255,255,255,255,119,98,35,255,78,64,37,255,188,150,40,255,
254,209,43,255,255,217,45,255,255,214,46,255,255,216,46,255,255,216,46,255,255,
216,46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,216,
46,255,255,216,46,255,255,215,46,255,255,216,46,255,255,216,46,255,255,217,46,
255,255,218,46,255,255,218,46,255,255,216,46,255,255,215,46,255,255,216,46,255,
255,216,46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,
216,46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,216,
46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,216,46,
255,255,216,46,255,255,215,43,255,255,215,40,255,255,213,32,255,250,195,22,255,
151,116,8,255,39,28,7,255,169,151,78,255,255,255,255,255,255,255,255,255,255,
255,255,255,0,0,0,124,0,0,0,113,0,0,0,94,0,0,0,68,0,0,0,39,0,0,0,18,0,0,0,5,0,0,
0,7,0,0,0,21,0,0,0,44,255,255,255,255,255,255,255,255,255,255,255,255,77,62,
31,255,106,88,34,255,253,201,36,255,255,220,37,255,255,214,38,255,255,212,38,
255,255,214,38,255,255,213,37,255,255,213,37,255,255,213,37,255,255,213,37,255,
255,213,37,255,255,213,37,255,255,213,37,255,255,213,37,255,255,213,37,255,255,
216,37,255,255,220,37,255,255,219,37,255,255,211,37,255,255,219,37,255,255,218,
37,255,255,214,37,255,255,213,37,255,255,213,37,255,255,213,37,255,255,213,37,
255,255,213,37,255,255,213,37,255,255,213,37,255,255,213,37,255,255,213,37,255,
255,213,37,255,255,213,37,255,255,213,37,255,255,213,37,255,255,213,37,255,255,
213,37,255,255,213,37,255,255,213,37,255,255,213,37,255,255,213,34,255,255,212,
29,255,255,213,20,255,255,215,7,255,229,173,0,255,54,37,0,255,77,59,9,255,255,
255,255,255,255,255,255,255,255,255,255,255,0,0,0,126,0,0,0,117,0,0,0,100,0,0,0,
75,0,0,0,44,0,0,0,21,0,0,0,7,0,0,0,8,0,0,0,23,0,0,0,46,255,255,255,255,255,255,
255,255,255,255,255,255,65,54,30,255,117,96,31,255,255,212,31,255,255,213,31,
255,254,207,31,255,254,206,29,255,255,208,28,255,255,208,27,255,255,207,26,255,
255,207,26,255,255,207,26,255,255,207,26,255,255,207,26,255,255,207,26,255,255,
207,26,255,255,208,26,255,255,215,26,255,255,207,26,255,180,149,26,255,133,111,
26,255,212,174,26,255,255,214,26,255,255,212,26,255,254,206,26,255,255,207,26,
255,255,207,26,255,255,207,26,255,255,207,26,255,255,207,26,255,255,207,26,255,
255,207,26,255,255,207,26,255,255,207,26,255,255,207,26,255,255,207,26,255,255,
207,26,255,255,207,26,255,255,207,26,255,255,207,26,255,255,207,26,255,255,207,
25,255,255,207,22,255,255,205,16,255,255,201,6,255,251,205,0,255,232,178,0,255,
58,43,0,255,56,40,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,
127,0,0,0,119,0,0,0,102,0,0,0,78,0,0,0,46,0,0,0,23,0,0,0,8,0,0,0,8,0,0,0,24,0,0,
0,47,255,255,255,255,255,255,255,255,255,255,255,255,61,52,28,255,115,95,29,
255,255,211,28,255,255,212,26,255,254,205,23,255,255,206,19,255,255,206,17,255,
255,205,15,255,255,205,15,255,255,205,15,255,255,205,15,255,255,205,15,255,255,
205,15,255,255,205,15,255,255,205,15,255,255,212,15,255,255,213,15,255,189,154,
15,255,51,44,15,255,15,15,15,255,82,73,15,255,225,183,15,255,255,216,15,255,
255,210,15,255,254,203,15,255,255,205,15,255,255,205,15,255,255,205,15,255,255,
205,15,255,255,205,15,255,255,205,15,255,255,205,15,255,255,205,15,255,255,205,
15,255,255,205,15,255,255,205,15,255,255,205,15,255,255,205,15,255,255,205,15,
255,255,205,15,255,255,205,13,255,255,204,10,255,255,203,4,255,251,199,0,255,
240,197,0,255,221,175,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,255,
255,255,255,255,255,0,0,0,127,0,0,0,119,0,0,0,103,0,0,0,79,0,0,0,47,0,0,0,24,0,
0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,
255,64,52,28,255,117,94,28,255,255,213,26,255,255,210,23,255,255,206,18,255,255,
205,13,255,255,204,10,255,255,203,7,255,255,203,6,255,255,203,6,255,255,203,6,
255,255,203,6,255,255,202,6,255,255,202,6,255,255,208,6,255,255,212,6,255,209,
167,6,255,70,56,6,255,6,6,6,255,6,6,6,255,6,6,6,255,99,86,6,255,227,183,6,255,
255,213,6,255,255,207,6,255,254,201,6,255,255,203,6,255,255,203,6,255,255,203,6,
255,255,203,6,255,255,203,6,255,255,203,6,255,255,203,6,255,255,203,6,255,255,
203,6,255,255,203,6,255,255,203,6,255,255,203,6,255,255,203,6,255,255,203,6,255,
255,203,5,255,255,202,1,255,251,199,0,255,243,192,0,255,233,189,0,255,217,171,0,
255,57,44,0,255,59,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,
0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,
0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,63,52,28,255,115,94,
28,255,255,213,25,255,255,210,21,255,255,205,15,255,255,204,9,255,255,203,5,
255,255,202,2,255,255,202,1,255,255,202,1,255,255,202,1,255,255,202,1,255,255,
201,1,255,255,207,1,255,255,215,1,255,217,174,1,255,72,60,1,255,1,1,1,255,1,1,1,
255,1,1,1,255,1,1,1,255,1,1,1,255,101,82,1,255,229,183,1,255,255,211,1,255,255,
204,1,255,255,202,1,255,255,202,1,255,255,202,1,255,255,202,1,255,255,202,1,255,
255,202,1,255,255,202,1,255,255,202,1,255,255,202,1,255,255,202,1,255,255,202,1,
255,255,202,1,255,255,202,1,255,255,202,1,255,255,202,0,255,253,200,0,255,247,
196,0,255,239,189,0,255,230,189,0,255,214,169,0,255,57,43,0,255,59,41,0,255,255,
255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,
80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,
255,255,255,255,255,255,65,52,28,255,115,94,28,255,255,213,25,255,255,210,20,
255,255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,204,0,255,255,217,0,255,242,192,0,255,
81,65,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,4,5,0,
255,121,96,0,255,254,201,0,255,255,212,0,255,255,204,0,255,254,200,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,254,201,0,255,251,199,0,255,245,194,0,255,238,189,0,255,230,189,0,255,217,
165,0,255,57,43,0,255,59,41,0,255,255,255,255,255,255,255,255,255,255,255,255,
255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,
0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,
115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,
203,3,255,255,202,1,255,255,202,0,255,255,202,0,255,255,202,0,255,255,205,0,255,
255,213,0,255,242,191,0,255,98,74,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,
0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,12,11,0,255,142,113,0,255,254,201,0,
255,255,211,0,255,255,204,0,255,254,200,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,
255,238,189,0,255,230,189,0,255,216,165,0,255,57,43,0,255,58,41,0,255,255,255,
255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,
0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,
255,255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,
255,255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,
202,0,255,255,205,0,255,255,212,0,255,231,186,0,255,105,89,0,255,0,0,0,255,0,0,
0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,
0,0,255,17,15,0,255,147,117,0,255,254,201,0,255,255,211,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,254,
201,0,255,251,199,0,255,245,194,0,255,238,189,0,255,230,189,0,255,217,165,0,255,
57,43,0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,
128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,
0,48,255,255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,115,94,28,
255,255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,255,
255,202,1,255,255,202,0,255,255,204,0,255,255,210,0,255,233,184,0,255,111,91,0,
255,3,5,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,25,22,0,255,163,131,0,255,255,206,0,
255,255,210,0,255,255,200,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,189,0,255,230,189,0,
255,214,169,0,255,57,43,0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,
255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,
0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,64,52,
28,255,115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,
255,255,203,3,255,255,202,1,255,255,202,0,255,255,210,0,255,238,188,0,255,121,
95,0,255,8,8,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,
0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,36,32,0,
255,189,149,0,255,255,210,0,255,255,206,0,255,254,200,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,189,0,
255,230,189,0,255,217,165,0,255,57,43,0,255,58,41,0,255,255,255,255,255,255,255,
255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,
24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,
255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,
255,204,8,255,255,203,3,255,255,202,1,255,255,206,0,255,255,205,0,255,145,115,0,
255,18,13,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,
0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,
0,0,255,54,43,0,255,200,161,0,255,255,213,0,255,255,204,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,
189,0,255,230,189,0,255,215,165,0,255,57,43,0,255,58,41,0,255,255,255,255,255,
255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,
0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,
255,255,255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,255,255,
205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,255,208,0,255,213,169,0,
255,18,16,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,
0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,
0,0,255,0,0,0,255,0,0,0,255,73,58,0,255,250,198,0,255,255,208,0,255,254,200,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,
238,189,0,255,230,189,0,255,218,165,0,255,57,43,0,255,58,41,0,255,255,255,255,
255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,
0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,
255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,255,
255,205,14,255,255,204,8,255,255,203,3,255,255,203,1,255,255,206,0,255,198,151,
0,255,0,0,0,255,0,0,0,255,0,0,0,255,11,5,0,255,58,38,0,255,91,62,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,6,2,0,255,91,63,0,255,44,
29,0,255,0,0,0,255,0,0,0,255,0,0,0,255,31,21,0,255,225,173,0,255,255,204,0,255,
254,201,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,254,201,0,255,251,199,0,255,245,
194,0,255,238,189,0,255,230,189,0,255,215,165,0,255,57,43,0,255,58,41,0,255,255,
255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,
80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,
255,255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,
255,255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,255,205,0,255,234,
175,0,255,98,66,0,255,81,54,0,255,149,107,0,255,233,175,0,255,255,210,0,255,211,
165,0,255,4,3,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,40,29,0,
255,255,207,0,255,255,209,0,255,202,153,0,255,116,84,0,255,72,49,0,255,144,105,
0,255,255,200,0,255,255,206,0,255,254,201,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,254,201,0,255,251,199,0,255,245,194,0,255,238,189,0,255,230,189,0,255,214,
169,0,255,57,43,0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,
255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,
0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,
115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,
203,3,255,255,202,1,255,255,205,0,255,255,209,0,255,254,201,0,255,254,202,0,255,
255,206,0,255,255,213,0,255,255,220,0,255,211,167,0,255,0,0,0,255,0,0,0,255,0,0,
0,255,0,0,0,255,0,0,0,255,0,0,0,255,33,25,0,255,255,212,0,255,255,220,0,255,
255,211,0,255,255,205,0,255,251,200,0,255,255,205,0,255,255,209,0,255,255,203,0,
255,254,200,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,254,201,0,255,251,199,0,255,
245,194,0,255,238,189,0,255,230,189,0,255,217,165,0,255,57,43,0,255,58,41,0,255,
255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,
0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,
255,255,255,255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,
210,20,255,255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,254,200,0,
255,255,203,0,255,255,205,0,255,255,206,0,255,255,204,0,255,255,203,0,255,255,
210,0,255,207,164,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,32,22,0,255,255,206,0,255,255,212,0,255,255,203,0,255,255,206,0,255,255,206,
0,255,255,204,0,255,255,202,0,255,254,200,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,189,0,255,230,
189,0,255,214,169,0,255,57,43,0,255,58,41,0,255,255,255,255,255,255,255,255,255,
255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,
8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,
64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,
204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,203,0,255,255,210,0,255,209,164,0,255,0,0,0,255,
0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,22,16,0,255,235,179,0,255,
255,212,0,255,255,202,0,255,255,203,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,254,201,0,255,
251,199,0,255,245,194,0,255,238,188,0,255,230,187,0,255,214,169,0,255,57,42,0,
255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,
120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,
255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,
25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,203,0,
255,255,211,0,255,212,167,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,8,9,0,255,174,137,0,255,255,210,0,255,255,209,0,255,255,202,0,255,
254,200,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,188,0,255,
230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,255,
255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,
0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,
255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,
204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,203,0,255,255,209,0,255,222,175,0,255,25,21,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,57,47,0,255,194,
156,0,255,255,205,0,255,255,211,0,255,255,204,0,255,254,200,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,254,201,0,255,251,
199,0,255,245,194,0,255,238,188,0,255,230,189,0,255,214,170,0,255,57,42,0,255,
58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,
120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,
255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,
25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,207,0,255,240,193,0,255,83,66,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,41,34,0,255,152,121,0,255,246,194,0,255,255,
212,0,255,255,207,0,255,255,200,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,188,0,255,230,
189,0,255,214,170,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,255,255,
255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,
8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,
64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,
204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,206,0,255,255,209,0,255,169,128,0,
255,9,4,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,14,14,0,255,113,91,0,255,228,182,0,255,255,213,0,255,255,208,0,255,255,202,
0,255,255,201,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,254,201,0,255,251,199,0,
255,245,194,0,255,238,188,0,255,230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,
255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,
104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,
255,255,255,255,255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,25,255,
255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,255,202,
0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,209,0,255,231,174,0,255,74,56,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,80,67,0,255,203,
159,0,255,255,207,0,255,255,211,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,254,201,0,255,251,199,0,255,245,194,0,255,238,188,0,255,230,189,0,255,214,
170,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,
255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,
0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,
115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,
203,3,255,255,202,1,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,207,0,255,255,207,0,255,180,136,0,
255,33,22,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,
0,255,0,0,0,255,0,0,0,255,44,31,0,255,166,122,0,255,255,204,0,255,255,215,0,
255,255,206,0,255,255,200,0,255,254,200,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,
238,188,0,255,230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,255,255,255,255,
255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,
0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,
255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,255,
255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,202,
0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,209,0,255,254,199,0,255,158,115,0,255,30,18,0,255,0,0,0,255,0,
0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,
21,15,0,255,147,118,0,255,244,191,0,255,255,210,0,255,255,210,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,254,
201,0,255,251,199,0,255,245,194,0,255,238,188,0,255,230,189,0,255,214,170,0,255,
57,42,0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,
128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,
0,48,255,255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,115,94,28,
255,255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,255,
255,202,1,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,212,0,255,255,
208,0,255,192,154,0,255,61,42,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,
0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,65,53,0,255,186,149,0,
255,255,208,0,255,255,212,0,255,255,202,0,255,255,201,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,188,0,255,
230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,255,
255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,
0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,
255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,
204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,254,200,0,
255,255,202,0,255,255,209,0,255,255,216,0,255,241,188,0,255,91,62,0,255,1,1,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,36,31,0,255,172,137,0,255,255,205,0,255,255,211,0,255,255,202,0,
255,255,201,0,255,255,202,0,255,255,202,0,255,254,201,0,255,251,199,0,255,245,
194,0,255,238,188,0,255,230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,255,255,
255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,
80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,
255,255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,
255,255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,200,0,255,255,206,0,255,255,214,0,
255,233,175,0,255,125,91,0,255,26,17,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,24,21,0,255,151,121,0,255,
255,205,0,255,255,211,0,255,255,202,0,255,255,202,0,255,255,202,0,255,254,201,0,
255,251,199,0,255,245,194,0,255,238,188,0,255,230,189,0,255,214,170,0,255,57,42,
0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,
0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,
48,255,255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,115,94,28,255,
255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,255,255,
202,1,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,203,0,255,255,207,0,255,255,211,0,255,246,188,0,255,174,130,0,255,61,42,
0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,
0,0,255,0,0,0,255,23,20,0,255,157,126,0,255,255,204,0,255,255,208,0,255,254,
201,0,255,255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,188,0,255,
230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,255,
255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,
0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,
255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,
204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,254,200,0,255,255,203,0,255,255,
209,0,255,255,207,0,255,211,161,0,255,101,69,0,255,7,2,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,42,34,0,255,197,
149,0,255,255,208,0,255,255,204,0,255,254,200,0,255,254,201,0,255,251,199,0,255,
245,194,0,255,238,188,0,255,230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,255,
255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,
0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,
255,255,255,255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,
210,20,255,255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,254,200,0,255,255,202,0,255,255,208,0,255,255,209,0,255,243,184,0,
255,154,109,0,255,25,16,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,
0,0,0,255,0,0,0,255,0,0,0,255,116,92,0,255,255,205,0,255,255,208,0,255,254,
200,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,188,0,255,230,189,0,255,
214,170,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,
255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,
8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,64,52,28,
255,115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,255,
255,203,3,255,255,202,1,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,201,0,255,255,204,0,255,255,211,0,255,255,209,0,255,213,164,0,255,70,48,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,39,31,
0,255,211,168,0,255,255,207,0,255,255,202,0,255,254,201,0,255,251,199,0,255,
245,194,0,255,238,188,0,255,230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,255,
255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,
0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,
255,255,255,255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,
210,20,255,255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,254,200,0,255,255,202,0,
255,255,210,0,255,255,212,0,255,213,161,0,255,86,58,0,255,0,0,0,255,0,0,0,255,0,
0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,1,2,0,255,174,138,0,255,255,208,0,255,
255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,188,0,255,230,189,0,
255,214,170,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,
255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,
0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,64,52,
28,255,115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,
255,255,203,3,255,255,202,1,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,200,0,255,255,208,0,255,255,
210,0,255,212,162,0,255,44,31,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,
0,255,0,0,0,255,158,123,0,255,255,208,0,255,255,204,0,255,254,201,0,255,251,
199,0,255,245,194,0,255,238,188,0,255,230,189,0,255,214,170,0,255,57,42,0,255,
58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,
120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,
255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,
25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,200,0,255,255,212,0,255,255,207,0,255,79,56,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,147,117,0,255,
255,208,0,255,255,207,0,255,253,199,0,255,251,199,0,255,245,194,0,255,238,188,0,
255,230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,
255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,
24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,
255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,
255,204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,201,0,
255,255,208,0,255,255,209,0,255,83,61,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,123,91,0,255,254,191,0,255,255,204,0,255,253,199,0,255,
251,199,0,255,245,194,0,255,238,188,0,255,230,189,0,255,214,170,0,255,57,42,0,
255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,
120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,
255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,
25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,201,0,255,255,209,0,255,255,209,0,255,82,63,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,140,107,0,255,
255,207,0,255,255,208,0,255,253,199,0,255,251,199,0,255,245,194,0,255,238,188,0,
255,230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,
255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,
24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,
255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,
255,204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,201,0,
255,255,207,0,255,255,208,0,255,83,64,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,130,102,0,255,255,205,0,255,255,206,0,255,253,199,0,255,
251,199,0,255,245,194,0,255,238,188,0,255,230,189,0,255,214,170,0,255,57,42,0,
255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,
120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,
255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,115,93,27,255,255,213,
25,255,255,210,19,255,255,205,13,255,255,203,6,255,255,202,1,255,254,201,0,255,
254,201,0,255,254,201,0,255,254,201,0,255,254,201,0,255,254,201,0,255,254,201,0,
255,254,201,0,255,254,201,0,255,254,201,0,255,254,201,0,255,254,201,0,255,254,
201,0,255,254,201,0,255,254,201,0,255,254,201,0,255,254,201,0,255,254,201,0,255,
254,201,0,255,254,201,0,255,254,200,0,255,254,207,0,255,254,207,0,255,84,64,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,144,111,0,255,
254,206,0,255,254,205,0,255,252,198,0,255,249,197,0,255,244,193,0,255,237,187,0,
255,229,188,0,255,214,170,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,
255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,
24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,
255,255,64,52,28,255,114,92,26,255,255,212,22,255,255,209,16,255,255,204,9,255,
255,202,1,255,252,200,0,255,249,197,0,255,248,196,0,255,248,196,0,255,248,196,0,
255,248,196,0,255,248,196,0,255,248,196,0,255,248,196,0,255,248,196,0,255,248,
196,0,255,248,196,0,255,248,196,0,255,248,196,0,255,248,196,0,255,248,196,0,255,
248,196,0,255,248,196,0,255,248,196,0,255,248,196,0,255,248,196,0,255,248,195,0,
255,248,202,0,255,248,198,0,255,82,62,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,125,100,0,255,246,196,0,255,248,200,0,255,246,194,0,255,
245,194,0,255,240,190,0,255,233,184,0,255,227,186,0,255,213,169,0,255,57,42,0,
255,58,40,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,
120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,
255,255,255,255,255,255,255,255,255,255,255,65,51,27,255,113,91,24,255,255,211,
18,255,255,208,10,255,255,202,1,255,248,196,0,255,243,192,0,255,240,190,0,255,
239,189,0,255,239,189,0,255,239,189,0,255,239,189,0,255,239,189,0,255,239,189,0,
255,239,189,0,255,239,189,0,255,239,189,0,255,239,189,0,255,239,189,0,255,239,
189,0,255,239,189,0,255,239,189,0,255,239,189,0,255,239,189,0,255,239,189,0,255,
239,189,0,255,239,189,0,255,239,188,0,255,239,193,0,255,239,191,0,255,134,94,0,
255,53,31,0,255,46,24,0,255,48,25,0,255,48,27,0,255,45,25,0,255,51,28,0,255,159,
120,0,255,239,189,0,255,239,192,0,255,237,187,0,255,236,187,0,255,233,185,0,255,
228,180,0,255,224,184,0,255,211,167,0,255,58,42,0,255,58,40,0,255,255,255,255,
255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,
0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,
255,255,255,255,255,60,48,24,255,111,88,19,255,255,211,10,255,255,208,0,255,244,
192,0,255,236,186,0,255,230,181,0,255,227,179,0,255,226,178,0,255,226,178,0,255,
226,178,0,255,226,178,0,255,226,178,0,255,226,178,0,255,226,178,0,255,226,178,0,
255,226,178,0,255,226,178,0,255,226,178,0,255,226,178,0,255,226,178,0,255,226,
178,0,255,226,178,0,255,226,178,0,255,226,178,0,255,226,178,0,255,226,178,0,255,
226,178,0,255,226,180,0,255,226,184,0,255,215,165,0,255,205,153,0,255,207,157,0,
255,209,157,0,255,209,157,0,255,207,155,0,255,203,152,0,255,222,168,0,255,226,
182,0,255,226,179,0,255,224,176,0,255,224,177,0,255,222,175,0,255,221,174,0,255,
218,179,0,255,209,166,0,255,56,41,0,255,56,38,0,255,255,255,255,255,255,255,255,
255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,
0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,
255,64,51,19,255,92,71,10,255,254,201,0,255,242,202,0,255,230,188,0,255,221,179,
0,255,216,175,0,255,213,173,0,255,212,172,0,255,212,172,0,255,212,172,0,255,
212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,
255,212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,212,
172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,
212,172,0,255,212,173,0,255,212,174,0,255,212,175,0,255,212,176,0,255,212,177,0,
255,212,177,0,255,212,176,0,255,212,174,0,255,212,172,0,255,212,172,0,255,212,
171,0,255,212,171,0,255,212,172,0,255,212,172,0,255,212,172,0,255,212,180,0,255,
199,150,0,255,50,34,0,255,71,54,5,255,255,255,255,255,255,255,255,255,255,255,
255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,
8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,95,71,10,
255,43,29,0,255,171,128,0,255,227,175,0,255,217,179,0,255,209,170,0,255,206,168,
0,255,203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,
203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,
255,203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,203,
166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,
203,166,0,255,203,166,0,255,203,167,0,255,203,166,0,255,203,166,0,255,203,166,0,
255,203,166,0,255,203,167,0,255,203,167,0,255,203,167,0,255,203,166,0,255,203,
166,0,255,203,166,0,255,203,166,0,255,204,168,0,255,206,162,0,255,131,100,0,255,
36,23,2,255,138,120,49,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,
0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,
0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,73,50,0,255,25,14,0,
255,48,32,0,255,89,62,0,255,105,79,0,255,105,80,0,255,105,80,0,255,103,79,0,255,
103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,
103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,
103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,
103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,
103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,
103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,105,79,0,255,103,78,0,255,
79,58,0,255,37,24,0,255,27,15,0,255,115,102,30,255,255,255,255,255,255,255,255,
255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,
0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,
255,34,0,0,255,54,38,0,255,61,43,0,255,47,32,0,255,41,27,0,255,40,27,0,255,40,
27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,
255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,
27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,
255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,
27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,
255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,47,33,0,255,62,
45,0,255,61,43,0,255,29,29,0,255,255,255,255,255,255,255,255,255,255,255,255,
255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,
0,0,24,0,0,0,47,232,232,232,214,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,221,221,221,
225,0,0,0,127,0,0,0,119,0,0,0,103,0,0,0,79,0,0,0,47,0,0,0,24,0,0,0,8,0,0,0,8,0,
0,0,23,0,0,0,46,164,164,164,140,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,133,133,133,
173,0,0,0,127,0,0,0,119,0,0,0,102,0,0,0,78,0,0,0,46,0,0,0,23,0,0,0,8,0,0,0,7,0,
0,0,21,0,0,0,44,0,0,0,75,148,148,148,155,223,223,223,223,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,221,221,221,225,133,133,133,173,0,0,0,127,0,0,0,126,
0,0,0,117,0,0,0,100,0,0,0,75,0,0,0,44,0,0,0,21,0,0,0,7,0,0,0,5,0,0,0,18,0,0,0,
39,0,0,0,68,0,0,0,94,0,0,0,113,0,0,0,124,0,0,0,127,0,0,0,127,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,127,0,0,0,127,0,0,0,124,0,0,0,
113,0,0,0,94,0,0,0,68,0,0,0,39,0,0,0,18,0,0,0,5,0,0,0,4,0,0,0,14,0,0,0,33,0,0,0,
58,0,0,0,84,0,0,0,105,0,0,0,118,0,0,0,124,0,0,0,126,0,0,0,127,0,0,0,127,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,127,0,0,0,127,0,0,0,126,0,0,0,124,0,0,0,118,0,0,0,105,0,0,0,
84,0,0,0,58,0,0,0,33,0,0,0,14,0,0,0,4,0,0,0,2,0,0,0,10,0,0,0,24,0,0,0,45,0,0,0,
69,0,0,0,90,0,0,0,105,0,0,0,113,0,0,0,117,0,0,0,119,0,0,0,119,0,0,0,120,0,0,0,
120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,
120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,
120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,
120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,
120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,
120,0,0,0,119,0,0,0,119,0,0,0,117,0,0,0,113,0,0,0,105,0,0,0,90,0,0,0,69,0,0,0,
45,0,0,0,24,0,0,0,10,0,0,0,2,0,0,0,1,0,0,0,6,0,0,0,15,0,0,0,31,0,0,0,50,0,0,0,
69,0,0,0,84,0,0,0,94,0,0,0,100,0,0,0,102,0,0,0,103,0,0,0,104,0,0,0,104,0,0,0,
104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,
104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,
104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,
104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,
104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,
103,0,0,0,102,0,0,0,100,0,0,0,94,0,0,0,84,0,0,0,69,0,0,0,50,0,0,0,31,0,0,0,15,0,
0,0,6,0,0,0,1,255,255,255,0,0,0,0,3,0,0,0,8,0,0,0,18,0,0,0,31,0,0,0,45,0,0,0,
58,0,0,0,68,0,0,0,75,0,0,0,78,0,0,0,79,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,
0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,
0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,
80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,
0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,
0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,79,0,0,0,78,0,0,0,75,0,0,0,68,0,0,0,58,0,0,0,
45,0,0,0,31,0,0,0,18,0,0,0,8,0,0,0,3,255,255,255,0,255,255,255,0,0,0,0,1,0,0,0,
3,0,0,0,8,0,0,0,15,0,0,0,24,0,0,0,33,0,0,0,39,0,0,0,44,0,0,0,46,0,0,0,47,0,0,
0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,
0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,
48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,
0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,
0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,47,0,0,0,
46,0,0,0,44,0,0,0,39,0,0,0,33,0,0,0,24,0,0,0,15,0,0,0,8,0,0,0,3,0,0,0,1,255,
255,255,0,255,255,255,0,255,255,255,0,0,0,0,1,0,0,0,3,0,0,0,6,0,0,0,10,0,0,0,14,
0,0,0,18,0,0,0,21,0,0,0,23,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,
24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,
0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,
0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,
24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,
0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,23,0,0,0,21,0,0,0,18,0,0,0,14,0,0,0,10,
0,0,0,6,0,0,0,3,0,0,0,1,255,255,255,0,255,255,255,0,255,255,255,0,255,255,255,
0,255,255,255,0,255,255,255,0,0,0,0,1,0,0,0,2,0,0,0,4,0,0,0,5,0,0,0,7,0,0,0,8,
0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,
8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,
0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,
0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,
0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,7,0,0,0,5,0,0,0,4,0,0,0,
2,0,0,0,1,255,255,255,0,255,255,255,0,255,255,255,0,255,255,255,0};
static Fl_RGB_Image image_EasyLeftThenRight(idata_EasyLeftThenRight, 64, 64, 4, 0);

void TrackEditorUI::cb_easyRightThenLeft_i(Fl_Menu_*, void*) {
  trackView->setSign(kEasyRightThenLeft);
}
void TrackEditorUI::cb_easyRightThenLeft(Fl_Menu_* o, void* v) {
  ((TrackEditorUI*)(o->parent()->user_data()))->cb_easyRightThenLeft_i(o,v);
}

static unsigned char idata_EasyRightThenLeft[] =
{255,255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,0,0,0,1,0,0,0,2,0,
0,0,4,0,0,0,5,0,0,0,7,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,
0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,
8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,
0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,
0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,
0,0,0,7,0,0,0,5,0,0,0,4,0,0,0,2,0,0,0,1,255,255,255,0,255,255,255,0,255,255,
255,0,255,255,255,0,255,255,255,0,255,255,255,0,0,0,0,1,0,0,0,3,0,0,0,6,0,0,0,
10,0,0,0,14,0,0,0,18,0,0,0,21,0,0,0,23,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,
0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,
0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,
24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,
0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,
0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,23,0,0,0,21,0,0,0,18,0,0,0,
14,0,0,0,10,0,0,0,6,0,0,0,3,0,0,0,1,255,255,255,0,255,255,255,0,255,255,255,0,
0,0,0,1,0,0,0,3,0,0,0,8,230,230,230,100,247,247,247,201,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,241,241,241,206,194,194,194,118,0,0,0,39,0,0,0,33,0,
0,0,24,0,0,0,15,0,0,0,8,0,0,0,3,0,0,0,1,255,255,255,0,255,255,255,0,0,0,0,3,0,
0,0,8,225,225,225,102,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,171,171,171,134,0,0,0,
58,0,0,0,45,0,0,0,31,0,0,0,18,0,0,0,8,0,0,0,3,255,255,255,0,0,0,0,1,0,0,0,6,0,
0,0,15,246,246,246,202,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,229,229,229,217,0,0,
0,84,0,0,0,69,0,0,0,50,0,0,0,31,0,0,0,15,0,0,0,6,0,0,0,1,0,0,0,2,0,0,0,10,0,0,
0,24,255,255,255,255,255,255,255,255,255,255,255,255,74,74,44,255,105,88,46,
255,114,93,49,255,101,85,50,255,97,83,51,255,97,84,52,255,97,85,52,255,97,85,52,
255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,
255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,
255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,
255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,
255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,
255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,97,84,51,255,95,80,48,
255,96,80,43,255,109,87,34,255,95,75,22,255,44,44,9,255,255,255,255,255,255,255,
255,255,255,255,255,255,0,0,0,105,0,0,0,90,0,0,0,69,0,0,0,45,0,0,0,24,0,0,0,10,
0,0,0,2,0,0,0,4,0,0,0,14,0,0,0,33,255,255,255,255,255,255,255,255,255,255,255,
255,120,88,40,255,70,58,42,255,83,71,45,255,116,98,47,255,128,106,49,255,128,
106,50,255,128,107,50,255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,
51,255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,51,
255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,51,255,
129,108,51,255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,51,255,129,
108,51,255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,
51,255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,51,
255,129,108,51,255,129,108,51,255,129,108,51,255,129,107,50,255,128,106,49,255,
126,105,47,255,122,100,42,255,100,82,34,255,58,46,22,255,47,31,9,255,105,70,0,
255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,118,0,0,0,105,0,0,0,
84,0,0,0,58,0,0,0,33,0,0,0,14,0,0,0,4,0,0,0,5,0,0,0,18,0,0,0,39,255,255,255,
255,255,255,255,255,255,255,255,255,125,104,42,255,76,62,37,255,188,150,40,255,
254,209,43,255,255,217,45,255,255,214,46,255,255,216,46,255,255,216,46,255,255,
216,46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,216,
46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,216,46,
255,255,216,46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,216,46,255,
255,215,46,255,255,215,46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,
216,46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,216,
46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,216,46,
255,255,216,46,255,255,215,43,255,255,215,40,255,255,213,32,255,249,195,22,255,
152,117,8,255,35,22,0,255,113,83,0,255,255,255,255,255,255,255,255,255,255,255,
255,255,0,0,0,124,0,0,0,113,0,0,0,94,0,0,0,68,0,0,0,39,0,0,0,18,0,0,0,5,0,0,0,7,
0,0,0,21,0,0,0,44,255,255,255,255,255,255,255,255,255,255,255,255,75,58,31,
255,105,86,34,255,253,202,36,255,255,220,37,255,255,214,38,255,255,212,38,255,
255,214,38,255,255,213,37,255,255,213,37,255,255,213,37,255,255,213,37,255,255,
213,37,255,255,213,37,255,255,213,37,255,255,213,37,255,255,213,37,255,255,213,
37,255,255,213,37,255,255,213,37,255,255,213,37,255,255,213,37,255,255,213,37,
255,255,213,37,255,255,213,37,255,255,213,37,255,255,215,37,255,255,214,37,255,
255,217,37,255,255,216,37,255,255,217,37,255,255,214,37,255,255,212,37,255,255,
213,37,255,255,213,37,255,255,213,37,255,255,213,37,255,255,213,37,255,255,213,
37,255,255,213,37,255,255,213,37,255,255,213,37,255,255,213,34,255,255,212,29,
255,255,213,20,255,255,215,7,255,231,175,0,255,55,39,0,255,70,51,0,255,255,255,
255,255,255,255,255,255,255,255,255,255,0,0,0,126,0,0,0,117,0,0,0,100,0,0,0,75,
0,0,0,44,0,0,0,21,0,0,0,7,0,0,0,8,0,0,0,23,0,0,0,46,255,255,255,255,255,255,
255,255,255,255,255,255,64,53,30,255,117,96,31,255,255,212,31,255,255,213,31,
255,254,207,31,255,254,206,29,255,255,208,28,255,255,208,27,255,255,207,26,255,
255,207,26,255,255,207,26,255,255,207,26,255,255,207,26,255,255,207,26,255,255,
207,26,255,255,207,26,255,255,207,26,255,255,207,26,255,255,207,26,255,255,207,
26,255,255,207,26,255,255,207,26,255,255,207,26,255,255,207,26,255,255,207,26,
255,255,209,26,255,255,215,26,255,250,203,26,255,223,181,26,255,252,206,26,255,
255,213,26,255,255,209,26,255,254,206,26,255,255,207,26,255,255,207,26,255,255,
207,26,255,255,207,26,255,255,207,26,255,255,207,26,255,255,207,26,255,255,207,
25,255,255,207,22,255,255,205,16,255,255,201,6,255,251,205,0,255,232,177,0,255,
60,44,0,255,57,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,
127,0,0,0,119,0,0,0,102,0,0,0,78,0,0,0,46,0,0,0,23,0,0,0,8,0,0,0,8,0,0,0,24,0,0,
0,47,255,255,255,255,255,255,255,255,255,255,255,255,61,53,28,255,115,95,29,
255,255,211,28,255,255,212,26,255,254,205,23,255,255,206,19,255,255,206,17,255,
255,205,15,255,255,205,15,255,255,205,15,255,255,205,15,255,255,205,15,255,255,
205,15,255,255,205,15,255,255,205,15,255,255,205,15,255,255,205,15,255,255,205,
15,255,255,205,15,255,255,205,15,255,255,205,15,255,255,205,15,255,255,205,15,
255,255,204,15,255,255,208,15,255,255,216,15,255,253,203,15,255,135,110,15,255,
56,52,15,255,158,135,15,255,250,203,15,255,255,212,15,255,255,205,15,255,254,
203,15,255,255,205,15,255,255,205,15,255,255,205,15,255,255,205,15,255,255,205,
15,255,255,205,15,255,255,205,13,255,255,204,10,255,255,203,4,255,251,199,0,
255,240,197,0,255,221,175,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,
255,255,255,255,255,255,0,0,0,127,0,0,0,119,0,0,0,103,0,0,0,79,0,0,0,47,0,0,0,
24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,
255,255,64,52,28,255,117,94,28,255,255,213,26,255,255,210,23,255,255,206,18,255,
255,205,13,255,255,204,10,255,255,203,7,255,255,203,6,255,255,203,6,255,255,203,
6,255,255,203,6,255,255,203,6,255,255,203,6,255,255,203,6,255,255,203,6,255,
255,203,6,255,255,203,6,255,255,203,6,255,255,203,6,255,255,203,6,255,255,203,6,
255,255,202,6,255,255,205,6,255,255,213,6,255,255,204,6,255,148,119,6,255,12,11,
6,255,6,6,6,255,36,32,6,255,166,134,6,255,255,205,6,255,255,211,6,255,255,201,
6,255,255,203,6,255,255,203,6,255,255,203,6,255,255,203,6,255,255,203,6,255,
255,203,6,255,255,203,5,255,255,202,1,255,251,199,0,255,243,192,0,255,233,189,0,
255,217,171,0,255,57,44,0,255,59,41,0,255,255,255,255,255,255,255,255,255,255,
255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,
0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,63,52,
28,255,115,94,28,255,255,213,25,255,255,210,21,255,255,205,15,255,255,204,9,
255,255,203,5,255,255,202,2,255,255,202,1,255,255,202,1,255,255,202,1,255,255,
202,1,255,255,202,1,255,255,202,1,255,255,202,1,255,255,202,1,255,255,202,1,255,
255,202,1,255,255,202,1,255,255,202,1,255,255,202,1,255,255,202,1,255,255,204,1,
255,255,211,1,255,255,204,1,255,155,120,1,255,20,16,1,255,1,1,1,255,1,1,1,255,1,
1,1,255,45,35,1,255,196,156,1,255,255,214,1,255,255,207,1,255,254,200,1,255,
255,202,1,255,255,202,1,255,255,202,1,255,255,202,1,255,255,202,1,255,255,202,0,
255,253,200,0,255,247,196,0,255,239,189,0,255,230,189,0,255,214,169,0,255,57,43,
0,255,59,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,
0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,
48,255,255,255,255,255,255,255,255,255,255,255,255,65,52,28,255,115,94,28,255,
255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,255,255,
202,1,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,209,0,255,255,205,0,255,163,
126,0,255,27,18,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,59,48,0,
255,225,178,0,255,255,217,0,255,255,206,0,255,254,200,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,
238,189,0,255,230,189,0,255,217,165,0,255,57,43,0,255,59,41,0,255,255,255,255,
255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,
0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,
255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,255,
255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,202,
0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,200,0,
255,255,207,0,255,255,208,0,255,177,144,0,255,39,30,0,255,0,0,0,255,0,0,0,255,0,
0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,73,62,0,255,233,186,0,255,255,
213,0,255,255,209,0,255,254,201,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
254,201,0,255,251,199,0,255,245,194,0,255,238,189,0,255,230,189,0,255,216,165,0,
255,57,43,0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,
0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,
0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,115,94,
28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,
255,255,202,1,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,209,0,255,255,210,0,255,184,147,0,255,40,35,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,79,67,0,255,222,167,0,255,255,209,0,255,255,207,0,255,254,201,0,
255,255,202,0,255,255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,
189,0,255,230,189,0,255,217,165,0,255,57,43,0,255,58,41,0,255,255,255,255,255,
255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,
0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,
255,255,255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,255,255,
205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,201,0,255,255,206,0,255,255,214,0,255,
205,163,0,255,60,51,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,
0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,89,68,0,255,220,169,0,
255,255,211,0,255,255,206,0,255,254,200,0,255,255,202,0,255,254,201,0,255,251,
199,0,255,245,194,0,255,238,189,0,255,230,189,0,255,214,169,0,255,57,43,0,255,
58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,
120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,
255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,
25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,201,0,255,255,205,0,255,255,
215,0,255,245,194,0,255,77,64,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,
0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,1,
0,0,255,103,82,0,255,230,184,0,255,255,210,0,255,255,205,0,255,254,200,0,255,
254,201,0,255,251,199,0,255,245,194,0,255,238,189,0,255,230,189,0,255,217,165,0,
255,57,43,0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,
0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,
0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,115,94,
28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,
255,255,202,1,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,204,0,255,
255,215,0,255,249,198,0,255,116,95,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,5,6,0,255,124,102,0,255,243,192,0,255,255,211,0,255,255,
202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,189,0,255,230,189,0,255,
215,165,0,255,57,43,0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,
255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,
8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,64,52,28,
255,115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,255,
255,203,3,255,255,202,1,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
208,0,255,253,200,0,255,116,92,0,255,2,2,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,
0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,
0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,10,10,0,255,142,117,0,255,255,211,0,
255,255,204,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,189,0,255,230,
189,0,255,218,165,0,255,57,43,0,255,58,41,0,255,255,255,255,255,255,255,255,255,
255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,
8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,
64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,
204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,203,0,255,191,152,0,255,13,11,0,255,0,0,0,255,0,0,0,255,0,0,0,255,1,0,0,
255,10,6,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,
0,255,21,15,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,26,21,0,255,248,196,
0,255,255,207,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,189,0,255,
230,189,0,255,215,165,0,255,57,43,0,255,58,41,0,255,255,255,255,255,255,255,255,
255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,
0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,
255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,
204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,205,0,255,207,164,0,255,39,30,0,255,0,0,0,255,16,8,0,255,77,52,0,255,
163,114,0,255,153,115,0,255,16,14,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,
0,0,0,255,27,23,0,255,219,170,0,255,157,110,0,255,67,46,0,255,14,9,0,255,0,0,
0,255,59,38,0,255,251,198,0,255,255,206,0,255,254,201,0,255,251,199,0,255,245,
194,0,255,238,189,0,255,230,189,0,255,214,169,0,255,57,43,0,255,58,41,0,255,255,
255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,
80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,
255,255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,
255,255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,207,0,255,255,207,0,255,199,153,0,255,165,120,0,
255,216,156,0,255,255,203,0,255,255,216,0,255,189,150,0,255,12,10,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,18,16,0,255,255,202,0,255,255,215,0,
255,255,201,0,255,216,162,0,255,173,126,0,255,227,169,0,255,255,214,0,255,255,
203,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,189,0,255,230,189,0,255,
217,165,0,255,57,43,0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,
255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,
8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,64,52,28,
255,115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,255,
255,203,3,255,255,202,1,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
201,0,255,255,207,0,255,255,207,0,255,255,202,0,255,255,207,0,255,255,212,0,255,
255,213,0,255,185,142,0,255,8,6,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,
0,0,255,13,13,0,255,245,192,0,255,255,213,0,255,255,210,0,255,255,208,0,255,
255,201,0,255,255,207,0,255,255,207,0,255,254,200,0,255,254,201,0,255,251,199,0,
255,245,194,0,255,238,189,0,255,230,189,0,255,214,169,0,255,57,43,0,255,58,41,0,
255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,
104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,
255,255,255,255,255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,25,255,
255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,255,202,
0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,254,200,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,205,0,255,255,211,0,255,184,138,0,255,9,6,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,14,14,0,255,243,192,0,255,
255,210,0,255,255,201,0,255,255,202,0,255,255,202,0,255,255,202,0,255,254,201,0,
255,254,200,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,188,0,255,230,
187,0,255,214,169,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,255,255,
255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,
8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,
64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,
204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,203,0,255,255,
208,0,255,255,213,0,255,170,127,0,255,8,7,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,
0,0,255,0,0,0,255,23,18,0,255,243,191,0,255,255,210,0,255,254,200,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,254,201,0,255,
251,199,0,255,245,194,0,255,238,188,0,255,230,189,0,255,214,170,0,255,57,42,0,
255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,
120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,
255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,
25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,203,0,255,255,206,0,255,255,213,0,255,239,190,0,255,92,72,0,255,0,
0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,45,30,0,255,247,187,
0,255,255,208,0,255,254,200,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,188,0,
255,230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,
255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,
24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,
255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,
255,204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,201,0,255,255,203,0,255,255,208,0,255,255,210,0,255,
225,180,0,255,108,89,0,255,5,7,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,
0,0,255,0,0,0,255,104,84,0,255,255,203,0,255,255,207,0,255,254,200,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,254,201,0,255,
251,199,0,255,245,194,0,255,238,188,0,255,230,189,0,255,214,170,0,255,57,42,0,
255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,
120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,
255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,
25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,201,0,255,255,203,0,255,255,
212,0,255,255,207,0,255,191,152,0,255,80,63,0,255,0,1,0,255,0,0,0,255,0,0,0,255,
0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,2,0,0,255,181,136,0,255,255,209,0,255,
255,205,0,255,254,200,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,188,0,255,230,
189,0,255,214,170,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,255,255,
255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,
8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,
64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,
204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,205,0,255,255,216,0,255,255,203,0,255,161,133,0,255,38,31,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,49,34,
0,255,221,166,0,255,255,208,0,255,255,202,0,255,254,200,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,254,201,0,255,251,199,0,
255,245,194,0,255,238,188,0,255,230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,
255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,
104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,
255,255,255,255,255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,25,255,
255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,255,202,
0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,201,0,255,255,202,0,255,255,207,0,255,255,214,0,255,248,196,0,255,128,102,0,
255,20,16,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,
0,255,0,0,0,255,10,7,0,255,143,111,0,255,255,202,0,255,255,208,0,255,254,201,
0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,188,0,255,230,189,0,
255,214,170,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,
255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,
0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,64,52,
28,255,115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,
255,255,203,3,255,255,202,1,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,204,0,255,255,211,0,255,255,207,0,255,
205,163,0,255,82,64,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,
0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,111,83,0,255,239,189,0,255,255,
210,0,255,255,203,0,255,254,201,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,
255,238,188,0,255,230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,255,255,255,
255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,
0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,
255,255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,
255,255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,206,0,255,255,212,0,255,
255,201,0,255,162,131,0,255,40,35,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,
0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,12,6,0,255,127,94,0,255,249,
194,0,255,255,213,0,255,255,203,0,255,254,201,0,255,254,201,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,254,201,0,
255,251,199,0,255,245,194,0,255,238,188,0,255,230,189,0,255,214,170,0,255,57,42,
0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,
0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,
48,255,255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,115,94,28,255,
255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,255,255,
202,1,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,207,0,255,
255,209,0,255,234,187,0,255,138,111,0,255,18,14,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,24,13,0,255,150,
109,0,255,253,198,0,255,255,214,0,255,255,204,0,255,254,201,0,255,254,201,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,188,0,255,230,
189,0,255,214,170,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,255,255,
255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,
8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,
64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,
204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,207,0,255,255,211,0,255,209,167,0,255,88,73,0,255,2,4,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,67,47,
0,255,175,129,0,255,255,200,0,255,255,213,0,255,255,204,0,255,254,200,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,254,201,0,255,251,199,0,255,245,
194,0,255,238,188,0,255,230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,255,255,
255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,
80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,
255,255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,
255,255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,
202,0,255,255,204,0,255,255,211,0,255,211,168,0,255,75,58,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,7,4,0,
255,101,74,0,255,218,165,0,255,255,204,0,255,255,211,0,255,255,204,0,255,254,
200,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,254,201,0,
255,251,199,0,255,245,194,0,255,238,188,0,255,230,189,0,255,214,170,0,255,57,42,
0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,
0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,
48,255,255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,115,94,28,255,
255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,255,255,
202,1,255,255,202,0,255,255,200,0,255,255,208,0,255,244,192,0,255,104,84,0,255,
0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,34,20,0,255,140,101,0,255,235,178,0,255,255,211,0,255,255,208,0,
255,255,202,0,255,254,200,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,188,0,
255,230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,
255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,
24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,
255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,
255,204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,205,0,255,255,209,0,
255,174,139,0,255,17,13,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,
0,0,0,255,0,0,0,255,0,0,0,255,63,51,0,255,214,161,0,255,255,195,0,255,255,209,
0,255,255,205,0,255,255,202,0,255,254,200,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,254,201,0,255,251,
199,0,255,245,194,0,255,238,188,0,255,230,189,0,255,214,170,0,255,57,42,0,255,
58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,
120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,
255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,
25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,
255,202,0,255,255,207,0,255,244,192,0,255,86,73,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,5,2,0,255,99,70,0,255,235,178,0,255,
255,215,0,255,255,206,0,255,254,203,0,255,254,201,0,255,254,201,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,188,0,255,230,189,0,
255,214,170,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,
255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,
0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,64,52,
28,255,115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,
255,255,203,3,255,255,202,1,255,255,203,0,255,255,206,0,255,217,171,0,255,20,17,
0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,32,19,0,255,
139,107,0,255,236,183,0,255,255,214,0,255,255,205,0,255,255,202,0,255,254,201,0,
255,254,201,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,254,201,0,255,251,199,0,
255,245,194,0,255,238,188,0,255,230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,
255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,
104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,
255,255,255,255,255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,25,255,
255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,255,203,
0,255,255,210,0,255,206,164,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,
0,255,0,0,0,255,12,8,0,255,161,123,0,255,255,204,0,255,255,211,0,255,255,204,
0,255,255,201,0,255,254,201,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,188,0,255,
230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,255,
255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,
0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,
255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,
204,8,255,255,203,3,255,255,202,1,255,255,203,0,255,255,211,0,255,194,154,0,255,
0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,46,36,0,255,243,
192,0,255,255,215,0,255,255,204,0,255,254,201,0,255,254,201,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,254,201,0,255,
251,199,0,255,245,194,0,255,238,188,0,255,230,189,0,255,214,170,0,255,57,42,0,
255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,
120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,
255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,
25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,
255,205,0,255,255,210,0,255,165,131,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,71,52,0,255,255,207,0,255,255,210,0,255,254,200,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,188,0,
255,230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,
255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,
24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,
255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,
255,204,8,255,255,203,3,255,255,202,1,255,255,205,0,255,255,208,0,255,152,123,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,74,54,0,255,255,
208,0,255,255,208,0,255,254,200,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,254,201,0,255,
251,199,0,255,245,194,0,255,238,188,0,255,230,189,0,255,214,170,0,255,57,42,0,
255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,
120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,
255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,
25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,
255,206,0,255,255,209,0,255,150,119,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,73,55,0,255,255,208,0,255,255,208,0,255,255,201,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,188,0,
255,230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,
255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,
24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,
255,255,64,52,28,255,115,93,27,255,255,213,25,255,255,210,19,255,255,205,13,255,
255,203,6,255,255,202,1,255,254,201,0,255,254,205,0,255,254,208,0,255,152,122,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,75,55,0,255,254,
207,0,255,254,207,0,255,254,200,0,255,254,201,0,255,254,201,0,255,254,201,0,255,
254,201,0,255,254,201,0,255,254,201,0,255,254,201,0,255,254,201,0,255,254,201,0,
255,254,201,0,255,254,201,0,255,254,201,0,255,254,201,0,255,254,201,0,255,254,
201,0,255,254,201,0,255,254,201,0,255,254,201,0,255,254,201,0,255,253,200,0,255,
249,197,0,255,244,193,0,255,237,187,0,255,229,188,0,255,214,170,0,255,57,42,0,
255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,
120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,
255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,114,92,26,255,255,212,
22,255,255,209,16,255,255,204,9,255,255,202,1,255,252,200,0,255,249,197,0,255,
248,200,0,255,248,203,0,255,144,118,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,69,53,0,255,248,201,0,255,248,201,0,255,248,195,0,255,
248,196,0,255,248,196,0,255,248,196,0,255,248,196,0,255,248,196,0,255,248,196,0,
255,248,196,0,255,248,196,0,255,248,196,0,255,248,196,0,255,248,196,0,255,248,
196,0,255,248,196,0,255,248,196,0,255,248,196,0,255,248,196,0,255,248,196,0,255,
248,196,0,255,248,196,0,255,247,196,0,255,245,194,0,255,240,190,0,255,233,184,0,
255,227,186,0,255,213,169,0,255,57,42,0,255,58,40,0,255,255,255,255,255,255,255,
255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,
24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,
255,255,65,52,27,255,113,91,24,255,255,211,18,255,255,208,10,255,255,202,1,255,
248,196,0,255,243,192,0,255,240,190,0,255,239,191,0,255,239,190,0,255,140,112,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,79,56,0,255,238,
187,0,255,239,192,0,255,239,189,0,255,239,189,0,255,239,189,0,255,239,189,0,255,
239,189,0,255,239,189,0,255,239,189,0,255,239,189,0,255,239,189,0,255,239,189,0,
255,239,189,0,255,239,189,0,255,239,189,0,255,239,189,0,255,239,189,0,255,239,
189,0,255,239,189,0,255,239,189,0,255,239,189,0,255,239,189,0,255,238,189,0,255,
236,187,0,255,233,185,0,255,228,180,0,255,224,184,0,255,211,167,0,255,58,42,0,
255,58,40,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,
120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,
255,255,255,255,255,255,255,255,255,255,255,58,48,24,255,111,88,19,255,255,211,
10,255,255,208,0,255,244,192,0,255,236,186,0,255,230,181,0,255,227,179,0,255,
226,180,0,255,226,185,0,255,216,168,0,255,175,132,0,255,177,134,0,255,179,136,0,
255,179,136,0,255,177,135,0,255,177,131,0,255,199,152,0,255,226,184,0,255,226,
179,0,255,226,178,0,255,226,178,0,255,226,178,0,255,226,178,0,255,226,178,0,255,
226,178,0,255,226,178,0,255,226,178,0,255,226,178,0,255,226,178,0,255,226,178,0,
255,226,178,0,255,226,178,0,255,226,178,0,255,226,178,0,255,226,178,0,255,226,
178,0,255,226,178,0,255,226,178,0,255,226,178,0,255,225,177,0,255,224,177,0,255,
222,175,0,255,221,174,0,255,218,179,0,255,209,166,0,255,57,43,0,255,57,40,0,255,
255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,
0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,
255,255,255,255,255,255,255,255,63,49,19,255,91,71,10,255,254,201,0,255,242,202,
0,255,230,188,0,255,221,179,0,255,216,175,0,255,213,173,0,255,212,172,0,255,
212,173,0,255,212,175,0,255,212,175,0,255,212,178,0,255,212,179,0,255,212,179,0,
255,212,179,0,255,212,175,0,255,212,174,0,255,212,174,0,255,212,170,0,255,212,
172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,
212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,
255,212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,212,
172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,
212,172,0,255,212,180,0,255,199,151,0,255,53,36,0,255,66,48,0,255,255,255,255,
255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,
0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,
255,255,255,255,255,98,76,13,255,41,27,0,255,171,128,0,255,227,175,0,255,217,
179,0,255,209,170,0,255,206,168,0,255,203,166,0,255,203,166,0,255,203,166,0,255,
203,166,0,255,203,167,0,255,203,168,0,255,203,168,0,255,203,168,0,255,203,168,0,
255,203,167,0,255,203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,203,
166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,
203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,
255,203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,203,
166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,204,168,0,255,
206,162,0,255,131,100,0,255,32,20,0,255,98,70,0,255,255,255,255,255,255,255,255,
255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,
0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,
255,79,55,0,255,24,12,0,255,48,32,0,255,89,62,0,255,105,79,0,255,105,80,0,255,
105,80,0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,
103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,
103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,
103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,
103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,
103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,
105,79,0,255,103,78,0,255,79,58,0,255,37,26,0,255,32,19,0,255,83,60,0,255,255,
255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,
80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,
255,255,255,255,255,255,34,0,0,255,54,38,0,255,61,43,0,255,47,32,0,255,41,27,0,
255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,
27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,
255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,
27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,
255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,
27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,
255,47,33,0,255,62,45,0,255,61,43,0,255,29,29,0,255,255,255,255,255,255,255,255,
255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,
0,0,8,0,0,0,8,0,0,0,24,0,0,0,47,232,232,232,214,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,221,221,221,225,0,0,0,127,0,0,0,119,0,0,0,103,0,0,0,79,0,0,0,47,0,0,0,24,0,
0,0,8,0,0,0,8,0,0,0,23,0,0,0,46,164,164,164,140,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,133,133,133,173,0,0,0,127,0,0,0,119,0,0,0,102,0,0,0,78,0,0,0,46,0,0,0,23,0,
0,0,8,0,0,0,7,0,0,0,21,0,0,0,44,0,0,0,75,148,148,148,155,223,223,223,223,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,221,221,221,225,133,133,133,173,0,0,
0,127,0,0,0,126,0,0,0,117,0,0,0,100,0,0,0,75,0,0,0,44,0,0,0,21,0,0,0,7,0,0,0,
5,0,0,0,18,0,0,0,39,0,0,0,68,0,0,0,94,0,0,0,113,0,0,0,124,0,0,0,127,0,0,0,127,
0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,127,0,0,0,
127,0,0,0,124,0,0,0,113,0,0,0,94,0,0,0,68,0,0,0,39,0,0,0,18,0,0,0,5,0,0,0,4,0,0,
0,14,0,0,0,33,0,0,0,58,0,0,0,84,0,0,0,105,0,0,0,118,0,0,0,124,0,0,0,126,0,0,0,
127,0,0,0,127,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,127,0,0,0,127,0,0,0,126,0,0,0,124,0,0,0,
118,0,0,0,105,0,0,0,84,0,0,0,58,0,0,0,33,0,0,0,14,0,0,0,4,0,0,0,2,0,0,0,10,0,0,
0,24,0,0,0,45,0,0,0,69,0,0,0,90,0,0,0,105,0,0,0,113,0,0,0,117,0,0,0,119,0,0,0,
119,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,
120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,
120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,
120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,
120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,
120,0,0,0,120,0,0,0,120,0,0,0,119,0,0,0,119,0,0,0,117,0,0,0,113,0,0,0,105,0,0,0,
90,0,0,0,69,0,0,0,45,0,0,0,24,0,0,0,10,0,0,0,2,0,0,0,1,0,0,0,6,0,0,0,15,0,0,0,
31,0,0,0,50,0,0,0,69,0,0,0,84,0,0,0,94,0,0,0,100,0,0,0,102,0,0,0,103,0,0,0,104,
0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,
104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,
104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,
104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,
104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,
104,0,0,0,104,0,0,0,103,0,0,0,102,0,0,0,100,0,0,0,94,0,0,0,84,0,0,0,69,0,0,0,50,
0,0,0,31,0,0,0,15,0,0,0,6,0,0,0,1,255,255,255,0,0,0,0,3,0,0,0,8,0,0,0,18,0,0,
0,31,0,0,0,45,0,0,0,58,0,0,0,68,0,0,0,75,0,0,0,78,0,0,0,79,0,0,0,80,0,0,0,80,
0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,
80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,
0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,
0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,
80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,79,0,0,0,78,0,0,0,75,0,0,
0,68,0,0,0,58,0,0,0,45,0,0,0,31,0,0,0,18,0,0,0,8,0,0,0,3,255,255,255,0,255,
255,255,0,0,0,0,1,0,0,0,3,0,0,0,8,0,0,0,15,0,0,0,24,0,0,0,33,0,0,0,39,0,0,0,44,
0,0,0,46,0,0,0,47,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,
48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,
0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,
0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,
48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,
0,48,0,0,0,47,0,0,0,46,0,0,0,44,0,0,0,39,0,0,0,33,0,0,0,24,0,0,0,15,0,0,0,8,0,
0,0,3,0,0,0,1,255,255,255,0,255,255,255,0,255,255,255,0,0,0,0,1,0,0,0,3,0,0,0,
6,0,0,0,10,0,0,0,14,0,0,0,18,0,0,0,21,0,0,0,23,0,0,0,24,0,0,0,24,0,0,0,24,0,0,
0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,
0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,
24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,
0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,
0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,23,0,0,0,21,0,0,0,
18,0,0,0,14,0,0,0,10,0,0,0,6,0,0,0,3,0,0,0,1,255,255,255,0,255,255,255,0,255,
255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,0,0,0,1,0,0,0,2,0,0,0,4,0,0,
0,5,0,0,0,7,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,
0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,
0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,
8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,
0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,7,0,
0,0,5,0,0,0,4,0,0,0,2,0,0,0,1,255,255,255,0,255,255,255,0,255,255,255,0,255,
255,255,0};
static Fl_RGB_Image image_EasyRightThenLeft(idata_EasyRightThenLeft, 64, 64, 4, 0);

void TrackEditorUI::cb_hardLeftThenRight_i(Fl_Menu_*, void*) {
  trackView->setSign(kHardLeftThenRight);
}
void TrackEditorUI::cb_hardLeftThenRight(Fl_Menu_* o, void* v) {
  ((TrackEditorUI*)(o->parent()->user_data()))->cb_hardLeftThenRight_i(o,v);
}

static unsigned char idata_HardLeftThenRight[] =
{255,255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,0,0,0,1,0,0,0,2,0,
0,0,4,0,0,0,5,0,0,0,7,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,
0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,
8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,
0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,
0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,
0,0,0,7,0,0,0,5,0,0,0,4,0,0,0,2,0,0,0,1,255,255,255,0,255,255,255,0,255,255,
255,0,255,255,255,0,255,255,255,0,255,255,255,0,0,0,0,1,0,0,0,3,0,0,0,6,0,0,0,
10,0,0,0,14,0,0,0,18,0,0,0,21,0,0,0,23,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,
0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,
0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,
24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,
0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,
0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,23,0,0,0,21,0,0,0,18,0,0,0,
14,0,0,0,10,0,0,0,6,0,0,0,3,0,0,0,1,255,255,255,0,255,255,255,0,255,255,255,0,
0,0,0,1,0,0,0,3,0,0,0,8,230,230,230,100,247,247,247,201,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,241,241,241,206,194,194,194,118,0,0,0,39,0,0,0,33,0,
0,0,24,0,0,0,15,0,0,0,8,0,0,0,3,0,0,0,1,255,255,255,0,255,255,255,0,0,0,0,3,0,
0,0,8,225,225,225,102,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,171,171,171,134,0,0,0,
58,0,0,0,45,0,0,0,31,0,0,0,18,0,0,0,8,0,0,0,3,255,255,255,0,0,0,0,1,0,0,0,6,0,
0,0,15,246,246,246,202,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,229,229,229,217,0,0,
0,84,0,0,0,69,0,0,0,50,0,0,0,31,0,0,0,15,0,0,0,6,0,0,0,1,0,0,0,2,0,0,0,10,0,0,
0,24,255,255,255,255,255,255,255,255,255,255,255,255,74,74,44,255,105,88,46,
255,114,93,49,255,101,85,50,255,97,83,51,255,97,84,52,255,97,85,52,255,97,85,52,
255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,
255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,
255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,
255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,
255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,
255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,97,84,51,255,95,80,48,
255,96,80,43,255,109,87,34,255,95,75,22,255,44,44,9,255,255,255,255,255,255,255,
255,255,255,255,255,255,0,0,0,105,0,0,0,90,0,0,0,69,0,0,0,45,0,0,0,24,0,0,0,10,
0,0,0,2,0,0,0,4,0,0,0,14,0,0,0,33,255,255,255,255,255,255,255,255,255,255,255,
255,117,87,39,255,72,59,42,255,83,71,45,255,116,98,47,255,128,106,49,255,128,
106,50,255,128,107,50,255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,
51,255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,51,
255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,51,255,
129,108,51,255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,51,255,129,
108,51,255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,
51,255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,51,
255,129,108,51,255,129,108,51,255,129,108,51,255,129,107,50,255,128,106,49,255,
126,105,47,255,122,100,42,255,100,82,34,255,58,46,22,255,47,31,9,255,105,70,0,
255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,118,0,0,0,105,0,0,0,
84,0,0,0,58,0,0,0,33,0,0,0,14,0,0,0,4,0,0,0,5,0,0,0,18,0,0,0,39,255,255,255,
255,255,255,255,255,255,255,255,255,119,98,35,255,78,64,37,255,188,150,40,255,
254,209,43,255,255,217,45,255,255,214,46,255,255,216,46,255,255,216,46,255,255,
216,46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,216,
46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,215,46,255,255,216,46,
255,255,216,46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,215,46,255,
255,216,46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,
216,46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,216,
46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,216,46,
255,255,216,46,255,255,215,43,255,255,215,40,255,255,213,32,255,249,195,22,255,
152,117,8,255,35,22,0,255,113,83,0,255,255,255,255,255,255,255,255,255,255,255,
255,255,0,0,0,124,0,0,0,113,0,0,0,94,0,0,0,68,0,0,0,39,0,0,0,18,0,0,0,5,0,0,0,7,
0,0,0,21,0,0,0,44,255,255,255,255,255,255,255,255,255,255,255,255,77,62,31,
255,106,88,34,255,253,201,36,255,255,220,37,255,255,214,38,255,255,212,38,255,
255,214,38,255,255,213,37,255,255,213,37,255,255,213,37,255,255,213,37,255,255,
213,37,255,255,213,37,255,255,213,37,255,255,213,37,255,255,213,37,255,255,213,
37,255,255,213,37,255,255,216,37,255,255,220,37,255,255,212,37,255,255,218,37,
255,255,217,37,255,255,212,37,255,255,213,37,255,255,213,37,255,255,213,37,255,
255,213,37,255,255,213,37,255,255,213,37,255,255,213,37,255,255,213,37,255,255,
213,37,255,255,213,37,255,255,213,37,255,255,213,37,255,255,213,37,255,255,213,
37,255,255,213,37,255,255,213,37,255,255,213,37,255,255,213,34,255,255,212,29,
255,255,213,20,255,255,215,7,255,231,175,0,255,55,39,0,255,70,51,0,255,255,255,
255,255,255,255,255,255,255,255,255,255,0,0,0,126,0,0,0,117,0,0,0,100,0,0,0,75,
0,0,0,44,0,0,0,21,0,0,0,7,0,0,0,8,0,0,0,23,0,0,0,46,255,255,255,255,255,255,
255,255,255,255,255,255,65,54,30,255,117,96,31,255,255,212,31,255,255,213,31,
255,254,207,31,255,254,206,29,255,255,208,28,255,255,208,27,255,255,207,26,255,
255,207,26,255,255,207,26,255,255,207,26,255,255,207,26,255,255,207,26,255,255,
207,26,255,255,207,26,255,255,207,26,255,255,208,26,255,255,216,26,255,244,198,
26,255,159,136,26,255,221,180,26,255,255,215,26,255,255,211,26,255,254,206,26,
255,255,207,26,255,255,207,26,255,255,207,26,255,255,207,26,255,255,207,26,255,
255,207,26,255,255,207,26,255,255,207,26,255,255,207,26,255,255,207,26,255,255,
207,26,255,255,207,26,255,255,207,26,255,255,207,26,255,255,207,26,255,255,207,
25,255,255,207,22,255,255,205,16,255,255,201,6,255,251,205,0,255,232,177,0,255,
60,44,0,255,57,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,
127,0,0,0,119,0,0,0,102,0,0,0,78,0,0,0,46,0,0,0,23,0,0,0,8,0,0,0,8,0,0,0,24,0,0,
0,47,255,255,255,255,255,255,255,255,255,255,255,255,61,52,28,255,115,95,29,
255,255,211,28,255,255,212,26,255,254,205,23,255,255,206,19,255,255,206,17,255,
255,205,15,255,255,205,15,255,255,205,15,255,255,205,15,255,255,205,15,255,255,
205,15,255,255,205,15,255,255,205,15,255,255,205,15,255,255,205,15,255,255,211,
15,255,255,208,15,255,152,122,15,255,26,23,15,255,93,75,15,255,231,187,15,255,
255,215,15,255,255,205,15,255,255,205,15,255,255,205,15,255,255,205,15,255,255,
205,15,255,255,205,15,255,255,205,15,255,255,205,15,255,255,205,15,255,255,205,
15,255,255,205,15,255,255,205,15,255,255,205,15,255,255,205,15,255,255,205,15,
255,255,205,15,255,255,205,13,255,255,204,10,255,255,203,4,255,251,199,0,255,
240,197,0,255,221,175,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,255,
255,255,255,255,255,0,0,0,127,0,0,0,119,0,0,0,103,0,0,0,79,0,0,0,47,0,0,0,24,0,
0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,
255,64,52,28,255,117,94,28,255,255,213,26,255,255,210,23,255,255,206,18,255,255,
205,13,255,255,204,10,255,255,203,7,255,255,203,6,255,255,203,6,255,255,203,6,
255,255,203,6,255,255,203,6,255,255,203,6,255,255,203,6,255,255,203,6,255,255,
207,6,255,255,212,6,255,195,159,6,255,43,36,6,255,6,6,6,255,8,7,6,255,146,117,6,
255,255,208,6,255,255,211,6,255,255,201,6,255,255,203,6,255,255,203,6,255,255,
203,6,255,255,203,6,255,255,203,6,255,255,203,6,255,255,203,6,255,255,203,6,255,
255,203,6,255,255,203,6,255,255,203,6,255,255,203,6,255,255,203,6,255,255,203,6,
255,255,203,5,255,255,202,1,255,251,199,0,255,243,192,0,255,233,189,0,255,217,
171,0,255,57,44,0,255,59,41,0,255,255,255,255,255,255,255,255,255,255,255,255,
255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,
0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,63,52,28,255,
115,94,28,255,255,213,25,255,255,210,21,255,255,205,15,255,255,204,9,255,255,
203,5,255,255,202,2,255,255,202,1,255,255,202,1,255,255,202,1,255,255,202,1,255,
255,202,1,255,255,202,1,255,255,202,1,255,255,203,1,255,255,212,1,255,229,181,1,
255,81,65,1,255,1,1,1,255,1,1,1,255,1,1,1,255,41,33,1,255,196,156,1,255,255,212,
1,255,255,207,1,255,254,200,1,255,255,202,1,255,255,202,1,255,255,202,1,255,
255,202,1,255,255,202,1,255,255,202,1,255,255,202,1,255,255,202,1,255,255,202,1,
255,255,202,1,255,255,202,1,255,255,202,1,255,255,202,1,255,255,202,0,255,253,
200,0,255,247,196,0,255,239,189,0,255,230,189,0,255,214,169,0,255,57,43,0,255,
59,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,
120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,
255,255,255,255,255,255,255,255,255,255,255,65,52,28,255,115,94,28,255,255,213,
25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,201,0,
255,255,203,0,255,255,210,0,255,250,198,0,255,125,100,0,255,1,0,0,255,0,0,0,255,
0,0,0,255,0,0,0,255,0,0,0,255,63,50,0,255,219,173,0,255,255,213,0,255,255,204,
0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,
189,0,255,230,189,0,255,217,165,0,255,57,43,0,255,59,41,0,255,255,255,255,255,
255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,
0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,
255,255,255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,255,255,
205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,201,0,255,255,207,0,255,255,
215,0,255,166,131,0,255,18,16,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,
0,255,0,0,0,255,115,97,0,255,255,202,0,255,255,211,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,254,201,0,255,251,199,0,255,245,194,0,255,238,189,0,255,230,189,0,255,216,
165,0,255,57,43,0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,
255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,
0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,
115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,
203,3,255,255,202,1,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,201,0,255,255,205,0,255,255,216,0,255,243,193,0,255,53,42,0,255,0,0,0,255,0,
0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,15,13,0,255,171,132,
0,255,255,209,0,255,255,207,0,255,255,200,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,254,201,0,255,251,199,0,255,245,
194,0,255,238,189,0,255,230,189,0,255,217,165,0,255,57,43,0,255,58,41,0,255,255,
255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,
80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,
255,255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,
255,255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,201,0,255,255,202,0,255,255,212,0,255,252,199,0,255,
114,90,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,53,42,0,255,209,166,0,255,255,213,0,255,255,206,0,255,
254,200,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,254,
201,0,255,251,199,0,255,245,194,0,255,238,189,0,255,230,189,0,255,214,169,0,255,
57,43,0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,
128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,
0,48,255,255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,115,94,28,
255,255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,255,
255,202,1,255,255,202,0,255,255,202,0,255,255,202,0,255,255,203,0,255,255,210,0,
255,255,203,0,255,147,120,0,255,8,9,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,88,69,0,255,234,
186,0,255,255,211,0,255,255,204,0,255,254,200,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,189,0,255,230,
189,0,255,217,165,0,255,57,43,0,255,58,41,0,255,255,255,255,255,255,255,255,255,
255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,
8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,
64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,
204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,205,0,255,255,208,0,255,188,149,0,255,33,29,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,5,4,0,255,130,103,0,255,250,199,0,255,255,209,0,255,255,201,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,
238,189,0,255,230,189,0,255,215,165,0,255,57,43,0,255,58,41,0,255,255,255,255,
255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,
0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,
255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,255,
255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,202,
0,255,255,202,0,255,255,208,0,255,237,188,0,255,81,67,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,23,20,0,255,180,143,0,255,255,210,0,255,255,
204,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,254,201,0,255,251,199,0,
255,245,194,0,255,238,189,0,255,230,189,0,255,218,165,0,255,57,43,0,255,58,41,0,
255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,
104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,
255,255,255,255,255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,25,255,
255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,255,202,
0,255,255,202,0,255,255,204,0,255,255,209,0,255,190,149,0,255,4,4,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,82,62,0,255,255,203,0,255,
255,206,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,254,201,0,255,251,
199,0,255,245,194,0,255,238,189,0,255,230,189,0,255,215,165,0,255,57,43,0,255,
58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,
120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,
255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,
25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,
255,202,0,255,255,202,0,255,255,205,0,255,255,203,0,255,130,106,0,255,0,0,0,255,
0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,1,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,32,26,0,255,255,
201,0,255,255,207,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,254,201,0,
255,251,199,0,255,245,194,0,255,238,189,0,255,230,189,0,255,214,169,0,255,57,43,
0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,
0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,
48,255,255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,115,94,28,255,
255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,255,255,
202,1,255,255,202,0,255,255,202,0,255,255,204,0,255,255,206,0,255,158,127,0,255,
0,0,0,255,0,0,0,255,9,6,0,255,73,54,0,255,36,26,0,255,0,0,0,255,0,0,0,255,0,0,
0,255,0,0,0,255,0,0,0,255,2,0,0,255,82,59,0,255,33,21,0,255,0,0,0,255,0,0,0,
255,65,53,0,255,255,203,0,255,255,206,0,255,255,202,0,255,255,202,0,255,255,202,
0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,189,0,255,230,189,0,
255,217,165,0,255,57,43,0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,
255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,
0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,64,52,
28,255,115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,
255,255,203,3,255,255,202,1,255,255,202,0,255,255,202,0,255,255,203,0,255,255,
209,0,255,230,183,0,255,120,86,0,255,101,72,0,255,172,133,0,255,240,190,0,255,
96,79,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,22,18,0,255,224,
176,0,255,203,156,0,255,121,91,0,255,90,67,0,255,184,146,0,255,255,210,0,255,
255,203,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,254,201,0,255,251,
199,0,255,245,194,0,255,238,189,0,255,230,189,0,255,214,169,0,255,57,43,0,255,
58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,
120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,
255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,
25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,205,0,255,255,209,0,255,247,185,0,
255,247,186,0,255,255,212,0,255,255,209,0,255,97,78,0,255,0,0,0,255,0,0,0,255,0,
0,0,255,0,0,0,255,0,0,0,255,14,10,0,255,242,192,0,255,255,217,0,255,254,198,0,
255,239,181,0,255,255,203,0,255,255,208,0,255,255,200,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,188,0,
255,230,187,0,255,214,169,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,
255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,
24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,
255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,
255,204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,202,0,255,255,202,0,
255,254,201,0,255,255,202,0,255,255,205,0,255,255,204,0,255,255,210,0,255,251,
199,0,255,94,75,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,9,9,0,
255,231,184,0,255,255,211,0,255,255,207,0,255,255,202,0,255,255,204,0,255,255,
203,0,255,254,201,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,254,201,0,
255,251,199,0,255,245,194,0,255,238,188,0,255,230,189,0,255,214,170,0,255,57,42,
0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,
0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,
48,255,255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,115,94,28,255,
255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,255,255,
202,1,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,254,201,0,255,
254,201,0,255,254,200,0,255,255,207,0,255,252,201,0,255,94,74,0,255,0,0,0,255,0,
0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,14,6,0,255,234,178,0,255,255,208,0,255,
255,202,0,255,254,200,0,255,254,201,0,255,254,201,0,255,254,200,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,
238,188,0,255,230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,255,255,255,255,
255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,
0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,
255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,255,
255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,202,
0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,208,0,255,251,200,0,255,93,73,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,
0,0,0,255,12,9,0,255,234,183,0,255,255,211,0,255,255,202,0,255,255,203,0,255,
255,203,0,255,255,203,0,255,255,203,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,188,0,255,230,189,0,255,
214,170,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,
255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,
8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,64,52,28,
255,115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,255,
255,203,3,255,255,202,1,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,208,0,255,247,195,0,255,84,67,
0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,14,13,0,255,236,186,0,
255,255,215,0,255,255,206,0,255,255,208,0,255,255,208,0,255,255,208,0,255,255,
206,0,255,255,206,0,255,255,207,0,255,255,205,0,255,255,205,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,254,201,0,255,251,199,0,
255,245,194,0,255,238,188,0,255,230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,
255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,
104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,
255,255,255,255,255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,25,255,
255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,255,202,
0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,208,0,255,252,200,0,255,92,72,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,14,12,0,255,193,155,0,255,242,192,0,255,237,188,0,255,
235,187,0,255,234,187,0,255,236,188,0,255,239,189,0,255,237,189,0,255,237,188,0,
255,243,194,0,255,255,205,0,255,255,208,0,255,255,205,0,255,254,200,0,255,255,
202,0,255,255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,188,0,255,
230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,255,
255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,
0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,
255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,
204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,206,0,255,250,198,0,
255,90,72,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,39,
34,0,255,53,48,0,255,53,49,0,255,52,50,0,255,51,47,0,255,53,51,0,255,58,53,0,
255,57,51,0,255,58,50,0,255,80,69,0,255,156,122,0,255,236,186,0,255,255,209,0,
255,255,204,0,255,254,200,0,255,255,202,0,255,254,201,0,255,251,199,0,255,245,
194,0,255,238,188,0,255,230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,255,255,
255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,
80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,
255,255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,
255,255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,206,0,255,253,198,0,255,90,72,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,
0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,13,9,0,255,128,102,0,255,253,199,0,
255,255,207,0,255,254,200,0,255,255,202,0,255,254,201,0,255,251,199,0,255,245,
194,0,255,238,188,0,255,230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,255,255,
255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,
80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,
255,255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,
255,255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,206,0,255,250,199,0,255,89,71,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,
0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,21,19,0,255,193,155,0,255,
255,211,0,255,255,202,0,255,255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,
255,238,188,0,255,230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,255,255,255,
255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,
0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,
255,255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,
255,255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,207,0,255,252,200,0,255,106,83,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,96,75,0,255,255,
206,0,255,255,206,0,255,255,201,0,255,254,201,0,255,251,199,0,255,245,194,0,255,
238,188,0,255,230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,255,255,255,255,
255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,
0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,
255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,255,
255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,202,
0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,204,0,255,255,206,0,255,167,124,0,255,8,2,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,55,40,0,255,255,
204,0,255,255,208,0,255,255,201,0,255,254,201,0,255,251,199,0,255,245,194,0,255,
238,188,0,255,230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,255,255,255,255,
255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,
0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,
255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,255,
255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,202,
0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,207,0,255,231,175,0,255,92,67,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,47,31,0,255,255,
207,0,255,255,208,0,255,255,201,0,255,254,201,0,255,251,199,0,255,245,194,0,255,
238,188,0,255,230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,255,255,255,255,
255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,
0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,
255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,255,
255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,202,
0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,207,0,255,255,208,0,255,230,172,0,255,133,97,0,255,38,28,0,
255,10,4,0,255,10,0,0,255,9,0,0,255,7,0,0,255,7,0,0,255,7,0,0,255,9,0,0,255,12,
4,0,255,5,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,
47,34,0,255,255,207,0,255,255,208,0,255,255,201,0,255,254,201,0,255,251,199,0,
255,245,194,0,255,238,188,0,255,230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,
255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,
104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,
255,255,255,255,255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,25,255,
255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,255,202,
0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,254,201,0,255,255,206,0,255,255,209,0,255,255,206,0,
255,255,203,0,255,255,204,0,255,255,208,0,255,255,208,0,255,255,208,0,255,255,
208,0,255,255,208,0,255,255,210,0,255,255,210,0,255,184,138,0,255,16,10,0,255,0,
0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,57,40,0,255,255,208,0,255,255,
208,0,255,255,201,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,188,0,255,
230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,255,
255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,
0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,
255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,
204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,254,200,0,255,255,202,0,255,255,204,0,255,255,208,0,255,255,210,0,255,255,
210,0,255,255,210,0,255,255,210,0,255,255,210,0,255,255,210,0,255,255,212,0,255,
255,216,0,255,206,155,0,255,15,11,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,
0,0,0,255,54,40,0,255,255,208,0,255,255,208,0,255,255,201,0,255,254,201,0,255,
251,199,0,255,245,194,0,255,238,188,0,255,230,189,0,255,214,170,0,255,57,42,0,
255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,
120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,
255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,
25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
201,0,255,255,201,0,255,255,201,0,255,255,201,0,255,255,201,0,255,255,201,0,255,
255,201,0,255,255,201,0,255,255,203,0,255,255,211,0,255,199,158,0,255,16,14,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,54,40,0,255,255,208,0,255,
255,208,0,255,255,201,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,188,0,
255,230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,
255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,
24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,
255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,
255,204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,203,0,
255,255,209,0,255,203,161,0,255,19,13,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,59,40,0,255,255,208,0,255,255,208,0,255,255,201,0,255,254,201,0,
255,251,199,0,255,245,194,0,255,238,188,0,255,230,189,0,255,214,170,0,255,57,42,
0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,
0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,
48,255,255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,115,94,28,255,
255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,255,255,
202,1,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,203,0,255,255,209,0,255,203,162,0,255,
18,18,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,56,37,0,255,255,
208,0,255,255,208,0,255,255,201,0,255,254,201,0,255,251,199,0,255,245,194,0,255,
238,188,0,255,230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,255,255,255,255,
255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,
0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,
255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,255,
255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,202,
0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,203,0,255,255,208,0,255,203,155,0,255,19,13,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,53,37,0,255,255,209,0,255,255,208,0,255,255,
201,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,188,0,255,230,189,0,255,
214,170,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,
255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,
8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,64,52,28,
255,115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,255,
255,203,3,255,255,202,1,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,203,0,255,255,208,0,
255,203,155,0,255,17,15,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,
48,35,0,255,255,207,0,255,255,208,0,255,255,201,0,255,254,201,0,255,251,199,0,
255,245,194,0,255,238,188,0,255,230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,
255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,
104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,
255,255,255,255,255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,25,255,
255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,255,202,
0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,203,0,255,255,208,0,255,204,155,0,255,20,15,0,255,0,
0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,54,41,0,255,255,208,0,255,255,
208,0,255,255,201,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,188,0,255,
230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,255,
255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,
0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,
255,64,52,28,255,115,93,27,255,255,213,25,255,255,210,19,255,255,205,13,255,255,
203,6,255,255,202,1,255,254,201,0,255,254,201,0,255,254,201,0,255,254,201,0,255,
254,201,0,255,254,201,0,255,254,201,0,255,254,201,0,255,254,201,0,255,254,201,0,
255,254,201,0,255,254,201,0,255,254,201,0,255,254,201,0,255,254,201,0,255,254,
201,0,255,254,201,0,255,254,201,0,255,254,201,0,255,254,201,0,255,254,202,0,255,
254,207,0,255,203,154,0,255,20,15,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,
0,0,0,255,54,41,0,255,254,208,0,255,254,207,0,255,254,200,0,255,253,200,0,255,
249,197,0,255,244,193,0,255,237,187,0,255,229,188,0,255,214,170,0,255,57,42,0,
255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,
120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,
255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,114,92,26,255,255,212,
22,255,255,209,16,255,255,204,9,255,255,202,1,255,252,200,0,255,249,197,0,255,
248,196,0,255,248,196,0,255,248,196,0,255,248,196,0,255,248,196,0,255,248,196,0,
255,248,196,0,255,248,196,0,255,248,196,0,255,248,196,0,255,248,196,0,255,248,
196,0,255,248,196,0,255,248,196,0,255,248,196,0,255,248,196,0,255,248,196,0,255,
248,196,0,255,248,196,0,255,248,197,0,255,248,202,0,255,197,149,0,255,17,14,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,47,33,0,255,248,200,0,255,
248,202,0,255,248,195,0,255,247,196,0,255,245,194,0,255,240,190,0,255,233,184,0,
255,227,186,0,255,213,169,0,255,57,42,0,255,58,40,0,255,255,255,255,255,255,255,
255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,
24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,
255,255,65,51,27,255,113,91,24,255,255,211,18,255,255,208,10,255,255,202,1,255,
248,196,0,255,243,192,0,255,240,190,0,255,239,189,0,255,239,189,0,255,239,189,0,
255,239,189,0,255,239,189,0,255,239,189,0,255,239,189,0,255,239,189,0,255,239,
189,0,255,239,189,0,255,239,189,0,255,239,189,0,255,239,189,0,255,239,189,0,255,
239,189,0,255,239,189,0,255,239,189,0,255,239,189,0,255,239,189,0,255,239,190,0,
255,239,194,0,255,185,140,0,255,15,11,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,46,32,0,255,239,190,0,255,239,194,0,255,239,188,0,255,238,189,0,
255,236,187,0,255,233,185,0,255,228,180,0,255,224,184,0,255,211,167,0,255,58,42,
0,255,58,40,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,
0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,
48,255,255,255,255,255,255,255,255,255,255,255,255,60,48,24,255,111,88,19,255,
255,211,10,255,255,208,0,255,244,192,0,255,236,186,0,255,230,181,0,255,227,179,
0,255,226,178,0,255,226,178,0,255,226,178,0,255,226,178,0,255,226,178,0,255,
226,178,0,255,226,178,0,255,226,178,0,255,226,178,0,255,226,178,0,255,226,178,0,
255,226,178,0,255,226,178,0,255,226,178,0,255,226,178,0,255,226,178,0,255,226,
178,0,255,226,178,0,255,226,178,0,255,226,180,0,255,226,182,0,255,197,150,0,255,
90,65,0,255,56,34,0,255,48,32,0,255,50,32,0,255,56,35,0,255,56,35,0,255,105,77,
0,255,226,177,0,255,226,181,0,255,226,178,0,255,225,177,0,255,224,177,0,255,
222,175,0,255,221,174,0,255,218,179,0,255,209,166,0,255,57,43,0,255,57,40,0,255,
255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,
0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,
255,255,255,255,255,255,255,255,64,51,19,255,92,71,10,255,254,201,0,255,242,202,
0,255,230,188,0,255,221,179,0,255,216,175,0,255,213,173,0,255,212,172,0,255,
212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,
255,212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,212,
172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,
212,172,0,255,212,172,0,255,212,175,0,255,212,177,0,255,212,171,0,255,212,175,0,
255,212,177,0,255,212,177,0,255,212,176,0,255,212,171,0,255,212,171,0,255,212,
179,0,255,212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,
212,172,0,255,212,180,0,255,199,151,0,255,53,36,0,255,66,48,0,255,255,255,255,
255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,
0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,
255,255,255,255,255,95,71,10,255,43,29,0,255,171,128,0,255,227,175,0,255,217,
179,0,255,209,170,0,255,206,168,0,255,203,166,0,255,203,166,0,255,203,166,0,255,
203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,
255,203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,203,
166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,
203,166,0,255,203,166,0,255,203,168,0,255,203,170,0,255,203,171,0,255,203,173,0,
255,203,173,0,255,203,173,0,255,203,171,0,255,203,170,0,255,203,167,0,255,203,
166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,204,168,0,255,
206,162,0,255,131,100,0,255,32,20,0,255,98,70,0,255,255,255,255,255,255,255,255,
255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,
0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,
255,73,50,0,255,25,14,0,255,48,32,0,255,89,62,0,255,105,79,0,255,105,80,0,255,
105,80,0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,
103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,
103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,
103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,104,79,0,255,104,79,0,255,
104,78,0,255,104,78,0,255,104,78,0,255,104,78,0,255,104,78,0,255,104,78,0,255,
104,78,0,255,104,79,0,255,104,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,
105,79,0,255,103,78,0,255,79,58,0,255,37,26,0,255,32,19,0,255,83,60,0,255,255,
255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,
80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,
255,255,255,255,255,255,34,0,0,255,54,38,0,255,61,43,0,255,47,32,0,255,41,27,0,
255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,
27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,
255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,
27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,
255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,
27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,
255,47,33,0,255,62,45,0,255,61,43,0,255,29,29,0,255,255,255,255,255,255,255,255,
255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,
0,0,8,0,0,0,8,0,0,0,24,0,0,0,47,232,232,232,214,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,221,221,221,225,0,0,0,127,0,0,0,119,0,0,0,103,0,0,0,79,0,0,0,47,0,0,0,24,0,
0,0,8,0,0,0,8,0,0,0,23,0,0,0,46,164,164,164,140,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,133,133,133,173,0,0,0,127,0,0,0,119,0,0,0,102,0,0,0,78,0,0,0,46,0,0,0,23,0,
0,0,8,0,0,0,7,0,0,0,21,0,0,0,44,0,0,0,75,148,148,148,155,223,223,223,223,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,221,221,221,225,133,133,133,173,0,0,
0,127,0,0,0,126,0,0,0,117,0,0,0,100,0,0,0,75,0,0,0,44,0,0,0,21,0,0,0,7,0,0,0,
5,0,0,0,18,0,0,0,39,0,0,0,68,0,0,0,94,0,0,0,113,0,0,0,124,0,0,0,127,0,0,0,127,
0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,127,0,0,0,
127,0,0,0,124,0,0,0,113,0,0,0,94,0,0,0,68,0,0,0,39,0,0,0,18,0,0,0,5,0,0,0,4,0,0,
0,14,0,0,0,33,0,0,0,58,0,0,0,84,0,0,0,105,0,0,0,118,0,0,0,124,0,0,0,126,0,0,0,
127,0,0,0,127,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,127,0,0,0,127,0,0,0,126,0,0,0,124,0,0,0,
118,0,0,0,105,0,0,0,84,0,0,0,58,0,0,0,33,0,0,0,14,0,0,0,4,0,0,0,2,0,0,0,10,0,0,
0,24,0,0,0,45,0,0,0,69,0,0,0,90,0,0,0,105,0,0,0,113,0,0,0,117,0,0,0,119,0,0,0,
119,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,
120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,
120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,
120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,
120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,
120,0,0,0,120,0,0,0,120,0,0,0,119,0,0,0,119,0,0,0,117,0,0,0,113,0,0,0,105,0,0,0,
90,0,0,0,69,0,0,0,45,0,0,0,24,0,0,0,10,0,0,0,2,0,0,0,1,0,0,0,6,0,0,0,15,0,0,0,
31,0,0,0,50,0,0,0,69,0,0,0,84,0,0,0,94,0,0,0,100,0,0,0,102,0,0,0,103,0,0,0,104,
0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,
104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,
104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,
104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,
104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,
104,0,0,0,104,0,0,0,103,0,0,0,102,0,0,0,100,0,0,0,94,0,0,0,84,0,0,0,69,0,0,0,50,
0,0,0,31,0,0,0,15,0,0,0,6,0,0,0,1,255,255,255,0,0,0,0,3,0,0,0,8,0,0,0,18,0,0,
0,31,0,0,0,45,0,0,0,58,0,0,0,68,0,0,0,75,0,0,0,78,0,0,0,79,0,0,0,80,0,0,0,80,
0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,
80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,
0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,
0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,
80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,79,0,0,0,78,0,0,0,75,0,0,
0,68,0,0,0,58,0,0,0,45,0,0,0,31,0,0,0,18,0,0,0,8,0,0,0,3,255,255,255,0,255,
255,255,0,0,0,0,1,0,0,0,3,0,0,0,8,0,0,0,15,0,0,0,24,0,0,0,33,0,0,0,39,0,0,0,44,
0,0,0,46,0,0,0,47,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,
48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,
0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,
0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,
48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,
0,48,0,0,0,47,0,0,0,46,0,0,0,44,0,0,0,39,0,0,0,33,0,0,0,24,0,0,0,15,0,0,0,8,0,
0,0,3,0,0,0,1,255,255,255,0,255,255,255,0,255,255,255,0,0,0,0,1,0,0,0,3,0,0,0,
6,0,0,0,10,0,0,0,14,0,0,0,18,0,0,0,21,0,0,0,23,0,0,0,24,0,0,0,24,0,0,0,24,0,0,
0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,
0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,
24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,
0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,
0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,23,0,0,0,21,0,0,0,
18,0,0,0,14,0,0,0,10,0,0,0,6,0,0,0,3,0,0,0,1,255,255,255,0,255,255,255,0,255,
255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,0,0,0,1,0,0,0,2,0,0,0,4,0,0,
0,5,0,0,0,7,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,
0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,
0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,
8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,
0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,7,0,
0,0,5,0,0,0,4,0,0,0,2,0,0,0,1,255,255,255,0,255,255,255,0,255,255,255,0,255,
255,255,0};
static Fl_RGB_Image image_HardLeftThenRight(idata_HardLeftThenRight, 64, 64, 4, 0);

void TrackEditorUI::cb_hardRightThenLeft_i(Fl_Menu_*, void*) {
  trackView->setSign(kHardRightThenLeft);
}
void TrackEditorUI::cb_hardRightThenLeft(Fl_Menu_* o, void* v) {
  ((TrackEditorUI*)(o->parent()->user_data()))->cb_hardRightThenLeft_i(o,v);
}

static unsigned char idata_HardRightThenLeft[] =
{255,255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,0,0,0,1,0,0,0,2,0,
0,0,4,0,0,0,5,0,0,0,7,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,
0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,
8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,
0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,
0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,
0,0,0,7,0,0,0,5,0,0,0,4,0,0,0,2,0,0,0,1,255,255,255,0,255,255,255,0,255,255,
255,0,255,255,255,0,255,255,255,0,255,255,255,0,0,0,0,1,0,0,0,3,0,0,0,6,0,0,0,
10,0,0,0,14,0,0,0,18,0,0,0,21,0,0,0,23,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,
0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,
0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,
24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,
0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,
0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,23,0,0,0,21,0,0,0,18,0,0,0,
14,0,0,0,10,0,0,0,6,0,0,0,3,0,0,0,1,255,255,255,0,255,255,255,0,255,255,255,0,
0,0,0,1,0,0,0,3,0,0,0,8,230,230,230,100,247,247,247,201,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,241,241,241,206,194,194,194,118,0,0,0,39,0,0,0,33,0,
0,0,24,0,0,0,15,0,0,0,8,0,0,0,3,0,0,0,1,255,255,255,0,255,255,255,0,0,0,0,3,0,
0,0,8,225,225,225,102,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,171,171,171,134,0,0,0,
58,0,0,0,45,0,0,0,31,0,0,0,18,0,0,0,8,0,0,0,3,255,255,255,0,0,0,0,1,0,0,0,6,0,
0,0,15,246,246,246,202,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,229,229,229,217,0,0,
0,84,0,0,0,69,0,0,0,50,0,0,0,31,0,0,0,15,0,0,0,6,0,0,0,1,0,0,0,2,0,0,0,10,0,0,
0,24,255,255,255,255,255,255,255,255,255,255,255,255,74,74,44,255,105,88,46,
255,114,93,49,255,101,85,50,255,97,83,51,255,97,84,52,255,97,85,52,255,97,85,52,
255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,
255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,
255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,
255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,
255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,
255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,97,84,51,255,95,80,48,
255,96,80,43,255,109,87,34,255,95,75,22,255,44,44,9,255,255,255,255,255,255,255,
255,255,255,255,255,255,0,0,0,105,0,0,0,90,0,0,0,69,0,0,0,45,0,0,0,24,0,0,0,10,
0,0,0,2,0,0,0,4,0,0,0,14,0,0,0,33,255,255,255,255,255,255,255,255,255,255,255,
255,117,87,39,255,72,59,42,255,83,71,45,255,116,98,47,255,128,106,49,255,128,
106,50,255,128,107,50,255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,
51,255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,51,
255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,51,255,
129,108,51,255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,51,255,129,
108,51,255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,
51,255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,51,
255,129,108,51,255,129,108,51,255,129,108,51,255,129,107,50,255,128,106,49,255,
126,105,47,255,122,100,42,255,100,82,34,255,58,46,22,255,47,31,9,255,105,70,0,
255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,118,0,0,0,105,0,0,0,
84,0,0,0,58,0,0,0,33,0,0,0,14,0,0,0,4,0,0,0,5,0,0,0,18,0,0,0,39,255,255,255,
255,255,255,255,255,255,255,255,255,119,98,35,255,78,64,37,255,188,150,40,255,
254,209,43,255,255,217,45,255,255,214,46,255,255,216,46,255,255,216,46,255,255,
216,46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,216,
46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,216,46,
255,255,216,46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,216,46,255,
255,215,46,255,255,216,46,255,255,216,46,255,255,219,46,255,255,220,46,255,255,
220,46,255,255,217,46,255,255,216,46,255,255,215,46,255,255,216,46,255,255,216,
46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,216,46,
255,255,216,46,255,255,215,43,255,255,215,40,255,255,213,32,255,249,195,22,255,
152,117,8,255,35,22,0,255,113,83,0,255,255,255,255,255,255,255,255,255,255,255,
255,255,0,0,0,124,0,0,0,113,0,0,0,94,0,0,0,68,0,0,0,39,0,0,0,18,0,0,0,5,0,0,0,7,
0,0,0,21,0,0,0,44,255,255,255,255,255,255,255,255,255,255,255,255,77,62,31,
255,106,88,34,255,253,201,36,255,255,220,37,255,255,214,38,255,255,212,38,255,
255,214,38,255,255,213,37,255,255,213,37,255,255,213,37,255,255,213,37,255,255,
213,37,255,255,213,37,255,255,213,37,255,255,213,37,255,255,213,37,255,255,213,
37,255,255,213,37,255,255,213,37,255,255,213,37,255,255,213,37,255,255,213,37,
255,255,213,37,255,255,213,37,255,255,213,37,255,255,215,37,255,255,220,37,255,
255,222,37,255,252,206,37,255,255,217,37,255,255,221,37,255,255,215,37,255,255,
212,37,255,255,213,37,255,255,213,37,255,255,213,37,255,255,213,37,255,255,213,
37,255,255,213,37,255,255,213,37,255,255,213,37,255,255,213,34,255,255,212,29,
255,255,213,20,255,255,215,7,255,231,175,0,255,55,39,0,255,70,51,0,255,255,255,
255,255,255,255,255,255,255,255,255,255,0,0,0,126,0,0,0,117,0,0,0,100,0,0,0,75,
0,0,0,44,0,0,0,21,0,0,0,7,0,0,0,8,0,0,0,23,0,0,0,46,255,255,255,255,255,255,
255,255,255,255,255,255,65,54,30,255,117,96,31,255,255,212,31,255,255,213,31,
255,254,207,31,255,254,206,29,255,255,208,28,255,255,208,27,255,255,207,26,255,
255,207,26,255,255,207,26,255,255,207,26,255,255,207,26,255,255,207,26,255,255,
207,26,255,255,207,26,255,255,207,26,255,255,207,26,255,255,207,26,255,255,207,
26,255,255,207,26,255,255,207,26,255,255,207,26,255,255,207,26,255,255,208,26,
255,255,213,26,255,255,213,26,255,174,148,26,255,50,47,26,255,129,114,26,255,
247,202,26,255,255,215,26,255,255,207,26,255,255,207,26,255,255,207,26,255,255,
207,26,255,255,207,26,255,255,207,26,255,255,207,26,255,255,207,26,255,255,207,
25,255,255,207,22,255,255,205,16,255,255,201,6,255,251,205,0,255,232,177,0,255,
60,44,0,255,57,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,
127,0,0,0,119,0,0,0,102,0,0,0,78,0,0,0,46,0,0,0,23,0,0,0,8,0,0,0,8,0,0,0,24,0,0,
0,47,255,255,255,255,255,255,255,255,255,255,255,255,61,52,28,255,115,95,29,
255,255,211,28,255,255,212,26,255,254,205,23,255,255,206,19,255,255,206,17,255,
255,205,15,255,255,205,15,255,255,205,15,255,255,205,15,255,255,205,15,255,255,
205,15,255,255,205,15,255,255,205,15,255,255,205,15,255,255,205,15,255,255,205,
15,255,255,205,15,255,255,205,15,255,255,205,15,255,255,205,15,255,255,205,15,
255,255,205,15,255,255,208,15,255,255,214,15,255,211,173,15,255,63,55,15,255,15,
15,15,255,27,25,15,255,170,137,15,255,255,212,15,255,255,210,15,255,255,203,15,
255,255,205,15,255,255,205,15,255,255,205,15,255,255,205,15,255,255,205,15,255,
255,205,15,255,255,205,13,255,255,204,10,255,255,203,4,255,251,199,0,255,240,
197,0,255,221,175,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,255,255,
255,255,255,255,0,0,0,127,0,0,0,119,0,0,0,103,0,0,0,79,0,0,0,47,0,0,0,24,0,0,0,
8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,
64,52,28,255,117,94,28,255,255,213,26,255,255,210,23,255,255,206,18,255,255,
205,13,255,255,204,10,255,255,203,7,255,255,203,6,255,255,203,6,255,255,203,6,
255,255,203,6,255,255,203,6,255,255,203,6,255,255,203,6,255,255,203,6,255,255,
203,6,255,255,203,6,255,255,203,6,255,255,203,6,255,255,203,6,255,255,203,6,255,
255,202,6,255,255,204,6,255,255,211,6,255,237,190,6,255,94,80,6,255,6,6,6,255,6,
6,6,255,6,6,6,255,63,50,6,255,211,170,6,255,255,212,6,255,255,206,6,255,254,
201,6,255,255,203,6,255,255,203,6,255,255,203,6,255,255,203,6,255,255,203,6,255,
255,203,5,255,255,202,1,255,251,199,0,255,243,192,0,255,233,189,0,255,217,171,0,
255,57,44,0,255,59,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,
0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,
0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,63,52,28,255,115,94,
28,255,255,213,25,255,255,210,21,255,255,205,15,255,255,204,9,255,255,203,5,
255,255,202,2,255,255,202,1,255,255,202,1,255,255,202,1,255,255,202,1,255,255,
202,1,255,255,202,1,255,255,202,1,255,255,202,1,255,255,202,1,255,255,202,1,255,
255,202,1,255,255,202,1,255,255,202,1,255,255,202,1,255,255,201,1,255,255,209,1,
255,255,211,1,255,166,132,1,255,12,12,1,255,1,1,1,255,1,1,1,255,1,1,1,255,1,1,1,
255,100,81,1,255,244,192,1,255,255,210,1,255,255,202,1,255,255,202,1,255,255,
202,1,255,255,202,1,255,255,202,1,255,255,202,1,255,255,202,0,255,253,200,0,255,
247,196,0,255,239,189,0,255,230,189,0,255,214,169,0,255,57,43,0,255,59,41,0,255,
255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,
0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,
255,255,255,255,255,255,255,255,65,52,28,255,115,94,28,255,255,213,25,255,255,
210,20,255,255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,201,0,255,255,204,0,255,255,212,0,255,206,163,0,255,36,30,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,12,8,0,255,172,135,0,255,
255,211,0,255,255,207,0,255,254,200,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,189,0,255,230,
189,0,255,217,165,0,255,57,43,0,255,59,41,0,255,255,255,255,255,255,255,255,255,
255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,
8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,
64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,
204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,201,0,255,255,203,0,255,255,
213,0,255,239,191,0,255,83,71,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,
0,255,0,0,0,255,0,0,0,255,38,33,0,255,212,170,0,255,255,213,0,255,255,206,0,
255,254,200,0,255,255,202,0,255,255,202,0,255,255,202,0,255,254,201,0,255,251,
199,0,255,245,194,0,255,238,189,0,255,230,189,0,255,216,165,0,255,57,43,0,255,
58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,
120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,
255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,
25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,203,0,255,255,210,0,255,255,205,0,255,135,109,0,255,1,1,0,255,0,0,
0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,
88,75,0,255,235,188,0,255,255,212,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,189,0,255,230,
189,0,255,217,165,0,255,57,43,0,255,58,41,0,255,255,255,255,255,255,255,255,255,
255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,
8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,
64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,
204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,207,0,255,255,208,0,255,174,
142,0,255,27,23,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,5,6,0,255,137,109,0,255,255,205,0,255,255,209,
0,255,255,202,0,255,254,200,0,255,255,202,0,255,254,201,0,255,251,199,0,255,
245,194,0,255,238,189,0,255,230,189,0,255,214,169,0,255,57,43,0,255,58,41,0,255,
255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,
0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,
255,255,255,255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,
210,20,255,255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,203,0,255,
255,213,0,255,218,172,0,255,60,52,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,
0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,31,25,0,
255,182,147,0,255,255,208,0,255,255,208,0,255,254,200,0,255,255,202,0,255,254,
201,0,255,251,199,0,255,245,194,0,255,238,189,0,255,230,189,0,255,217,165,0,255,
57,43,0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,
128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,
0,48,255,255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,115,94,28,
255,255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,255,
255,202,1,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
203,0,255,255,209,0,255,251,197,0,255,115,90,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,63,52,0,255,224,176,0,255,255,211,0,255,255,202,0,255,
255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,189,0,255,230,189,0,
255,215,165,0,255,57,43,0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,
255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,
0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,64,52,
28,255,115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,
255,255,203,3,255,255,202,1,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,205,0,255,255,209,0,255,175,140,0,255,10,8,0,255,0,0,0,255,0,
0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,
0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,130,105,0,255,255,208,0,255,
255,204,0,255,255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,189,0,
255,230,189,0,255,218,165,0,255,57,43,0,255,58,41,0,255,255,255,255,255,255,255,
255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,
24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,
255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,
255,204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,206,0,255,255,205,0,255,97,79,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,42,35,0,255,255,202,0,255,
255,207,0,255,255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,189,0,
255,230,189,0,255,215,165,0,255,57,43,0,255,58,41,0,255,255,255,255,255,255,255,
255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,
24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,
255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,
255,204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,206,0,255,255,201,0,255,94,72,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,19,11,0,255,3,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,
0,255,0,0,0,255,17,11,0,255,0,0,0,255,0,0,0,255,0,0,0,255,35,26,0,255,254,202,
0,255,255,207,0,255,255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,
238,189,0,255,230,189,0,255,214,169,0,255,57,43,0,255,58,41,0,255,255,255,255,
255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,
0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,
255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,255,
255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,202,
0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,204,0,255,255,210,0,255,189,145,0,
255,18,10,0,255,7,0,0,255,98,71,0,255,198,158,0,255,70,59,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,31,25,0,255,186,141,0,255,121,87,0,255,19,10,
0,255,7,2,0,255,125,90,0,255,255,204,0,255,255,204,0,255,255,202,0,255,254,
201,0,255,251,199,0,255,245,194,0,255,238,189,0,255,230,189,0,255,217,165,0,255,
57,43,0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,
128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,
0,48,255,255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,115,94,28,
255,255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,255,
255,202,1,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,208,0,255,255,208,0,255,231,174,0,255,227,165,0,255,255,206,0,255,
255,209,0,255,80,59,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,26,
20,0,255,234,186,0,255,255,209,0,255,235,179,0,255,233,177,0,255,255,203,0,255,
255,213,0,255,255,202,0,255,255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,
255,238,189,0,255,230,189,0,255,214,169,0,255,57,43,0,255,58,41,0,255,255,255,
255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,
0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,
255,255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,
255,255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,201,0,255,255,206,0,
255,255,205,0,255,255,205,0,255,255,216,0,255,255,200,0,255,77,55,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,17,14,0,255,223,174,0,255,255,214,0,
255,255,206,0,255,255,205,0,255,255,206,0,255,255,202,0,255,254,200,0,255,255,
202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,188,0,255,230,187,0,255,
214,169,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,
255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,
8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,64,52,28,
255,115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,255,
255,203,3,255,255,202,1,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,254,201,0,255,254,201,0,255,255,202,0,255,
255,208,0,255,250,193,0,255,73,52,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,
0,0,0,255,19,15,0,255,221,174,0,255,255,210,0,255,255,202,0,255,254,200,0,255,
254,201,0,255,254,200,0,255,255,202,0,255,255,202,0,255,254,201,0,255,251,199,0,
255,245,194,0,255,238,188,0,255,230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,
255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,
104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,
255,255,255,255,255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,25,255,
255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,255,202,
0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,201,0,255,255,209,0,255,253,198,0,255,77,57,
0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,18,14,0,255,220,173,0,
255,255,210,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,188,0,255,
230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,255,
255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,
0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,
255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,
204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,203,0,255,255,203,0,
255,255,204,0,255,255,204,0,255,255,204,0,255,255,204,0,255,255,203,0,255,255,
205,0,255,255,210,0,255,254,195,0,255,76,54,0,255,0,0,0,255,0,0,0,255,0,0,0,255,
0,0,0,255,0,0,0,255,12,9,0,255,216,169,0,255,255,209,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,254,201,0,255,
251,199,0,255,245,194,0,255,238,188,0,255,230,189,0,255,214,170,0,255,57,42,0,
255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,
120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,
255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,
25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,201,0,255,255,204,0,
255,255,207,0,255,255,207,0,255,255,208,0,255,255,207,0,255,255,209,0,255,255,
208,0,255,255,210,0,255,255,209,0,255,255,211,0,255,255,214,0,255,254,198,0,255,
76,55,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,13,9,0,255,218,
171,0,255,255,209,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,188,0,
255,230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,
255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,
24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,
255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,
255,204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,205,0,255,255,212,0,255,255,204,0,255,221,176,0,255,189,
155,0,255,175,140,0,255,176,147,0,255,175,145,0,255,177,148,0,255,177,147,0,255,
177,147,0,255,181,150,0,255,162,135,0,255,36,28,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,12,10,0,255,217,168,0,255,255,209,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,254,201,0,
255,251,199,0,255,245,194,0,255,238,188,0,255,230,189,0,255,214,170,0,255,57,42,
0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,
0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,
48,255,255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,115,94,28,255,
255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,255,255,
202,1,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,211,0,255,
252,199,0,255,133,107,0,255,25,21,0,255,1,2,0,255,0,0,0,255,0,2,0,255,0,0,0,255,
2,2,0,255,1,2,0,255,2,3,0,255,3,4,0,255,10,9,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,7,7,0,255,213,170,0,255,255,209,0,255,255,202,
0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
254,201,0,255,251,199,0,255,245,194,0,255,238,188,0,255,230,189,0,255,214,170,0,
255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,
0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,
0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,115,94,
28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,
255,255,202,1,255,255,202,0,255,255,202,0,255,255,202,0,255,255,208,0,255,255,
200,0,255,127,101,0,255,6,3,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,5,4,0,255,214,170,0,255,255,209,0,255,255,202,
0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
254,201,0,255,251,199,0,255,245,194,0,255,238,188,0,255,230,189,0,255,214,170,0,
255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,
0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,
0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,115,94,
28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,
255,255,202,1,255,255,202,0,255,255,202,0,255,255,204,0,255,255,209,0,255,203,
161,0,255,17,15,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,8,6,0,255,212,169,0,255,255,207,0,255,255,202,
0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
254,201,0,255,251,199,0,255,245,194,0,255,238,188,0,255,230,189,0,255,214,170,0,
255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,
0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,
0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,115,94,
28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,
255,255,202,1,255,255,202,0,255,255,202,0,255,255,205,0,255,255,208,0,255,158,
124,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,
0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,25,21,0,255,219,175,0,255,255,209,0,255,255,
200,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
254,201,0,255,251,199,0,255,245,194,0,255,238,188,0,255,230,189,0,255,214,170,0,
255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,
0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,
0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,115,94,
28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,
255,255,202,1,255,255,202,0,255,255,201,0,255,255,205,0,255,255,208,0,255,128,
99,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,
0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,102,74,0,255,244,195,0,255,255,207,0,255,254,
200,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
254,201,0,255,251,199,0,255,245,194,0,255,238,188,0,255,230,189,0,255,214,170,0,
255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,
0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,
0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,115,94,
28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,
255,255,202,1,255,255,202,0,255,255,201,0,255,255,207,0,255,255,210,0,255,124,
97,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,
0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,69,49,0,255,208,158,0,255,255,208,0,255,255,205,0,255,
254,200,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,254,201,0,255,251,199,0,255,245,194,0,255,238,188,0,255,230,189,0,255,214,
170,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,
255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,
0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,
115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,
203,3,255,255,202,1,255,255,202,0,255,255,201,0,255,255,207,0,255,255,210,0,255,
126,100,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,7,5,0,
255,46,30,0,255,45,26,0,255,42,22,0,255,42,25,0,255,42,24,0,255,42,24,0,255,42,
24,0,255,45,25,0,255,68,45,0,255,150,108,0,255,245,192,0,255,255,212,0,255,255,
208,0,255,254,202,0,255,254,200,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,188,0,
255,230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,
255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,
24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,
255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,
255,204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,201,0,255,255,207,0,
255,255,210,0,255,128,104,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,127,97,0,255,255,202,0,255,255,211,0,255,255,207,0,255,255,209,0,
255,255,209,0,255,255,209,0,255,255,209,0,255,255,207,0,255,255,203,0,255,255,
206,0,255,255,213,0,255,255,206,0,255,254,201,0,255,254,200,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,254,201,0,
255,251,199,0,255,245,194,0,255,238,188,0,255,230,189,0,255,214,170,0,255,57,42,
0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,
0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,
48,255,255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,115,94,28,255,
255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,255,255,
202,1,255,255,202,0,255,255,201,0,255,255,207,0,255,255,210,0,255,128,104,0,255,
0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,166,125,0,255,255,
216,0,255,255,212,0,255,255,207,0,255,255,208,0,255,255,208,0,255,255,208,0,255,
255,208,0,255,255,208,0,255,255,206,0,255,255,204,0,255,255,202,0,255,254,200,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,
238,188,0,255,230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,255,255,255,255,
255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,
0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,
255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,255,
255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,201,
0,255,255,205,0,255,255,208,0,255,124,100,0,255,0,0,0,255,0,0,0,255,0,0,0,255,
0,0,0,255,0,0,0,255,0,0,0,255,164,125,0,255,255,207,0,255,255,204,0,255,254,
200,0,255,255,201,0,255,255,201,0,255,255,201,0,255,255,201,0,255,255,201,0,255,
255,201,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,188,0,255,230,189,0,255,
214,170,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,
255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,
8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,64,52,28,
255,115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,255,
255,203,3,255,255,202,1,255,255,202,0,255,255,202,0,255,255,206,0,255,255,211,0,
255,131,109,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,
165,126,0,255,255,209,0,255,255,204,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,254,201,0,255,251,199,0,
255,245,194,0,255,238,188,0,255,230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,
255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,
104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,
255,255,255,255,255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,25,255,
255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,255,202,
0,255,255,201,0,255,255,205,0,255,255,208,0,255,131,105,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,165,124,0,255,255,209,0,255,255,204,
0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,188,0,255,
230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,255,
255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,
0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,
255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,
204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,201,0,255,255,207,0,255,
255,208,0,255,132,105,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,
0,0,255,165,124,0,255,255,209,0,255,255,204,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,254,201,0,255,
251,199,0,255,245,194,0,255,238,188,0,255,230,189,0,255,214,170,0,255,57,42,0,
255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,
120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,
255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,
25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,
255,202,0,255,255,201,0,255,255,207,0,255,255,208,0,255,132,105,0,255,0,0,0,255,
0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,165,124,0,255,255,209,0,255,
255,204,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,188,0,
255,230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,
255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,
24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,
255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,
255,204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,201,0,255,255,207,0,
255,255,208,0,255,132,105,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,165,124,0,255,255,209,0,255,255,204,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,254,201,0,
255,251,199,0,255,245,194,0,255,238,188,0,255,230,189,0,255,214,170,0,255,57,42,
0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,
0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,
48,255,255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,115,93,27,255,
255,213,25,255,255,210,19,255,255,205,13,255,255,203,6,255,255,202,1,255,254,
201,0,255,254,201,0,255,254,200,0,255,254,206,0,255,254,207,0,255,131,105,0,255,
0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,164,124,0,255,254,
208,0,255,254,203,0,255,254,201,0,255,254,201,0,255,254,201,0,255,254,201,0,255,
254,201,0,255,254,201,0,255,254,201,0,255,254,201,0,255,254,201,0,255,254,201,0,
255,254,201,0,255,254,201,0,255,254,201,0,255,254,201,0,255,254,201,0,255,254,
201,0,255,254,201,0,255,254,201,0,255,253,200,0,255,249,197,0,255,244,193,0,255,
237,187,0,255,229,188,0,255,214,170,0,255,57,42,0,255,58,41,0,255,255,255,255,
255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,
0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,
255,255,255,255,255,64,52,28,255,114,92,26,255,255,212,22,255,255,209,16,255,
255,204,9,255,255,202,1,255,252,200,0,255,249,197,0,255,248,196,0,255,248,195,0,
255,248,199,0,255,248,202,0,255,127,100,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,
0,255,0,0,0,255,0,0,0,255,159,122,0,255,248,203,0,255,248,198,0,255,248,196,0,
255,248,196,0,255,248,196,0,255,248,196,0,255,248,196,0,255,248,196,0,255,248,
196,0,255,248,196,0,255,248,196,0,255,248,196,0,255,248,196,0,255,248,196,0,255,
248,196,0,255,248,196,0,255,248,196,0,255,248,196,0,255,248,196,0,255,248,196,0,
255,247,196,0,255,245,194,0,255,240,190,0,255,233,184,0,255,227,186,0,255,213,
169,0,255,57,42,0,255,58,40,0,255,255,255,255,255,255,255,255,255,255,255,255,
255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,
0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,65,51,27,255,
113,91,24,255,255,211,18,255,255,208,10,255,255,202,1,255,248,196,0,255,243,192,
0,255,240,190,0,255,239,189,0,255,239,189,0,255,239,193,0,255,239,194,0,255,
121,97,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,150,
112,0,255,239,194,0,255,239,190,0,255,239,189,0,255,239,189,0,255,239,189,0,255,
239,189,0,255,239,189,0,255,239,189,0,255,239,189,0,255,239,189,0,255,239,189,0,
255,239,189,0,255,239,189,0,255,239,189,0,255,239,189,0,255,239,189,0,255,239,
189,0,255,239,189,0,255,239,189,0,255,239,189,0,255,238,189,0,255,236,187,0,255,
233,185,0,255,228,180,0,255,224,184,0,255,211,167,0,255,58,42,0,255,58,40,0,255,
255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,
0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,
255,255,255,255,255,255,255,255,60,48,24,255,111,88,19,255,255,211,10,255,255,
208,0,255,244,192,0,255,236,186,0,255,230,181,0,255,227,179,0,255,226,178,0,255,
226,178,0,255,226,180,0,255,226,178,0,255,128,104,0,255,36,23,0,255,36,20,0,255,
40,24,0,255,40,24,0,255,38,22,0,255,52,33,0,255,169,127,0,255,226,181,0,255,
226,179,0,255,226,178,0,255,226,178,0,255,226,178,0,255,226,178,0,255,226,178,0,
255,226,178,0,255,226,178,0,255,226,178,0,255,226,178,0,255,226,178,0,255,226,
178,0,255,226,178,0,255,226,178,0,255,226,178,0,255,226,178,0,255,226,178,0,255,
226,178,0,255,226,178,0,255,225,177,0,255,224,177,0,255,222,175,0,255,221,174,0,
255,218,179,0,255,209,166,0,255,57,43,0,255,57,40,0,255,255,255,255,255,255,255,
255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,
24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,
255,255,64,51,19,255,92,71,10,255,254,201,0,255,242,202,0,255,230,188,0,255,221,
179,0,255,216,175,0,255,213,173,0,255,212,172,0,255,212,172,0,255,212,174,0,255,
212,177,0,255,212,174,0,255,212,170,0,255,212,176,0,255,212,176,0,255,212,176,0,
255,212,175,0,255,212,170,0,255,212,177,0,255,212,176,0,255,212,171,0,255,212,
172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,
212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,
255,212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,212,
172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,212,180,0,255,
199,151,0,255,53,36,0,255,66,48,0,255,255,255,255,255,255,255,255,255,255,255,
255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,
8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,95,71,10,
255,43,29,0,255,171,128,0,255,227,175,0,255,217,179,0,255,209,170,0,255,206,168,
0,255,203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,203,167,0,255,
203,170,0,255,203,171,0,255,203,173,0,255,203,173,0,255,203,173,0,255,203,173,0,
255,203,171,0,255,203,169,0,255,203,167,0,255,203,166,0,255,203,166,0,255,203,
166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,
203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,
255,203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,203,
166,0,255,203,166,0,255,203,166,0,255,204,168,0,255,206,162,0,255,131,100,0,255,
32,20,0,255,98,70,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,
128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,
0,48,255,255,255,255,255,255,255,255,255,255,255,255,73,50,0,255,25,14,0,255,
48,32,0,255,89,62,0,255,105,79,0,255,105,80,0,255,105,80,0,255,103,79,0,255,
103,79,0,255,103,79,0,255,103,79,0,255,104,79,0,255,104,78,0,255,104,78,0,255,
104,78,0,255,104,78,0,255,104,78,0,255,104,78,0,255,104,78,0,255,104,79,0,255,
104,79,0,255,104,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,
103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,
103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,
103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,105,79,0,255,103,78,0,255,
79,58,0,255,37,26,0,255,32,19,0,255,83,60,0,255,255,255,255,255,255,255,255,
255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,
0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,
255,34,0,0,255,54,38,0,255,61,43,0,255,47,32,0,255,41,27,0,255,40,27,0,255,40,
27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,
255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,
27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,
255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,
27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,
255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,47,33,0,255,62,
45,0,255,61,43,0,255,29,29,0,255,255,255,255,255,255,255,255,255,255,255,255,
255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,
0,0,24,0,0,0,47,232,232,232,214,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,221,221,221,
225,0,0,0,127,0,0,0,119,0,0,0,103,0,0,0,79,0,0,0,47,0,0,0,24,0,0,0,8,0,0,0,8,0,
0,0,23,0,0,0,46,164,164,164,140,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,133,133,133,
173,0,0,0,127,0,0,0,119,0,0,0,102,0,0,0,78,0,0,0,46,0,0,0,23,0,0,0,8,0,0,0,7,0,
0,0,21,0,0,0,44,0,0,0,75,148,148,148,155,223,223,223,223,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,221,221,221,225,133,133,133,173,0,0,0,127,0,0,0,126,
0,0,0,117,0,0,0,100,0,0,0,75,0,0,0,44,0,0,0,21,0,0,0,7,0,0,0,5,0,0,0,18,0,0,0,
39,0,0,0,68,0,0,0,94,0,0,0,113,0,0,0,124,0,0,0,127,0,0,0,127,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,127,0,0,0,127,0,0,0,124,0,0,0,
113,0,0,0,94,0,0,0,68,0,0,0,39,0,0,0,18,0,0,0,5,0,0,0,4,0,0,0,14,0,0,0,33,0,0,0,
58,0,0,0,84,0,0,0,105,0,0,0,118,0,0,0,124,0,0,0,126,0,0,0,127,0,0,0,127,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,127,0,0,0,127,0,0,0,126,0,0,0,124,0,0,0,118,0,0,0,105,0,0,0,
84,0,0,0,58,0,0,0,33,0,0,0,14,0,0,0,4,0,0,0,2,0,0,0,10,0,0,0,24,0,0,0,45,0,0,0,
69,0,0,0,90,0,0,0,105,0,0,0,113,0,0,0,117,0,0,0,119,0,0,0,119,0,0,0,120,0,0,0,
120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,
120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,
120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,
120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,
120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,
120,0,0,0,119,0,0,0,119,0,0,0,117,0,0,0,113,0,0,0,105,0,0,0,90,0,0,0,69,0,0,0,
45,0,0,0,24,0,0,0,10,0,0,0,2,0,0,0,1,0,0,0,6,0,0,0,15,0,0,0,31,0,0,0,50,0,0,0,
69,0,0,0,84,0,0,0,94,0,0,0,100,0,0,0,102,0,0,0,103,0,0,0,104,0,0,0,104,0,0,0,
104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,
104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,
104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,
104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,
104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,
103,0,0,0,102,0,0,0,100,0,0,0,94,0,0,0,84,0,0,0,69,0,0,0,50,0,0,0,31,0,0,0,15,0,
0,0,6,0,0,0,1,255,255,255,0,0,0,0,3,0,0,0,8,0,0,0,18,0,0,0,31,0,0,0,45,0,0,0,
58,0,0,0,68,0,0,0,75,0,0,0,78,0,0,0,79,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,
0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,
0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,
80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,
0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,
0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,79,0,0,0,78,0,0,0,75,0,0,0,68,0,0,0,58,0,0,0,
45,0,0,0,31,0,0,0,18,0,0,0,8,0,0,0,3,255,255,255,0,255,255,255,0,0,0,0,1,0,0,0,
3,0,0,0,8,0,0,0,15,0,0,0,24,0,0,0,33,0,0,0,39,0,0,0,44,0,0,0,46,0,0,0,47,0,0,
0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,
0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,
48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,
0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,
0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,47,0,0,0,
46,0,0,0,44,0,0,0,39,0,0,0,33,0,0,0,24,0,0,0,15,0,0,0,8,0,0,0,3,0,0,0,1,255,
255,255,0,255,255,255,0,255,255,255,0,0,0,0,1,0,0,0,3,0,0,0,6,0,0,0,10,0,0,0,14,
0,0,0,18,0,0,0,21,0,0,0,23,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,
24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,
0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,
0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,
24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,
0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,23,0,0,0,21,0,0,0,18,0,0,0,14,0,0,0,10,
0,0,0,6,0,0,0,3,0,0,0,1,255,255,255,0,255,255,255,0,255,255,255,0,255,255,255,
0,255,255,255,0,255,255,255,0,0,0,0,1,0,0,0,2,0,0,0,4,0,0,0,5,0,0,0,7,0,0,0,8,
0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,
8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,
0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,
0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,
0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,7,0,0,0,5,0,0,0,4,0,0,0,
2,0,0,0,1,255,255,255,0,255,255,255,0,255,255,255,0,255,255,255,0};
static Fl_RGB_Image image_HardRightThenLeft(idata_HardRightThenLeft, 64, 64, 4, 0);

void TrackEditorUI::cb_LRLR_i(Fl_Menu_*, void*) {
  trackView->setSign(kLRLR);
}
void TrackEditorUI::cb_LRLR(Fl_Menu_* o, void* v) {
  ((TrackEditorUI*)(o->parent()->user_data()))->cb_LRLR_i(o,v);
}

static unsigned char idata_LRLR[] =
{255,255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,0,0,0,1,0,0,0,2,0,
0,0,4,0,0,0,5,0,0,0,7,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,
0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,
8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,
0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,
0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,
0,0,0,7,0,0,0,5,0,0,0,4,0,0,0,2,0,0,0,1,255,255,255,0,255,255,255,0,255,255,
255,0,255,255,255,0,255,255,255,0,255,255,255,0,0,0,0,1,0,0,0,3,0,0,0,6,0,0,0,
10,0,0,0,14,0,0,0,18,0,0,0,21,0,0,0,23,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,
0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,
0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,
24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,
0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,
0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,23,0,0,0,21,0,0,0,18,0,0,0,
14,0,0,0,10,0,0,0,6,0,0,0,3,0,0,0,1,255,255,255,0,255,255,255,0,255,255,255,0,
0,0,0,1,0,0,0,3,0,0,0,8,230,230,230,100,247,247,247,201,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,241,241,241,206,194,194,194,118,0,0,0,39,0,0,0,33,0,
0,0,24,0,0,0,15,0,0,0,8,0,0,0,3,0,0,0,1,255,255,255,0,255,255,255,0,0,0,0,3,0,
0,0,8,225,225,225,102,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,171,171,171,134,0,0,0,
58,0,0,0,45,0,0,0,31,0,0,0,18,0,0,0,8,0,0,0,3,255,255,255,0,0,0,0,1,0,0,0,6,0,
0,0,15,246,246,246,202,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,229,229,229,217,0,0,
0,84,0,0,0,69,0,0,0,50,0,0,0,31,0,0,0,15,0,0,0,6,0,0,0,1,0,0,0,2,0,0,0,10,0,0,
0,24,255,255,255,255,255,255,255,255,255,255,255,255,74,74,44,255,105,88,46,
255,114,93,49,255,101,85,50,255,97,83,51,255,97,84,52,255,97,85,52,255,97,85,52,
255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,
255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,
255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,
255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,
255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,
255,98,85,52,255,98,85,52,255,98,85,52,255,98,85,52,255,97,84,51,255,95,80,48,
255,96,80,43,255,109,87,34,255,95,75,22,255,44,44,9,255,255,255,255,255,255,255,
255,255,255,255,255,255,0,0,0,105,0,0,0,90,0,0,0,69,0,0,0,45,0,0,0,24,0,0,0,10,
0,0,0,2,0,0,0,4,0,0,0,14,0,0,0,33,255,255,255,255,255,255,255,255,255,255,255,
255,117,87,39,255,72,59,42,255,83,71,45,255,116,98,47,255,128,106,49,255,128,
106,50,255,128,107,50,255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,
51,255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,51,
255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,51,255,
129,108,51,255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,51,255,129,
108,51,255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,
51,255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,51,255,129,108,51,
255,129,108,51,255,129,108,51,255,129,108,51,255,129,107,50,255,128,106,49,255,
126,105,47,255,122,100,42,255,100,82,34,255,58,46,22,255,47,31,9,255,104,70,0,
255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,118,0,0,0,105,0,0,0,
84,0,0,0,58,0,0,0,33,0,0,0,14,0,0,0,4,0,0,0,5,0,0,0,18,0,0,0,39,255,255,255,
255,255,255,255,255,255,255,255,255,119,98,35,255,78,64,37,255,188,150,40,255,
254,209,43,255,255,217,45,255,255,214,46,255,255,216,46,255,255,216,46,255,255,
216,46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,216,
46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,216,46,
255,255,215,46,255,255,216,46,255,255,216,46,255,255,218,46,255,255,218,46,255,
255,216,46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,
216,46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,216,
46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,216,46,255,255,216,46,
255,255,216,46,255,255,215,43,255,255,215,40,255,255,213,32,255,249,195,22,255,
152,117,8,255,35,22,0,255,112,84,0,255,255,255,255,255,255,255,255,255,255,255,
255,255,0,0,0,124,0,0,0,113,0,0,0,94,0,0,0,68,0,0,0,39,0,0,0,18,0,0,0,5,0,0,0,7,
0,0,0,21,0,0,0,44,255,255,255,255,255,255,255,255,255,255,255,255,77,62,31,
255,106,88,34,255,253,201,36,255,255,220,37,255,255,214,38,255,255,212,38,255,
255,214,38,255,255,213,37,255,255,213,37,255,255,213,37,255,255,213,37,255,255,
213,37,255,255,213,37,255,255,213,37,255,255,213,37,255,255,213,37,255,255,213,
37,255,255,213,37,255,255,213,37,255,255,213,37,255,255,215,37,255,255,219,37,
255,255,215,37,255,255,211,37,255,255,219,37,255,255,214,37,255,255,213,37,255,
255,213,37,255,255,213,37,255,255,213,37,255,255,213,37,255,255,213,37,255,255,
213,37,255,255,213,37,255,255,213,37,255,255,213,37,255,255,213,37,255,255,213,
37,255,255,213,37,255,255,213,37,255,255,213,37,255,255,213,34,255,255,212,29,
255,255,213,20,255,255,215,7,255,231,175,0,255,55,39,0,255,69,51,0,255,255,255,
255,255,255,255,255,255,255,255,255,255,0,0,0,126,0,0,0,117,0,0,0,100,0,0,0,75,
0,0,0,44,0,0,0,21,0,0,0,7,0,0,0,8,0,0,0,23,0,0,0,46,255,255,255,255,255,255,
255,255,255,255,255,255,65,54,30,255,117,96,31,255,255,212,31,255,255,213,31,
255,254,207,31,255,254,206,29,255,255,208,28,255,255,208,27,255,255,207,26,255,
255,207,26,255,255,207,26,255,255,207,26,255,255,207,26,255,255,207,26,255,255,
207,26,255,255,207,26,255,255,207,26,255,255,207,26,255,255,207,26,255,255,208,
26,255,255,214,26,255,255,212,26,255,176,151,26,255,158,135,26,255,253,207,26,
255,255,213,26,255,255,207,26,255,255,207,26,255,255,207,26,255,255,207,26,255,
255,207,26,255,255,207,26,255,255,207,26,255,255,207,26,255,255,207,26,255,255,
207,26,255,255,207,26,255,255,207,26,255,255,207,26,255,255,207,26,255,255,207,
25,255,255,207,22,255,255,205,16,255,255,201,6,255,251,205,0,255,232,177,0,255,
60,44,0,255,57,42,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,
127,0,0,0,119,0,0,0,102,0,0,0,78,0,0,0,46,0,0,0,23,0,0,0,8,0,0,0,8,0,0,0,24,0,0,
0,47,255,255,255,255,255,255,255,255,255,255,255,255,61,52,28,255,115,95,29,
255,255,211,28,255,255,212,26,255,254,205,23,255,255,206,19,255,255,206,17,255,
255,205,15,255,255,205,15,255,255,205,15,255,255,205,15,255,255,205,15,255,255,
205,15,255,255,205,15,255,255,205,15,255,255,205,15,255,255,205,15,255,255,205,
15,255,255,205,15,255,255,207,15,255,255,216,15,255,211,171,15,255,38,36,15,
255,31,30,15,255,204,165,15,255,255,214,15,255,255,209,15,255,254,203,15,255,
255,205,15,255,255,205,15,255,255,205,15,255,255,205,15,255,255,205,15,255,255,
205,15,255,255,205,15,255,255,205,15,255,255,205,15,255,255,205,15,255,255,205,
15,255,255,205,15,255,255,205,13,255,255,204,10,255,255,203,4,255,251,199,0,
255,240,197,0,255,221,175,0,255,57,42,0,255,57,41,0,255,255,255,255,255,255,255,
255,255,255,255,255,255,0,0,0,127,0,0,0,119,0,0,0,103,0,0,0,79,0,0,0,47,0,0,0,
24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,
255,255,64,52,28,255,117,94,28,255,255,213,26,255,255,210,23,255,255,206,18,255,
255,205,13,255,255,204,10,255,255,203,7,255,255,203,6,255,255,203,6,255,255,203,
6,255,255,203,6,255,255,203,6,255,255,203,6,255,255,203,6,255,255,203,6,255,
255,203,6,255,255,203,6,255,255,204,6,255,255,212,6,255,241,193,6,255,92,77,6,
255,6,6,6,255,6,6,6,255,71,63,6,255,234,187,6,255,255,213,6,255,255,203,6,255,
255,203,6,255,255,203,6,255,255,203,6,255,255,203,6,255,255,203,6,255,255,203,6,
255,255,203,6,255,255,203,6,255,255,203,6,255,255,203,6,255,255,203,6,255,255,
203,6,255,255,203,5,255,255,202,1,255,251,199,0,255,243,192,0,255,233,189,0,255,
217,171,0,255,57,44,0,255,57,39,0,255,255,255,255,255,255,255,255,255,255,255,
255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,
8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,63,52,28,
255,115,94,28,255,255,213,25,255,255,210,21,255,255,205,15,255,255,204,9,255,
255,203,5,255,255,202,2,255,255,202,1,255,255,202,1,255,255,202,1,255,255,202,1,
255,255,202,1,255,255,202,1,255,255,202,1,255,255,202,1,255,255,202,1,255,255,
202,1,255,255,207,1,255,255,211,1,255,150,124,1,255,8,7,1,255,1,1,1,255,1,1,1,
255,1,1,1,255,134,110,1,255,255,204,1,255,255,211,1,255,255,200,1,255,255,202,1,
255,255,202,1,255,255,202,1,255,255,202,1,255,255,202,1,255,255,202,1,255,255,
202,1,255,255,202,1,255,255,202,1,255,255,202,1,255,255,202,1,255,255,202,0,255,
253,200,0,255,247,196,0,255,239,189,0,255,230,189,0,255,214,169,0,255,57,43,0,
255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,
120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,
255,255,255,255,255,255,255,255,255,255,255,65,52,28,255,115,94,28,255,255,213,
25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,201,0,255,255,204,0,255,255,214,0,255,226,
179,0,255,35,31,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,25,22,0,255,181,
143,0,255,255,211,0,255,255,207,0,255,254,200,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,
189,0,255,230,189,0,255,217,165,0,255,57,43,0,255,58,41,0,255,255,255,255,255,
255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,
0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,
255,255,255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,255,255,
205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,203,0,255,255,212,0,255,241,193,0,255,95,79,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,56,44,0,255,231,184,0,255,255,213,0,
255,255,204,0,255,254,200,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
254,201,0,255,251,199,0,255,245,194,0,255,238,189,0,255,230,189,0,255,216,165,0,
255,57,43,0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,
0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,
0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,115,94,
28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,
255,255,202,1,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,207,0,255,255,209,0,255,
159,126,0,255,10,10,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,
0,255,0,0,0,255,123,102,0,255,254,201,0,255,255,211,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,
255,238,189,0,255,230,189,0,255,217,165,0,255,57,43,0,255,58,41,0,255,255,255,
255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,
0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,
255,255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,
255,255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,201,0,255,
255,202,0,255,255,214,0,255,221,176,0,255,37,32,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,16,14,0,255,171,136,0,255,
255,211,0,255,255,206,0,255,254,200,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,254,
201,0,255,251,199,0,255,245,194,0,255,238,189,0,255,230,189,0,255,214,169,0,255,
57,43,0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,
128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,
0,48,255,255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,115,94,28,
255,255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,255,
255,202,1,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,211,0,255,254,202,0,255,108,88,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,56,48,0,255,239,193,0,255,255,214,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,189,0,255,
230,189,0,255,217,165,0,255,57,43,0,255,58,41,0,255,255,255,255,255,255,255,255,
255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,
0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,
255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,
204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,204,0,255,255,207,0,255,170,135,0,
255,3,5,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,121,100,0,255,255,203,0,255,255,205,
0,255,254,200,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,
255,238,189,0,255,230,189,0,255,215,165,0,255,57,43,0,255,58,41,0,255,255,255,
255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,
0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,
255,255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,
255,255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,206,0,255,
253,200,0,255,110,84,0,255,0,0,0,255,0,0,0,255,14,9,0,255,31,22,0,255,0,0,0,255,
0,0,0,255,0,0,0,255,0,0,0,255,16,12,0,255,26,20,0,255,0,0,0,255,0,0,0,255,55,
46,0,255,240,192,0,255,255,206,0,255,254,200,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,254,201,0,
255,251,199,0,255,245,194,0,255,238,189,0,255,230,189,0,255,218,165,0,255,57,43,
0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,
0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,
48,255,255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,115,94,28,255,
255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,255,255,
202,1,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,204,0,255,255,205,0,255,173,130,0,255,54,39,0,255,116,84,0,
255,223,168,0,255,167,124,0,255,1,1,0,255,0,0,0,255,0,0,0,255,0,0,0,255,102,80,
0,255,238,176,0,255,154,107,0,255,69,46,0,255,138,105,0,255,255,203,0,255,255,
205,0,255,254,200,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,
255,238,189,0,255,230,189,0,255,215,165,0,255,57,43,0,255,58,41,0,255,255,255,
255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,
0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,
255,255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,
255,255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,209,0,255,255,207,0,255,247,197,0,255,255,208,0,255,255,223,0,255,180,140,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,103,82,0,255,255,221,0,255,255,215,
0,255,250,196,0,255,255,203,0,255,255,209,0,255,255,203,0,255,254,201,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,189,0,255,230,
189,0,255,214,169,0,255,57,43,0,255,58,41,0,255,255,255,255,255,255,255,255,255,
255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,
8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,
64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,
204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,201,0,255,255,204,0,
255,255,206,0,255,255,208,0,255,255,211,0,255,172,136,0,255,0,0,0,255,0,0,0,255,
0,0,0,255,0,0,0,255,83,67,0,255,255,203,0,255,255,218,0,255,255,215,0,255,255,
207,0,255,255,204,0,255,254,201,0,255,254,201,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,254,201,0,
255,251,199,0,255,245,194,0,255,238,189,0,255,230,189,0,255,217,165,0,255,57,43,
0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,
0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,
48,255,255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,115,94,28,255,
255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,255,255,
202,1,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,201,0,255,255,205,0,
255,255,208,0,255,176,137,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,8,11,0,
255,117,98,0,255,195,162,0,255,243,193,0,255,255,210,0,255,255,209,0,255,255,
205,0,255,254,200,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,
255,238,189,0,255,230,189,0,255,214,169,0,255,57,43,0,255,58,41,0,255,255,255,
255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,
0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,
255,255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,
255,255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,203,0,255,255,208,0,255,201,160,0,
255,11,11,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,3,4,0,255,49,
43,0,255,159,132,0,255,240,191,0,255,255,215,0,255,255,204,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,254,201,0,255,251,199,0,255,245,194,0,255,238,188,0,255,230,187,0,255,214,
169,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,
255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,
0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,
115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,
203,3,255,255,202,1,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,208,0,255,250,199,0,255,105,80,0,255,0,0,0,255,0,0,0,255,
0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,90,72,0,255,246,
195,0,255,255,215,0,255,255,204,0,255,254,200,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,
255,238,188,0,255,230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,255,255,255,
255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,
0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,
255,255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,
255,255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,203,0,255,255,211,0,
255,229,174,0,255,97,67,0,255,4,3,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,
0,0,0,255,0,0,0,255,0,0,0,255,117,93,0,255,249,196,0,255,255,209,0,255,255,
200,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
254,201,0,255,251,199,0,255,245,194,0,255,238,188,0,255,230,189,0,255,214,170,0,
255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,
0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,
0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,115,94,
28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,
255,255,202,1,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,254,200,0,255,255,204,0,255,255,213,0,255,254,199,0,255,179,134,0,
255,64,49,0,255,3,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,11,
7,0,255,181,142,0,255,255,209,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,
255,238,188,0,255,230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,255,255,255,
255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,
0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,
255,255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,
255,255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,254,200,0,
255,255,204,0,255,255,211,0,255,255,211,0,255,241,189,0,255,173,132,0,255,83,57,
0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,118,95,0,255,255,207,
0,255,255,204,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,188,0,255,230,189,0,
255,214,170,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,
255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,
0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,64,52,
28,255,115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,
255,255,203,3,255,255,202,1,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,208,0,255,255,217,0,255,255,223,0,255,231,184,0,255,42,35,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,79,61,0,255,255,205,0,255,255,206,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,254,201,0,255,
251,199,0,255,245,194,0,255,238,188,0,255,230,189,0,255,214,170,0,255,57,42,0,
255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,
120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,
255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,
25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,201,0,255,255,202,0,255,255,207,0,255,255,210,0,255,255,211,0,255,
255,206,0,255,161,136,0,255,10,11,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,
86,68,0,255,255,206,0,255,255,206,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,
188,0,255,230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,255,255,255,255,255,
255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,
0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,
255,255,255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,255,255,
205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,205,0,255,
255,212,0,255,255,206,0,255,211,168,0,255,119,102,0,255,35,31,0,255,0,2,0,255,0,
0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,144,108,0,255,255,209,0,255,
255,204,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,254,201,0,255,251,199,0,255,245,194,0,255,238,188,0,255,230,189,0,255,214,
170,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,
255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,
0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,
115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,
203,3,255,255,202,1,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,211,0,255,253,199,0,255,142,118,0,255,35,31,
0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,
27,19,0,255,204,155,0,255,255,210,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,254,201,0,255,251,199,0,255,245,
194,0,255,238,188,0,255,230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,255,255,
255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,
80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,
255,255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,
255,255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,208,0,255,252,201,0,
255,127,105,0,255,5,5,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,
0,0,255,0,0,0,255,5,1,0,255,142,110,0,255,255,201,0,255,255,209,0,255,254,200,
0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
254,201,0,255,251,199,0,255,245,194,0,255,238,188,0,255,230,189,0,255,214,170,0,
255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,
0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,
0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,115,94,
28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,
255,255,202,1,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,204,0,255,255,209,0,255,200,158,0,255,19,16,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,29,18,0,255,132,98,0,255,253,198,0,
255,255,211,0,255,255,203,0,255,254,201,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,
238,188,0,255,230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,255,255,255,255,
255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,
0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,
255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,255,
255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,202,
0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,201,0,255,255,206,0,255,255,207,0,255,130,108,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,18,12,0,255,108,
80,0,255,207,157,0,255,253,199,0,255,255,210,0,255,255,204,0,255,254,201,0,255,
254,200,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,254,201,0,255,251,199,0,255,245,194,0,255,238,188,0,255,230,189,0,255,214,
170,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,
255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,
0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,
115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,
203,3,255,255,202,1,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,201,0,
255,255,208,0,255,255,205,0,255,80,61,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,11,7,0,255,117,87,0,255,217,165,0,255,255,204,0,255,255,212,0,255,255,210,0,
255,255,204,0,255,254,201,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,254,201,0,255,251,199,0,255,
245,194,0,255,238,188,0,255,230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,255,
255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,
0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,
255,255,255,255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,
210,20,255,255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,201,0,255,255,208,0,255,255,206,0,255,
66,46,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,80,61,0,255,248,197,0,255,
255,224,0,255,255,213,0,255,255,202,0,255,255,200,0,255,254,200,0,255,254,200,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,188,0,255,
230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,255,
255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,
0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,
255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,
204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,201,0,255,255,208,0,255,255,204,0,255,89,69,0,255,0,0,0,255,0,0,0,255,0,
0,0,255,0,0,0,255,34,26,0,255,180,143,0,255,255,204,0,255,255,214,0,255,255,
208,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,254,201,0,
255,251,199,0,255,245,194,0,255,238,188,0,255,230,189,0,255,214,170,0,255,57,42,
0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,
0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,
48,255,255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,115,94,28,255,
255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,255,255,
202,1,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,201,0,255,255,205,0,
255,255,208,0,255,156,119,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,17,15,0,255,94,77,0,255,211,168,0,255,255,212,0,255,255,209,0,255,255,200,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,
238,188,0,255,230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,255,255,255,255,
255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,
0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,
255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,255,
255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,202,
0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,203,0,255,255,210,0,255,232,178,0,
255,71,49,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,32,
27,0,255,203,160,0,255,255,210,0,255,255,205,0,255,254,200,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,254,201,0,255,251,199,0,255,245,194,0,255,238,188,0,255,230,189,0,255,214,
170,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,
255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,
0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,
115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,
203,3,255,255,202,1,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,207,0,255,255,211,0,255,195,150,0,255,42,30,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,74,66,0,255,236,190,0,255,
255,208,0,255,254,201,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,254,201,0,255,251,199,0,255,245,
194,0,255,238,188,0,255,230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,255,255,
255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,
80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,
255,255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,25,255,255,210,20,
255,255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,255,202,0,255,255,
202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,200,0,255,255,208,0,
255,255,209,0,255,203,155,0,255,87,61,0,255,4,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,8,8,0,255,195,153,0,255,255,206,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,254,201,0,255,251,199,0,255,245,194,0,255,238,188,0,255,230,189,0,255,214,
170,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,
255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,
0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,
115,94,28,255,255,213,25,255,255,210,20,255,255,205,14,255,255,204,8,255,255,
203,3,255,255,202,1,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,255,202,0,255,255,202,0,255,255,208,0,255,255,215,0,255,251,
197,0,255,135,99,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,174,
136,0,255,255,208,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,254,201,0,255,251,199,0,
255,245,194,0,255,238,188,0,255,230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,
255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,
104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,
255,255,255,255,255,255,255,255,255,64,52,28,255,115,94,28,255,255,213,25,255,
255,210,20,255,255,205,14,255,255,204,8,255,255,203,3,255,255,202,1,255,255,202,
0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,
255,255,202,0,255,254,200,0,255,255,206,0,255,255,215,0,255,225,176,0,255,31,23,
0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,167,129,0,255,255,209,0,255,255,
204,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,255,202,0,255,
255,202,0,255,255,202,0,255,254,201,0,255,251,199,0,255,245,194,0,255,238,188,0,
255,230,189,0,255,214,170,0,255,57,42,0,255,58,41,0,255,255,255,255,255,255,255,
255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,
24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,
255,255,64,52,28,255,115,93,27,255,255,213,25,255,255,210,19,255,255,205,13,255,
255,203,6,255,255,202,1,255,254,201,0,255,254,201,0,255,254,201,0,255,254,201,0,
255,254,201,0,255,254,201,0,255,254,201,0,255,254,201,0,255,254,201,0,255,254,
201,0,255,254,201,0,255,254,201,0,255,254,201,0,255,254,201,0,255,254,201,0,255,
254,202,0,255,254,210,0,255,245,192,0,255,48,38,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,164,130,0,255,254,208,0,255,254,203,0,255,254,201,0,255,254,201,0,
255,254,201,0,255,254,201,0,255,254,201,0,255,254,201,0,255,254,201,0,255,253,
200,0,255,249,197,0,255,244,193,0,255,237,187,0,255,229,188,0,255,214,170,0,255,
57,42,0,255,58,41,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,
128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,
0,48,255,255,255,255,255,255,255,255,255,255,255,255,64,52,28,255,114,92,26,
255,255,212,22,255,255,209,16,255,255,204,9,255,255,202,1,255,252,200,0,255,249,
197,0,255,248,196,0,255,248,196,0,255,248,196,0,255,248,196,0,255,248,196,0,255,
248,196,0,255,248,196,0,255,248,196,0,255,248,196,0,255,248,196,0,255,248,196,0,
255,248,196,0,255,248,196,0,255,248,196,0,255,248,195,0,255,248,203,0,255,237,
188,0,255,46,42,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,158,124,0,255,248,
203,0,255,248,198,0,255,248,196,0,255,248,196,0,255,248,196,0,255,248,196,0,255,
248,196,0,255,248,196,0,255,248,196,0,255,247,196,0,255,245,194,0,255,240,190,0,
255,233,184,0,255,227,186,0,255,213,169,0,255,57,42,0,255,58,41,0,255,255,255,
255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,
0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,
255,255,255,255,255,255,65,51,27,255,113,91,24,255,255,211,18,255,255,208,10,
255,255,202,1,255,248,196,0,255,243,192,0,255,240,190,0,255,239,189,0,255,239,
189,0,255,239,189,0,255,239,189,0,255,239,189,0,255,239,189,0,255,239,189,0,255,
239,189,0,255,239,189,0,255,239,189,0,255,239,189,0,255,239,189,0,255,239,189,0,
255,239,189,0,255,239,189,0,255,239,192,0,255,223,170,0,255,53,39,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,151,116,0,255,239,192,0,255,239,189,0,255,239,
189,0,255,239,189,0,255,239,189,0,255,239,189,0,255,239,189,0,255,239,189,0,255,
239,189,0,255,238,189,0,255,236,187,0,255,233,185,0,255,228,180,0,255,224,184,0,
255,211,167,0,255,57,42,0,255,58,39,0,255,255,255,255,255,255,255,255,255,255,
255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,
0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,60,48,
24,255,111,88,19,255,255,211,10,255,255,208,0,255,244,192,0,255,236,186,0,255,
230,181,0,255,227,179,0,255,226,178,0,255,226,178,0,255,226,178,0,255,226,178,0,
255,226,178,0,255,226,178,0,255,226,178,0,255,226,178,0,255,226,178,0,255,226,
178,0,255,226,178,0,255,226,178,0,255,226,178,0,255,226,178,0,255,226,178,0,255,
226,181,0,255,226,177,0,255,161,122,0,255,123,94,0,255,126,94,0,255,122,98,0,
255,127,96,0,255,201,152,0,255,226,183,0,255,226,179,0,255,226,178,0,255,226,
178,0,255,226,178,0,255,226,178,0,255,226,178,0,255,226,178,0,255,226,178,0,255,
225,177,0,255,224,177,0,255,222,175,0,255,221,174,0,255,218,179,0,255,209,166,0,
255,57,43,0,255,56,39,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,
0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,
0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,64,51,19,255,92,71,
10,255,254,201,0,255,242,202,0,255,230,188,0,255,221,179,0,255,216,175,0,255,
213,173,0,255,212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,
255,212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,212,
172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,212,171,0,255,
212,175,0,255,212,173,0,255,212,175,0,255,212,177,0,255,212,175,0,255,212,171,0,
255,212,175,0,255,212,175,0,255,212,170,0,255,212,172,0,255,212,172,0,255,212,
172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,212,172,0,255,
212,172,0,255,212,172,0,255,212,172,0,255,212,180,0,255,199,151,0,255,53,36,0,
255,65,47,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,
120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,
255,255,255,255,255,255,255,255,255,255,255,95,71,10,255,43,29,0,255,171,128,0,
255,227,175,0,255,217,179,0,255,209,170,0,255,206,168,0,255,203,166,0,255,203,
166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,
203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,
255,203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,203,167,0,255,203,
168,0,255,203,170,0,255,203,170,0,255,203,170,0,255,203,169,0,255,203,167,0,255,
203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,
255,203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,203,166,0,255,203,
166,0,255,204,168,0,255,206,162,0,255,131,100,0,255,32,20,0,255,98,70,0,255,255,
255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,
80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,
255,255,255,255,255,255,73,50,0,255,25,14,0,255,48,32,0,255,89,62,0,255,105,79,
0,255,105,80,0,255,105,80,0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,
0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,
0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,
0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,78,0,255,103,78,0,255,103,78,
0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,
0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,0,255,103,79,
0,255,103,79,0,255,105,79,0,255,103,78,0,255,79,58,0,255,37,26,0,255,32,19,0,
255,82,58,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,
120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,
255,255,255,255,255,255,255,255,255,255,255,34,0,0,255,54,38,0,255,61,43,0,255,
47,32,0,255,41,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,
0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,
40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,
0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,
40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,
0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,40,27,0,255,
40,27,0,255,40,27,0,255,47,33,0,255,62,45,0,255,61,43,0,255,29,29,0,255,255,
255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,
80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,47,232,232,232,214,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,221,221,221,225,0,0,0,127,0,0,0,119,0,0,0,103,0,0,0,79,
0,0,0,47,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,23,0,0,0,46,164,164,164,140,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,133,133,133,173,0,0,0,127,0,0,0,119,0,0,0,102,0,0,0,78,
0,0,0,46,0,0,0,23,0,0,0,8,0,0,0,7,0,0,0,21,0,0,0,44,0,0,0,75,148,148,148,155,
223,223,223,223,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,221,221,221,225,
133,133,133,173,0,0,0,127,0,0,0,126,0,0,0,117,0,0,0,100,0,0,0,75,0,0,0,44,0,0,0,
21,0,0,0,7,0,0,0,5,0,0,0,18,0,0,0,39,0,0,0,68,0,0,0,94,0,0,0,113,0,0,0,124,0,0,
0,127,0,0,0,127,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,
0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,
0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,127,0,0,0,127,0,0,0,124,0,0,0,113,0,0,0,94,0,0,0,68,0,0,0,39,0,0,0,18,
0,0,0,5,0,0,0,4,0,0,0,14,0,0,0,33,0,0,0,58,0,0,0,84,0,0,0,105,0,0,0,118,0,0,0,
124,0,0,0,126,0,0,0,127,0,0,0,127,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,127,0,0,0,127,0,0,0,
126,0,0,0,124,0,0,0,118,0,0,0,105,0,0,0,84,0,0,0,58,0,0,0,33,0,0,0,14,0,0,0,4,0,
0,0,2,0,0,0,10,0,0,0,24,0,0,0,45,0,0,0,69,0,0,0,90,0,0,0,105,0,0,0,113,0,0,0,
117,0,0,0,119,0,0,0,119,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,
120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,
120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,
120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,
120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,
120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,119,0,0,0,119,0,0,0,117,0,0,0,
113,0,0,0,105,0,0,0,90,0,0,0,69,0,0,0,45,0,0,0,24,0,0,0,10,0,0,0,2,0,0,0,1,0,0,
0,6,0,0,0,15,0,0,0,31,0,0,0,50,0,0,0,69,0,0,0,84,0,0,0,94,0,0,0,100,0,0,0,102,
0,0,0,103,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,
104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,
104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,
104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,
104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,
104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,103,0,0,0,102,0,0,0,100,0,0,0,94,0,0,0,
84,0,0,0,69,0,0,0,50,0,0,0,31,0,0,0,15,0,0,0,6,0,0,0,1,255,255,255,0,0,0,0,3,0,
0,0,8,0,0,0,18,0,0,0,31,0,0,0,45,0,0,0,58,0,0,0,68,0,0,0,75,0,0,0,78,0,0,0,79,
0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,
80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,
0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,
0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,
80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,79,0,0,
0,78,0,0,0,75,0,0,0,68,0,0,0,58,0,0,0,45,0,0,0,31,0,0,0,18,0,0,0,8,0,0,0,3,
255,255,255,0,255,255,255,0,0,0,0,1,0,0,0,3,0,0,0,8,0,0,0,15,0,0,0,24,0,0,0,33,
0,0,0,39,0,0,0,44,0,0,0,46,0,0,0,47,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,
48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,
0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,
0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,
48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,
0,48,0,0,0,48,0,0,0,48,0,0,0,47,0,0,0,46,0,0,0,44,0,0,0,39,0,0,0,33,0,0,0,24,
0,0,0,15,0,0,0,8,0,0,0,3,0,0,0,1,255,255,255,0,255,255,255,0,255,255,255,0,0,
0,0,1,0,0,0,3,0,0,0,6,0,0,0,10,0,0,0,14,0,0,0,18,0,0,0,21,0,0,0,23,0,0,0,24,0,
0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,
24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,
0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,
0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,
24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,
0,23,0,0,0,21,0,0,0,18,0,0,0,14,0,0,0,10,0,0,0,6,0,0,0,3,0,0,0,1,255,255,255,
0,255,255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,0,0,0,
1,0,0,0,2,0,0,0,4,0,0,0,5,0,0,0,7,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,
0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,
0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,
0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,
8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,
0,8,0,0,0,8,0,0,0,7,0,0,0,5,0,0,0,4,0,0,0,2,0,0,0,1,255,255,255,0,255,255,255,
0,255,255,255,0,255,255,255,0};
static Fl_RGB_Image image_LRLR(idata_LRLR, 64, 64, 4, 0);

void TrackEditorUI::cb_RLRL_i(Fl_Menu_*, void*) {
  trackView->setSign(kRLRL);
}
void TrackEditorUI::cb_RLRL(Fl_Menu_* o, void* v) {
  ((TrackEditorUI*)(o->parent()->user_data()))->cb_RLRL_i(o,v);
}

static unsigned char idata_RLRL[] =
{255,255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,0,0,0,1,0,0,0,2,0,
0,0,4,0,0,0,5,0,0,0,7,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,
0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,
8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,
0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,
0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,
0,0,0,7,0,0,0,5,0,0,0,4,0,0,0,2,0,0,0,1,255,255,255,0,255,255,255,0,255,255,
255,0,255,255,255,0,255,255,255,0,255,255,255,0,0,0,0,1,0,0,0,3,0,0,0,6,0,0,0,
10,0,0,0,14,0,0,0,18,0,0,0,21,0,0,0,23,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,
0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,
0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,
24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,
0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,
0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,23,0,0,0,21,0,0,0,18,0,0,0,
14,0,0,0,10,0,0,0,6,0,0,0,3,0,0,0,1,255,255,255,0,255,255,255,0,255,255,255,0,
0,0,0,1,0,0,0,3,0,0,0,8,230,230,230,100,247,247,247,201,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,241,241,241,206,194,194,194,118,0,0,0,39,0,0,0,33,0,
0,0,24,0,0,0,15,0,0,0,8,0,0,0,3,0,0,0,1,255,255,255,0,255,255,255,0,0,0,0,3,0,
0,0,8,225,225,225,102,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,171,171,171,134,0,0,0,
58,0,0,0,45,0,0,0,31,0,0,0,18,0,0,0,8,0,0,0,3,255,255,255,0,0,0,0,1,0,0,0,6,0,
0,0,15,246,246,246,202,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,229,229,229,217,0,0,
0,84,0,0,0,69,0,0,0,50,0,0,0,31,0,0,0,15,0,0,0,6,0,0,0,1,0,0,0,2,0,0,0,10,0,0,
0,24,255,255,255,255,255,255,255,255,255,255,255,255,74,74,44,255,112,90,46,
255,118,96,49,255,105,87,50,255,102,85,51,255,102,86,52,255,102,86,52,255,102,
86,52,255,102,87,52,255,102,87,52,255,102,87,52,255,102,87,52,255,102,87,52,
255,102,87,52,255,102,87,52,255,102,87,52,255,102,87,52,255,102,87,52,255,102,
87,52,255,102,87,52,255,102,87,52,255,102,87,52,255,102,87,52,255,102,87,52,
255,102,87,52,255,102,87,52,255,102,87,52,255,102,87,52,255,102,87,52,255,102,
87,52,255,102,87,52,255,102,87,52,255,102,87,52,255,102,87,52,255,102,87,52,
255,102,87,52,255,102,87,52,255,102,87,52,255,102,87,52,255,102,87,52,255,102,
87,52,255,102,87,52,255,101,86,51,255,99,83,48,255,100,82,43,255,115,90,34,255,
101,78,22,255,78,44,9,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,
105,0,0,0,90,0,0,0,69,0,0,0,45,0,0,0,24,0,0,0,10,0,0,0,2,0,0,0,4,0,0,0,14,0,0,0,
33,255,255,255,255,255,255,255,255,255,255,255,255,119,92,39,255,75,63,42,255,
87,71,45,255,120,99,47,255,133,110,49,255,134,109,50,255,133,109,50,255,133,
109,51,255,136,110,51,255,136,110,51,255,136,110,51,255,136,110,51,255,136,110,
51,255,136,110,51,255,136,110,51,255,136,110,51,255,136,110,51,255,136,110,51,
255,136,110,51,255,136,110,51,255,136,110,51,255,136,110,51,255,135,110,51,255,
135,110,51,255,135,110,51,255,135,110,51,255,135,110,51,255,135,110,51,255,135,
110,51,255,136,110,51,255,136,110,51,255,136,110,51,255,136,110,51,255,136,110,
51,255,136,110,51,255,136,110,51,255,136,110,51,255,136,110,51,255,136,110,51,
255,136,110,51,255,135,109,50,255,134,109,49,255,132,107,47,255,126,102,42,255,
104,84,34,255,62,48,22,255,46,35,9,255,93,64,0,255,255,255,255,255,255,255,255,
255,255,255,255,255,0,0,0,118,0,0,0,105,0,0,0,84,0,0,0,58,0,0,0,33,0,0,0,14,0,0,
0,4,0,0,0,5,0,0,0,18,0,0,0,39,255,255,255,255,255,255,255,255,255,255,255,255,
126,100,35,255,81,64,37,255,190,149,40,255,253,205,43,255,255,212,45,255,255,
212,46,255,255,212,46,255,255,212,46,255,255,212,46,255,255,212,46,255,255,212,
46,255,255,212,46,255,255,212,46,255,255,212,46,255,255,212,46,255,255,212,46,
255,255,212,46,255,255,212,46,255,255,212,46,255,255,212,46,255,255,212,46,255,
255,212,46,255,255,212,46,255,255,211,46,255,255,212,46,255,255,212,46,255,255,
212,46,255,255,212,46,255,255,212,46,255,255,212,46,255,255,212,46,255,255,212,
46,255,255,212,46,255,255,212,46,255,255,212,46,255,255,212,46,255,255,212,46,
255,255,212,46,255,255,212,46,255,255,212,46,255,255,212,46,255,255,211,43,255,
255,210,40,255,255,208,32,255,250,190,22,255,157,117,8,255,40,23,0,255,101,70,0,
255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,124,0,0,0,113,0,0,0,
94,0,0,0,68,0,0,0,39,0,0,0,18,0,0,0,5,0,0,0,7,0,0,0,21,0,0,0,44,255,255,255,
255,255,255,255,255,255,255,255,255,83,64,31,255,110,89,34,255,253,198,36,255,
255,214,37,255,255,210,38,255,255,208,38,255,255,210,38,255,255,210,37,255,255,
210,37,255,255,210,37,255,255,210,37,255,255,210,37,255,255,210,37,255,255,210,
37,255,255,210,37,255,255,210,37,255,255,210,37,255,255,210,37,255,255,210,37,
255,255,210,37,255,255,209,37,255,255,209,37,255,255,210,37,255,255,213,37,255,
255,215,37,255,252,205,37,255,255,216,37,255,255,213,37,255,255,208,37,255,255,
209,37,255,255,210,37,255,255,210,37,255,255,210,37,255,255,210,37,255,255,210,
37,255,255,210,37,255,255,210,37,255,255,210,37,255,255,210,37,255,255,210,37,
255,255,210,37,255,255,208,34,255,255,209,29,255,255,208,20,255,255,211,7,255,
234,170,0,255,60,42,0,255,79,56,0,255,255,255,255,255,255,255,255,255,255,255,
255,255,0,0,0,126,0,0,0,117,0,0,0,100,0,0,0,75,0,0,0,44,0,0,0,21,0,0,0,7,0,0,0,
8,0,0,0,23,0,0,0,46,255,255,255,255,255,255,255,255,255,255,255,255,71,56,30,
255,123,100,31,255,255,207,31,255,255,208,31,255,254,202,31,255,254,203,29,255,
255,203,28,255,255,203,27,255,255,203,26,255,255,203,26,255,255,203,26,255,255,
203,26,255,255,203,26,255,255,203,26,255,255,203,26,255,255,203,26,255,255,203,
26,255,255,203,26,255,255,203,26,255,255,203,26,255,255,203,26,255,255,204,26,
255,255,205,26,255,255,212,26,255,219,178,26,255,118,104,26,255,213,171,26,255,
255,211,26,255,255,205,26,255,254,201,26,255,255,203,26,255,255,203,26,255,255,
203,26,255,255,203,26,255,255,203,26,255,255,203,26,255,255,203,26,255,255,203,
26,255,255,203,26,255,255,203,26,255,255,203,25,255,255,202,22,255,255,201,16,
255,255,197,6,255,251,200,0,255,232,172,0,255,63,45,0,255,71,50,0,255,255,255,
255,255,255,255,255,255,255,255,255,255,0,0,0,127,0,0,0,119,0,0,0,102,0,0,0,78,
0,0,0,46,0,0,0,23,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,47,255,255,255,255,255,255,
255,255,255,255,255,255,68,55,28,255,121,97,29,255,255,206,28,255,255,207,26,
255,254,201,23,255,255,201,19,255,255,201,17,255,255,200,15,255,255,200,15,255,
255,200,15,255,255,200,15,255,255,200,15,255,255,200,15,255,255,200,15,255,255,
200,15,255,255,200,15,255,255,200,15,255,255,200,15,255,255,200,15,255,255,200,
15,255,255,200,15,255,255,200,15,255,255,208,15,255,239,188,15,255,103,88,15,
255,15,15,15,255,96,83,15,255,239,187,15,255,255,211,15,255,255,200,15,255,255,
200,15,255,255,200,15,255,255,200,15,255,255,200,15,255,255,200,15,255,255,200,
15,255,255,200,15,255,255,200,15,255,255,200,15,255,255,200,15,255,255,200,13,
255,255,199,10,255,255,198,4,255,251,195,0,255,240,192,0,255,221,168,0,255,61,
46,0,255,70,49,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,127,
0,0,0,119,0,0,0,103,0,0,0,79,0,0,0,47,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,
48,255,255,255,255,255,255,255,255,255,255,255,255,68,55,28,255,121,97,28,255,
255,208,26,255,255,206,23,255,255,201,18,255,255,200,13,255,255,199,10,255,255,
199,7,255,255,198,6,255,255,198,6,255,255,198,6,255,255,198,6,255,255,198,6,255,
255,198,6,255,255,198,6,255,255,198,6,255,255,198,6,255,255,198,6,255,255,198,6,
255,255,198,6,255,255,199,6,255,255,204,6,255,255,201,6,255,144,112,6,255,10,12,
6,255,6,6,6,255,8,7,6,255,151,112,6,255,255,204,6,255,255,204,6,255,254,197,6,
255,255,198,6,255,255,198,6,255,255,198,6,255,255,198,6,255,255,198,6,255,255,
198,6,255,255,198,6,255,255,198,6,255,255,198,6,255,255,198,5,255,255,197,1,255,
251,194,0,255,243,189,0,255,233,185,0,255,219,168,0,255,59,44,0,255,70,50,0,255,
255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,
0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,
255,255,255,255,255,255,255,255,69,56,28,255,121,98,28,255,255,206,25,255,255,
205,21,255,255,200,15,255,255,199,9,255,255,198,5,255,255,197,2,255,255,197,1,
255,255,197,1,255,255,197,1,255,255,197,1,255,255,197,1,255,255,197,1,255,255,
197,1,255,255,197,1,255,255,197,1,255,255,197,1,255,255,197,1,255,255,198,1,255,
255,201,1,255,255,211,1,255,204,159,1,255,29,24,1,255,1,1,1,255,1,1,1,255,1,1,1,
255,28,18,1,255,207,161,1,255,255,208,1,255,255,201,1,255,254,196,1,255,255,197,
1,255,255,197,1,255,255,197,1,255,255,197,1,255,255,197,1,255,255,197,1,255,
255,197,1,255,255,197,1,255,255,197,0,255,253,195,0,255,247,191,0,255,239,186,0,
255,230,183,0,255,216,166,0,255,59,43,0,255,71,50,0,255,255,255,255,255,255,255,
255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,
24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,
255,255,69,56,28,255,121,97,28,255,255,206,25,255,255,206,20,255,255,200,14,255,
255,199,8,255,255,198,3,255,255,197,1,255,255,197,0,255,255,197,0,255,255,197,0,
255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,
197,0,255,255,197,0,255,255,197,0,255,255,199,0,255,255,207,0,255,241,186,0,255,
88,67,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,86,69,0,255,238,
186,0,255,255,207,0,255,255,198,0,255,254,196,0,255,255,197,0,255,255,197,0,255,
255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,254,196,0,
255,251,194,0,255,245,189,0,255,238,185,0,255,230,184,0,255,217,160,0,255,62,43,
0,255,71,50,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,
0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,
48,255,255,255,255,255,255,255,255,255,255,255,255,69,56,28,255,121,97,28,255,
255,206,25,255,255,206,20,255,255,200,14,255,255,199,8,255,255,198,3,255,255,
197,1,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,
255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,198,0,
255,255,205,0,255,253,195,0,255,122,92,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,
0,255,0,0,0,255,0,0,0,255,0,0,0,255,120,96,0,255,252,197,0,255,255,205,0,255,
255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,
255,255,197,0,255,255,197,0,255,254,196,0,255,251,194,0,255,245,189,0,255,238,
185,0,255,230,184,0,255,217,162,0,255,61,45,0,255,71,50,0,255,255,255,255,255,
255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,
0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,
255,255,255,255,69,56,28,255,121,97,28,255,255,206,25,255,255,206,20,255,255,
200,14,255,255,199,8,255,255,198,3,255,255,197,1,255,255,197,0,255,255,197,0,
255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,
197,0,255,255,197,0,255,255,198,0,255,255,201,0,255,255,208,0,255,191,149,0,255,
29,22,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,25,18,0,255,206,157,0,255,255,208,0,255,255,202,0,255,254,196,0,255,255,197,
0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,
254,196,0,255,251,194,0,255,245,189,0,255,238,185,0,255,230,184,0,255,217,161,0,
255,62,43,0,255,71,50,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,
0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,
0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,69,56,28,255,121,97,
28,255,255,206,25,255,255,206,20,255,255,200,14,255,255,199,8,255,255,198,3,
255,255,197,1,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,
197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,200,0,255,
255,210,0,255,231,179,0,255,56,44,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,
0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,57,47,0,255,224,175,0,255,
255,208,0,255,255,198,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,
255,255,197,0,255,255,197,0,255,254,196,0,255,251,194,0,255,245,189,0,255,238,
185,0,255,230,184,0,255,216,165,0,255,59,43,0,255,71,50,0,255,255,255,255,255,
255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,
0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,
255,255,255,255,69,56,28,255,121,97,28,255,255,206,25,255,255,206,20,255,255,
200,14,255,255,199,8,255,255,198,3,255,255,197,1,255,255,197,0,255,255,197,0,
255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,
197,0,255,255,199,0,255,255,206,0,255,255,197,0,255,127,102,0,255,0,0,0,255,0,0,
0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,
0,0,255,0,0,0,255,122,98,0,255,255,198,0,255,255,205,0,255,254,196,0,255,255,
197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,254,196,0,255,
251,194,0,255,245,189,0,255,238,185,0,255,230,184,0,255,217,161,0,255,62,43,0,
255,71,50,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,
120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,
255,255,255,255,255,255,255,255,255,255,255,69,56,28,255,121,97,28,255,255,206,
25,255,255,206,20,255,255,200,14,255,255,199,8,255,255,198,3,255,255,197,1,255,
255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,
255,255,197,0,255,255,197,0,255,255,200,0,255,255,200,0,255,178,130,0,255,13,6,
0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,
0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,12,9,0,255,187,144,0,255,255,201,0,255,
255,198,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,
255,254,196,0,255,251,194,0,255,245,189,0,255,238,185,0,255,230,184,0,255,217,
161,0,255,61,45,0,255,71,50,0,255,255,255,255,255,255,255,255,255,255,255,255,
255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,
0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,69,56,28,255,
121,97,28,255,255,206,25,255,255,206,20,255,255,200,14,255,255,199,8,255,255,
198,3,255,255,197,1,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,
255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,201,0,255,255,197,0,
255,127,92,0,255,0,0,0,255,0,0,0,255,5,3,0,255,35,23,0,255,0,0,0,255,0,0,0,255,
0,0,0,255,0,0,0,255,0,0,0,255,42,27,0,255,10,3,0,255,0,0,0,255,0,0,0,255,154,
114,0,255,255,198,0,255,255,198,0,255,255,197,0,255,255,197,0,255,255,197,0,255,
255,197,0,255,255,197,0,255,254,196,0,255,251,194,0,255,245,189,0,255,238,185,0,
255,230,184,0,255,220,161,0,255,61,45,0,255,71,50,0,255,255,255,255,255,255,255,
255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,
24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,
255,255,69,56,28,255,121,97,28,255,255,206,25,255,255,206,20,255,255,200,14,255,
255,199,8,255,255,198,3,255,255,197,1,255,255,197,0,255,255,197,0,255,255,197,0,
255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,
201,0,255,255,198,0,255,165,121,0,255,35,21,0,255,69,46,0,255,172,125,0,255,194,
141,0,255,7,4,0,255,0,0,0,255,0,0,0,255,0,0,0,255,5,5,0,255,225,164,0,255,194,
141,0,255,80,53,0,255,46,28,0,255,189,138,0,255,255,199,0,255,255,198,0,255,255,
197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,254,196,0,255,
251,194,0,255,245,189,0,255,238,185,0,255,230,184,0,255,217,161,0,255,61,43,0,
255,71,50,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,
120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,
255,255,255,255,255,255,255,255,255,255,255,69,56,28,255,121,97,28,255,255,206,
25,255,255,206,20,255,255,200,14,255,255,199,8,255,255,198,3,255,255,197,1,255,
255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,
255,255,197,0,255,255,197,0,255,255,199,0,255,255,204,0,255,255,201,0,255,249,
189,0,255,255,200,0,255,255,217,0,255,244,182,0,255,5,3,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,255,207,0,255,255,214,0,255,255,197,0,255,248,190,0,255,
255,203,0,255,255,202,0,255,254,196,0,255,255,197,0,255,255,197,0,255,255,197,0,
255,255,197,0,255,255,197,0,255,254,196,0,255,251,194,0,255,245,189,0,255,238,
185,0,255,230,184,0,255,216,163,0,255,59,43,0,255,71,50,0,255,255,255,255,255,
255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,
0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,
255,255,255,255,69,56,28,255,121,97,28,255,255,206,25,255,255,206,20,255,255,
200,14,255,255,199,8,255,255,198,3,255,255,197,1,255,255,197,0,255,255,197,0,
255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,
197,0,255,255,197,0,255,255,197,0,255,255,203,0,255,255,211,0,255,255,212,0,255,
255,214,0,255,203,156,0,255,4,1,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,
255,201,0,255,255,207,0,255,255,201,0,255,255,202,0,255,255,200,0,255,255,197,0,
255,254,196,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,
197,0,255,254,196,0,255,251,194,0,255,245,189,0,255,238,185,0,255,230,183,0,255,
217,163,0,255,62,43,0,255,71,50,0,255,255,255,255,255,255,255,255,255,255,255,
255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,
8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,69,56,28,
255,121,97,28,255,255,206,25,255,255,206,20,255,255,200,14,255,255,199,8,255,
255,198,3,255,255,197,1,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,
255,255,197,0,255,255,197,0,255,255,197,0,255,255,198,0,255,255,200,0,255,255,
203,0,255,255,206,0,255,255,197,0,255,207,158,0,255,165,126,0,255,60,53,0,255,0,
0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,1,0,0,255,255,199,0,255,255,205,0,255,
255,196,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,
255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,254,196,0,255,251,
194,0,255,245,189,0,255,238,185,0,255,230,182,0,255,216,166,0,255,59,43,0,255,
71,50,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,
120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,
255,255,255,255,255,255,255,255,255,255,255,69,56,28,255,121,97,28,255,255,206,
25,255,255,206,20,255,255,200,14,255,255,199,8,255,255,198,3,255,255,197,1,255,
255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,
255,255,198,0,255,255,199,0,255,255,207,0,255,255,201,0,255,194,151,0,255,93,73,
0,255,18,16,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,
35,26,0,255,255,197,0,255,255,203,0,255,255,197,0,255,255,197,0,255,255,197,0,
255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,
197,0,255,255,197,0,255,254,196,0,255,251,194,0,255,245,189,0,255,238,185,0,255,
230,181,0,255,216,164,0,255,59,43,0,255,71,50,0,255,255,255,255,255,255,255,255,
255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,
0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,
255,69,56,28,255,121,97,28,255,255,206,25,255,255,206,20,255,255,200,14,255,255,
199,8,255,255,198,3,255,255,197,1,255,255,197,0,255,255,197,0,255,255,197,0,255,
255,197,0,255,255,197,0,255,255,197,0,255,255,199,0,255,255,205,0,255,252,192,0,
255,144,115,0,255,20,16,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,
0,0,0,255,0,0,0,255,14,8,0,255,158,115,0,255,255,204,0,255,255,199,0,255,255,
197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,
255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,254,196,0,255,251,194,0,
255,245,189,0,255,238,185,0,255,230,185,0,255,216,164,0,255,59,44,0,255,71,50,0,
255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,
104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,
255,255,255,255,255,255,255,255,255,69,56,28,255,121,97,28,255,255,206,25,255,
255,206,20,255,255,200,14,255,255,199,8,255,255,198,3,255,255,197,1,255,255,197,
0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,198,0,255,
255,202,0,255,255,202,0,255,155,121,0,255,14,13,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,26,16,0,255,149,108,0,255,249,185,0,
255,255,206,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,
197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,
255,197,0,255,254,196,0,255,251,194,0,255,245,189,0,255,238,184,0,255,230,183,0,
255,216,164,0,255,59,44,0,255,71,50,0,255,255,255,255,255,255,255,255,255,255,
255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,
0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,69,56,
28,255,121,97,28,255,255,206,25,255,255,206,20,255,255,200,14,255,255,199,8,
255,255,198,3,255,255,197,1,255,255,197,0,255,255,197,0,255,255,197,0,255,255,
197,0,255,255,197,0,255,255,198,0,255,255,202,0,255,225,172,0,255,50,38,0,255,0,
0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,10,6,0,255,71,48,0,
255,187,137,0,255,255,198,0,255,255,205,0,255,255,200,0,255,254,196,0,255,255,
197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,
255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,254,196,0,255,251,194,0,
255,245,189,0,255,238,184,0,255,230,183,0,255,216,164,0,255,59,44,0,255,71,50,0,
255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,
104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,
255,255,255,255,255,255,255,255,255,69,56,28,255,121,97,28,255,255,206,25,255,
255,206,20,255,255,200,14,255,255,199,8,255,255,198,3,255,255,197,1,255,255,197,
0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,200,0,255,
255,203,0,255,184,143,0,255,2,1,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,
20,12,0,255,124,86,0,255,223,165,0,255,255,196,0,255,255,205,0,255,255,204,0,
255,255,199,0,255,254,196,0,255,254,196,0,255,255,197,0,255,255,197,0,255,255,
197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,
255,197,0,255,255,197,0,255,254,196,0,255,251,194,0,255,245,189,0,255,238,184,0,
255,230,183,0,255,216,164,0,255,59,44,0,255,71,50,0,255,255,255,255,255,255,255,
255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,
24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,
255,255,69,56,28,255,121,97,28,255,255,206,25,255,255,206,20,255,255,200,14,255,
255,199,8,255,255,198,3,255,255,197,1,255,255,197,0,255,255,197,0,255,255,197,0,
255,255,197,0,255,255,197,0,255,255,200,0,255,255,204,0,255,170,131,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,4,0,0,255,103,79,0,255,255,194,0,255,255,218,
0,255,255,209,0,255,255,201,0,255,255,197,0,255,254,196,0,255,255,197,0,255,
255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,
255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,254,
196,0,255,251,194,0,255,245,189,0,255,238,184,0,255,230,183,0,255,216,164,0,255,
59,44,0,255,71,50,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,
128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,
0,48,255,255,255,255,255,255,255,255,255,255,255,255,69,56,28,255,121,97,28,
255,255,206,25,255,255,206,20,255,255,200,14,255,255,199,8,255,255,198,3,255,
255,197,1,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,
255,255,200,0,255,255,204,0,255,172,132,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,
0,255,0,0,0,255,42,35,0,255,172,133,0,255,239,185,0,255,255,202,0,255,255,208,
0,255,255,201,0,255,255,197,0,255,255,199,0,255,255,197,0,255,255,197,0,255,
255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,
255,255,197,0,255,255,197,0,255,255,197,0,255,254,196,0,255,251,194,0,255,245,
189,0,255,238,184,0,255,230,183,0,255,216,164,0,255,59,44,0,255,71,50,0,255,255,
255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,
80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,
255,255,255,255,255,255,69,56,28,255,121,97,28,255,255,206,25,255,255,206,20,
255,255,200,14,255,255,199,8,255,255,198,3,255,255,197,1,255,255,197,0,255,255,
197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,199,0,255,255,201,0,255,
198,147,0,255,14,9,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,8,5,
0,255,56,47,0,255,138,109,0,255,238,184,0,255,255,207,0,255,255,205,0,255,255,
199,0,255,254,196,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,
255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,
255,254,196,0,255,251,194,0,255,245,189,0,255,238,184,0,255,230,183,0,255,216,
164,0,255,59,44,0,255,71,50,0,255,255,255,255,255,255,255,255,255,255,255,255,
255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,
0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,69,56,28,255,
121,97,28,255,255,206,25,255,255,206,20,255,255,200,14,255,255,199,8,255,255,
198,3,255,255,197,1,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,
255,197,0,255,255,198,0,255,255,203,0,255,246,181,0,255,85,60,0,255,0,0,0,255,0,
0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,47,39,0,
255,158,126,0,255,248,191,0,255,255,204,0,255,255,197,0,255,255,197,0,255,255,
197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,
255,197,0,255,255,197,0,255,255,197,0,255,254,196,0,255,251,194,0,255,245,189,0,
255,238,184,0,255,230,183,0,255,216,164,0,255,59,44,0,255,71,50,0,255,255,255,
255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,
0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,
255,255,255,255,255,255,69,56,28,255,121,97,28,255,255,206,25,255,255,206,20,
255,255,200,14,255,255,199,8,255,255,198,3,255,255,197,1,255,255,197,0,255,255,
197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,198,0,255,255,201,0,255,
255,204,0,255,197,145,0,255,37,26,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,
0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,11,10,0,255,140,106,0,255,255,202,0,
255,255,202,0,255,254,196,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,
197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,
254,196,0,255,251,194,0,255,245,189,0,255,238,184,0,255,230,183,0,255,216,164,0,
255,59,44,0,255,71,50,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,
0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,
0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,69,56,28,255,121,97,
28,255,255,206,25,255,255,206,20,255,255,200,14,255,255,199,8,255,255,198,3,
255,255,197,1,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,
197,0,255,255,197,0,255,255,197,0,255,255,204,0,255,255,201,0,255,182,133,0,255,
53,33,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,32,23,0,255,245,189,0,255,255,207,0,255,255,197,0,255,255,197,0,
255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,
197,0,255,255,197,0,255,255,197,0,255,254,196,0,255,251,194,0,255,245,189,0,255,
238,184,0,255,230,183,0,255,216,164,0,255,59,44,0,255,71,50,0,255,255,255,255,
255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,
0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,
255,255,255,255,255,69,56,28,255,121,97,28,255,255,206,25,255,255,206,20,255,
255,200,14,255,255,199,8,255,255,198,3,255,255,197,1,255,255,197,0,255,255,197,
0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,
255,197,0,255,255,202,0,255,255,206,0,255,247,189,0,255,158,115,0,255,41,26,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,169,
130,0,255,255,202,0,255,255,199,0,255,255,197,0,255,255,197,0,255,255,197,0,255,
255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,
255,254,196,0,255,251,194,0,255,245,189,0,255,238,184,0,255,230,183,0,255,216,
164,0,255,59,44,0,255,71,50,0,255,255,255,255,255,255,255,255,255,255,255,255,
255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,
0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,69,56,28,255,
121,97,28,255,255,206,25,255,255,206,20,255,255,200,14,255,255,199,8,255,255,
198,3,255,255,197,1,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,
255,197,0,255,255,197,0,255,255,197,0,255,255,199,0,255,255,197,0,255,255,201,0,
255,255,207,0,255,255,200,0,255,218,159,0,255,152,111,0,255,60,41,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,111,86,0,255,255,202,0,255,255,201,
0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,
255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,254,196,0,255,251,194,0,
255,245,189,0,255,238,184,0,255,230,183,0,255,216,164,0,255,59,44,0,255,71,50,0,
255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,
104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,
255,255,255,255,255,255,255,255,255,69,56,28,255,121,97,28,255,255,206,25,255,
255,206,20,255,255,200,14,255,255,199,8,255,255,198,3,255,255,197,1,255,255,197,
0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,
255,197,0,255,255,197,0,255,255,197,0,255,255,198,0,255,255,197,0,255,255,204,0,
255,255,210,0,255,255,214,0,255,213,157,0,255,21,14,0,255,0,0,0,255,0,0,0,255,0,
0,0,255,0,0,0,255,96,72,0,255,255,199,0,255,255,201,0,255,255,197,0,255,255,
197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,
255,197,0,255,255,197,0,255,254,196,0,255,251,194,0,255,245,189,0,255,238,184,0,
255,230,183,0,255,216,164,0,255,59,44,0,255,71,50,0,255,255,255,255,255,255,255,
255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,
24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,
255,255,69,56,28,255,121,97,28,255,255,206,25,255,255,206,20,255,255,200,14,255,
255,199,8,255,255,198,3,255,255,197,1,255,255,197,0,255,255,197,0,255,255,197,0,
255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,
197,0,255,255,198,0,255,255,199,0,255,255,205,0,255,255,205,0,255,237,183,0,255,
142,113,0,255,0,1,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,124,94,0,255,
255,201,0,255,255,200,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,
255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,254,
196,0,255,251,194,0,255,245,189,0,255,238,184,0,255,230,183,0,255,216,164,0,255,
59,44,0,255,71,50,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,
128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,
0,48,255,255,255,255,255,255,255,255,255,255,255,255,69,56,28,255,121,97,28,
255,255,206,25,255,255,206,20,255,255,200,14,255,255,199,8,255,255,198,3,255,
255,197,1,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,
255,255,197,0,255,255,197,0,255,255,197,0,255,255,199,0,255,255,199,0,255,255,
206,0,255,241,188,0,255,136,115,0,255,40,35,0,255,1,1,0,255,0,0,0,255,0,0,0,255,
0,0,0,255,0,0,0,255,6,0,0,255,197,146,0,255,255,204,0,255,255,197,0,255,255,
197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,
255,197,0,255,255,197,0,255,255,197,0,255,254,196,0,255,251,194,0,255,245,189,0,
255,238,184,0,255,230,183,0,255,216,164,0,255,59,44,0,255,71,50,0,255,255,255,
255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,
0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,
255,255,255,255,255,255,69,56,28,255,121,97,28,255,255,206,25,255,255,206,20,
255,255,200,14,255,255,199,8,255,255,198,3,255,255,197,1,255,255,197,0,255,255,
197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,
255,197,0,255,255,197,0,255,255,203,0,255,238,185,0,255,110,90,0,255,0,3,0,255,
0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,97,71,0,255,255,
197,0,255,255,205,0,255,254,196,0,255,255,197,0,255,255,197,0,255,255,197,0,255,
255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,
255,254,196,0,255,251,194,0,255,245,189,0,255,238,184,0,255,230,183,0,255,216,
164,0,255,59,44,0,255,71,50,0,255,255,255,255,255,255,255,255,255,255,255,255,
255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,
0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,69,56,28,255,
121,97,28,255,255,206,25,255,255,206,20,255,255,200,14,255,255,199,8,255,255,
198,3,255,255,197,1,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,
255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,200,0,255,255,200,0,
255,156,120,0,255,7,7,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,
0,0,255,65,46,0,255,213,156,0,255,255,207,0,255,255,199,0,255,254,196,0,255,
255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,
255,255,197,0,255,255,197,0,255,255,197,0,255,254,196,0,255,251,194,0,255,245,
189,0,255,238,184,0,255,230,183,0,255,216,164,0,255,59,44,0,255,71,50,0,255,255,
255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,
80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,
255,255,255,255,255,255,69,56,28,255,121,97,28,255,255,206,25,255,255,206,20,
255,255,200,14,255,255,199,8,255,255,198,3,255,255,197,1,255,255,197,0,255,255,
197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,
255,198,0,255,255,202,0,255,249,191,0,255,80,62,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,0,0,0,255,13,7,0,255,121,86,0,255,242,187,0,255,255,208,0,255,255,
201,0,255,254,196,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,
255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,
255,254,196,0,255,251,194,0,255,245,189,0,255,238,184,0,255,230,183,0,255,216,
164,0,255,59,44,0,255,71,50,0,255,255,255,255,255,255,255,255,255,255,255,255,
255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,
0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,69,56,28,255,
121,97,28,255,255,206,25,255,255,206,20,255,255,200,14,255,255,199,8,255,255,
198,3,255,255,197,1,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,
255,197,0,255,255,197,0,255,255,197,0,255,255,198,0,255,255,204,0,255,245,188,0,
255,54,44,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,15,9,0,255,155,109,0,
255,252,184,0,255,255,208,0,255,255,201,0,255,254,196,0,255,254,196,0,255,255,
197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,
255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,254,196,0,255,251,194,0,
255,245,189,0,255,238,184,0,255,230,183,0,255,216,164,0,255,59,44,0,255,71,50,0,
255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,
104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,
255,255,255,255,255,255,255,255,255,69,56,28,255,121,97,28,255,255,206,25,255,
255,206,20,255,255,200,14,255,255,199,8,255,255,198,3,255,255,197,1,255,255,197,
0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,
255,197,0,255,255,198,0,255,255,203,0,255,241,177,0,255,40,28,0,255,0,0,0,255,0,
0,0,255,0,0,0,255,0,0,0,255,83,60,0,255,255,192,0,255,255,208,0,255,255,200,0,
255,254,196,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,
197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,255,197,0,255,
255,197,0,255,255,197,0,255,254,196,0,255,251,194,0,255,245,189,0,255,238,184,0,
255,230,183,0,255,216,164,0,255,59,44,0,255,71,50,0,255,255,255,255,255,255,255,
255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,
24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,
255,255,69,56,28,255,121,96,27,255,255,206,25,255,255,206,19,255,255,200,13,255,
255,198,6,255,255,197,1,255,254,196,0,255,254,196,0,255,254,196,0,255,254,196,0,
255,254,196,0,255,254,196,0,255,254,196,0,255,254,196,0,255,254,197,0,255,254,
202,0,255,238,183,0,255,39,27,0,255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,108,
83,0,255,254,204,0,255,254,201,0,255,253,195,0,255,253,195,0,255,254,196,0,255,
254,196,0,255,254,196,0,255,254,196,0,255,254,196,0,255,254,196,0,255,254,196,0,
255,254,196,0,255,254,196,0,255,254,196,0,255,254,196,0,255,254,196,0,255,253,
195,0,255,249,192,0,255,244,189,0,255,237,183,0,255,229,182,0,255,216,164,0,255,
59,44,0,255,71,50,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,
128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,
0,48,255,255,255,255,255,255,255,255,255,255,255,255,69,56,28,255,120,97,26,
255,255,206,22,255,255,204,16,255,255,199,9,255,255,197,1,255,252,195,0,255,249,
192,0,255,248,192,0,255,248,192,0,255,248,192,0,255,248,192,0,255,248,192,0,255,
248,192,0,255,248,192,0,255,248,193,0,255,248,200,0,255,232,178,0,255,34,24,0,
255,0,0,0,255,0,0,0,255,0,0,0,255,0,0,0,255,102,80,0,255,248,197,0,255,248,195,
0,255,247,191,0,255,248,192,0,255,248,192,0,255,248,192,0,255,248,192,0,255,
248,192,0,255,248,192,0,255,248,192,0,255,248,192,0,255,248,192,0,255,248,192,0,
255,248,192,0,255,248,192,0,255,248,192,0,255,247,191,0,255,245,189,0,255,240,
185,0,255,233,180,0,255,227,181,0,255,215,164,0,255,59,44,0,255,70,50,0,255,255,
255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,
80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,
255,255,255,255,255,255,68,54,27,255,119,96,24,255,255,207,18,255,255,203,10,
255,255,197,1,255,248,192,0,255,243,188,0,255,240,185,0,255,239,185,0,255,239,
185,0,255,239,185,0,255,239,185,0,255,239,185,0,255,239,185,0,255,239,185,0,255,
239,186,0,255,239,191,0,255,219,171,0,255,36,26,0,255,0,0,0,255,0,0,0,255,0,0,0,
255,0,0,0,255,98,75,0,255,239,187,0,255,239,188,0,255,239,185,0,255,239,185,0,
255,239,185,0,255,239,185,0,255,239,185,0,255,239,185,0,255,239,185,0,255,239,
185,0,255,239,185,0,255,239,185,0,255,239,185,0,255,239,185,0,255,239,185,0,255,
239,185,0,255,238,184,0,255,236,182,0,255,233,180,0,255,228,177,0,255,224,180,0,
255,213,162,0,255,59,43,0,255,70,50,0,255,255,255,255,255,255,255,255,255,255,
255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,
0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,255,255,255,255,255,255,66,51,
24,255,117,92,19,255,255,204,10,255,255,203,0,255,244,187,0,255,236,182,0,255,
230,178,0,255,227,175,0,255,226,175,0,255,226,175,0,255,226,175,0,255,226,175,0,
255,226,175,0,255,226,175,0,255,226,174,0,255,226,175,0,255,226,176,0,255,218,
159,0,255,105,69,0,255,61,31,0,255,65,36,0,255,67,37,0,255,72,41,0,255,148,104,
0,255,226,175,0,255,226,176,0,255,226,175,0,255,226,175,0,255,226,175,0,255,
226,175,0,255,226,175,0,255,226,175,0,255,226,175,0,255,226,175,0,255,226,175,0,
255,226,175,0,255,226,175,0,255,226,175,0,255,226,175,0,255,226,175,0,255,225,
174,0,255,224,173,0,255,222,171,0,255,221,172,0,255,218,174,0,255,211,161,0,255,
58,42,0,255,69,49,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,
128,0,0,0,120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,
0,48,255,255,255,255,255,255,255,255,255,255,255,255,71,53,19,255,98,73,10,
255,254,194,0,255,242,198,0,255,230,183,0,255,221,174,0,255,216,171,0,255,213,
169,0,255,212,168,0,255,212,168,0,255,212,168,0,255,212,168,0,255,212,168,0,255,
212,168,0,255,212,168,0,255,212,168,0,255,212,169,0,255,212,171,0,255,212,167,0,
255,212,167,0,255,212,172,0,255,212,170,0,255,212,166,0,255,212,170,0,255,212,
171,0,255,212,167,0,255,212,168,0,255,212,168,0,255,212,168,0,255,212,168,0,255,
212,168,0,255,212,168,0,255,212,168,0,255,212,168,0,255,212,168,0,255,212,168,0,
255,212,168,0,255,212,168,0,255,212,168,0,255,212,168,0,255,212,168,0,255,212,
168,0,255,212,168,0,255,212,169,0,255,212,175,0,255,199,147,0,255,55,38,0,255,
75,53,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,
120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,
255,255,255,255,255,255,255,255,255,255,255,99,73,10,255,48,34,0,255,172,130,0,
255,227,170,0,255,217,174,0,255,209,165,0,255,206,164,0,255,203,162,0,255,203,
162,0,255,203,162,0,255,203,162,0,255,203,162,0,255,203,162,0,255,203,162,0,255,
203,162,0,255,203,162,0,255,203,162,0,255,203,163,0,255,203,166,0,255,203,166,0,
255,203,168,0,255,203,168,0,255,203,166,0,255,203,165,0,255,203,162,0,255,203,
162,0,255,203,162,0,255,203,162,0,255,203,162,0,255,203,162,0,255,203,162,0,255,
203,162,0,255,203,162,0,255,203,162,0,255,203,162,0,255,203,162,0,255,203,162,0,
255,203,162,0,255,203,162,0,255,203,162,0,255,203,162,0,255,203,162,0,255,203,
162,0,255,204,163,0,255,206,158,0,255,135,101,0,255,37,23,0,255,87,62,0,255,255,
255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,
80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,255,255,255,255,255,
255,255,255,255,255,255,85,56,0,255,28,18,0,255,53,35,0,255,93,65,0,255,111,83,
0,255,110,80,0,255,108,80,0,255,108,79,0,255,107,79,0,255,107,79,0,255,107,79,
0,255,107,79,0,255,107,79,0,255,107,79,0,255,107,79,0,255,107,79,0,255,107,79,
0,255,107,79,0,255,107,79,0,255,107,79,0,255,107,78,0,255,107,78,0,255,107,79,
0,255,107,79,0,255,107,79,0,255,107,79,0,255,107,79,0,255,107,79,0,255,107,79,
0,255,107,79,0,255,107,79,0,255,107,79,0,255,107,79,0,255,107,79,0,255,107,79,
0,255,107,79,0,255,107,79,0,255,107,79,0,255,107,79,0,255,107,79,0,255,107,79,
0,255,108,79,0,255,108,79,0,255,106,78,0,255,83,60,0,255,42,26,0,255,32,22,0,
255,77,53,0,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,
120,0,0,0,104,0,0,0,80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,48,255,
255,255,255,255,255,255,255,255,255,255,255,34,0,0,255,61,42,0,255,66,46,0,255,
51,34,0,255,44,30,0,255,43,29,0,255,43,29,0,255,43,29,0,255,43,29,0,255,43,29,
0,255,43,29,0,255,43,29,0,255,43,29,0,255,43,29,0,255,43,29,0,255,43,29,0,255,
43,29,0,255,43,29,0,255,43,29,0,255,43,29,0,255,43,29,0,255,43,29,0,255,43,29,
0,255,43,29,0,255,43,29,0,255,43,29,0,255,43,29,0,255,43,29,0,255,43,29,0,255,
43,29,0,255,43,29,0,255,43,29,0,255,43,29,0,255,43,29,0,255,43,29,0,255,43,29,
0,255,43,29,0,255,43,29,0,255,43,29,0,255,43,29,0,255,43,29,0,255,43,29,0,255,
43,29,0,255,44,29,0,255,52,35,0,255,67,46,0,255,64,43,0,255,58,29,0,255,255,
255,255,255,255,255,255,255,255,255,255,255,0,0,0,128,0,0,0,120,0,0,0,104,0,0,0,
80,0,0,0,48,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,24,0,0,0,47,232,232,232,214,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,221,221,221,225,0,0,0,127,0,0,0,119,0,0,0,103,0,0,0,79,
0,0,0,47,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,23,0,0,0,46,164,164,164,140,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,133,133,133,173,0,0,0,127,0,0,0,119,0,0,0,102,0,0,0,78,
0,0,0,46,0,0,0,23,0,0,0,8,0,0,0,7,0,0,0,21,0,0,0,44,0,0,0,75,148,148,148,155,
223,223,223,223,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,221,221,221,225,
133,133,133,173,0,0,0,127,0,0,0,126,0,0,0,117,0,0,0,100,0,0,0,75,0,0,0,44,0,0,0,
21,0,0,0,7,0,0,0,5,0,0,0,18,0,0,0,39,0,0,0,68,0,0,0,94,0,0,0,113,0,0,0,124,0,0,
0,127,0,0,0,127,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,
0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,
0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,127,0,0,0,127,0,0,0,124,0,0,0,113,0,0,0,94,0,0,0,68,0,0,0,39,0,0,0,18,
0,0,0,5,0,0,0,4,0,0,0,14,0,0,0,33,0,0,0,58,0,0,0,84,0,0,0,105,0,0,0,118,0,0,0,
124,0,0,0,126,0,0,0,127,0,0,0,127,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,
128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0,127,0,0,0,127,0,0,0,
126,0,0,0,124,0,0,0,118,0,0,0,105,0,0,0,84,0,0,0,58,0,0,0,33,0,0,0,14,0,0,0,4,0,
0,0,2,0,0,0,10,0,0,0,24,0,0,0,45,0,0,0,69,0,0,0,90,0,0,0,105,0,0,0,113,0,0,0,
117,0,0,0,119,0,0,0,119,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,
120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,
120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,
120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,
120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,
120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,120,0,0,0,119,0,0,0,119,0,0,0,117,0,0,0,
113,0,0,0,105,0,0,0,90,0,0,0,69,0,0,0,45,0,0,0,24,0,0,0,10,0,0,0,2,0,0,0,1,0,0,
0,6,0,0,0,15,0,0,0,31,0,0,0,50,0,0,0,69,0,0,0,84,0,0,0,94,0,0,0,100,0,0,0,102,
0,0,0,103,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,
104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,
104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,
104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,
104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,
104,0,0,0,104,0,0,0,104,0,0,0,104,0,0,0,103,0,0,0,102,0,0,0,100,0,0,0,94,0,0,0,
84,0,0,0,69,0,0,0,50,0,0,0,31,0,0,0,15,0,0,0,6,0,0,0,1,255,255,255,0,0,0,0,3,0,
0,0,8,0,0,0,18,0,0,0,31,0,0,0,45,0,0,0,58,0,0,0,68,0,0,0,75,0,0,0,78,0,0,0,79,
0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,
80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,
0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,
0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,
80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,80,0,0,0,79,0,0,
0,78,0,0,0,75,0,0,0,68,0,0,0,58,0,0,0,45,0,0,0,31,0,0,0,18,0,0,0,8,0,0,0,3,
255,255,255,0,255,255,255,0,0,0,0,1,0,0,0,3,0,0,0,8,0,0,0,15,0,0,0,24,0,0,0,33,
0,0,0,39,0,0,0,44,0,0,0,46,0,0,0,47,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,
48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,
0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,
0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,
48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,0,48,0,0,
0,48,0,0,0,48,0,0,0,48,0,0,0,47,0,0,0,46,0,0,0,44,0,0,0,39,0,0,0,33,0,0,0,24,
0,0,0,15,0,0,0,8,0,0,0,3,0,0,0,1,255,255,255,0,255,255,255,0,255,255,255,0,0,
0,0,1,0,0,0,3,0,0,0,6,0,0,0,10,0,0,0,14,0,0,0,18,0,0,0,21,0,0,0,23,0,0,0,24,0,
0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,
24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,
0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,
0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,
24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,0,24,0,0,
0,23,0,0,0,21,0,0,0,18,0,0,0,14,0,0,0,10,0,0,0,6,0,0,0,3,0,0,0,1,255,255,255,
0,255,255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,255,255,255,0,0,0,0,
1,0,0,0,2,0,0,0,4,0,0,0,5,0,0,0,7,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,
0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,
0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,
0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,
8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,
0,8,0,0,0,8,0,0,0,7,0,0,0,5,0,0,0,4,0,0,0,2,0,0,0,1,255,255,255,0,255,255,255,
0,255,255,255,0,255,255,255,0};
static Fl_RGB_Image image_RLRL(idata_RLRL, 64, 64, 4, 0);

void TrackEditorUI::cb_road_i(Fl_Menu_*, void*) {
  trackView->setTile(kRoad);
}
void TrackEditorUI::cb_road(Fl_Menu_* o, void* v) {
  ((TrackEditorUI*)(o->parent()->user_data()))->cb_road_i(o,v);
}

void TrackEditorUI::cb_offroad_i(Fl_Menu_*, void*) {
  trackView->setTile(kOffroad);
}
void TrackEditorUI::cb_offroad(Fl_Menu_* o, void* v) {
  ((TrackEditorUI*)(o->parent()->user_data()))->cb_offroad_i(o,v);
}

void TrackEditorUI::cb_wall_i(Fl_Menu_*, void*) {
  trackView->setTile(kWall);
}
void TrackEditorUI::cb_wall(Fl_Menu_* o, void* v) {
  ((TrackEditorUI*)(o->parent()->user_data()))->cb_wall_i(o,v);
}

void TrackEditorUI::cb_flipVertical_i(Fl_Menu_*, void*) {
  trackView->flipVertical();
trackView->redraw();
}
void TrackEditorUI::cb_flipVertical(Fl_Menu_* o, void* v) {
  ((TrackEditorUI*)(o->parent()->user_data()))->cb_flipVertical_i(o,v);
}

void TrackEditorUI::cb_flipHorizontal_i(Fl_Menu_*, void*) {
  trackView->flipHorizontal();
trackView->redraw();
}
void TrackEditorUI::cb_flipHorizontal(Fl_Menu_* o, void* v) {
  ((TrackEditorUI*)(o->parent()->user_data()))->cb_flipHorizontal_i(o,v);
}

void TrackEditorUI::cb_clockwiseMenuItem_i(Fl_Menu_*, void*) {
  trackView->toggleClockwise();
}
void TrackEditorUI::cb_clockwiseMenuItem(Fl_Menu_* o, void* v) {
  ((TrackEditorUI*)(o->parent()->user_data()))->cb_clockwiseMenuItem_i(o,v);
}

void TrackEditorUI::cb_about_i(Fl_Menu_*, void*) {
  aboutBox->show();
}
void TrackEditorUI::cb_about(Fl_Menu_* o, void* v) {
  ((TrackEditorUI*)(o->parent()->user_data()))->cb_about_i(o,v);
}

void TrackEditorUI::cb_help_i(Fl_Menu_*, void*) {
  helpWindow->show();
}
void TrackEditorUI::cb_help(Fl_Menu_* o, void* v) {
  ((TrackEditorUI*)(o->parent()->user_data()))->cb_help_i(o,v);
}

Fl_Menu_Item TrackEditorUI::menu_mainMenuBar[] = {
 {"File", 0,  0, 0, 64, FL_NORMAL_LABEL, 0, 14, 0},
 {"New...", 0x4006e,  (Fl_Callback*)TrackEditorUI::cb_newMap, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {"Open...", 0x4006f,  (Fl_Callback*)TrackEditorUI::cb_open, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {"Import From Image...", 0x40069,  (Fl_Callback*)TrackEditorUI::cb_import, 0, 128, FL_NORMAL_LABEL, 0, 14, 0},
 {"Save", 0x40073,  (Fl_Callback*)TrackEditorUI::cb_save, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {"Save As...", 0x50073,  (Fl_Callback*)TrackEditorUI::cb_saveAs, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {"Install Track", 0x50069,  (Fl_Callback*)TrackEditorUI::cb_install, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {"Uninstall Track", 0x50075,  (Fl_Callback*)TrackEditorUI::cb_uninstall, 0, 128, FL_NORMAL_LABEL, 0, 14, 0},
 {"Quit", 0x40071,  (Fl_Callback*)TrackEditorUI::cb_quit, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {0,0,0,0,0,0,0,0,0},
 {"Tools", 0,  0, 0, 64, FL_NORMAL_LABEL, 0, 14, 0},
 {"Draw", 0x31,  (Fl_Callback*)TrackEditorUI::cb_draw, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {"Path", 0x32,  (Fl_Callback*)TrackEditorUI::cb_path, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {"Startline", 0x33,  (Fl_Callback*)TrackEditorUI::cb_startline, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {"Scroll", 0x34,  (Fl_Callback*)TrackEditorUI::cb_scroll, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {"Sign", 0x35,  (Fl_Callback*)TrackEditorUI::cb_roadSign, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {0,0,0,0,0,0,0,0,0},
 {"Signs", 0,  0, 0, 64, FL_NORMAL_LABEL, 0, 14, 0},
 {0, 0,  (Fl_Callback*)TrackEditorUI::cb_easyLeft, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {0, 0,  (Fl_Callback*)TrackEditorUI::cb_easyRight, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {0, 0,  (Fl_Callback*)TrackEditorUI::cb_hardLeft, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {0, 0,  (Fl_Callback*)TrackEditorUI::cb_hardRight, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {0, 0,  (Fl_Callback*)TrackEditorUI::cb_easyLeftThenRight, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {0, 0,  (Fl_Callback*)TrackEditorUI::cb_easyRightThenLeft, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {0, 0,  (Fl_Callback*)TrackEditorUI::cb_hardLeftThenRight, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {0, 0,  (Fl_Callback*)TrackEditorUI::cb_hardRightThenLeft, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {0, 0,  (Fl_Callback*)TrackEditorUI::cb_LRLR, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {0, 0,  (Fl_Callback*)TrackEditorUI::cb_RLRL, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {0,0,0,0,0,0,0,0,0},
 {"Tiles", 0,  0, 0, 64, FL_NORMAL_LABEL, 0, 14, 0},
 {"Road", 0,  (Fl_Callback*)TrackEditorUI::cb_road, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {"Offroad", 0,  (Fl_Callback*)TrackEditorUI::cb_offroad, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {"Wall", 0,  (Fl_Callback*)TrackEditorUI::cb_wall, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {0,0,0,0,0,0,0,0,0},
 {"Track", 0,  0, 0, 64, FL_NORMAL_LABEL, 0, 14, 0},
 {"Flip Vertical", 0,  (Fl_Callback*)TrackEditorUI::cb_flipVertical, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {"Flip Horizontal", 0,  (Fl_Callback*)TrackEditorUI::cb_flipHorizontal, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {"Clockwise", 0,  (Fl_Callback*)TrackEditorUI::cb_clockwiseMenuItem, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {0,0,0,0,0,0,0,0,0},
 {"Help", 0,  0, 0, 64, FL_NORMAL_LABEL, 0, 14, 0},
 {"About toycars_track_editor...", 0,  (Fl_Callback*)TrackEditorUI::cb_about, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {"Help...", 0,  (Fl_Callback*)TrackEditorUI::cb_help, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {0,0,0,0,0,0,0,0,0},
 {0,0,0,0,0,0,0,0,0}
};
Fl_Menu_Item* TrackEditorUI::fileMenu = TrackEditorUI::menu_mainMenuBar + 0;
Fl_Menu_Item* TrackEditorUI::newMap = TrackEditorUI::menu_mainMenuBar + 1;
Fl_Menu_Item* TrackEditorUI::open = TrackEditorUI::menu_mainMenuBar + 2;
Fl_Menu_Item* TrackEditorUI::import = TrackEditorUI::menu_mainMenuBar + 3;
Fl_Menu_Item* TrackEditorUI::save = TrackEditorUI::menu_mainMenuBar + 4;
Fl_Menu_Item* TrackEditorUI::saveAs = TrackEditorUI::menu_mainMenuBar + 5;
Fl_Menu_Item* TrackEditorUI::install = TrackEditorUI::menu_mainMenuBar + 6;
Fl_Menu_Item* TrackEditorUI::uninstall = TrackEditorUI::menu_mainMenuBar + 7;
Fl_Menu_Item* TrackEditorUI::quit = TrackEditorUI::menu_mainMenuBar + 8;
Fl_Menu_Item* TrackEditorUI::toolsMenu = TrackEditorUI::menu_mainMenuBar + 10;
Fl_Menu_Item* TrackEditorUI::draw = TrackEditorUI::menu_mainMenuBar + 11;
Fl_Menu_Item* TrackEditorUI::path = TrackEditorUI::menu_mainMenuBar + 12;
Fl_Menu_Item* TrackEditorUI::startline = TrackEditorUI::menu_mainMenuBar + 13;
Fl_Menu_Item* TrackEditorUI::scroll = TrackEditorUI::menu_mainMenuBar + 14;
Fl_Menu_Item* TrackEditorUI::roadSign = TrackEditorUI::menu_mainMenuBar + 15;
Fl_Menu_Item* TrackEditorUI::signsMenu = TrackEditorUI::menu_mainMenuBar + 17;
Fl_Menu_Item* TrackEditorUI::easyLeft = TrackEditorUI::menu_mainMenuBar + 18;
Fl_Menu_Item* TrackEditorUI::easyRight = TrackEditorUI::menu_mainMenuBar + 19;
Fl_Menu_Item* TrackEditorUI::hardLeft = TrackEditorUI::menu_mainMenuBar + 20;
Fl_Menu_Item* TrackEditorUI::hardRight = TrackEditorUI::menu_mainMenuBar + 21;
Fl_Menu_Item* TrackEditorUI::easyLeftThenRight = TrackEditorUI::menu_mainMenuBar + 22;
Fl_Menu_Item* TrackEditorUI::easyRightThenLeft = TrackEditorUI::menu_mainMenuBar + 23;
Fl_Menu_Item* TrackEditorUI::hardLeftThenRight = TrackEditorUI::menu_mainMenuBar + 24;
Fl_Menu_Item* TrackEditorUI::hardRightThenLeft = TrackEditorUI::menu_mainMenuBar + 25;
Fl_Menu_Item* TrackEditorUI::LRLR = TrackEditorUI::menu_mainMenuBar + 26;
Fl_Menu_Item* TrackEditorUI::RLRL = TrackEditorUI::menu_mainMenuBar + 27;
Fl_Menu_Item* TrackEditorUI::tilesMenu = TrackEditorUI::menu_mainMenuBar + 29;
Fl_Menu_Item* TrackEditorUI::road = TrackEditorUI::menu_mainMenuBar + 30;
Fl_Menu_Item* TrackEditorUI::offroad = TrackEditorUI::menu_mainMenuBar + 31;
Fl_Menu_Item* TrackEditorUI::wall = TrackEditorUI::menu_mainMenuBar + 32;
Fl_Menu_Item* TrackEditorUI::trackMenu = TrackEditorUI::menu_mainMenuBar + 34;
Fl_Menu_Item* TrackEditorUI::flipVertical = TrackEditorUI::menu_mainMenuBar + 35;
Fl_Menu_Item* TrackEditorUI::flipHorizontal = TrackEditorUI::menu_mainMenuBar + 36;
Fl_Menu_Item* TrackEditorUI::clockwiseMenuItem = TrackEditorUI::menu_mainMenuBar + 37;
Fl_Menu_Item* TrackEditorUI::helpMenu = TrackEditorUI::menu_mainMenuBar + 39;
Fl_Menu_Item* TrackEditorUI::about = TrackEditorUI::menu_mainMenuBar + 40;
Fl_Menu_Item* TrackEditorUI::help = TrackEditorUI::menu_mainMenuBar + 41;

void TrackEditorUI::cb_vertScroll_i(Fl_Scrollbar* o, void*) {
  trackView->setVertScrollFrac(o->value() / 10000.0);
}
void TrackEditorUI::cb_vertScroll(Fl_Scrollbar* o, void* v) {
  ((TrackEditorUI*)(o->parent()->user_data()))->cb_vertScroll_i(o,v);
}

void TrackEditorUI::cb_horizScroll_i(Fl_Scrollbar* o, void*) {
  trackView->setHorizScrollFrac(o->value() / 10000.0);
}
void TrackEditorUI::cb_horizScroll(Fl_Scrollbar* o, void* v) {
  ((TrackEditorUI*)(o->parent()->user_data()))->cb_horizScroll_i(o,v);
}

void TrackEditorUI::cb_OK_i(Fl_Return_Button*, void*) {
  //printf("width %d height %d\n", (int)widthInput->value(), (int)heightInput->value());
try { trackView->newMap((int)widthInput->value(), (int)heightInput->value()); }
catch (ScException e) {
   e.printMsg();
   fl_alert("Fatal error. Must quit now.");
   exit(1);
}
newTrackDialog->hide();
filename[0] = '\0';
mainWindow->label(filename);
}
void TrackEditorUI::cb_OK(Fl_Return_Button* o, void* v) {
  ((TrackEditorUI*)(o->parent()->user_data()))->cb_OK_i(o,v);
}

void TrackEditorUI::cb_Cancel_i(Fl_Button*, void*) {
  importImageDialog->hide();
}
void TrackEditorUI::cb_Cancel(Fl_Button* o, void* v) {
  ((TrackEditorUI*)(o->parent()->user_data()))->cb_Cancel_i(o,v);
}

void TrackEditorUI::cb_OK1_i(Fl_Return_Button*, void*) {
  try { trackView->importImage(importImageBox->getFilename()); }
catch (ScException e) {
   e.printMsg();
   fl_alert("Failed to import file %s\n", importImageBox->getFilename());
   importImageBox->hide();
   return;
}
filename[0] = '\0';
mainWindow->label(filename);
importImageDialog->hide();
}
void TrackEditorUI::cb_OK1(Fl_Return_Button* o, void* v) {
  ((TrackEditorUI*)(o->parent()->user_data()))->cb_OK1_i(o,v);
}

TrackEditorUI::TrackEditorUI() {
  { mainWindow = new Fl_Double_Window(800, 600);
    mainWindow->user_data((void*)(this));
    { mainMenuBar = new Fl_Menu_Bar(0, 0, 800, 20);
      { Fl_Menu_Item* o = &menu_mainMenuBar[18];
      o->image(image_EasyLeft);
      }
      { Fl_Menu_Item* o = &menu_mainMenuBar[19];
      o->image(image_EasyRight);
      }
      { Fl_Menu_Item* o = &menu_mainMenuBar[20];
      o->image(image_HardLeft);
      }
      { Fl_Menu_Item* o = &menu_mainMenuBar[21];
      o->image(image_HardRight);
      }
      { Fl_Menu_Item* o = &menu_mainMenuBar[22];
      o->image(image_EasyLeftThenRight);
      }
      { Fl_Menu_Item* o = &menu_mainMenuBar[23];
      o->image(image_EasyRightThenLeft);
      }
      { Fl_Menu_Item* o = &menu_mainMenuBar[24];
      o->image(image_HardLeftThenRight);
      }
      { Fl_Menu_Item* o = &menu_mainMenuBar[25];
      o->image(image_HardRightThenLeft);
      }
      { Fl_Menu_Item* o = &menu_mainMenuBar[26];
      o->image(image_LRLR);
      }
      { Fl_Menu_Item* o = &menu_mainMenuBar[27];
      o->image(image_RLRL);
      }
      { Fl_Menu_Item* o = &menu_mainMenuBar[37];
        o->flags = FL_MENU_TOGGLE;
      }
      mainMenuBar->menu(menu_mainMenuBar);
    } // Fl_Menu_Bar* mainMenuBar
    { trackView = new TrackView(0, 20, 780, 560, "This is the track_view");
      trackView->box(FL_NO_BOX);
      trackView->color(FL_BACKGROUND_COLOR);
      trackView->selection_color(FL_BACKGROUND_COLOR);
      trackView->labeltype(FL_NORMAL_LABEL);
      trackView->labelfont(0);
      trackView->labelsize(14);
      trackView->labelcolor(FL_FOREGROUND_COLOR);
      trackView->align(FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
      trackView->when(FL_WHEN_RELEASE);
      Fl_Group::current()->resizable(trackView);
    } // TrackView* trackView
    { vertScroll = new Fl_Scrollbar(780, 20, 20, 560);
      vertScroll->maximum(10000);
      vertScroll->Fl_Slider::value(10000);
      vertScroll->callback((Fl_Callback*)cb_vertScroll);
    } // Fl_Scrollbar* vertScroll
    { horizScroll = new Fl_Scrollbar(0, 580, 780, 20);
      horizScroll->type(1);
      horizScroll->maximum(10000);
      horizScroll->callback((Fl_Callback*)cb_horizScroll);
    } // Fl_Scrollbar* horizScroll
    mainWindow->end();
  } // Fl_Double_Window* mainWindow
  { newTrackDialog = new Fl_Double_Window(250, 100, "Enter Track Dimensions");
    newTrackDialog->user_data((void*)(this));
    { widthInput = new Fl_Value_Input(55, 15, 65, 25, "Width");
      widthInput->minimum(20);
      widthInput->maximum(400);
      widthInput->step(1);
      widthInput->value(80);
    } // Fl_Value_Input* widthInput
    { heightInput = new Fl_Value_Input(55, 55, 65, 25, "Height");
      heightInput->minimum(20);
      heightInput->maximum(400);
      heightInput->step(1);
      heightInput->value(50);
    } // Fl_Value_Input* heightInput
    { Fl_Return_Button* o = new Fl_Return_Button(150, 55, 80, 25, "OK");
      o->callback((Fl_Callback*)cb_OK);
    } // Fl_Return_Button* o
    newTrackDialog->set_modal();
    newTrackDialog->end();
  } // Fl_Double_Window* newTrackDialog
  { importImageDialog = new Fl_Double_Window(376, 255, "Select Colour Mapping");
    importImageDialog->user_data((void*)(this));
    { importImageBox = new ImportImageBox(0, 0, 255, 255);
      importImageBox->box(FL_NO_BOX);
      importImageBox->color(FL_BACKGROUND_COLOR);
      importImageBox->selection_color(FL_BACKGROUND_COLOR);
      importImageBox->labeltype(FL_NORMAL_LABEL);
      importImageBox->labelfont(0);
      importImageBox->labelsize(14);
      importImageBox->labelcolor(FL_FOREGROUND_COLOR);
      importImageBox->align(FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
      importImageBox->when(FL_WHEN_RELEASE);
    } // ImportImageBox* importImageBox
    { roadColourButton = new Fl_Light_Button(260, 5, 110, 25, "Road");
      roadColourButton->type(102);
      roadColourButton->labeltype(FL_ENGRAVED_LABEL);
    } // Fl_Light_Button* roadColourButton
    { offroadColourButton = new Fl_Light_Button(260, 35, 110, 25, "Offroad");
      offroadColourButton->type(102);
      offroadColourButton->labeltype(FL_ENGRAVED_LABEL);
    } // Fl_Light_Button* offroadColourButton
    { wallColourButton = new Fl_Light_Button(260, 65, 110, 25, "Wall");
      wallColourButton->type(102);
      wallColourButton->labeltype(FL_ENGRAVED_LABEL);
    } // Fl_Light_Button* wallColourButton
    { Fl_Button* o = new Fl_Button(260, 185, 110, 25, "Cancel");
      o->callback((Fl_Callback*)cb_Cancel);
    } // Fl_Button* o
    { Fl_Return_Button* o = new Fl_Return_Button(260, 215, 110, 25, "OK");
      o->callback((Fl_Callback*)cb_OK1);
    } // Fl_Return_Button* o
    importImageDialog->set_modal();
    importImageDialog->end();
  } // Fl_Double_Window* importImageDialog
  { aboutBox = new Fl_Double_Window(250, 205, "About");
    aboutBox->user_data((void*)(this));
    { Fl_Text_Display* o = aboutDisplay = new Fl_Text_Display(25, 20, 200, 160);
      Fl_Text_Buffer *buf = new Fl_Text_Buffer(0);
      buf->append(kAboutBoxText);
      o->buffer(buf);
    } // Fl_Text_Display* aboutDisplay
    aboutBox->set_modal();
    aboutBox->end();
  } // Fl_Double_Window* aboutBox
  { helpWindow = new Fl_Double_Window(512, 384, "Help");
    helpWindow->user_data((void*)(this));
    { Fl_Text_Display* o = helpDisplay = new Fl_Text_Display(20, 20, 472, 344);
      helpDisplay->align(FL_ALIGN_WRAP|FL_ALIGN_INSIDE);
      Fl_Text_Buffer *buf = new Fl_Text_Buffer(0);
      buf->append(kHelpText);
      o->buffer(buf);
      o->wrap_mode(1,70);
    } // Fl_Text_Display* helpDisplay
    helpWindow->end();
    helpWindow->resizable(helpWindow);
  } // Fl_Double_Window* helpWindow
  changed = false;
  filename[0] = '\0';
  trackView->setTool(kDrawTool);
  trackView->setTile(kRoad);
  trackView->setSign(kEasyLeft);
  trackView->setUI(this);
  mainWindow->label(filename);
  importImageBox->setBtns(roadColourButton, offroadColourButton, wallColourButton);
  
  easyRight->setonly();
  hardLeft->setonly();
  hardRight->setonly();
  easyLeftThenRight->setonly();
  easyRightThenLeft->setonly();
  hardLeftThenRight->setonly();
  hardRightThenLeft->setonly();
  LRLR->setonly();
  RLRL->setonly();
  easyLeft->setonly();
  
  roadSign->setonly();
  startline->setonly();
  scroll->setonly();
  path->setonly();
  draw->setonly();
  
  offroad->setonly();
  wall->setonly();
  road->setonly();
}

void TrackEditorUI::show(int argc, char **argv) {
  mainWindow->show(argc, argv);
}

void TrackEditorUI::setChanged(bool val) {
  changed = val;
}

int TrackEditorUI::check_save() {
  if (!changed) return 1;

  int r = fl_choice("The current file has not been saved.\n"
                    "Would you like to save it now?",
                    "Cancel", "Save", "Discard");

  if (r == 1) {
    cb_save_i(0,0); // Save the file...
    return !changed;
  }

  return (r == 2) ? 1 : 0;
}
